// File _3D_Controller.cpp -     3D   
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "_3D_Controller.h"
//////////////////////////////////////////////////////////////////////////////
tfloat UCNTfloat;
int UCNTint;
tvect UCNTvect;
int UCNTswitch;
//////////////////////////////////////////////////////////////////////////////
AbstCNT :: AbstCNT()
{
  EControl = NULL;
  Multiply = 1.0;
  Stop = no;
};

//////////////////////////////////////////////////////////////////////////////
void AbstCNT :: Regenerate()
{
};

//////////////////////////////////////////////////////////////////////////////
//   3D
//////////////////////////////////////////////////////////////////////////////
RandRotateCNT :: RandRotateCNT()
{
  Node = 0;
  SetRotate();
  NonStop = 0;
  s_mult = no;
  Circ = SCirc = 0; s_circ = s_scirc = no;
};

//////////////////////////////////////////////////////////////////////////////
void RandRotateCNT :: Reset()
{
  Time.Reset(); STime.Reset();
};

//////////////////////////////////////////////////////////////////////////////
void RandRotateCNT :: SetMap(int Xv, int Yv, int Zv)
{
  Map.Vx = Xv; Map.Vy = Yv; Map.Vz = Zv;
};

//////////////////////////////////////////////////////////////////////////////
void RandRotateCNT :: SetMultiply(tfloat m)
{
  Multiply = m; s_mult = Yes;
};

//////////////////////////////////////////////////////////////////////////////
void RandRotateCNT :: SetSMap(int Xv, int Yv, int Zv)
{
  SMap.Vx = Xv; SMap.Vy = Yv; SMap.Vz = Zv;
};

//////////////////////////////////////////////////////////////////////////////
void RandRotateCNT :: SetRotate(int m, int sm, tfloat cb, tfloat cj, int tb, int tj)
{
  if (m) { Map.Vx=1; Map.Vy=1; Map.Vz=1; };
  if (sm) { SMap.Vx=1; SMap.Vy=1; SMap.Vz=1; };
  CircBJ = SCircBJ = BJ(cb,cj);
  Time.Spread = STime.Spread = BJ(tb,tj);
};

//////////////////////////////////////////////////////////////////////////////
void RandRotateCNT :: Regenerate()
{
  tmap map = {0,0,0}, smap = {0,0,0};
  if (Stop || !Node) return;
  OBJ.Current(Node);
  if (Time.Next()) if (Map.Vx | Map.Vy | Map.Vz) { if (Map.Vx) map.Vx = Random(-1,1,NonStop); else map.Vx = COBJ->Map.Vx;
                                                   if (Map.Vy) map.Vy = Random(-1,1,NonStop); else map.Vy = COBJ->Map.Vy;
                                                   if (Map.Vz) map.Vz = Random(-1,1,NonStop); else map.Vz = COBJ->Map.Vz;
                                                   COBJ->SetMap(map.Vx, map.Vy, map.Vz);
                                                   COBJ->SetCirc((Circ = BJitter(CircBJ)) * Multiply); s_circ = Yes;
                                                 };
  if (STime.Next()) if (SMap.Vx | SMap.Vy | SMap.Vz) { if (SMap.Vx) smap.Vx = Random(-1,1,NonStop); else smap.Vx = COBJ->SMap.Vx;
                                                       if (SMap.Vy) smap.Vy = Random(-1,1,NonStop); else smap.Vy = COBJ->SMap.Vy;
                                                       if (SMap.Vz) smap.Vz = Random(-1,1,NonStop); else smap.Vz = COBJ->SMap.Vz;
                                                       COBJ->SetSMap(smap.Vx, smap.Vy, smap.Vz);
                                                       COBJ->SetSCirc((SCirc = BJitter(SCircBJ)) * Multiply); s_scirc = Yes;
                                                     };
  if (s_mult)
  { if (s_circ) COBJ->SetCirc(Circ * Multiply); 
    if (s_scirc) COBJ->SetSCirc(SCirc * Multiply);
    s_mult = no;
  };                                                                 
};

//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
RandUCNTfloat :: RandUCNTfloat() { Set(NULL); Reset(); };

//////////////////////////////////////////////////////////////////////////////
void RandUCNTfloat :: Reset() { Time.Reset(); };

//////////////////////////////////////////////////////////////////////////////
void RandUCNTfloat :: Set(tfloat *pv, tfloat vb, tfloat vj, int tb, int tj)
{ 
  PValue = pv; ValueBJ = BJ(vb,vj); Time.Spread = BJ(tb,tj); Reset();
};

//////////////////////////////////////////////////////////////////////////////
void RandUCNTfloat :: Regenerate()
{ 
  if (Stop) return;
  if (Time.Next())
  { pastValue = Value; 
    Value = UCNTfloat = BJitter(ValueBJ);
    if (EControl) EControl();
    if (PValue) *PValue = UCNTfloat * Multiply;
  };
};

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
SmRandUCNTfloat :: SmRandUCNTfloat() { Set(NULL); Smooth = Yes; Reset(); };

//////////////////////////////////////////////////////////////////////////////
void SmRandUCNTfloat :: Reset() { Time.Reset(); Val = BJitter(ValueBJ); Diff = 0; };

//////////////////////////////////////////////////////////////////////////////
void SmRandUCNTfloat :: Set(tfloat *pv, tfloat vb, tfloat vj, int tb, int tj)
{ 
  PValue = pv; ValueBJ = BJ(vb,vj); Time.Spread = BJ(tb,tj); Reset();
};

//////////////////////////////////////////////////////////////////////////////
void SmRandUCNTfloat :: Regenerate()
{ 
  if (Stop) return;
  if (Time.Next()) { Val += Diff; Diff = BJitter(ValueBJ) - Val; };
  pastValue = Value;
  Value = UCNTfloat = Time.Current / Time.Limit;
  if (Smooth) Value = UCNTfloat = Val + Diff * Hermit(Value); else Value = UCNTfloat = Val + Diff * Value;
  if (EControl) EControl();
  if (PValue) *PValue = UCNTfloat * Multiply;
};        

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
DataSmRandUCNTfloat :: DataSmRandUCNTfloat()
{
  Set(NULL,0);
  Data = NULL; DataCount = 0;
  Smooth = Yes;
  Reset();
};

//////////////////////////////////////////////////////////////////////////////
DataSmRandUCNTfloat :: ~DataSmRandUCNTfloat() { FreeMem(Data); };

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTfloat :: Reset() { Time.Reset(); pastValue = Value = NVal = PVal = -347000347; };

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTfloat :: SetDataCount(unsigned dc)
{
  FreeMem(Data);
  Data = (tfloat_arr *)GetMem(dc * sizeof(tfloat));
  DataCount = dc;
};

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTfloat :: SetData(unsigned n, tfloat r) {(*Data)[n] = r; };

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTfloat :: Set(tfloat *pv, unsigned dc , int tb, int tj)
{
  PValue = pv;
  Time.Spread = BJ(tb,tj);
  if (dc) SetDataCount(dc);
  Reset();
};

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTfloat :: Regenerate()
{
  if (Stop || !Data) return;
  if (Time.Next()) { if ((NVal == -347000347) && (PVal == -347000347)) NVal = (*Data)[Random(DataCount - 1)];
                     PVal = NVal; NVal = (*Data)[Random(DataCount - 1)];
                   };
  UCNTfloat = Time.Current / Time.Limit;
  pastValue = Value;
  if (Smooth) Value = UCNTfloat = PVal + (NVal - PVal) * Hermit(UCNTfloat);
        else Value = UCNTfloat = PVal + (NVal - PVal) * UCNTfloat;
  if (EControl) EControl();
  if (PValue) *PValue = UCNTfloat * Multiply;
};

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
DataSmRandUCNTfloatSwitch :: DataSmRandUCNTfloatSwitch()
{
  Set(NULL,0);
  Data = NULL; DataCount = 0;
  Smooth = Yes;
  TimeSwBJ = BJ(50,15);
  Reset();
};

//////////////////////////////////////////////////////////////////////////////
DataSmRandUCNTfloatSwitch :: ~DataSmRandUCNTfloatSwitch() { FreeMem(Data); };

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTfloatSwitch :: Reset() { Time.Reset(); pastValue = Value = NVal = PVal = -347000347; SwitchNow = Yes; };

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTfloatSwitch :: SetDataCount(unsigned dc)
{
  FreeMem(Data);
  Data = (tfloat_arr *)GetMem(dc * sizeof(tfloat));
  DataCount = dc;
};

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTfloatSwitch :: SetData(unsigned n, tfloat r) {(*Data)[n] = r; };

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTfloatSwitch :: Set(tfloat *pv, unsigned dc, int tswb, int tswj, int tb, int tj)
{
  PValue = pv; Time.Spread = BJ(tb,tj); TimeSwBJ = BJ(tswb,tswj);
  if (dc) SetDataCount(dc);
  Reset();
};

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTfloatSwitch :: Regenerate()
{
  if (Stop || !Data) return;
  if (Time.Next())
  { if ((NVal == -347000347) && (PVal == -347000347)) NVal = (*Data)[Random(1) * (DataCount - 1)];
    PVal = NVal; 
    if (!SwitchNow) { Time.Limit = BJitter(TimeSwBJ); NVal = (*Data)[Random(DataCount - 1)]; }; 
    SwitchNow = abs(1 - SwitchNow);
  };
  pastValue = Value;      
  if (SwitchNow) { UCNTfloat = Time.Current / Time.Limit;
                   if (Smooth) Value = UCNTfloat = PVal + (NVal - PVal) * Hermit(UCNTfloat);
                   else Value = UCNTfloat = PVal + (NVal - PVal) * UCNTfloat;
                 } else Value = UCNTfloat = PVal;        
  if (EControl) EControl();
  if (PValue) *PValue = UCNTfloat * Multiply;
};

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
dwRGB UCNTdwRGB;

DataSmRandUCNTdwRGB :: DataSmRandUCNTdwRGB()
{
  Data = NULL;
  DataCount = 0;
  Smooth = Yes;
  Reset();
};

//////////////////////////////////////////////////////////////////////////////
DataSmRandUCNTdwRGB :: ~DataSmRandUCNTdwRGB() { FreeMem(Data); };

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTdwRGB :: Reset() { Time.Reset(); pastValue = Value = NVal = PVal = 0; };

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTdwRGB :: SetDataCount(unsigned dc)
{
  FreeMem(Data);
  Data = (dwRGB_arr *)GetMem(dc * sizeof(dwRGB));
  DataCount = dc;
};

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTdwRGB :: SetData(unsigned n, dwRGB r) {(*Data)[n] = r; };

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTdwRGB :: Set(dwRGB *pv, unsigned dc , int tb, int tj)
{
  PValue = pv; Time.Spread = BJ(tb,tj);
  if (dc) SetDataCount(dc);
  Reset();
};

//////////////////////////////////////////////////////////////////////////////
void DataSmRandUCNTdwRGB :: Regenerate()
{
  if (Stop || !Data) return;
  if (Time.Next()) { if (!(NVal | PVal)) NVal = (*Data)[Random(DataCount - 1)];
                     PVal = NVal; NVal = (*Data)[Random(DataCount - 1)];
                   };
  UCNTfloat = Time.Current / Time.Limit;
  pastValue = Value;
  if (Smooth) Value = UCNTdwRGB = RGBblend(PVal,NVal,255 * Hermit(UCNTfloat)) | 0xff000000;
  else Value = UCNTdwRGB = RGBblend(PVal,NVal,255 * UCNTfloat) | 0xff000000;
  if (EControl) EControl();
  if (PValue) *PValue = UCNTdwRGB;
};

//////////////////////////////////////////////////////////////////////////////
//   3D  
//////////////////////////////////////////////////////////////////////////////
SmRandRotateCNT :: SmRandRotateCNT()
{
  PValue = NULL;
  ValueBJ = BJ((tfloat)0.0,(tfloat)1.0);
  Set(0); Smooth = Yes; Val = Diff = 0;
  Map = MAPis(0, 0, 1);
};

//////////////////////////////////////////////////////////////////////////////
void SmRandRotateCNT :: Set(unsigned node, tfloat vcircb, tfloat vcircj, tfloat ccirc, tfloat offs, int tb, int tj)
{
  Node = node;
  ValueBJ = BJ(vcircb,vcircj); CCirc = ccirc; Offs = offs;
  Time.Spread = BJ(tb,tj);
  Reset();
};

//////////////////////////////////////////////////////////////////////////////
void SmRandRotateCNT :: SetMultiply(tfloat m) { Multiply = m; };

//////////////////////////////////////////////////////////////////////////////
void SmRandRotateCNT :: Regenerate()
{
  if (Stop) return;
  SmRandUCNTfloat :: Regenerate();
  if (!Node) return;
  OBJ.Current(Node);
  if (Offs) COBJ->SetVCenter(0,0,Offs);
  tmap map;
  tfloat circ;
  if (CCirc) { map = MAPis(1,0,0); circ = CCirc; } else { map = COBJ->Map; circ = COBJ->Circ; };   
  COBJ->SetMap(Map.Vx, Map.Vy, Map.Vz); COBJ->SetCirc(UCNTfloat * Multiply); COBJ->Rotate();
  COBJ->SetMap(map.Vx, map.Vy, map.Vz); COBJ->SetCirc(circ);                  
};

//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
RandUCNTint :: RandUCNTint() { Set(NULL); };

//////////////////////////////////////////////////////////////////////////////
void RandUCNTint :: Reset() { Time.Reset(); };

//////////////////////////////////////////////////////////////////////////////
void RandUCNTint :: Set(int *pv, int vb, int vj, int tb, int tj)
{
  PValue = pv; ValueBJ = BJ(vb,vj); Time.Spread = BJ(tb,tj);
  Reset();
};

//////////////////////////////////////////////////////////////////////////////
void RandUCNTint :: Regenerate()
{
  if (Stop) return;
  if (Time.Next()) { pastValue = Value;
                     Value = UCNTint = BJitter(ValueBJ);
                     if (EControl) EControl();
                     if (PValue) *PValue = UCNTint;
                   };
};

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
RandUCNTvect :: RandUCNTvect() { Set(NULL); };

//////////////////////////////////////////////////////////////////////////////
void RandUCNTvect :: Reset() { Time.Reset(); };

//////////////////////////////////////////////////////////////////////////////
void RandUCNTvect :: Set(tvect *pv, tvect vb, tvect vj, int tb, int tj)
{
  PValue = pv; ValueBJ = BJ(vb,vj); Time.Spread = BJ(tb,tj);
  Reset();
};

//////////////////////////////////////////////////////////////////////////////
void RandUCNTvect :: Regenerate()
{
  if (Stop) return;
  if (Time.Next()) { pastValue = Value;
                     Value = UCNTvect = BJitter(ValueBJ);
                     if (EControl) EControl();
                     if (PValue) *PValue = UCNTvect * Multiply;
                   };
};

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
SmRandUCNTvect :: SmRandUCNTvect() { Set(NULL); Smooth = Yes; Reset(); };

//////////////////////////////////////////////////////////////////////////////
void SmRandUCNTvect :: Reset() { Time.Reset(); Val = BJitter(ValueBJ); Diff = 0; };

//////////////////////////////////////////////////////////////////////////////
void SmRandUCNTvect :: Set(tvect *pv, tvect vb, tvect vj, int tb, int tj)
{
  PValue = pv; ValueBJ = BJ(vb,vj); Time.Spread = BJ(tb,tj);
  Reset();
};

//////////////////////////////////////////////////////////////////////////////
void SmRandUCNTvect :: Regenerate()
{
  if (Stop) return;
  if (Time.Next()) { Val += Diff; Diff = BJitter(ValueBJ) - Val; };
  pastValue = Value;                               
  tfloat v = Time.Current / Time.Limit;
  if (Smooth) Value = UCNTvect = Val + Diff * Hermit(v); else Value = UCNTvect = Val + Diff * v;
  if (EControl) EControl();
  if (PValue) *PValue = UCNTvect * Multiply;
};

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
RandUCNTswitch :: RandUCNTswitch()
{
  Set(NULL);
  Refresh = Yes;
  ESwitch = NULL;
  Switch = On;
};

//////////////////////////////////////////////////////////////////////////////
void RandUCNTswitch :: Reset() { Time.Reset(); };

//////////////////////////////////////////////////////////////////////////////
void RandUCNTswitch :: Set(int *pv, int tonb, int tonj, int tofb, int tofj)
{
  PValue = pv; TimeOnBJ = BJ(tonb,tonj); TimeOffBJ = BJ(tofb,tofj);
  Reset();
};

//////////////////////////////////////////////////////////////////////////////
void RandUCNTswitch :: Regenerate()
{
  if (Stop) return;
  if (Time.Next())
  { Switch = !Switch;
    if (Switch) Time.Limit = BJitter(TimeOnBJ); else Time.Limit = BJitter(TimeOffBJ); 
    pastValue = Value;
    Value = UCNTswitch = Switch;
    if (EControl) EControl();
    if (ESwitch) ESwitch();
    if (PValue) *PValue = UCNTswitch;
  } if (Refresh) { pastValue = Value;
                   Value = UCNTswitch = Switch;
                   if (EControl) EControl();
                   if (PValue) *PValue = UCNTswitch;
                 };
};

//////////////////////////////////////////////////////////////////////////////
//  
//////////////////////////////////////////////////////////////////////////////
void InertionUCNTfloat :: Move(tfloat v) { Point += v; Moved = Yes;};

//////////////////////////////////////////////////////////////////////////////
void InertionUCNTfloat :: Regenerate()
{ 
  if (PValue) Value = *PValue; 
  if (Moved || !TerminationSteps) 
  { EV += (Point - Value) * Mobility; EV *= Damping; EVR = EV; Value += EV;
    Step = TerminationSteps;  
  } else { if (!Step) return; Step--;
           EV = EVR * Step / TerminationSteps; Value += EV; Point = Value;
         };
  if (PValue) *PValue = Value; Moved = No;
};

//////////////////////////////////////////////////////////////////////////////
void InertionUCNTfloat :: Set(tfloat *pv, tfloat sv, tfloat m, tfloat d, tfloat ts)
{ 
  Value = Point = sv; PValue = pv; EV = 0; Moved = 0; Mobility = m; Damping = d; Step = TerminationSteps = ts;
};     

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void InertionUCNTvect :: Set(tvect *pv, tvect sv, tfloat m, tfloat d, tfloat ts)
{ Value = Point = sv; PValue = pv; EV = 0; Moved = 0; Mobility = m; Damping = d; Step = TerminationSteps = ts;
};     

//////////////////////////////////////////////////////////////////////////////
void InertionUCNTvect :: Regenerate(tfloat lim)
{ tfloat m;
  if (PValue) Value = *PValue; if (zIgnore) { z = Value.z; Value.z = 0; };
  if (Moved || !TerminationSteps) 
  { EV += (Point - Value) * Mobility;
    EV *= Damping;
    m = !EV; if (m > lim) EV *= lim / m;
    EVR = EV; Value += EV; 
    Step = TerminationSteps;  
  } else { if (!Step) return; Step--;
           EV = EVR * Step / TerminationSteps; Value += EV; Point = Value;
         };
  if (zIgnore) Value.z = z;        
  if (PValue) *PValue = Value; Moved = No;
};

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void LInertionUCNTfloat :: Set(tfloat *pv, tfloat sv) { Value = Point = sv; PValue = pv; EV = 0; MoveNow = Moved = 0; };   

//////////////////////////////////////////////////////////////////////////////
int LInertionUCNTfloat :: Regenerate(tfloat lim, tfloat step)
{ tfloat m;
  if (PValue) Value = *PValue;
  if (Moved) 
  { if (Point > Value) EV += step; else EV -= step; 
    m = fabs(EV); if (m > lim) EV *= lim / m;
    Value += EV; MoveNow = Yes; 
  } else { if (!MoveNow) { Point = Value; return 0; };
           m = fabs(EV); if (m < step) { EV = 0; MoveNow = no; return 0; } else EV *= 1 - step / m;  
           Value += EV; Point = Value;
         };
  if (PValue) *PValue = Value; Moved = No;
  return MoveNow;
};

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void LInertionUCNTvect :: Set(tvect *pv, tvect sv) { Value = Point = sv; PValue = pv; EV = 0; MoveNow = Moved = 0; };     

//////////////////////////////////////////////////////////////////////////////
int LInertionUCNTvect :: Regenerate(tfloat lim, tfloat step) //
{ tfloat m;
  if (PValue) Value = *PValue; if (zIgnore) { z = Value.z; Value.z = 0; };
  if (Moved) 
  { EV += Norm(Point - Value) * step;
    m = !EV; if (m > lim) EV *= lim / m; 
    Value += EV; MoveNow = Yes; 
  } else { if (!MoveNow) { Point = Value; return 0; };
           m = !EV; if (m < step) { EV = 0; MoveNow = no; return 0; } else EV *= 1 - step / m;  
           Value += EV; Point = Value;
         };
  if (zIgnore) Value.z = z;        
  if (PValue) *PValue = Value;
  Moved = No;
  return MoveNow;
};

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
AbstCNT *CNTs[3*MAXCNT];

int CNTn[3] = {0};
int CNTend[3] = {0};

//////////////////////////////////////////////////////////////////////////////
void CNT_Regenerate()
{
  for (int ii = 0; ii < 3; ii++) for (int i = 0; i < CNTn[ii]; i++) CNTs[ii*i]->Regenerate();
};

void CNT_RegenerateHi()
{
  for (int i = 0; i < CNTn[pHi]; i++) CNTs[pHi*i]->Regenerate();
};

void CNT_RegenerateNormal()
{
  for (int i = 0; i < CNTn[pNormal]; i++) CNTs[pNormal*i]->Regenerate();
};

void CNT_RegenerateLow()
{
  for (int i = 0; i < CNTn[pLow]; i++) CNTs[pLow*i]->Regenerate();
};

//////////////////////////////////////////////////////////////////////////////
void CNT_Add(AbstCNT *c, int prior)
{
  CNTs[CNTn[prior]] = c; CNTn[prior]++; CNTend[prior] = (CNTn[prior] == MAXCNT); 
};

////////////////////////////////
void CNT_Del(AbstCNT *c)
{
  int n, i, ii;
  for (ii = 0; ii < 3; ii++)
   { n = CNTn[ii];
     for (i = 0; i < n; i++) if (CNTs[ii*i] == c) goto _found;
   };
  return;
  _found:
  for (i = i; i < (n - 1); i++) CNTs[ii*i] = CNTs[ii* (i+1)];
  CNTn[ii]--;  
};

///////////////////////////////////////////////////////////////////////////////
//  
int SPEED = 1; 
tfloat fSPEED = 1.0;
int SPEED_SkipNow = No;
int SPEED_HalfNow = No;
unsigned SPEED_History = No;
///////////////////////////////////////////////////////////////////////////////