// File _3D_Controller.h -     3D   
//////////////////////////////////////////////////////////////////////////////
#ifndef  _3D_Controller__
#define  _3D_Controller__
//////////////////////////////////////////////////////////////////////////////
#include "_3D.h"
//////////////////////////////////////////////////////////////////////////////
//   
class TimeCNT
{ public:
  tfloat Current, Limit, Delta;
  tBJint Spread;
  TimeCNT() { Current = 1.0; Limit = 0; Delta = 1.0; Spread = BJ(50, 25); }
  int In() { return (Current < (Limit - 0.00001)); };
  int Out() { return (Current > (Limit + 0.00001)); };
  int Inc() { if (In()) { Current += Delta * TIME_DELTA; return Yes; } else { Current = 0; Limit = BJitter(Spread); return no; }; };
  int Next() { if (In()) { Current += Delta * TIME_DELTA; return no; } else { Current = 0; Limit = BJitter(Spread); return Yes; }; };
  void Reset() { Current = 1.0; Limit = 0; };
  int Rem() { return Limit - Current; };
};

//////////////////////////////////////////////////////////////////////////////
//   3D
//     -  .
//////////////////////////////////////////////////////////////////////////////
//     
class AbstCNT
      { public:
        int Stop;
        tfloat Multiply;
        TimeCNT Time; 
        
        AbstCNT();
        
        void (*EControl)(); //      
        
        virtual void Regenerate(); 
      };
//////////////////////////////////////////////////////////////////////////////
//   
class RandRotateCNT : public AbstCNT
       { public:
         unsigned Node;            // ,   
         tmap Map, SMap;           //   Map, SMAp,  Yes  no, 1  0 
         tBJfloat CircBJ, SCircBJ; //       
         tfloat Circ, SCirc;       
         TimeCNT STime; 
         
         int NonStop;              //    

         RandRotateCNT();
         
         void Reset();
         void SetRotate(int = 1, int = 1, tfloat = m_PI/32, tfloat = m_PI/64, int = 50, int = 25); //       Map  SMap; + ,   + ,  . 
       void SetMap(int = 1, int = 1, int = 1); //    
         void SetSMap(int = 1, int = 1, int = 1);
         void SetMultiply(tfloat m = 1.0);
         void Regenerate();
         
         protected:
         int s_mult, s_circ, s_scirc;         
       };

//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
extern tfloat UCNTfloat;

class RandUCNTfloat : public AbstCNT
{ public:
  tfloat pastValue, Value, *PValue;   //  ,     ,   
  tBJfloat ValueBJ; //       

  RandUCNTfloat();
  void Reset();
  void Set(tfloat *pv, tfloat vb = 0, tfloat vj = 1, int tb = 50, int tj = 25); //      , ,  , ,  
  void Regenerate();
};
     
//////////////////////////////////////////////////////////////////////////////
class SmRandUCNTfloat : public AbstCNT // -   .
{ public:
  tfloat pastValue, Value, *PValue;   //   ,   
  tBJfloat ValueBJ; //       
  int Smooth; //  

  SmRandUCNTfloat();
  void Reset();
  void Set(tfloat *pv, tfloat vb = 0, tfloat vj = 1, int tb = 50, int tj = 25); //  , ,  , ,  
  void Regenerate();        
  protected:
  tfloat Val,Diff;
};

//////////////////////////////////////////////////////////////////////////////
extern dwRGB UCNTdwRGB;

class DataSmRandUCNTdwRGB : public AbstCNT // -       dwRGB.
                                           //     ,     
                                           //  ( )  .
{ public:
  dwRGB pastValue, Value, *PValue;   //   ,   
  dwRGB_arr *Data;  //    .
  unsigned DataCount; //  . 
  int Smooth; //  

  DataSmRandUCNTdwRGB();
  ~DataSmRandUCNTdwRGB();
  void Reset();
  void Set(dwRGB *, unsigned, int = 50, int = 25); //  ,   , ,  
  void SetData(unsigned, dwRGB); //     ,  ...
  void SetDataCount(unsigned);
  void Regenerate();
        
  protected:
  dwRGB NVal, PVal;
};

//////////////////////////////////////////////////////////////////////////////
class DataSmRandUCNTfloat : public AbstCNT // -    "".
                                           //     ,     
                                           //  ( )  .
{ public:
  tfloat pastValue, Value, *PValue;   //   ,   
  tfloat_arr *Data;        //    .
  unsigned DataCount;      //  . 
  int Smooth; //  

  DataSmRandUCNTfloat();
  ~DataSmRandUCNTfloat();
  void Reset();
  void Set(tfloat *, unsigned, int = 50, int = 25); //  ,   , ,  
  void SetData(unsigned, tfloat); //     ,  ...
  void SetDataCount(unsigned);
  void Regenerate();
        
  protected:
  tfloat NVal, PVal;
};

//////////////////////////////////////////////////////////////////////////////
class DataSmRandUCNTfloatSwitch : public AbstCNT  // -    -     .
{ public:
  tfloat pastValue, Value, *PValue;   //   ,   
  tfloat_arr *Data;        //    .
  unsigned DataCount;      //  . 
  int SwitchNow, Smooth;   // ***,  
  tBJint TimeSwBJ;         //     

  DataSmRandUCNTfloatSwitch();
  ~DataSmRandUCNTfloatSwitch();
  void Reset();
  void Set(tfloat *, unsigned, int = 50, int = 15, int = 250, int = 50); //   ,  , ,     ,   .
  void SetData(unsigned, tfloat); //     ,  ...
  void SetDataCount(unsigned);
  void Regenerate();
        
  protected:
  tfloat NVal, PVal;
};
            
//////////////////////////////////////////////////////////////////////////////
//   3D     
//////////////////////////////////////////////////////////////////////////////
class SmRandRotateCNT :  public SmRandUCNTfloat //  ""  Z  X, :
                                               // ValuBJ -  () (    Y  )
                                               // CCirc -  .
                                               //   Offs,    Z, ..  COBJ->SetVCenter(0,0,Offs)
{ public:
  unsigned Node; // ,   
  tfloat CCirc, Offs;
  tmap Map;
        
  SmRandRotateCNT();
  void Set(unsigned, tfloat = 0, tfloat = m_PI/80, tfloat = m_PI/200, tfloat = 0, int = 50, int = 25); //  ,     , , ,    
  void SetMultiply(tfloat m = 1.0);
  void Regenerate();
}; 
         
//////////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////////
extern int UCNTint;

class RandUCNTint : public AbstCNT
{ public:
  int pastValue, Value, *PValue;        //   ,   
  tBJint ValueBJ; //       

  RandUCNTint();
  void Reset();
  void Set(int *, int = 50, int = 50, int = 50, int = 25);
  void Regenerate();
};
//////////////////////////////////////////////////////////////////////////////
extern tvect UCNTvect;

class RandUCNTvect : public AbstCNT
{ public:
  tvect pastValue, Value, *PValue;        //   ,   
  tBJvectvect ValueBJ; //       

  RandUCNTvect();
  void Reset();
  void Set(tvect *, tvect = 0, tvect = 100, int = 50, int = 25);
  void Regenerate();
};
     
//////////////////////////////////////////////////////////////////////////////
class SmRandUCNTvect : public AbstCNT // -   .
{ public:
  tvect pastValue, Value, *PValue;   //   ,   
  tBJvectvect ValueBJ; //       
  int Smooth; //  

  SmRandUCNTvect();
  void Reset();
  void Set(tvect *, tvect = 0, tvect = 100, int = 50, int = 25); //  , ,  , ,  
  void Regenerate();
        
  protected:
  tvect Val,Diff;
};     

//////////////////////////////////////////////////////////////////////////////
extern int UCNTswitch;

class RandUCNTswitch : public AbstCNT
{ public:
  int pastValue, Value, *PValue;       //   ,   
      tBJint TimeOnBJ;   //      
      tBJint TimeOffBJ;  //      
  int Refresh; //  (    )   ( Regenerate)
  int Switch; //  
  void (*ESwitch)(); //    ,     

  RandUCNTswitch();
  void Reset();
  void Set(int *, int = 50, int = 50, int = 50, int = 25);
  void Regenerate();
};

//////////////////////////////////////////////////////////////////////////////
//  
//////////////////////////////////////////////////////////////////////////////
class InertionUCNTfloat
{ public:
  tfloat Mobility, Damping, TerminationSteps; // ,     
  tfloat Point,Value,EV;
  tfloat *PValue;
  int zIgnore;
        
  InertionUCNTfloat() { Set(); };
  void Set(tfloat *pv = NULL, tfloat sv = 0, tfloat m = 0.015, tfloat d = 0.9, tfloat ts = 15);     
  void Move(tfloat v);
  void Regenerate();

  protected:
  int Moved, Step;
  tfloat EVR;
  tfloat z;
};/**/

//////////////////////////////////////////////////////////////////////////////
class InertionUCNTvect
{ public:
  tfloat Mobility, Damping, TerminationSteps; // ,     
  tvect Point,Value,EV;
  tvect *PValue;
  int zIgnore;
        
  InertionUCNTvect() { Set(); zIgnore = no; };
  void Set(tvect *pv = NULL, tvect sv = 0, tfloat m = 0.015, tfloat d = 0.9, tfloat ts = 15);     
  void Move(tvect v) { Point += v; Moved = Yes;};
  void xMove(tfloat x) { Point.x += x;  Moved = Yes; };
  void yMove(tfloat y) { Point.y += y;  Moved = Yes; };
  void zMove(tfloat z) { Point.z += z;  Moved = Yes; };
  void Regenerate(tfloat lim = 10);
 
  protected:
  int Moved, Step;
      tvect EVR;
  tfloat z;
};

//////////////////////////////////////////////////////////////////////////////
class LInertionUCNTfloat
{ public:
  tfloat Point,Value,EV;
  tfloat *PValue;
  int MoveNow;
        
  LInertionUCNTfloat() { Set(); };
  void Set(tfloat *pv = NULL, tfloat sv = 0);   
  void Move(tfloat v) { Point += v; Moved = Yes;};
  int Regenerate(tfloat lim = 10, tfloat step = 1);

  protected:
  int Moved;
};

//////////////////////////////////////////////////////////////////////////////
class LInertionUCNTvect
{ public:
  tvect Point,Value,EV;
  tvect *PValue;
  int zIgnore;
  int MoveNow;
        
  LInertionUCNTvect() { Set(); zIgnore = no; };
  void Set(tvect *pv = NULL, tvect sv = 0);     
  void Move(tvect v) { Point += v; Moved = Yes;};
  void xMove(tfloat x) { Point.x += x;  Moved = Yes; };
  void yMove(tfloat y) { Point.y += y;  Moved = Yes; };
  void zMove(tfloat z) { Point.z += z;  Moved = Yes; };
  int Regenerate(tfloat lim = 10, tfloat step = 1);
  protected:
  int Moved;
  tfloat z;
};

//////////////////////////////////////////////////////////////////////////////
inline void OBJs_Regenerate()
{
  OBJs_DirectRotateQDec();
};

//////////////////////////////////////////////////////////////////////////////
//   .
#define MAXCNT 512

extern AbstCNT *CNTs[3*MAXCNT]; //    
extern int CNTn[3];             //      
                                // CNTn[pNormal] - 
extern int CNTend[3];           //      
                                // if CNTend[pNormal] ... - 
void CNT_Regenerate();          //    
void CNT_RegenerateHi();        //      
void CNT_RegenerateNormal();    // 
void CNT_RegenerateLow();       // 

void CNT_Add(AbstCNT *c, int prior = pNormal); //     
void CNT_Del(AbstCNT *c);                      // 
//////////////////////////////////////////////////////////////////////////////
//  
extern int SPEED; // 0 = 0.5, 1, 2
extern tfloat fSPEED; // 0 = 0.5, 1, 2
extern int SPEED_SkipNow; //   ""(  )
extern int SPEED_HalfNow; //   ""(  )
extern unsigned SPEED_History; //  - .

//  ?
inline int SPEED_CalcNow() { return (SPEED || (SPEED_History < 2) || !SPEED_HalfNow); };

inline void SPEED_ResetFlags() { SPEED_SkipNow = SPEED_HalfNow = SPEED_History = 0;};

//  
inline void SPEED_set(tfloat s) { fSPEED = s; SPEED = s + 0.001; SPEED_ResetFlags(); };

//   0.5 - 1 - 2,  Yes,   (..   2)
inline int SPEED_inc() { if (SPEED == 2) return No; SPEED_ResetFlags(); SPEED++; return Yes; };

//   0.5 - 1 - 2,  Yes,   (..   0 = 0.5)
inline int SPEED_dec() { if (SPEED == 0) return No; SPEED_ResetFlags(); SPEED--; return Yes; };

// ( )    
inline void SPEED_NextFlags() { SPEED_History++; if (SPEED == 0) SPEED_HalfNow ^= 1; else if (SPEED == 2) SPEED_SkipNow ^= 1; };
////////////////////////////////////////////////////////////////////////////////
#endif
