// File _COARRAY.cpp
//          
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "_COARRAY.h"

////////////////////////////////////////////////////////////////////////////////
BaseCOARRAY :: BaseCOARRAY()
{
  COBJECT = NULL;
  nCOBJECT = NULL;
  nameCOBJECT = NULL;
  fNEW = NULL;
  fDELETE = NULL;
  AutoCreate = Yes;
  First = 0x0fffffff; Last = 0;
  Top = COARRAYSEG;
  ARRAY = (tcounit_arr *)GetMemAlign(sizeof(tcounit) * COARRAYSEG,16,Yes);
};

////////////////////////////////////////////////////////////////////////////////
BaseCOARRAY :: BaseCOARRAY(void **co, int *nco, WCHAR **nameco, void *(*fnew)(), void (*fdelete)(void*), int nothing)
{
  COBJECT = NULL;
  nCOBJECT = NULL;
  nameCOBJECT = NULL;
  fNEW = NULL;
  fDELETE = NULL;
  AutoCreate = Yes;
  First = 0x0fffffff; Last = 0; Hole = Yes;
  Top = COARRAYSEG;
  ARRAY = (tcounit_arr *)GetMemAlign(sizeof(tcounit) * COARRAYSEG,16,Yes);
  Init(co,nco,nameco,fnew,fdelete,nothing);
};

////////////////////////////////////////////////////////////////////////////////
BaseCOARRAY :: ~BaseCOARRAY()
{
  Done();
  FreeMemAlign(ARRAY);
};

////////////////////////////////////////////////////////////////////////////////
void BaseCOARRAY :: Init(void **co, int *nco, WCHAR **nameco, void *(*fnew)(), void (*fdelete)(void*), int nothing)
{
  COBJECT = co;
  nCOBJECT = nco;
  nameCOBJECT = nameco;
  fNEW = fnew;
  fDELETE = fdelete;
  Nothing = nothing;
};

////////////////////////////////////////////////////////////////////////////////
int BaseCOARRAY :: Ready()
{
  return ((COBJECT != NULL) && (nCOBJECT != NULL) && (nameCOBJECT != NULL) && (fNEW != NULL) && (fDELETE != NULL));
};

////////////////////////////////////////////////////////////////////////////////
int BaseCOARRAY :: Create(int n, WCHAR *name)
{
  if (n == Nothing) return Nothing;
  AutoSize(n);
  UNIT = &(*ARRAY)[Number = n];
  if (UNIT->P) fDELETE(UNIT->P);
  *COBJECT = UNIT->P = fNEW();
  *nameCOBJECT = UNIT->Name = name;
  *nCOBJECT = n; 
  if (n > Last) Last = n; 
  if (n < First) First = n;
  Hole = Yes;
  return (UNIT->P != NULL);
};

////////////////////////////////////////////////////////////////////////////////
void BaseCOARRAY :: Delete(int n)
{
  UNIT = &(*ARRAY)[Number = n];
  if (!UNIT->P) return;
  fDELETE(UNIT->P);
  UNIT->P = NULL;
  UNIT->Name = NULL;
  if ((n == First) && (n == Last)) {First = 0x0fffffff; Last = 0;}; 
  if (n == First) { do {First++; } while (!(*ARRAY)[First].P);
                  } else if (n == Last) do {Last--;} while (!(*ARRAY)[Last].P);  
  Hole = Yes;
};

////////////////////////////////////////////////////////////////////////////////
int BaseCOARRAY :: DeleteName(WCHAR *name)
{
  if (NameNumber(name) != -1) { Delete(Number); return Number; }; 
  return -1;
};

////////////////////////////////////////////////////////////////////////////////
int BaseCOARRAY :: Present(int n)
{
  UNIT = &(*ARRAY)[Number = n];
  return (UNIT->P != NULL);
};

////////////////////////////////////////////////////////////////////////////////
int BaseCOARRAY :: NameNumber(WCHAR *name)
{
  for (Number = First; Number <= Last; Number++) { UNIT = &(*ARRAY)[Number];
                                                   if (UNIT->P && !wcscmp(UNIT->Name,name)) return Number;
                                                 };
  return -1;
};

////////////////////////////////////////////////////////////////////////////////
int BaseCOARRAY :: Count()
{
  int c = 0;
  for (Number = First; Number <= Last; Number++)
  if ((*ARRAY)[Number].P) c++;
  return c;
};

////////////////////////////////////////////////////////////////////////////////
int BaseCOARRAY :: PresentName(WCHAR *name)
{
  return (NameNumber(name) != -1);
};

////////////////////////////////////////////////////////////////////////////////
int BaseCOARRAY :: Add(WCHAR *name)
{
  GetFreeNum();
  int h = Hole;
  Create(Number,name); 
  Hole = h;
  return Number;
};

////////////////////////////////////////////////////////////////////////////////
void *BaseCOARRAY :: Get(int n)
{
  UNIT = &(*ARRAY)[Number = n];
  return UNIT->P;
};

////////////////////////////////////////////////////////////////////////////////
void *BaseCOARRAY :: GetName(WCHAR *name)
{
  if (NameNumber(name) != -1) return UNIT->P;
  return NULL;
};

////////////////////////////////////////////////////////////////////////////////
int BaseCOARRAY :: Current(int n)
{
  //if (n < 0) return 0;
  if (n >= Top) if (AutoCreate) return Create(n); else return no;
  UNIT = &(*ARRAY)[Number = n];
  if (UNIT->P == NULL) if (AutoCreate) return Create(n); else return no;
  *COBJECT = UNIT->P;
  *nCOBJECT = n; 
  *nameCOBJECT = UNIT->Name;
  return Yes;
};

////////////////////////////////////////////////////////////////////////////////
int BaseCOARRAY :: CurrentName(WCHAR *name)
{
  if (NameNumber(name) == -1) return no;
  return Current(Number);  
};

////////////////////////////////////////////////////////////////////////////////
int BaseCOARRAY :: Start()
{
  return ((Last >= First) && Current(First));
};

////////////////////////////////////////////////////////////////////////////////
int BaseCOARRAY :: Next()
{
  if (Number == Last) {Start(); return 0;}
  _loop:
  Number++; if ((*ARRAY)[Number].P) { Current(Number); return Yes; };
  goto _loop;
};

////////////////////////////////////////////////////////////////////////////////
void BaseCOARRAY :: Done()
{ 
  for (Number = First; Number <= Last; Number++)
  { UNIT = &(*ARRAY)[Number];
    if (UNIT->P) { fDELETE(UNIT->P);
                   UNIT->P = NULL;
                   UNIT->Name = NULL;
                 };
  };
  First = 0x0fffffff; Last = 0; Hole = Yes;
};

////////////////////////////////////////////////////////////////////////////////
void BaseCOARRAY :: AutoSize(int n)
{
  if (n >= Top) { n = (n / COARRAYSEG + 1) * COARRAYSEG;
                  tcounit_arr *tmpARRAY = (tcounit_arr *)GetMemAlign(sizeof(tcounit) * n,16,Yes);
                  memcpy(&(*tmpARRAY)[First],&(*ARRAY)[First],(Last - First + 1) * sizeof(tcounit));
                  FreeMemAlign(ARRAY); 
                  ARRAY = tmpARRAY;
                  Top = n; 
                };
};

////////////////////////////////////////////////////////////////////////////////
int BaseCOARRAY :: GetFreeNum()
{
  if (Hole) { for (Number = 0; Number <= Last; Number++)
               { UNIT = &(*ARRAY)[Number];
                 if (!UNIT->P) return Number;
               };
              Hole = no; 
            } else Number = Last + 1;
  Number;                 
  return Number;
};

//////////////////////////////////////////////////////////////////////////////
