// File _DRAW_2D.h

//////////////////////////////////////////////////////////////////////////////
#ifndef _DRAW_2D__
#define _DRAW_2D__

//////////////////////////////////////////////////////////////////////////////
//#include "__dxenv.h" //DDremove
#include "_DRAW_2D_GDIplus.h"
#include "_MATH_RandomBJ.h"

//////////////////////////////////////////////////////////////////////////////
//    ()     
//  ViewAs = modePUT + fromUR;
#define modePUT      0x00000001  //draw mode
#define modePUTALPHA 0x00000002  
#define modeADD      0x00000003
#define modeSUB      0x00000004
#define modeMUL      0x00000005
#define modeAVR      0x00000006
#define modeAVRHARD  0x00000007
#define modeAVRSOFT  0x00000008
#define modeMAX      0x00000009
#define modeIMUL     0x0000000a

#define fromXZERO   0x00000000 // 
#define fromXLAST   0x00000010  
#define fromXCENTER 0x00000020  
#define fromYZERO   0x00000000 
#define fromYLAST   0x00000040
#define fromYCENTER 0x00000080

#define fromL       0x00000000 // 
#define fromR       0x00000010  
#define fromLRC     0x00000020  
#define fromU       0x00000000 
#define fromD       0x00000040
#define fromUDC     0x00000080

#define fromUL      0x00000000 // 
#define fromUR      0x00000010 
#define fromUC      0x00000020 
#define fromDL      0x00000040 
#define fromDR      0x00000050
#define fromDC      0x00000060
#define fromCL      0x00000080 
#define fromCR      0x00000090 
#define fromCC      0x000000a0 

#define alignL      0x00000000 // 
#define alignLRC    0x00000100
#define alignR      0x00000200

#define alignU      0x00000400
#define alignUDC    0x00000800
#define alignD      0x00000c00

#define arrangeLR   0x00000000 // 
#define arrangeRL   0x00001000

#define arrangeUD   0x00004000
#define arrangeDU   0x00008000

#define shiftX      0x00000000 //  
#define shiftY      0x00000001

#define directionX  0x00000000 // 
#define directionY  0x00000001

#define horizontal  0x00000000 // 
#define vertical    0x00000001

#define alongX      0x00000000 // 
#define alongY      0x00000001

inline unsigned getMODE(unsigned p) { return p & 0x0000000f; }     //   

inline unsigned getFROM(unsigned p) { return p & 0x000000f0; }     //  
inline unsigned getFROMx(unsigned p) { return p & 0x00000030; }
inline unsigned getFROMy(unsigned p) { return p & 0x000000c0; }

inline unsigned getALIGN(unsigned p) { return p & 0x00000f00; }    //  
inline unsigned getALIGNx(unsigned p) { return p & 0x00000300; }
inline unsigned getALIGNy(unsigned p) { return p & 0x00000c00; }

inline unsigned getARRANGE(unsigned p) { return p & 0x0000f000; }  //  ( )
inline unsigned getARRANGEx(unsigned p) { return p & 0x00003000; }
inline unsigned getARRANGEy(unsigned p) { return p & 0x0000c000; }

inline unsigned getTYPE(unsigned p) { return p & 0x00ff0000; }     //  ().

inline unsigned g000f(unsigned p) { return p & 0x0000000f; }
inline unsigned g00f0(unsigned p) { return p & 0x000000f0; }
inline unsigned gff00(unsigned p) { return p & 0x0000ff00; }

//////////////////////////////////////////////////////////////////////////////
//#define DCOut 0   // DirectDraw
//#define DDOut 1   // Standart DC Draw
#define FullScreen 7777777 // for FullScreen

//////////////////////////////////////////////////////////////////////////////
extern tfloat DrawScale750;
extern tfloat DrawScale;
extern tfloat DrawYScale;  //        

extern int DrawOver;       //   -        
extern int DrawOverSafe;   // " "     

extern dwRGB DrawColor;      //    
extern int DrawIntensityI;   //   0..255
extern tfloat DrawIntensity; //   0..1.0  

inline void SetDrawIntensity(tfloat fi) { DrawIntensity = fi; DrawIntensityI = close255(fi * 255 + 0.5); }
inline void SetDrawIntensityI(int i) { DrawIntensityI = close255(i); DrawIntensity = (tfloat)i / 255; }
 
//////////////////////////////////////////////////////////////////////////////
//////////////  /////////////////////////////////////////////////////
//#define MAXresX 3200
#define MAXresY 32768
extern dwRGB_arr *DrawBits;      //      
extern dwRGB *DrawYptr[MAXresY];
//extern dwRGB *pRGB;

//////////////////////////////////////////////////////////////////////////////
//     : 
#define DrawYoffs(y) ((unsigned)DrawYptr[y] - (unsigned)DrawBits) //     ||     
#define DrawLinePtr(y) (DrawYptr[y])                              //     |y|
#define DrawPointPtr(x,y) (DrawYptr[y] + x)                       //      |x,y|  

//////////////////////////////////////////////////////////////////////////////
// 
#define DrawXRin(x) ((unsigned)x < DrawXR)   //       |X|
#define DrawYRin(y) ((unsigned)y < DrawYR)   //       |X|
//     2-x 
#define DrawXRinYRin(x, y) (DrawXRin(x) | (DrawYRin(y) << 1))
//  4-
#define Draw2XRin2YRin(x0, x1, y0, y1) (DrawXRin(x0) | (DrawXRin(x1) << 1) | (DrawYRin(y0) << 2) | (DrawYRin(y1) << 3))
//  8-
#define Draw4XRin4YRin(x0, x1, x2, x3, y0, y1, y2, y3) (DrawXRin(x0) | (DrawXRin(x1) << 1) | (DrawXRin(x2) << 2)  | (DrawXRin(x3) << 3) | (DrawYRin(y0) << 4) | (DrawYRin(y1) << 5) | (DrawYRin(y2) << 6)  | (DrawYRin(y3) << 7))
 
//////////////////////////////////////////////////////////////////////////////
extern int DrawAAlising;  //  ;

//////////////////////////////////////////////////////////////////////////////
extern int DrawAlignX;
extern int DrawAlignY;

int Draw2D_Init();
void Draw2D_Done();

void DrawSet(unsigned fsxres = FullScreen, unsigned yr = 1024); // DrawSet(400, 320),    4- 

extern int DrawXR;
extern int DrawYR;
extern int DrawXL;
extern int DrawYL;
extern tfloat fDrawXL;
extern tfloat fDrawYL;
extern int DrawXC;
extern int DrawYC;
extern tfloat fDrawXC;
extern tfloat fDrawYC;
extern unsigned  DrawSZ;
extern unsigned  DrawXSZ;
extern unsigned  DrawYSZ;
extern int DrawLOFFS;       //  ,   
extern int DrawXRfull;      // ,        .
extern int DrawYRfull;      // ,        .
extern int DrawPaintTrue;   //          -    DrawPaint -     ...
extern dwRGB *DrawPTRnear;  //       
extern dwRGB *DrawPTRfar;   //        

void DrawScaleSet(tfloat s);

//////////////////////////////////////////////////////////////////////////////
inline unsigned DrawImageVS_Size() { return DrawXSZ * DrawYSZ * 4; }
inline unsigned DrawImageSize() { return DrawXR * DrawYR * 4; }
inline void DrawSwapBits(dwRGB_arr **bits1, dwRGB_arr **bits2) { dwRGB_arr *bits = *bits1; *bits1 = *bits2; *bits2 = bits; }

//////////////////////////////////////////////////////////////////////////////
struct tRegion { int X, Y, XL, YL; };

struct tfRegion { tfloat X, Y, XL, YL; };

struct tdrawdata { int DrawXSZ, DrawYSZ, DrawXL, DrawYL, DrawXR, DrawYR, DrawXC, DrawYC,
                       DrawSZ, DrawLOFFS, DrawXRfull, DrawYRfull, DrawPaintTrue;
                   dwRGB *DrawPTRnear, *DrawPTRfar;
                   tRegion DrawRegion;
                   tfloat DrawScale750, DrawScale;
                   dwRGB_arr *DrawBits;
                 };

//////////////////////////////////////////////////////////////////////////////
// -   
extern tdrawdata DrawPort[8];

void DrawPortSave(int n = 0);
int DrawPortLoad(int n = 1);
void DrawPortMake(int n = 1, int xsz = 0, int ysz = 0, int ns = -1);
int DrawPortApply(int n = 1, int mode = modeMUL);
int DrawPortDone(int n = 0);

//////////////////////////////////////////////////////////////////////////////
extern tRegion DrawRegion;

inline tRegion RegionIs(int x, int y, int xl, int yl) { tRegion r; r.X = x; r.Y = y; r.XL = xl; r.YL = yl; return r; }
inline tRegion WHRegionIs(int x, int y, int w, int h) { tRegion r; r.X = x; r.Y = y; r.XL = x + w - 1; r.YL = y + h - 1; return r; }
inline tfRegion fWHRegionIs(tfloat x, tfloat y, tfloat w, tfloat h) { tfRegion r; r.X = x; r.Y = y; r.XL = x + w - 1; r.YL = y + h - 1; return r; }
inline tfRegion fRegionIs(tfloat x, tfloat y, tfloat xl, tfloat yl) { tfRegion r; r.X = x; r.Y = y; r.XL = xl; r.YL = yl; return r; }
inline tRegion RegionFull() { return RegionIs(0, 0, DrawXSZ - 1, DrawYSZ - 1); }
inline tRegion RegionOculusLeft() { return RegionIs(0, 0, DrawXSZ / 2 - 1, DrawYSZ - 1); }
inline tRegion RegionOculusRight() { return RegionIs(DrawXSZ / 2, 0, DrawXSZ - 1, DrawYSZ - 1); }

inline tRegion RegionCenterIs(int xr, int yr)
{ 
  int x2 = (DrawXR - xr) / 2, y2 = (DrawYR - yr) / 2; 
  return RegionIs(x2, y2, DrawXL - x2, DrawYL - y2);
}

inline tfRegion fRegionCenterIs(tfloat xr, tfloat yr)
{ 
  tfloat x2 = (DrawXR - xr) / 2, y2 = (DrawYR - yr) / 2; 
  return fRegionIs(x2, y2, DrawXL - x2, DrawYL - y2);
}

inline void RegionCenterGet(tRegion r, int *xc, int *yc) { *xc = (r.X + r.XL) / 2; *yc = (r.Y + r.YL) / 2; }
inline void fRegionCenterGet(tfRegion r, tfloat *xc, tfloat *yc) { *xc = (r.X + r.XL) / 2; *yc = (r.Y + r.YL) / 2; }
inline tfRegion RegionTofRegion(tRegion r) {  return fRegionIs(r.X, r.Y, r.XL, r.YL); }
inline tRegion fRegionToRegion(tfRegion r) {  return RegionIs(r.X, r.Y, r.XL, r.YL); }

inline tRegion RegionValidIs(int x, int y, int xl, int yl)
{ 
  tRegion r;
  if (xl > x) { r.X = x; r.XL = xl; } else { r.X = xl; r.XL = x; }
  if (yl > y) { r.Y = y; r.YL = yl; } else { r.Y = yl; r.YL = y; }        
  return r;
}

inline tfRegion RegionValidIs(tfloat x, tfloat y, tfloat xl, tfloat yl)
{ 
  tfRegion r;
  if (xl > x) { r.X = x; r.XL = xl; } else { r.X = xl; r.XL = x; }
  if (yl > y) { r.Y = y; r.YL = yl; } else { r.Y = yl; r.YL = y; }        
  return r;
}

inline tRegion RegionValidIs(tRegion r)
{ 
  tRegion vr;
  if (r.XL > r.X) { vr.X = r.X; vr.XL = r.XL; } else { vr.X = r.XL; vr.XL = r.X; }
  if (r.YL > r.Y) { vr.Y = r.Y; vr.YL = r.YL; } else { vr.Y = r.YL; vr.YL = r.Y; }        
  return vr;
}

inline int RegionValid(tRegion r) { return (r.X <= r.XL) && (r.Y <= r.YL); }
inline int RegionXValid(tRegion r) { return (r.X <= r.XL); }
inline int RegionYValid(tRegion r) { return (r.Y <= r.YL); }

inline int RegionsIdentical(tRegion r1, tRegion r2) { return (r1.X == r2.X) && (r1.Y == r2.Y) && (r1.XL == r2.XL) && (r1.YL == r2.YL); }

inline tfRegion RegionValidIs(tfRegion r)
{ 
  tfRegion vr;
  if (r.XL > r.X) { vr.X = r.X; vr.XL = r.XL; } else { vr.X = r.XL; vr.XL = r.X; }
  if (r.YL > r.Y) { vr.Y = r.Y; vr.YL = r.YL; } else { vr.Y = r.YL; vr.YL = r.Y; }        
  return vr;
}

inline tRegion RegionShift(tRegion r, int xs, int ys, int xls, int yls) { r.X += xs; r.Y += ys; r.XL += xls; r.YL += yls; return r; }
inline tfRegion RegionShift(tfRegion r, tfloat xs, tfloat ys, tfloat xls, tfloat yls) { r.X += xs; r.Y += ys; r.XL += xls; r.YL += yls; return r; }
inline tRegion RegionShift(tRegion r, int xs, int ys) { r.X += xs; r.Y += ys; r.XL += xs; r.YL += ys; return r; }
inline tfRegion RegionShift(tfRegion r, tfloat xs, tfloat ys) { r.X += xs; r.Y += ys; r.XL += xs; r.YL += ys; return r; }

inline tRegion RegionCrop(tRegion r, int xs, int ys = -1234567)
{ 
  if (ys == -1234567) ys = xs;
  r.X += xs; r.Y += ys; r.XL -= xs; r.YL -= ys; return r;
}

inline int RegionIn(int x, int y, tRegion r) { return ((x >= r.X) && (x <= r.XL) && (y >= r.Y) && (y <= r.YL)); } 

inline tRegion RegionClip(tRegion r, tRegion rc)
{ 
  if (r.X < rc.X) r.X = rc.X; if (r.XL > rc.XL) r.XL = rc.XL;
  if (r.Y < rc.Y) r.Y = rc.Y; if (r.YL > rc.YL) r.YL = rc.YL;
  return r; 
}

inline tfRegion RegionClip(tfRegion r, tfRegion rc)
{ 
  if (r.X < rc.X) r.X = rc.X; if (r.XL > rc.XL) r.XL = rc.XL;
  if (r.Y < rc.Y) r.Y = rc.Y; if (r.YL > rc.YL) r.YL = rc.YL;
  return r; 
}

inline void DrawRegionClip(tRegion &r)
{ 
  if (r.X < 0) r.X = 0; if (r.XL > DrawXL) r.XL = DrawXL;
  if (r.Y < 0) r.Y = 0; if (r.YL > DrawYL) r.YL = DrawYL;
}

inline unsigned DrawRegionClipSZ(tRegion &r)
{ 
  if (r.X < 0) r.X = 0; if (r.XL > DrawXL) r.XL = DrawXL;
  if (r.Y < 0) r.Y = 0; if (r.YL > DrawYL) r.YL = DrawYL;
  return (r.XL - r.X + 1);
}

inline void DrawRegionClipSZ(tRegion &r, unsigned &xsz, unsigned &ysz)
{ 
  if (r.X < 0) r.X = 0; if (r.XL > DrawXL) r.XL = DrawXL;
  if (r.Y < 0) r.Y = 0; if (r.YL > DrawYL) r.YL = DrawYL;
  xsz = (r.XL - r.X + 1); ysz = (r.YL - r.Y + 1);
}

inline void DrawRegionClip(tfRegion &r)
{ 
  if (r.X < 0) r.X = 0; if (r.XL > DrawXL) r.XL = DrawXL;
  if (r.Y < 0) r.Y = 0; if (r.YL > DrawYL) r.YL = DrawYL;
}

inline unsigned RegionSize(tRegion r) { return ((r.XL - r.X + 1) * (r.YL - r.Y + 1)) << 2; }
inline unsigned RegionXSize(tRegion r) { return (r.XL - r.X + 1); }
inline unsigned RegionYSize(tRegion r) { return (r.YL - r.Y + 1); }

inline void RegionAlign8(tRegion &r) //    ""  32 -  8 
                                     // 32 -        16 - .. 4 
{
  r.X = r.X & 0xfffffff8; r.Y = r.Y & 0xfffffff8;
  r.XL = ((r.XL + 1) & 0xfffffff8) - 1; r.YL = ((r.YL + 1) & 0xfffffff8) - 1;
}

inline int RegionMouseIn(tRegion r)
{
  return ((II.Mouse.X <= DrawRegion.X + r.XL) && (II.Mouse.X >= DrawRegion.X + r.X) &&
         (II.Mouse.Y <= DrawRegion.Y + r.YL) && (II.Mouse.Y >= DrawRegion.Y + r.Y));
}

inline int XMouseIn(int x, int xl)
{
  return ((II.Mouse.X <= DrawRegion.X + xl) && (II.Mouse.X >= DrawRegion.X + x));
}

inline int YMouseIn(int y, int yl)
{
  return ((II.Mouse.Y <= DrawRegion.Y + yl) && (II.Mouse.Y >= DrawRegion.Y + y));
}

inline void DrawRegionImageClip(tRegion &r, dwRGB **bits, unsigned &xbsz, unsigned &xsz, unsigned &ysz, int linesz = -1) 
{ 
  unsigned offsx = 0, offsy = 0;
  if (linesz == -1) xbsz = (r.XL - r.X + 1); else xbsz = linesz;
  if (r.X < 0) { offsx = -r.X; r.X = 0; }
  if (r.XL > DrawXL) r.XL = DrawXL;
  xsz = (r.XL - r.X + 1);
  if (r.Y < 0) { offsy = -r.Y; r.Y = 0; }
  if (r.YL > DrawYL) r.YL = DrawYL;
  ysz = (r.YL - r.Y + 1);
  *bits += offsy * xbsz + offsx; 
}

inline int DrawOut(int x, int y) { return (((unsigned)x > DrawXL) || ((unsigned)y > DrawYL)); }
inline int fDrawOut(tfloat x, tfloat y) { return ((x < -0.5) || (x > fDrawXL) || (y < -0.5) || (y > fDrawYL)); }
inline int DrawOut(int x, int y, int r) { return (((x + r) < 0) || ((x - r) > DrawXL) || ((y + r) < 0) || ((y - r) > DrawYL)); }
inline int fDrawOut(tfloat x, tfloat y, tfloat r) { return (((x + r) < -0.5) || ((x - r) > fDrawXL) || ((y + r) < -0.5) || ((y - r) > fDrawYL)); }
inline int DrawOut(int x1, int y1, int x2, int y2)
{ 
  cSwap(x1, x2); cSwap(y1, y2); return (((x2) < 0) || ((x1) > DrawXL) || ((y2) < 0) || ((y1) > DrawYL));
}
inline int fDrawOut(tfloat x1, tfloat y1, tfloat x2, tfloat y2)
{ 
  cSwap(x1, x2); cSwap(y1, y2); return (((x2) < -0.5) || ((x1) > fDrawXL) || ((y2) < -0.5) || ((y1) > fDrawYL));
}
inline int DrawOut(int x1, int y1, int x2, int y2, int r)
{ 
  cSwap(x1, x2); cSwap(y1, y2); return (((x2 + r) < 0) || ((x1 - r) > DrawXL) || ((y2 + r) < 0) || ((y1 - r) > DrawYL));
}
inline int fDrawOut(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat r)
{ 
  cSwap(x1, x2); cSwap(y1, y2); return (((x2 + r) < -0.5) || ((x1 - r) > fDrawXL) || ((y2 + r) < -0.5) || ((y1 - r) > fDrawYL));
}
inline int DrawOut(int x1, int y1, int x2, int y2, int r1, int r2)
{ 
  if ((min(x1 - r1, x2 - r2) > DrawXL) || (max(x1 + r1, x2 + r2) < 0) ||  
     (min(y1 - r1, y2 - r2) > DrawYL) || (max(y1 + r1, y2 + r2) < 0)) return Yes;
  return no; 
}
inline int fDrawOut(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat r1, tfloat r2)
{ 
  if ((min(x1 - r1, x2 - r2) > fDrawXL) || (max(x1 + r1, x2 + r2) < -0.5) ||  
     (min(y1 - r1, y2 - r2) > fDrawYL) || (max(y1 + r1, y2 + r2) < -0.5)) return Yes;
  return no; 
}
inline int DrawOut(tRegion r)
{ 
  cSwap(r.X, r.XL); cSwap(r.Y, r.YL); return (((r.XL) < 0) || ((r.X) > DrawXL) || ((r.YL) < 0) || ((r.Y) > DrawYL));
}
inline int fDrawOut(tfRegion r)
{ 
  cSwap(r.X, r.XL); cSwap(r.Y, r.YL); return (((r.XL) < -0.5) || ((r.X) > fDrawXL) || ((r.YL) < -0.5) || ((r.Y) > fDrawYL));
}
inline int DrawOutVR(tRegion r)
{ 
  return (((r.XL) < 0) || ((r.X) > DrawXL) || ((r.YL) < 0) || ((r.Y) > DrawYL));
}
inline int fDrawOutVR(tfRegion r)
{ 
  return (((r.XL) < -0.5) || ((r.X) > fDrawXL) || ((r.YL) < -0.5) || ((r.Y) > fDrawYL));
}


//////////////////////////////////////////////////////////////////////////////
extern int DrawYrevert;
//inline dwRGB *DrawNearPtr() {if (DrawYrevert) return DrawYptr[DrawYL]; else return DrawYptr[0]; }; 
//inline dwRGB *DrawFarPtr() {if (DrawYrevert) return DrawYptr[0]; else return DrawYptr[DrawYL] + DrawXL; }; 

extern void (*EDrawReplace)(); //         ,   DrawRegion
                               //        
extern int DrawReplace;        //        DrawRegionSet 
                               // ,   DrawRegionSet   Yes;
void DrawRegionSet(tRegion r = DrawRegion, int align8 = no, int yr = DrawYrevert);

//////////////////////////////////////////////////////////////////////////////
void DrawFROMconv(int x, int y, int xr, int yr, unsigned das, int &px, int &py, int &pxl, int &pyl, int pixSize, int pixSpace);
     //  ,    ,      .        , 0  1 -  (.. )
void DrawFROMconv(int x, int y, unsigned das, int &px, int &py);
     //  .

//////////////////////////////////////////////////////////////////////////////
//  
void DrawImageGet(dwRGB_arr *bits, tRegion r = RegionIs(-1,0,0,0)); //     
                                                                    //     -  .
                                                                    //      - ..    
void DrawImagePut(dwRGB_arr *bits, tRegion r = RegionIs(-1,0,0,0)); //     

////////////////////////////////////////////////////////////////////////////
//    
// ,       

//  DrawPoint-
void DrawPoint_PUT(dwRGB *dest, dwRGB color);
void DrawPoint_PUTALPHA(dwRGB *dest, dwRGB color);
void DrawPoint_PUTALPHASP(dwRGB *dest, dwRGB color, unsigned alphasp);
                          //        |alpha|-
                          //    | a = ALPHAsp((color >> 24) & 0xff) |  
unsigned ALPHAsp(unsigned alpha);
void DrawPoint_ADD(dwRGB *dest, dwRGB color);
void DrawPoint_SUB(dwRGB *dest, dwRGB color);
void DrawPoint_AVR(dwRGB *dest, dwRGB color);
void DrawPoint_AVRSOFT(dwRGB *dest, dwRGB color);
void DrawPoint_AVRHARD(dwRGB *dest, dwRGB color);
void DrawPoint_MUL(dwRGB *dest, dwRGB color);
void DrawPoint_IMUL(dwRGB *dest, dwRGB color);

//  
void DrawHLine(dwRGB *dest, dwRGB c, unsigned sz, int mode = modePUT);       // sz -   
void DrawVLine(dwRGB *dest, dwRGB c, unsigned vsz, int mode = modePUT);  
void DrawImage(dwRGB *dest, dwRGB *source, unsigned sz, int mode = modePUT); //    , ..   .

//  DrawPoint(DrawPointPtr(x,y), RGBis(255,125,0), modeADD) 
void DrawPoint(dwRGB *dest, dwRGB c, int mode = modePUT);
void DrawFill(dwRGB c, int mode = modePUT);

//  
void DrawRect(tRegion r, dwRGB c, int mode = modePUT);
void DrawCircle(int cx, int cy, tfloat rad, dwRGB color, int mode = modePUT);
void DrawImage(tRegion r, dwRGB *bits, int mode = modePUT, int linesz = -1);

////////////////////////////////////////////////////////////////////////////
//     
void DrawRect(tfRegion r, dwRGB c, int mode = modePUT);
void DrawImage(tfRegion fr, tRegion r, dwRGB *bits, int mode = modePUT);

///////////////////////////////////////////////////////////////////////////
// 
void DrawFalloff(int foff); // |foff = 0|  ,     DrawClear(). 

///////////////////////////////////////////////////////////////////////////
extern void (*EDrawClear)();     //   () ,   -  () DrawClear();
extern int (*DrawClearReason)(); //   
extern void (*DrawOverdraw)();   //    DrawPaint 
extern int DrawRepaint;          //  (    ). 
void DrawClearBorder(int force = no);  //  ,    force    
extern int DrawClearForce;       //    ... 
void DrawClear();

extern int FC_DrawPaint;         //  fps   DrawPaint
void FC_Prepare();
void FC_FpsHold();

inline void DrawPaint()
{  
  if (FC_DrawPaint) { FC_FpsHold(); FC_Prepare(); };
  if (DrawRepaint && DrawPaintTrue) { DCPaint(0, 0, DrawXSZ, DrawYSZ); DrawRepaint = no; 
                                    } else if (DrawPaintTrue) DCPaint(DrawRegion.X, DrawRegion.Y, DrawXR, DrawYR); //???
};

int DrawOtherMonitor();       //      .    
////////////////////////////////////////////////////////////////////////////
extern void (*EScreenLoadDraw)();          //     
void ScreenLoadDraw();
void ScreenLoadWait();
extern int ScreenLoadTime;    //    -    .
extern int ScreenLoadTimerID; 

////////////////////////////////////////////////////////////////////////////
//    - Half Resolution Imitation
//     DrawDownSize; 
                           
#define HRIdouble 0   //HRI   DrawHRImode:      .
#define HRIscopeDR 1
#define HRIscopeUR 2
#define HRIscopeDL 3
#define HRIscopeUL 4

#define HRIscope4 1
#define HRIscope8 2

extern int DrawHRIactive;  //  .
extern int DrawHRIexist;   // , .. , ..     DrawHRIswitch ();  DrawHRIorder = Yes;
extern int DrawHRIorder;   //        
extern int DrawHRImode;    //  HRI . .
extern int DrawMultiscope; //  

void DrawHRIpaint(); //      ,      .
void DrawHRIon();    //   ,    DrawHRIorder = Yes;    .
                     //     
void DrawHRIoff();   // , ..    ;
void DrawHRIreset(); // ,        - .
void DrawHRIdone();  // 

extern int DrawHRIbreak;    //   HRI  -     DrawHRIorder  No
extern int (*DrawHRItransitReason)(); //   ,                                       
////////////////////////////////////////////////////////////////////////////
///// preFilters ///////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
//   ,    .
extern int FLT_GhostEffect;       // = effNO, effEXPONENT, effSEXPONENT ...
extern int FLT_GhostMode;         //  ,  

void preFLT_Ghost();              //  
/*
extern int FLT_Memory             // 
extern int FLT_MemoryFrames;      // 
extern int FLT_MemoryCFrame;      //  
extern int FLT_MemoryMode;        //  

void postFLT_Memory();
/**/
////////////////////////////
/*   
extern int FLT_BlurMode;
extern int FLT_BlurRadius;

void FLT_Blur(); //  
/**/                  
////////////////////////////
//  ""   
void FLT_Done(); //   .

//////////////////////////////////////////////////////////////////////////////
// Save Regions -     .

class cRegionStore
{ public:
  cQAllocator Store;
  tRegion Region[256];
  dwRGB_arr *Bits[256];
  unsigned Last;
  
  cRegionStore() { Last = 0; };
  void Reset() { Last = 0; Store.Reset(); };
  int Save(tRegion r)
  { if (Last >= 256) return no;
    DrawRegionClip(r);
    if (!RegionValid(r)) return Yes;
    Bits[Last] = (dwRGB_arr *)Store.GetAutoExpand(RegionSize(r),(void *)&Bits);
    Region[Last] = r;
    DrawImageGet((dwRGB_arr *)Bits[Last],r);
    Last++; 
    return Yes;
  }
  int Restore(int all = Yes) //   
  { if (!Last) return No;
    if (all) { while (Last) { Last--; DrawImage(Region[Last],(dwRGB *)Bits[Last]); };
               Store.Reset();
             } else { Last--; DrawImage(Region[Last],(dwRGB *)Bits[Last]);
                      if (!Last) Store.Reset();   
                    }  
    return Yes; 
  }   
  void DrawLast() { DrawImage(Region[Last - 1],(dwRGB *)Bits[Last - 1]); }           
  protected:
  unsigned sBits;
};
        
extern cRegionStore DrawRegionStore;

//////////////////////////////////////////////////////////////////////////////
/////////////////////// Sprite Out Support Object ////////////////////////////
extern tRegion SPRregion;  //        .

inline void SPRregionReset() //  
{ 
  SPRregion.X = DrawXR; SPRregion.Y = DrawYR; SPRregion.XL = 0; SPRregion.YL = 0;
}

inline void SPRregionUpdate(tRegion r)
{
  if (r.X < SPRregion.X) SPRregion.X = r.X;
  if (r.Y < SPRregion.Y) SPRregion.Y = r.Y;
  if (r.XL > SPRregion.XL) SPRregion.XL = r.XL;
  if (r.YL > SPRregion.YL) SPRregion.YL = r.YL;
}

///////////////////////////////////////////////////////////////////////////////
//   -    ,       
//        16 (4  )
extern unsigned DrawLCACHElines;

void DrawLCACHEstart(int linecount = 4);     //  -     ,   256
dwRGB *DrawLCACHEget(dwRGB *putback = NULL); //         
                                             //   |putback|,       
void DrawLCACHEfinal();                      // 
void DrawLCACHEdone();                       //  

///////////////////////////////////////////////////////////////////////////////
extern dwRGB DrawRastrColor;           //  , ..   .,   = 255,255,255
extern int DrawRastrColorJitter;       //   , 0 -  
extern int DrawRastrColorJitterMono;   //   , Yes -  

void DrawRastr(int x, int y, unsigned mode, int xr, int yr, dwRGB_arr *bits, int pixSize, int pixSpace);

///////////////////////////////////////////////////////////////////////////////
extern dwRGB SPRforceColor;     //          ""  ""
extern int SPRforceMode;        //   . 
extern int SPRerrorReport;
extern int SPRpixSize;          //  ,    , 0  ,   : 1,3,5...
extern int SPRpixSpace;         //   , 0  .
extern int SPRpixShift;         //   ,      , 0  .

class BaseSPR                         //  
{ public:
  int XR, YR, Mode, Alpha, pixSize, pixSpace, pixShift;
  tRegion Region;                      //  - Placement
  dwRGB_arr *Bits;
  wchar_t Name[128];      //  .
  int Shift, ShiftAcc, ShiftDir;  //     DrawShifted(),      = shiftX -    X
      
  BaseSPR(wchar_t* name = NULL, wchar_t* name_mask = NULL, int xr = -1, int yr = -1); //    -  .                         
  ~BaseSPR();
       
  void Done();      
  void Draw(unsigned das = 0xffffffff);
  void DrawShifted(unsigned das = 0xffffffff);
  int Load(wchar_t* name, wchar_t* name_mask = NULL, int xr = -1, int yr = -1); //    ,    
  int LoadData(void *p, int xr, int yr);     // ""       
  int LoadDraw(tRegion r);                   // ""    
  void Place(int x = 0, int y = 0, unsigned das = modePUT | fromUL);
  dwRGB GetColor(int x, int y); //  , xres, yres -   
  int MouseIn();
  void Flip(int dir = alongX);
};

inline BaseSPR *SPRcopy(BaseSPR *src)
{ 
  BaseSPR *dest = (BaseSPR *)malloc(sizeof(BaseSPR));
  memcpy(dest,src,sizeof(BaseSPR));
  return dest;
}

class ChangeSPR                         //   
{ public:
  int MouseIn, Change, Click;
  BaseSPR *SprOut, *SprIn;
      
  ChangeSPR(wchar_t* name_out = NULL, wchar_t* name_in = NULL)
  { MouseIn = -1;  Click = Change = 0; SprOut = SprIn = NULL;
    SprOut = new BaseSPR(name_out); SprIn = new BaseSPR(name_in);
  }                           
  ~ChangeSPR() { Done(); }
  void Done() { SprOut->Done(); SprIn->Done(); SprOut = SprIn = NULL; MouseIn = -1;  Click = Change = 0; }      
  void SetClick() { Click = MouseIn; }
  void DrawClick() { if (Click) SprIn->Draw(); else SprOut->Draw(); Click = Click ^ 1; }
  void Draw(int force = no) { if (force || Change || (SprOut->MouseIn() != MouseIn)) { MouseIn = SprIn->MouseIn(); if (MouseIn && !Click) SprIn->Draw(); else SprOut->Draw(); } }
  int Load(wchar_t* name_out, wchar_t* name_in) { return (SprOut->Load(name_out) && SprIn->Load(name_in)); }
  void Place(int x = 0, int y = 0, unsigned das = modePUT | fromUL) { SprOut->Place(x,y,das); SprIn->Place(x, y, das); }
};

//////////////////////////////////////////////////////////////////////////////
//         
extern BaseSPR BImage;
extern int Draw_BImageBlend; //    0..255
extern int Draw_BImageUse;   //     
extern int Draw_BImageStart; //   
extern wchar_t Draw_BImagePath[1024]; // ( )   
//extern int Draw_BImageMode;  //  ,   

inline dwRGB Draw_BImageColor(dwRGB r, int x, int y)
{
  if (Draw_BImageBlend == 255) return BImage.GetColor(x, y);
  else return RGBblend(r, BImage.GetColor(x,y), Draw_BImageBlend);
}

inline int Draw_BImageLoad(wchar_t *name)
{
  int i = BImage.Load(name, NULL, DrawXR, DrawYR);
  BImage.Place(0, 0, modePUT);
  wcscpy(Draw_BImagePath, name);
  return Draw_BImageUse = i;
}

inline void Draw_BImageReLoad() { Draw_BImageLoad(Draw_BImagePath); }
inline void Draw_BImageDone() { BImage.Done(); Draw_BImageUse = off; }
inline void Draw_BImage() { BImage.Draw(); }
    
////////////////////////////////////////////////////////////////    
class NumsSPR         //     
{ public:
  int XR, YR, XRD, YRD, Mode;
  tRegion Region;
  unsigned Digits;
  BaseSPR *Nums;
    
  NumsSPR(wchar_t* name, wchar_t* name_mask = NULL);                          
  ~NumsSPR(); 
  void Load(wchar_t* name, wchar_t* name_mask = NULL);
  void SetDigits(unsigned digits);                                    
  void Draw(unsigned num);
  void Place(int x = 0, int y = 0, unsigned das = modePUT | fromUL);
};

inline NumsSPR *NSPRcopy(NumsSPR *src)
{ 
  NumsSPR *dest = (NumsSPR *)malloc(sizeof(NumsSPR));
  memcpy(dest, src, sizeof(NumsSPR));
  return dest;
}

////////////////////////////////////////////////////////////////    
class TextSPR         //    ,  ee 256  
{ public:
  int XR, YR, XRD, YRD, Mode;
  int LineCount, LineSpace, CharSpace; //     .
  tRegion Region;
  char *Text; 
  int Space[256];
  int LineWide[256];
  BaseSPR *TSpr;
      
  //void (*EDrawBefore)(tRegion r); //      
    
  TextSPR(wchar_t* name, wchar_t* name_mask = NULL);                          
  ~TextSPR(); 
  void Load(wchar_t* name, wchar_t* name_mask = NULL);
  void Place(int x = 0, int y = 0, unsigned das = modePUT | fromUL, char *text = NULL);
  void SetText(char *text);
  void Draw();
      
  protected:
  int PX, PY;
  void SizeCalc();
};

inline TextSPR *TSPRcopy(TextSPR *src)
{ 
  TextSPR *dest = (TextSPR *)malloc(sizeof(TextSPR));
  memcpy(dest,src,sizeof(TextSPR));
  return dest;
}
        
////////////////////////////////////////////////////////////////////////////////    
//  -        ,    256;
class TileSPR          
{ public:
  int XR, YR, XRD, YRD, Mode;  //  ,   .
  tRegion Region;              //  - Placement
  unsigned Items;
  unsigned DefaultSpace;       //   ,    0
  BaseSPR *Sprite[256];
  unsigned Space[256];

  void (*EDrawBefore)(tRegion r); //      

  TileSPR (wchar_t* name = NULL, unsigned space = -1); //       
  ~TileSPR (); 
  int AddWm(wchar_t* name = NULL, wchar_t* name_mask = NULL, unsigned space = -1); //      c space
  int Add(wchar_t* name = NULL, unsigned space = -1);  //      c space
  void Clear();                   //   .
  void Draw(int i = -1);          // i -      i;  - .
  void Place(int x = 0, int y = 0, unsigned das = modePUT | fromUL | alignL | arrangeUD);
  int getNum(wchar_t* name);      //      - name,   -1 -   .
  void Draw(wchar_t* name);       //    .
  
  protected:
  int PX, PY;
  void SizeCalc();
};    

////////////////////////////////////////////////////////////////////////////////    
//  -  ,    256;
class LayerSPR          
{ public:
  int Items;            //  
  tfloat scaleX,scaleY; //  
  tRegion Region;       //   (     ,      )
  BaseSPR *Sprite[256];
  
  LayerSPR(int x = 0, int y = 0, int xr = DrawXR, int yr = DrawYR, int sourcexr = -1, int sourceyr = -1, int mode = fromCC); //     -    
  ~LayerSPR(); 
  void Place(int x = 0, int y = 0, int xr = DrawXR, int yr = DrawYR, int sourcexr = -1, int sourceyr = -1, int mode = fromCC);
  void SetShiftDir(int shiftdir = -1); //       (     );
                                       //     -      
  int AddWm(wchar_t* name, wchar_t* name_mask, int place, int shift, int mode = modePUT + arrangeDU); //      c space
                                       //       place  mode
                                       //     -  
                                       // mode -   - arrangeDU, arrangeUD, arrangeLR, arrangeRL  
  int Add(wchar_t* name, int place, int shift, int mode = modePUT + fromDC);  //      c space
  void Clear();              //   .
  void Draw(int i = -1);     // i -      i;  - .
};

////////////////////////////////////////////////////////////////////////////////    
//  -     ,   256;
struct thispritem
{ wchar_t *Name;
  BaseSPR *Text, *dText; 
  int X,Y,         //  
  Button,      // OnOff  ,   -  -  .
  Delimiter,   // 
  Active;      // 
  int (*funcDepend)();   //        Active 
  WPARAM bKey, mKey, rKey, pKey;  //     ; 
};

extern thispritem *imItem;

class IMouseSPR          
{ public:
  int XS, XR, YR, XRD, YRD, Mode, MouseIn, ClickNow, IX, IY, IYL, IndShift;
  WPARAM Key;
  int Items;       //  
  tRegion Region,  //   (     ,      )
          iRegion; //    
  BaseSPR *MRP, *dMRP;
  BaseSPR *MP, *dMP;
  int mX, mXL, rX, rXL, pX, pXL; //  x -   
  BaseSPR *Button, *dButton;
  TextSPR *Text;
  thispritem *Item[256];
  unsigned Space[256];
  unsigned DefaultSpace;    //   ,    0

  int fromText;   //    ,  = 1, iAdd  fAdd       

  void (*EDrawBefore)(tRegion r); //      

  void (*EDrawChanges)(int x, int y1, int y2, int d);

  IMouseSPR(wchar_t* mrp = L"i_mnrspl", wchar_t* mp = L"i_mnpl", wchar_t* button = L"i_button", wchar_t* text = L"font_en");
  ~IMouseSPR(); 
  void Place(int x = 0, int y = 0, unsigned das = modeADD | fromCR);
  int addValue(wchar_t* name, int mkey, int rkey, int pkey, int (*depend)() = NULL, unsigned space = -1);  
  int addButton(wchar_t* name, int bkey, int (*depend)() = NULL, unsigned space = -1);
  int addDelimiter(unsigned space = -1);
  void Clear();               // .
  void Draw();               
  int LBDown();
  int LBUp();
  int RBDown();
  int RBUp();

  protected:
  int PX, PY;
  void SizeCalc();
  void DrawDelimiter(thispritem *sp);
  void DrawButton(thispritem *sp);
  void DrawValue(thispritem *sp);
  void IndSet(int y, int yl);
};
/**/
////////////////////////////////////////////////////////////////////////
//  ,     
class BaseGRD                               //  
{ public:
  int Size;
  dwRGB_arr *Bits;
  dwRGB Color; //         .

  BaseGRD(wchar_t* name = L"");                          
  ~BaseGRD(); 
      
  void Draw(int x = 0, int y = 0, int xl = 0, int yl = 0); //     -    .
                                                           //     ,       
  int Load(wchar_t* name);
  int LoadData(void *p, int size); // ""         
  int Make(dwRGB c1, dwRGB c2, unsigned size = 2, tfloat low = 0);
  dwRGB getColor(int y, int yr); //       y,   "" - yr   
};

////////////////////////////////////////////////////////////////////////////
//    TGA:  - ...////////////////////
////////////////////////////////////////////////////////////////////////////
void TGAsaveStart(wchar_t *path, int xr, int yr);
void TGAsaveLine(dwRGB *lp);
void TGAsaveFinish();

int TGAloadStart(wchar_t *path, int &xr, int &yr);
dwRGB *TGAloadLine();
void TGAloadFinish();

////////////////////////////////////////////////////////////////////////////
////////// Flip control ////////////////////////////////////////////////////
extern int FC_Stop;     //  

void FC_Prepare();      //   -   ()
void FC_Reset();
extern int FC_Time;     //   
extern int FC_TimeFree; //  ,   FC_Wait
int FC_Wait(int = 30);  // ,       fps-
                        //    FC_Prepare  FC_Shot - ,
                        //     FC_Stop = no
                       
//   FPS-,   ,      
extern int FC_Fps;      // () Fps
extern int FC_FpsMin;   //  Fps
extern int FC_FpsMax;   //  Fps
extern int FC_FpsReal;
extern int FC_HQ; 
extern int FC_VSync;
extern int FC_VSyncTime;

extern int    FC_CPUlock;
extern tfloat FC_CPUlevel;
extern tfloat FC_CPUlevelUp;    // 0.5 .. 0.85         
extern tfloat FC_CPUload;

extern void (*EFC_CPUreload)(int lock); //     ,  
                                        //        
                                        // lock = no ,   
                                        // ( ,    , )
                                        // lock = yes,   (). 

void FC_FpsHold(); //  Fps   FC_Fps   -
                   //   FC_Prepare,    , 
                   // FC_Prepare();
                   // Render()
                   // FC_FpsHold();
                   //       FC_FpsSet(...)
void FC_FpsSet(int fps = AUTO, void (*efunc)(int) = NULL);
                   //   FPS    - CPU

void FC_FpsChange(int fps); //   FPS

////////////////////////////////////////////////////////////////////////////
extern int DrawRecord; //    . . GDIbitmapSAVE
extern int DrawShot;   //  

extern unsigned DrawRecordCount;

////////////////////////////////////////////////////////////////////////////
int DrawBitsToClipboard(dwRGB *bits = (dwRGB *)DrawPTRnear, int xr = DrawXR, int yr = DrawYR, int loffs = abs(DrawLOFFS));

////////////////////////////////////////////////////////////////////////////
//    ...   
#define NonZero 0
#define EvenOdd 1

struct tPolyRotate { tfloat CX, CY, Angle; };
extern tPolyRotate DPRotate;
extern int DPRotateDo;

inline void DPRconv(tfloat &x, tfloat &y) { if (DPRotateDo) Rotate(DPRotate.CX, DPRotate.CY, DPRotate.Angle, x, y); }

void DrawPolyRotate(tfloat cx, tfloat cy, tfloat angle);
void DrawPolyRotateNo();

void DrawPolyComplex(int t = EvenOdd); //   ,    DrawPoly(...),
                                       //  (DrawPoly) -     
                                       //   -  ...    
void DrawPolyFill(int t = EvenOdd);
void DrawPolyFillNonZero();
void DrawPolyFillEvenOdd();
void DrawPolyFillRestore();

void DrawPolyNew();
void DrawPolyTo(tfloat x, tfloat y);
void DrawPolyMoveTo(tfloat x, tfloat y);
void DrawPolyLineTo(tfloat x, tfloat y);
void DrawPoly(dwRGB c, int mode = modePUT);

////////////////////////////////////////////////////////////////////////////
#define typePARABOLA 0
#define typeCIRCLE   1
#define typeHHERMIT  2

extern int fDrawCurve;
inline void fDrawCurveSet(int type) { fDrawCurve = type; }

int getCircSegs(tfloat r);
int getDxDy(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat &dx, tfloat &dy);
int getDxDy(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat &dx, tfloat &dy, tfloat &d);

struct tf4 { tfloat v[4]; };
inline tf4 f4Is(tfloat v0, tfloat v1, tfloat v2, tfloat v3) { tf4 f; f.v[0] = v0; f.v[1] = v1; f.v[2] = v2; f.v[3] = v3; return f; }

void fDrawEllipse(tfloat x, tfloat y, tfloat rx, tfloat ry, dwRGB c = 0xffffffff, unsigned m = modePUT);
void fDrawCircle(tfloat x, tfloat y, tfloat r, dwRGB c = 0xffffffff, unsigned m = modePUT);
void fDrawPotato(tfloat x, tfloat y, tfloat r, dwRGB c = 0xffffffff, unsigned m = modePUT,
                 tf4 p = f4Is(fRandom(0.75, 1.25), fRandom(0.75, 1.25), fRandom(0.75, 1.25), fRandom(0.75, 1.25)),
                 tf4 t = f4Is(fRandom(0.15, 0.25), fRandom(0.15, 0.25), fRandom(0.15, 0.25), fRandom(0.15, 0.25)),
                 tfloat a = -1);
void fDrawNGon(tfloat x, tfloat y, tfloat r, int cp, dwRGB c = 0xffffffff, unsigned m = modePUT,
               tfloat p0 = 1, tfloat p1 = 1, tfloat t0 = 0.2, tfloat t1 = 0.2, tfloat rp = 0, tfloat rt = 0,
               tfloat a = -1);
void fDrawRect(tfRegion r, dwRGB c = 0xffffffff, unsigned m = modePUT);
void fDrawRoundRect(tfRegion r, tfloat rad, dwRGB c = 0xffffffff, unsigned m = modePUT);
void fDrawLine(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat w = 1.0, dwRGB c = 0xffffffff, unsigned m = modePUT);
void fDrawRoundLine(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat w = 1.0, dwRGB c = 0xffffffff, unsigned m = modePUT, int r1 = Yes, int r2 = Yes);
void fDrawRay(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat w1, tfloat w2, dwRGB c = 0xffffffff, unsigned m = modePUT);
void fDrawRoundRay(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat w1, tfloat w2, dwRGB c = 0xffffffff, unsigned m = modePUT, int r1 = Yes, int r2 = Yes);

////////////////////////////////////////////////////////////////////////////
//     "" : fDraw...  ..
struct tCurl 
{
  tfloat x, y, w, ew, d, dAngle, rAngle;
  int i, Count, m, Style;
  dwRGB c; 
};

struct tCurlStyle
{
  tfloat wProg, dProg, rProg, sAngle;
  int sCount;
  tfloat (*EWide)(int, int, tfloat);
  void (*EDraw)(int i, int count, tfloat, tfloat, tfloat, tfloat, tfloat, tfloat, dwRGB, unsigned);
};

typedef tCurl tCurl_arr[256]; 
typedef tCurlStyle tCurlStyle_arr[256]; 

extern tCurlStyle *CurlStyle;

class cCurls                                 //  Curls - 
{ public:
  int Items, Size, Last, StyleSize, Recursion, Min;
  tfloat wDiff, wStop, Scale;
  cQQuery Query;
  tCurl_arr *Curl;
  tCurlStyle_arr *Style;
  cCurls(int size = 512, int ssize = 16);
  ~cCurls();
  void SetSize(int size);
  void SetStyleSize(int size);
  void SetStyle(int s = 0, tfloat wP = -1.0, tfloat dP = 0.985, tfloat rP = 1.015, int sC = 1000000, tfloat sA = M_PI / 4);
  void CopyStyle(int from, int to) {(*Style)[to] = (*Style)[from]; };
  void Add(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat w, tfloat a, int count, dwRGB c, int m = modePUT, int s = 0);
  void AddV(tfloat x, tfloat y, tfloat vx, tfloat vy, tfloat w, tfloat a, int count, dwRGB c, int m = modePUT, int s = 0) { Add(x, y, x + vx, y + vy, w, a, count, c, m, s); }
  void Add(tCurl c);
  void Draw(unsigned count = 0xffffffff);     // 0 -      ...
};

////////////////////////////////////////////////////////////////////////////
#endif