//////////////////////////////////////////////////////////////////////////////
//    ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "_DRAW_GPrimitives.h"

//////////////////////////////////////////////////////////////////////////////
typedef tGPRfileData tGPRfileData_arr[1024];
tGPRfileData_arr *GPRdata = NULL;
unsigned GPR_Drawed = 0;
unsigned GPR_Saved = 0;
//////////////////////////////////////////////////////////////////////////////
void GPR_Init(int draw)
{
  GPR_Done(draw); 
  if (draw) Draw3D_Init();
};

//////////////////////////////////////////////////////////////////////////////
void GPR_Done(int draw)
{
  if (draw) Draw3D_Done();
  if (GPRdata) free(GPRdata);
};


//////////////////////////////////////////////////////////////////////////////
//trgb GPR_fogColor, GPR_whiteColor = trgb(1,1,1);
tfloat GPR_Scale;
int GPR_fcR, GPR_fcG, GPR_fcB; 

inline void GPR_FogBlend(int &r, int &g, int &b, int fog)
{
  r = GPR_fcR + (r - GPR_fcR) * fog / 65025;
  g = GPR_fcG + (g - GPR_fcG) * fog / 65025;
  b = GPR_fcB + (b - GPR_fcB) * fog / 65025;
};

inline void GPR_WhiteBlend(int &r, int &g, int &b, int fog)
{
  r = 65025 + (r - 65025) * fog / 65025;
  g = 65025 + (g - 65025) * fog / 65025;
  b = 65025 + (b - 65025) * fog / 65025;
};

inline void GPR_RGBmult(unsigned &r, unsigned &g, unsigned &b, unsigned m)
{
  r = r * m / 65025;
  g = g * m / 65025;
  b = b * m / 65025;
};

inline unsigned to65025(tfloat t) { return t * 65025 + 0.5; };
//////////////////////////////////////////////////////////////////////////////
void GPR_Prepare()
{
  DrawPrepare();
  //GPR_fogColor = trgb((tfloat)sR(VS_CColor) / 255,(tfloat)sG(VS_CColor) / 255,(tfloat)sB(VS_CColor) / 255);
  GPR_fcR = sR(VS_CColor) * 255; GPR_fcG = sG(VS_CColor) * 255; GPR_fcB = sB(VS_CColor) * 255;
  GPR_Scale = DrawScale750 * DrawZoom * 100;
};

//////////////////////////////////////////////////////////////////////////////

void *fnewGPR() { return (void *)new BaseGPR; };
void fdeleteGPR(void *p) { delete(BaseGPR *)p; };

BaseGPR *CGPR = NULL;
int CGPRn; 
WCHAR *CGPRname;
BaseCOARRAY GPR((void **)&CGPR,&CGPRn,&CGPRname,fnewGPR,fdeleteGPR);

//////////////////////////////////////////////////////////////////////////////
void GPR_Copy(unsigned s, unsigned d)
{
  GPR.Current(d);
  *CGPR=* ((BaseGPR *)GPR.Get(s));
};

//////////////////////////////////////////////////////////////////////////////
BaseGPR :: BaseGPR()
{
  ViewAs = vasCIRC + modePUT;
  Mode = modePUT;
  Type = vasCIRC;
  mFog = 1;
  Scale=1;
  Next = valNO;
  DrawUnit = NULL;
};
//////////////////////////////////////////////////////////////////////////////
BaseGPR :: ~BaseGPR()
{ 
};

//////////////////////////////////////////////////////////////////////////////
/*void BaseGPR :: Load(wchar_t * name)
{
};/**/

//////////////////////////////////////////////////////////////////////////////
void BaseGPR :: SetViewAs(unsigned vas, dwRGB color, wchar_t * name)
{
  ViewAs = vas;
  Type = getTYPE(vas);
  Mode = getMODE(vas);
  Color = color;
};

////////////////////////////////////////////////////////////////////////////////////////
int GPRfileWNow = 0; 

int BaseGPR :: Draw(tvect p, tfloat scale, dwRGB color, dwRGB *pcolor, tfloat effect)
{
  tfloat k, ffog, falpha, fall, rad;
  unsigned m = Mode, alpha, r, g, b;
  dwRGB c;
  p.z += DrawCenter.z;
  if (p.z < DrawPlaneClip) return DrawDeepSort; //  ,      
  if (Draw_BImageUse) 
  { k = DrawPspK(p.z) * DrawZoom; 
    p.x = ((p.x + DrawStereoOffs) * k + DrawCenter.x) * DrawScale750 + DrawXC;
    p.y = (p.y * k + DrawCenter.y) * DrawScale750 + DrawYC;
    rad = k * Scale * scale * DrawScale750 * 100; if (rad < DrawLimit) rad = DrawLimit;
    *pcolor = color = Draw_BImageColor(color, p.x, p.y);
    alpha = to255(DrawIntensity);
    if ((m <= modePUTALPHA) || (m >= modeAVR)) m += (alpha != 255);
    if (DrawUnit) DrawUnit(p, rad, ALPHAset(RGBmult(color,Color), alpha), m);
    else DrawCircle(p.x + 0.5, p.y + 0.5, rad, ALPHAset(RGBmult(color,Color), alpha), m);
    return 0;  
  };
  if ((effect < 0.001) || !(alpha = RGBalpha(Color) * RGBalpha(color))) return 0;
  falpha = (tfloat)alpha / 65025 * effect * fDrawNearFadefor (p.z);
  ffog = floatClose(fDrawFogfor (p.z) / mFog, 1);
  if ((fall = falpha * ffog * DrawIntensity) < 0.0001) return 0;
  k = DrawPspK(p.z) * DrawZoom; 
  p.x = ((p.x + DrawStereoOffs) * k + DrawCenter.x) * DrawScale750 + DrawXC;
  p.y = (p.y * k + DrawCenter.y) * DrawScale750 + DrawYC;
  rad = k * Scale * scale * DrawScale750 * 100; if (rad < DrawLimit) rad = DrawLimit;
  r = sR(Color) * sR(color); g = sG(Color) * sG(color); b = sB(Color) * sB(color); 
  if ((m <= modePUTALPHA) || (m >= modeAVR))
  { alpha = to255(falpha * DrawIntensity); m += (alpha != 255);
    GPR_FogBlend((int &)r,(int &)g,(int &)b, to65025(ffog)); 
  } else { if (m <= modeSUB) GPR_RGBmult(r, g, b, to65025(fall));
           else GPR_WhiteBlend((int &)r,(int &)g,(int &)b, to65025(fall));
           alpha = 255;
         };
  if (DrawUnit) DrawUnit(p, rad, ALPHAset(RGBis(r / 255, g / 255, b / 255), alpha), m);
  else DrawCircle(p.x + 0.5, p.y + 0.5, rad, ALPHAset(RGBis(r / 255, g / 255, b / 255), alpha), m);
  GPR_Drawed++;
  return 0;
}; /**/

////////////////////////////////////////////////////////////////////////////////////////
int BaseGPR :: Save(tvect p, tfloat scale, dwRGB color, dwRGB *pcolor, tfloat effect)
{
  tfloat k, ffog, falpha, fall, rad, x, y, dl = DrawLimit * 0.333;
  unsigned m = Mode, alpha, r, g, b;
  dwRGB c;
  if (!GPRfileWNow) return 0;
  p.z += DrawCenter.z; if (p.z < DrawPlaneClip) return DrawDeepSort;
  if (!(alpha = RGBalpha(Color) * RGBalpha(color)) || (effect == 0)) return 0;
  falpha = (tfloat)alpha / 65025 * effect * fDrawNearFadefor (p.z);
  ffog = floatClose(fDrawFogfor (p.z) / mFog, 1);
  if ((fall = falpha * ffog) * DrawIntensity < 0.0001) return 0;
  k = DrawPspK(p.z) * DrawZoom; 
  x = (p.x * k + DrawCenter.x) * DrawScale750 + DrawXC;
  y = (p.y * k + DrawCenter.y) * DrawScale750 + DrawYC;
  rad = k * Scale * scale * DrawScale750 * 100; if (rad < dl) rad = dl;
  r = sR(Color) * sR(color); g = sG(Color) * sG(color); b = sB(Color) * sB(color); 
  if ((m <= modePUTALPHA) || (m >= modeAVR)) { GPR_FogBlend((int &)r,(int &)g,(int &)b, to65025(ffog)); fall = falpha; };
  GPRfileWrite(x, y, rad, r, g, b, to65025(fall), m);
  GPR_Saved++;
  return 0;
}; /**/

//////////////////////////////////////////////////////////////////////////////
//     ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void GPRfileWStart()
{
  GPRdata = (tGPRfileData_arr *)GetMemAutoIncrease((char *)GPRdata, GPR_Drawed * sizeof(tGPRfileData));
  GPR_Saved = 0;
  GPRfileWNow = Yes;
};

//////////////////////////////////////////////////////////////////////////////
void GPRfileWrite(tfloat x, tfloat y, tfloat rad, unsigned r, unsigned g, unsigned b, unsigned a, unsigned m)
{
  tGPRfileData *d = &((*GPRdata)[GPR_Saved]);
  d->X = x; d->Y = y; d->Rad = rad;
  d->cR = r; d->cG = g; d->cB = b; d->cA = a;
  d->Mode = m;
};

//////////////////////////////////////////////////////////////////////////////
void GPRfileWFinish(wchar_t *path)
{
  tGPRfileHeader h;
  h.XR = DrawXR; h.YR = DrawYR;
  h.DrawHRImode = DrawHRImode;
  h.DrawMultiscope = DrawMultiscope;
  h.FLT_GhostEffect = FLT_GhostEffect;
  h.FLT_GhostMode = FLT_GhostMode;
  h.Items = GPR_Drawed;
  h.Color = VS_CColor;
  h.DrawIntensity = DrawIntensity;
  FileWOpen(path);
  FileWrite((char *)&h, sizeof(h));
  FileWrite((char *)GPRdata, GPR_Drawed * sizeof(tGPRfileData));
  FileClose();
  GPRfileWNow = no;
};

//////////////////////////////////////////////////////////////////////////////