 // File _WIN.h

////////////////////////////////////////////////////////////////////////////////
#ifndef __WINTO__
#define __WINTO__

////////////////////////////////////////////////////////////////////////////////
#include "_RGB.h"
#include "_MEM.h"

////////////////////////////////////////////////////////////////////////////////
extern int IU_Items;                        // ,          
extern tintORunsigned IU_Array[256];        //  ,          .        

inline void iPush(int &i, int newi) { IU_Array[IU_Items].i = i; i = newi; IU_Items++; }
inline void iPull(int &i) { IU_Items--; i = IU_Array[IU_Items].i; }

inline void uPush(unsigned &u, unsigned newu) { IU_Array[IU_Items].u = u; u = newu; IU_Items++; }
inline void uPull(unsigned &u) { IU_Items--; u = IU_Array[IU_Items].u; }

inline void i64Push(_int64 &i, _int64 newi) { IU_Array[IU_Items].i64 = i; i = newi; IU_Items++; }
inline void i64Pull(_int64 &i) { IU_Items--; i = IU_Array[IU_Items].i64; }

void EmpyVoid();
int EmpyInt();

////////////////////////////////////////////////////////////////////////////////
//   /////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
#define _Esc_ 0x1B  
#define _Enter_ 0x0D                           
#define _Space_ 0x20                          

#define _F1_ 0x70 
#define _F2_ 0x71
#define _F3_ 0x72 
#define _F4_ 0x73
#define _F5_ 0x74 
#define _F6_ 0x75
#define _F7_ 0x76 
#define _F8_ 0x77
#define _F9_ 0x78 
#define _F10_ 0x79
#define _F11_ 0x7A 
#define _F12_ 0x7B

#define _Plus_ 0xBB 
#define _Minus_ 0xBD

#define _EPlus_ 0x6B 
#define _EMinus_ 0x6D

#define _Shift_ 0x10
#define _Ctrl_ 0x11
#define _Alt_ 0x12
#define _Break_ 0x13

#define _Tab_ 0x09
#define _Backspace_ 0x08
#define _Del_ 0x2E
#define _Ins_ 0x2D

#define _PageUp_ 0x21
#define _PageDown_ 0x22
#define _End_ 0x23
#define _Home_ 0x24
#define _ScrollLock_ 0x91

#define _CU_ 0x26
#define _CD_ 0x28
#define _CL_ 0x25
#define _CR_ 0x27 

#define _NCU_ 104
#define _NCD_ 98
#define _NCL_ 100
#define _NCR_ 102 

#define _0_ 0x30  
#define _1_ 0x31 
#define _2_ 0x32
#define _3_ 0x33 
#define _4_ 0x34
#define _5_ 0x35 
#define _6_ 0x36
#define _7_ 0x37 
#define _8_ 0x38
#define _9_ 0x39 

#define _A_ 0x41  
#define _B_ 0x42
#define _C_ 0x43
#define _D_ 0x44 
#define _E_ 0x45
#define _F_ 0x46 
#define _G_ 0x47
#define _H_ 0x48 
#define _I_ 0x49
#define _J_ 0x4A 
#define _K_ 0x4B  
#define _L_ 0x4C
#define _M_ 0x4D
#define _N_ 0x4E 
#define _O_ 0x4F
#define _P_ 0x50 
#define _Q_ 0x51
#define _R_ 0x52 
#define _S_ 0x53
#define _T_ 0x54 
#define _U_ 0x55  
#define _V_ 0x56
#define _W_ 0x57
#define _X_ 0x58 
#define _Y_ 0x59
#define _Z_ 0x5A  

#define _Colon_ 0xba  
#define _Quote_ 0xde  
#define _LCorner_ 0xbc
#define _RCorner_ 0xbe
#define _LBracket_ 0xdb
#define _RBracket_ 0xdd
#define _Slash_ 0xbf
#define _BSlash_ 0xdc

////////////////////////////////////////////////////////////////////////////////
//         //////////////////////////
////////////////////////////////////////////////////////////////////////////////
extern int IIMouseHold;
int IR_RecordKey(WPARAM key, int reg); 

struct tMouseMove
{ 
  int X, Y, DX, DY;
};

struct tMouseInfo
{ 
  int Down, Up, DClick, Move; 
  int LB, MB, RB, Wheel;
  int X, Y, DX, DY;
  tMouseMove MoveStore[256];
  int LastStore, AutoStore;
};

struct tCachBlocked
{ 
  WPARAM key; 
  int reg;
}; 

void KeyEmptyExt(unsigned key);

class cInputInfo 
{ 
  public:
  tMouseInfo Mouse;
  int KeyCode;
  int KeyUp[256];
  int KeyDown[256];
  int AnyKeyUp;
  int AnyKeyDown;
  int AnyKeyAsync;
  int AsyncOrder;               //   
  int AnyKey;
  int AsyncKey[256];            //   
  int ShiftCtrlAltResetKeyDown; //  ?
  int Block;                    //  
  int BlockAfterRecord;         //      ( Reset),    Cach
  tCachBlocked Cach[256];       //   32 
  int CachID;  
  void (*KeyDownExt)(unsigned);        //         
  void (*KeyUpExt)(unsigned);                
  
  void ResetMouse()
  { Mouse.Down = Mouse.Up = Mouse.Move = Mouse.LB = Mouse.MB = Mouse.RB = Mouse.Wheel = 0;
    Mouse.LastStore = -1;
    Mouse.AutoStore = Yes;
  }
  void ResetKeyUp() { ZeroMemory(&KeyUp,sizeof(KeyUp)); AnyKey = AnyKeyUp = no; }
  void ResetAsyncKey() { AnyKeyAsync = no; ZeroMemory(&AsyncKey,sizeof(AsyncKey)); }
  int KeyShift() { return KeyDown[_Shift_]; }
  int KeyCtrl() { return KeyDown[_Ctrl_]; }
  int KeyAlt() { return KeyDown[_Alt_]; }
  void AsyncKeyRequest()
  { 
    if (AsyncOrder)
     for (int i = 0; i < 256; i++)
      if (AsyncKey[i]) if (GetAsyncKeyState(i)) KeyDownSet(i,Yes); else if (KeyDown[i]) KeyUpSet(i,Yes);
  }
  void ResetKeyDown()
  { 
    for (int i = 0; i < 16; i++) if (!AsyncKey[i]) KeyDown[i] = 0;
    if (ShiftCtrlAltResetKeyDown) ResetShiftCtrlAltKeyDown(); 
    for (int i = 20; i < 256; i++) if (!AsyncKey[i]) KeyDown[i] = 0;
  }
  void ResetKeys() { ResetKeyUp(); ResetKeyDown(); };
  void ResetShiftCtrlAltKeyDown() { for (int i = 16; i < 20; i++) KeyDown[i] = 0; }
  void Reset()
  { 
    ResetMouse();
    ResetKeyUp(); ResetKeyDown(); Block = No;
    if (BlockAfterRecord)
    { if (CachID) { CachID--; if (Cach[CachID].reg) KeyUpSet(Cach[CachID].key); else KeyDownSet(Cach[CachID].key); }  
    } else CachID = 0; 
  }
  cInputInfo()
  { 
    KeyCode = 0; CachID = 0; Block = no; BlockAfterRecord = no; AsyncOrder = Yes;
    ShiftCtrlAltResetKeyDown = Yes;
    ResetAsyncKey(); Reset();
    ShiftCtrlAltResetKeyDown = no;
    KeyDownExt = KeyUpExt = KeyEmptyExt;
  }
  void MouseMoveStore()
  {
    tMouseMove mm;
    mm.X = Mouse.X;   mm.Y = Mouse.Y;
    mm.DX = Mouse.DX; mm.DY = Mouse.DY;
    Mouse.MoveStore[Mouse.LastStore = (Mouse.LastStore + 1) % 256] = mm;
  }
  void MouseMove(int x, int y) 
  { 
    Mouse.DX = x - Mouse.X; Mouse.DY = y - Mouse.Y;
    Mouse.Move = (Mouse.DX || Mouse.DY);
    Mouse.X = x; Mouse.Y = y;
    if (Mouse.AutoStore) MouseMoveStore();
  }
  void RecordKey(WPARAM key, int reg) { if (IR_RecordKey(key, reg)) Block = BlockAfterRecord; } 
  void CachKey(WPARAM key, int reg)
  { 
    if (!BlockAfterRecord) return;
    if (CachID < 256) { Cach[CachID].key = key; Cach[CachID].reg = reg; CachID++; }
  }
  void KeyUpSet(WPARAM key, int async = 0)
  { key &= 255; if (!key) return;
    if (Block) { CachKey(key, 1); return; };
    if (async || !AsyncKey[key])
    { KeyCode = key; KeyUp[key] = AnyKeyUp = AnyKey = Yes; KeyDown[key] = No; KeyDown[key] = No;
      KeyUpExt(key);
      RecordKey(key, Yes); AnyKeyAsync += async;
    }
  }
  void KeyDownSet(WPARAM key, int async = 0)
  { key &= 255; if (!key) return;
    if (!KeyDown[key])
    { if (Block) { CachKey(key,0); return; };
      if (async || !AsyncKey[key])
      { KeyCode = key; KeyDown[key] = AnyKeyDown = AnyKey = Yes;
        KeyDownExt(key); 
        RecordKey(key, no); AnyKeyAsync -= async;
      }  
    }
  }
  int getKeyUp(int key) { int k = KeyUp[key & 255]; KeyUp[key & 255] = 0; return k; }
  int getKeyDown(int key) { int k = KeyDown[key & 255]; KeyDown[key & 255] = 0; return k; }
};
extern cInputInfo II;
extern int MouseShowCursor;     //       ,       
extern int MouseShowCursorTime; //       ,  MouseShowCursor = no 
extern int MouseShowCursorNow;  //   ""      
extern int MouseShowCursorForce;//   

///////////////////////////////////////////////////////////////////////////////
#define NormalPriority  0
#define HighPriority 1
#define CriticalPriority 2

extern HINSTANCE hInst;
extern HDC hBaseDC;
extern HDC hMemDC;
extern HWND hMainWindow;
extern ATOM rMainWindow;
extern HBITMAP hImage;
extern HBITMAP hOldImage;
extern dwRGB_arr *ImageBits;
extern BITMAPINFOHEADER bmiHeader;

extern int ProcessPriority;

extern char ProgramName[256];     //  ( ) 
extern wchar_t ProgramNameW[256]; //  ( ) 
extern wchar_t *ProgramPathW;     //  ( )

extern int CanCloseApp;
extern int ScreenSaverCheck;
extern int ScreenSaver;
extern wchar_t * ScreenSaverMessage;         //   
extern wchar_t * ScreenSaverTitle;           // 
extern wchar_t * ScreenSaverPreviewText;     //   .
extern void (*EScreenSaverPreviewDraw)();  //       
extern RECT ScreenSaverRECT;
extern int ScreenSaverIs;                  //    .
extern void (*ScreenSaverParametersWindow)(); //       
extern void (*ScreenSaverProcess)();       //     
extern int ScreenSaverParametersWindowXR;
extern int ScreenSaverParametersWindowYR;
extern int ScreenSaverTitleAsNameProgram;

#define msgAsk(message, title) MessageBox(hMainWindow, message, title, MB_YESNO) 
#define msgErr(message, title) MessageBox(hMainWindow, message, title, MB_ICONERROR|MB_OK) 
#define msgInf(message, title) MessageBox(hMainWindow, message, title, MB_OK | MB_ICONHAND)
#define msgFrom(message, title) MessageBox(hMainWindow, message, title, MB_OK)
#define msgMain(message) MessageBox(hMainWindow, message, WinName, MB_OK) 

extern LPCWSTR WinName;  // Name Window
extern int WinNameLikeProgramName;

extern void (*ProcessFunc)();
extern int UserCursor;
//////////////////////////////////////////////////////////////////////////////
int GetWinVersion();

//////////////////////////////////////////////////////////////
#define TimersCount 256                //   
extern int Timer[TimersCount];         //  if (Timer[7]) -  ... :  
                                       //     ,     ,   
                                       //  11111110000000011111111000000 
extern int TimerAutoStop[TimersCount]; //  ;
extern void *TimerEFunc[TimersCount];  //      . 
                                       //      .
                                       //   .
extern int TimerLock[TimersCount];     //    .
                                       //     -   TimerLock[my_id_timer] = no;
inline int getFreeTimer(int up)        //   ,  up = Yes -  .   -                   
{
  if (up) { for (int i = (TimersCount - 1); i >= 0; i--) if (!TimerLock[i]) {TimerLock[i] = Yes; return i;}
          } else for (int i = 0; i < TimersCount; i++) if (!TimerLock[i]) {TimerLock[i] = Yes; return i; }
  return -1;
}

inline void TimerEFuncSet(int i, void (*func)()) //   ,       . 
{
  TimerEFunc[i] = (void *)func;
}

//////////////////////////////////
inline void TimerRun(int id_timer, int time_int, int astop = Yes, void (*func)() = NULL) //  0..255,    .
{                                                                                         //     .
  SetTimer(hMainWindow, 1347 + id_timer, time_int, NULL); Timer[id_timer] = Yes; TimerAutoStop[id_timer] = astop;
  if (func) TimerEFunc[id_timer] = (void *)func;
}

//////////////////////////////////
inline void TimerStop(int id_timer)              // ,  0..255.
{
  KillTimer(hMainWindow,1347 + id_timer);
  Timer[id_timer] ^= Timer[id_timer]; 
}

//////////////////////////////////////////////////////////////
inline wchar_t *char2wchar(char *c, wchar_t *wc) //    ,   
{
  int zc;
  for (int i = 0; i <= strlen(c); i++) { zc = wc[i] = c[i]; if (!zc) return wc; };
  return NULL;
}

//////////////////////////////////////////////////////////////
inline char *wchar2char(wchar_t *wc, char *c) //    ,   
{
  int zc;
  for (int i = 0; i <= wcslen(wc); i++) { zc = c[i] = wc[i]; if (!zc) return c; }
  return NULL;
}

//////////////////////////////////////////////////////////////
extern WPARAM WParam;
extern LPARAM LParam;
extern unsigned MouseX, MouseY;

extern void (*OnClipboard)();
extern void (*OnCreate)();
extern void (*OnAfterCreate)();
extern void (*OnDestroy)();
extern void (*OnKeyDown)();
extern void (*OnKeyUp)();
extern void (*OnCopy)();
extern void (*OnPaste)();
extern void (*OnMouseMove)();
extern void (*OnMouseWheel)();
extern void (*OnMouseLButtonUp)();
extern void (*OnMouseLButtonDClick)();
extern void (*OnMouseLButtonDown)();
extern void (*OnMouseMButtonUp)();
extern void (*OnMouseMButtonDClick)();
extern void (*OnMouseMButtonDown)();
extern void (*OnMouseRButtonUp)();
extern void (*OnMouseRButtonDClick)();
extern void (*OnMouseRButtonDown)();
extern void (*OnRegister)();
extern void (*OnPaint)();

extern int ClipboardView;  //     . 

inline int OnClipboardDo(void (*func)()) { return (int)(OnClipboard = func); }
inline int OnCreateDo(void (*func)()) { return (int)(OnCreate = func); }
inline int OnAfterCreateDo(void (*func)()) { return (int)(OnAfterCreate = func); }
inline int OnDestroyDo(void (*func)()) { return (int)(OnDestroy = func); }
inline int OnKeyDownDo(void (*func)()) { return (int)(OnKeyDown = func); }
inline int OnKeyUpDo(void (*func)()) { return (int)(OnKeyUp = func); }
inline int OnCopyDo(void (*func)()) { return (int)(OnCopy = func); }
inline int OnPasteDo(void (*func)()) { return (int)(OnPaste = func); }
inline int OnMouseMoveDo(void (*func)()) { return (int)(OnMouseMove = func); }
inline int OnMouseWheelDo(void (*func)()) { return (int)(OnMouseMove = func); }
inline int OnMouseLButtonUpDo(void (*func)()) { return (int)(OnMouseLButtonUp = func); }
inline int OnMouseLButtonDClickDo(void (*func)()) { return (int)(OnMouseLButtonDClick = func); }
inline int OnMouseLButtonDownDo(void (*func)()) { return (int)(OnMouseLButtonDown = func); }
inline int OnMouseMButtonUpDo(void (*func)()) { return (int)(OnMouseMButtonUp = func); }
inline int OnMouseMButtonDClickDo(void (*func)()) { return (int)(OnMouseMButtonDClick = func); }
inline int OnMouseMButtonDownDo(void (*func)()) { return (int)(OnMouseMButtonDown = func); }
inline int OnMouseRButtonUpDo(void (*func)()) { return (int)(OnMouseRButtonUp = func); }
inline int OnMouseRButtonDClickDo(void (*func)()) { return (int)(OnMouseRButtonDClick = func); }
inline int OnMouseRButtonDownDo(void (*func)()) { return (int)(OnMouseRButtonDown = func); }
inline int OnRegisterDo(void (*func)()) { return (int)(OnRegister = func); }
inline int OnPaintDo(void (*func)()) { return (int)(OnPaint = func); }

//////////////////////////////////////////////////////////////
extern DWORD WindowStyle;     //  
extern int MainWindowCreated; //  
int WINAPI WinMain(HINSTANCE hThisInst, HINSTANCE hPrevInst, LPSTR lpszArgs, int nWinMode);
LRESULT CALLBACK WindowFunc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK DialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
DWORD ProcessThread(LPVOID param);

void KillProcessThread(void);
void RunProcessThread(void);
void HaltError(wchar_t * errm);
void CloseProcess();
int CloseOldWindow(); //   ()      

//////////////////////////////////////////////////////////////////////////////
int InitDCDraw();   
void DoneDCDraw();

extern int OtherMonitor;
int TryOtherMonitorOutput();
extern int MonitorFQ[16];
extern int MonitorCount;
int GetMonitorFq(int n = OtherMonitor);

inline void WaitMainWindowCreate() { while (!MainWindowCreated) Sleep(10); }

//////////////////////////////////////////////////////////////////////////////
//  

class cMDialog 
{ 
  public:
  void (*EMenu)();
  void (*EMouseLBUp)();
  int Close;
  
  cMDialog(void (*emenu)() = NULL, void (*emlbup)() = NULL) { EMenu = emenu; EMouseLBUp = emlbup; Close = no; }

  void Activate()
  { mMove = OnMouseMove;
    mLBDown = OnMouseLButtonDown;
    mLBUp = OnMouseLButtonUp;
    mRBDown = OnMouseRButtonDown;
    mRBUp = OnMouseRButtonUp;
    kDown = OnKeyDown;
    kUp = OnKeyUp;
    OnMouseMove = NULL;
    OnMouseLButtonDown = NULL;
    OnMouseLButtonUp = EMouseLBUp;
    OnMouseRButtonDown = NULL;
    OnMouseRButtonUp = NULL;
    OnKeyDown = NULL;
    OnKeyUp = NULL;
    if (EMenu) EMenu();
    II.ResetKeys();
    while (!II.KeyUp[_Esc_] && !Close) Sleep(200);
    II.ResetKeys();
    OnMouseMove = mMove;
    OnMouseLButtonDown = mLBDown;
    OnMouseLButtonUp = mLBUp;
    OnMouseRButtonDown = mRBDown;
    OnMouseRButtonUp = mRBUp;
    OnKeyDown = kDown;
    OnKeyUp = kUp;
    Close = no;
  }

  protected:
  void (*mMove)(),(*mLBDown)(),(*mLBUp)(),(*mRBDown)(),(*mRBUp)(),
       (*kDown)(),(*kUp)();
};

//////////////////////////////////////////////////////////////////////////////
extern int VS_FullScreen;
extern int VS_X;                    //  X
extern int VS_Y;                    // Y
extern dwRGB VS_BColor;              //  ,  
extern dwRGB VS_CColor;              //     

//////////////////////////////////////////////////////////////////////////////
extern int DCwait;

inline void DCPaint(int x = 0, int y = 0, int xw = VS_X, int yh = VS_Y)
{ 
  BitBlt(hBaseDC, x, y, xw, yh, hMemDC, x, y, SRCCOPY);
  //SetDIBitsToDevice(hBaseDC, x, y, xw, yh, x, y, 0, xw, ImageBits,(BITMAPINFO *)&bmiHeader, 0);
}
inline void DCRepaint() { InvalidateRect(hMainWindow, NULL, 1); }

//////////////////////////////////////////////////////////////////////////////
inline void DCClear()
{
  dwMemSetA16((DWORD *)ImageBits,VS_CColor, VS_Y * VS_X << 2);
}

/////////////////////////////////////////
#define NullHalt(p)((p == NULL) ? HaltError(L"Out of memory") : 1)

///////////////////////////////////////
extern int MemAutoIncreaseSize;

char *GetMemAutoIncrease(char *ptr_old, unsigned size, unsigned aiseg = 4096, unsigned size_old = 0);
                                             //    
                                             // ptr_old - , size -    
                                             //     , ..    
                                             //       
                                             //         
void *GetMem(unsigned count, int clear = 0);
void FreeMem(void  *p);
void *GetMemAlign(unsigned count, unsigned align = 16, int clear = 0); 
                                             //     align
                                             //   clear   
                                             //   clear =  255,     .
unsigned GetMemAlignSize(void *ptr);
void FreeMemAlign(void  *p);

void *GetLMem(unsigned count, int clear = 0);
void FreeLMem(void  *p);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//    (   )  p -   NULL  . //
//  Yes,            . /////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
inline void RemoveMem(void *newp, void *p, void *parr, unsigned items, unsigned last)
{ 
  if (!items || !parr) return; items--;
  tunsigned_arr *ptrs = (tunsigned_arr *)parr; 
  unsigned psize = 0, size; 
  for (int i = 0; i <= items; i++)
  { if (i == items) size = last - ((unsigned)(*ptrs)[items] - (unsigned)p) + 1;
    else size = (unsigned)(*ptrs)[i + 1] - (unsigned)(*ptrs)[i] + 1;
    memmove_s((void *)((unsigned)newp + psize), size, (void *)(*ptrs)[i], size);
    (*ptrs)[i] = ((unsigned)newp + psize); psize += size;
  } 
}

inline int AutoExpandMem(void **p, unsigned &sz_was, unsigned sz_need, int clear = 0, void *parr = NULL, unsigned items = 0, unsigned last = 0) 
{ 
  if (!*p)
  { *p = GetMemAlign(sz_need, 16, clear); sz_was = sz_need; return yes;
  } else if (sz_need > sz_was) { void *pp = *p;
                                 *p = GetMemAlign(sz_need, 16, clear); sz_was = sz_need;
                                 RemoveMem(*p, pp, parr, items, last);
                                 FreeMemAlign(pp);
                                 return yes;
                               } 
  return (sz_was != sz_need);
}

//////////////////////////////////////////////////////////////////////////////////
//      ,  : ///
//       ,    -          ///
//////////////////////////////////////////////////////////////////////////////////
class cQAllocator
{ 
  public:
  unsigned Last, Size, Seg, Items;
  void *Temp;
  cQAllocator(unsigned seg = 655360) { Temp = NULL; Last = 0; SetSize(seg); }
  ~cQAllocator() { FreeMemAlign(Temp); }
  void Reset() { Items = Last = 0; }
  void SetSize(unsigned seg = 655360) { if (Temp) FreeMemAlign(Temp);
                                        Items = Last = 0; Size = seg; Seg = seg; Temp = GetMemAlign(seg);
                                      }
  void *Get(unsigned sz) { unsigned rem = Last; Last += sz; Items++; return (void *)((unsigned)Temp + rem); }
  void *GetAutoExpand(unsigned sz, void *p = NULL)
  { unsigned rem = Last; Last += sz; 
    if (Last > Size) AutoExpandMem(&Temp, Size, Last + Seg, 0, p, Items, rem);
    Items++;
    return (void *)((unsigned)Temp + rem);
  }                   
};

//////////////////////////////////////////////////////////////////////////////////
//                                       ///
//      -                        ///
//////////////////////////////////////////////////////////////////////////////////
class cQQuery
{ 
  public:
  unsigned First, Size;
  tunsigned_arr *Query;
  cQQuery(unsigned size = 512) { Query = NULL; First = 0; SetSize(size); }
  ~cQQuery() { free(Query); }
  void Reset() { First = 0; for (int i = 0; i < Size; i++)(*Query)[i] = i; }
  void SetSize(unsigned size) { if (size == Size) return; if (Query) free(Query); First = 0; Size = size; Query = (tunsigned_arr *)malloc(size * sizeof(unsigned)); Reset(); }
  int Get(unsigned &el) { if (First == Size) return no; else { el = (*Query)[First]; First++; return Yes; } }
  void Return(unsigned el) { if (First) First--; else return;(*Query)[First] = el; }                   
};

//////////////////////////////////////////////////////////////////////////////
//    /////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
int InitTICK();
extern LARGE_INTEGER TICK[128]; //      TICKEXACTUP 
void itk(int);
void atk(int);

//////////////////////////////////////////////////////////////////////////////
int FileExists(WCHAR *name);
void CreateDir(wchar_t * dir);

//////////////////////////////////////////////////////////////////////////////
wchar_t * NameThisProg();

//////////////////////////////////////////////////////////////////////////////
extern WCHAR StrResult[64];
int NumToStr(unsigned n, unsigned digits = 0);   //        
                                                 //    64-,   StrResult  
extern char CharResult[64];
int NumToChar(unsigned n, unsigned digits = 0);  //        

#define StrZero(str)(str[0] = 0)

//////////////////////////////////////////////////////////////////////////////
// :    . ////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
char *ClipboardTextGet();         //     NULL
int ClipboardTextPut(char *text); //     no

///////////////////////////////////////////////////////////////////////////////
//  , ,  ///////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
extern char *KeyUpWord[256];
extern char *KeyDownWord[256];

////////////////////////////////
inline char *GetKeyWord(WPARAM key, int reg)  //     
{                                             // reg = Yes -   ,  "Shift"
  if (reg) return KeyUpWord[key & 255]; else return KeyDownWord[key & 255];
} 

////////////////////////////////
inline WPARAM GetWordKey(char *keyword, int *reg)  //     
                                                   //  reg -  ,  Yes -  
                                                   // no - .
                                                   //   -       . 
                                                   //  - 0    ...
{ 
  if (!keyword) return 0;
  *reg = Yes; for (int i = 0; i < 256; i++) if (KeyUpWord[i]) if (!strcmp(KeyUpWord[i], keyword)) return i;  
  *reg = no; for (int i = 0; i < 256; i++) if (KeyDownWord[i]) if (!strcmp(KeyDownWord[i], keyword)) return i;  
  return 0;
}                

inline WPARAM II_KeySet(WPARAM key, int reg)       //       "" 
{ if (!key) return 0;
  iPush(II.Block,no); iPush(II.BlockAfterRecord, no);
  if (reg) II.KeyUpSet(key, yes); else II.KeyDownSet(key, yes);
  iPull(II.BlockAfterRecord); iPull(II.Block);
  return key;
}

inline WPARAM II_KeyWordSet(char *keyword)         //     
{ int reg = 0, ocr = GetWordKey(keyword, &reg); 
  return II_KeySet(ocr, reg);
}

///////////////////////////////////////////////////////////////////////////////
//     ( ). IR - Input Record. /////
//   () II /////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
extern int IR_Order;          //    .
extern char* IR_Buffer;       //   
extern unsigned IR_Current;   //   
                              // 
extern char *IR_Allow[256];   //      
extern int IR_AllowItems;     //   ""  ;  0 -  .   -  .
extern int IR_PassUse;        //   IR_Pass
extern _int64 IR_Pass;        //   1-,   1     ,
                              //        . 
//////////////////////////////////////
inline void IR_PassInc()      //    ()
{
  if (IR_Order && IR_PassUse) IR_Pass++; 
};

//////////////////////////////////////
void IR_AllowAdd(char *types, ...);    //     -,     ,   "s"
                                        //  IR_AllowAdd("ssss","K","U","Sp","Sp"); -     K  

inline void IR_AllowAdd(char *keyword) //   , : IR_AllowAdd("Sp");                                      
{ 
  IR_Allow[IR_AllowItems] = keyword; IR_AllowItems++;
};

//////////////////////////////////////
int IR_AllowCheck(char *keyword);      //   ,  Yes,  . 

//////////////////////////////////////
extern char IR_Separator;        // ,   -  - 0x20
extern unsigned IR_StrLenght;    //   -  .   - 80,   - .
extern int IR_RecordMade;        //   
extern int IR_ReturnMade;        //    
extern int IR_ReturnRem;         //    .
extern int IR_PassAsyncOnly;     //     ()    
extern int IR_ReturnMake;        //      IR_StrLenght;

//////////////////////////////////////
inline int IR_MadeReset() { int made = IR_RecordMade; IR_RecordMade = no; return made; } //   .

//////////////////////////////////////
int IR_Record(char *keyword);   // ,    
                                 //  "Tb","K",    -   
                                 //   -   "En","e". 
                                 //     .
                                 //  Yes -  () 

//////////////////////////////////////
extern void (*IR_RecordKeyBefore)(int key, int reg); 
extern void (*IR_RecordKeyAfter)(int key, int reg); 

extern int IR_KeyUpAllow[256];   //     
extern int IR_KeyDownAllow[256];

inline void IR_KeyAllowClear() { for (int i = 0; i < 256; i++) { IR_KeyUpAllow[i] = IR_KeyDownAllow[i] = 0; } } 

inline int IR_RecordKey(WPARAM key, int reg)     //     - key
{
  if (!IR_Order) return no;
  if (IR_RecordKeyBefore) IR_RecordKeyBefore(key, reg); 
  if (reg) { if (!IR_KeyUpAllow[key]) return no; } else if (!IR_KeyDownAllow[key]) return no;
  if (IR_PassAsyncOnly && !II.AnyKeyAsync) IR_Pass = 0;
  if (IR_Record(GetKeyWord(key,reg))) { if (IR_RecordKeyAfter) IR_RecordKeyAfter(key, reg); return Yes;
                                      } else return no; 
};
                                    
///////////////////////////////////////////     IR_Allow     
inline int IR_RecordInteger(_int64 num) //  
{ 
  char cnum[65];
  if (!IR_Order) return no;
  iPush(IR_AllowItems ,0); i64Push(IR_Pass, 0);
  IR_Record(_i64toa(num, cnum, 10));
  i64Pull(IR_Pass); iPull(IR_AllowItems);
  return Yes;
}

//////////////////////////////////////
inline int IR_RecordFloat(double num, int digits = 32)   //   
{
  char cnum[65];
  if (!IR_Order) return no;
  int err = _gcvt_s(cnum, 65, num, digits);
  if (!err) { iPush(IR_AllowItems, 0); i64Push(IR_Pass, 0);
              IR_Record(cnum);
              i64Pull(IR_Pass); iPull(IR_AllowItems);
              return Yes;
            } else return no;
}

//////////////////////////////////////
inline int IR_RecordWord(char *word)      //  .
{ 
  if (!IR_Order) return no;
  iPush(IR_AllowItems,0); i64Push(IR_Pass, 0);
  IR_Record(word);
  i64Pull(IR_Pass); iPull(IR_AllowItems); 
  return Yes;
}

//////////////////////////////////////
int IR_RecordReturn();                      //   .
                                 
//////////////////////////////////////
inline void IR_Start(char *chkword = NULL)  //  
{
  IR_Current = IR_ReturnMade = IR_RecordMade = IR_Pass = 0; 
  IR_ReturnRem = IR_StrLenght;
  IR_Order = Yes;
  if (chkword) IR_RecordWord(chkword);
}

//////////////////////////////////////
inline void IR_Stop() { IR_Order = no; }    // 

//////////////////////////////////////
inline int IR_ClipboardPut() { return ClipboardTextPut(IR_Buffer); } //    

///////////////////////////////////////////////////////////////////////////
//  , . IA - Input Analize ////////////////////////////
///////////////////////////////////////////////////////////////////////////
#define readNumber 0        //  
#define readSymbol 1
#define readSpecialSymbol 2
#define readWord 4

//////////////////////////////////////
int IA_ClipboardGet();          //    

extern char *IA_Buffer;         //  -   
                                //   IA_Read, :
extern int IA_Type;             //   
extern unsigned IA_Current;     //    
extern unsigned IA_CurrentBack; //  ,     
                                // IA_Current,     IA_Read();
extern int IA_Count;            //   
extern char *IA_Word;           //    .
extern char IA_Chars[1024];     //  . 
extern char IA_Symbol;          //   
extern _int64 IA_Number;        // 
extern _int64 IA_Integer;       //  
extern double IA_Float;         // 

extern char IA_Separator;       // ,   -  - 0x20
int IA_Read();                  // ,  0    .
inline void IA_Back() { IA_Current = IA_CurrentBack; } //       IA_Read();

inline void IA_Start() { IA_Current = 0; } //  
inline int IA_StartClipboard() { IA_Current = 0; return (int)(IA_Buffer = ClipboardTextGet()); } //       
inline int IA_StartBuffer(char *buff) { IA_Current = 0; return (int)(IA_Buffer = buff); }       //    
inline int IA_WordIs(char *word) { if (!strcmp(IA_Chars, word)) return Yes; else return no; }    //  

///////////////////////////////////////////////////////////////////////////
//   , IP - Input Play,    IA ///
///////////////////////////////////////////////////////////////////////////
extern int IP_AutoRewind;    //  .   = no;
extern int IP_Order;         //    .

//////////////////////////////////////
inline int IP_StartClipboard(char *chkword = NULL)    //   , chkword -        
{
  IP_Order = IA_StartClipboard(); if (IP_Order && chkword) { IA_Read(); IP_Order = IA_WordIs(chkword); }
  return IP_Order; 
}

//////////////////////////////////////
inline int IP_StartBuffer(char *buff, char *chkword = NULL) //    ,       IO_Buffer
{
  IP_Order = IA_StartBuffer(buff); if (IP_Order && chkword) { IA_Read(); IP_Order = IA_WordIs(chkword); } 
  return IP_Order;
}

//////////////////////////////////////
extern int IP_PassUse;            //    .
extern _int64 IP_Pass;            //    Play,       - 
extern WPARAM IP_OCR;             //   --.
extern int IP_StopedNow;          //   .   Yes -       IP_Play,    IP_StopedNow - .

int IP_Play(int resetkyes = Yes); // :    .  ,  
                                  //  ""   IO_Buffer,   .  
                                  //   0 -   :   IA_Buffer
//////////////////////////////////////
inline void IP_PlayStart() { IA_Current = 0; IP_Order = Yes; } //  

//////////////////////////////////////
inline void IP_PlayStop() { IP_Order = no; } // 

////////////////////////////////////////////////////////////////////////////////////
//    IR  IP ///////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
extern int IP_Hide; //    . - ..  .

//////////////////////////////////////
extern char IP_Name[256];
inline int IP_Name_Try()  //   
{ 
  IA_Read();
  if (IA_WordIs("nameIS")) { IA_Read(); strcpy(IP_Name,IA_Word); } else IA_Back();
  return no; 
}

//////////////////////////////////////
extern char IP_Music[1024];
extern int IP_MusicIs;
extern int IP_MusicSend;
extern int IP_MusicStop;

inline void IP_Music_Read()
{ 
  int s = IP_Music[0] = 0;
  while (IA_Buffer[IA_Current] == ' ') IA_Current++;
  while (_strnicmp(&(IA_Buffer[IA_Current]),"randomSEED",10))
  { IP_Music[s] = IA_Buffer[IA_Current];
    s++; IA_Current++;
  }
  s--; IP_Music[s] = 0; s--;
  while (IP_Music[s] == ' ') { IP_Music[s] = 0; s--; }
}

inline int IP_Music_Try()  //   
{ 
  IA_Read();
  IP_MusicSend = IA_WordIs("musicsendIS");
  IP_MusicStop = IA_WordIs("musicstopIS");
  IP_MusicIs = IP_MusicSend || IP_MusicStop || IA_WordIs("musicIS");
  if (!IP_MusicIs) { IA_Back(); return no; } 
  IP_Music_Read(); 
  return no; 
}

//////////////////////////////////////
inline int IP_RandomSeed_Try()  //    RandomSeed
{ 
  IA_Read();
  if (IA_WordIs("randomSEED"))
  { IA_Read(); if (IA_Type == readNumber) { RandomSeed(IA_Number); return Yes; } else { IA_Back(); RandomSeed(); } 
  } else { IA_Back(); RandomSeed(); } 
  return no; 
}

//////////////////////////////////////
inline void IR_LocalStart() //   ,    ,         
{
  IR_Start(); 
  IR_RecordWord("");
  IR_RecordReturn();
  IR_RecordWord(ProgramName);
  IR_RecordWord("randomSEED");
  IR_RecordInteger(RandSeed);
  IR_RecordReturn();
}

//////////////////////////////////////
inline int IR_LocalStop(int cbrdput = Yes) //   ,      
{
  if (IR_Order)
  { IR_RecordReturn();
    IR_RecordWord("");
    IR_RecordReturn();
    IR_Stop(); 
    if (cbrdput) IR_ClipboardPut();
  }
  return 0;
}

//////////////////////////////////////
inline int IP_LocalStart() //   ,      
{
  IP_AutoRewind = IP_Hide = No;
  if (IP_StartClipboard(ProgramName))
  { IP_Name_Try();
    IP_Music_Try(); 
    IP_RandomSeed_Try(); return Yes;     
  } else return no;
}

//////////////////////////////////////
inline int IP_LocalStart(char *buff, unsigned chk = 0xffffffff) 
{
  IP_AutoRewind = IP_Hide = No;
  if (IP_StartBuffer(buff,(char *)((unsigned)ProgramName & chk)))
  { IP_Name_Try();
    IP_Music_Try(); 
    IP_RandomSeed_Try(); return Yes;     
  } else return no;
}

//////////////////////////////////////
inline void IP_IR_LocalStart(int tryplay, int record = !ScreenSaverIs) //    ,       record = Yes
                                                                       //     tryplay
{
  if (!tryplay || !IP_LocalStart()) { RandomSeed(); if (record) IR_LocalStart(); }  
}

//////////////////////////////////////
inline int IP_HideNow() { return (IP_Order && IP_Hide); } //   , .. ,      . 

////////////////////////////////////////////////////////////////////////////////////
//    /////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
extern int CPU_ID;
extern int CPU_MMX;
extern int CPU_SSE;
extern int CPU_SSE2;
extern int CPU_3DNOW;
extern int CPU_Count;
extern _SYSTEM_INFO CPU_Info;

void CPU_FeaturesRequest();

inline int CPU_Single() { return (CPU_Count == 1); }
inline int CPU_Multi() { return (CPU_Count > 1); }

////////////////////////////////////////////////////////////////////////////////////
inline int ExecIndependently(wchar_t *name = ProgramPathW, wchar_t *cmndl = NULL) //   (  )
{
  return (int)ShellExecute(NULL, L"open", name, cmndl, NULL, SW_SHOW) > 32;
}

////////////////////////////////////////////////////////////////////////////////////
inline void ForceActivate(HWND hWnd = hMainWindow)  //  
{
  SetWindowPos(hWnd,HWND_TOP,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
  return; 
}

////////////////////////////////////////////////////////////////////////////////////
extern HMODULE hmCommonResource;

inline void InitCommonResource() { if (!hmCommonResource) hmCommonResource = GetModuleHandle(0); }

inline void LoadCommonResource(wchar_t *dllname, wchar_t *dllnamepath = L"") //    -  ,
                                                                              //  dll-        ,  exe-  
{ 
  if (!(hmCommonResource = LoadLibrary(dllname)))
  if (!(hmCommonResource = LoadLibrary(dllnamepath))) HaltError(L"Common Resource file Not found.   "); 
}

////////////////////////////////////////////////////////////////////////////////////
//   . /////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
extern unsigned SizeOfFile;

unsigned FileSize(wchar_t *path);           
unsigned FileLoad(wchar_t *path, char *buffer, unsigned size = 0);  //  ,  |0|  -   . 
char *FileLoad(wchar_t *path, int memalign = no);                   //    ,  |NULL| -   .
unsigned FileSave(wchar_t *path, char *buffer, unsigned size);      // ,      |0|  ...

extern HANDLE HandleOfFile;

HANDLE FileROpen(wchar_t *path);
HANDLE FileWOpen(wchar_t *path);
unsigned FileWrite(char *buffer, unsigned count); //   
unsigned FileRead(char *buffer, unsigned count);  //   
void FileClose();

//////////////////////////////////////////////////////////////////////////////////////////////
//   ,   CSIDL,  CSIDL_COMMON_STARTUP //
// |path| -  .                                                                 //
//////////////////////////////////////////////////////////////////////////////////////////////
int GetPathSpecial(int csidl,  wchar_t *path);
int PathFileExists(wchar_t *path);

extern wchar_t SOFilePath[2048];
wchar_t *getSavePath(wchar_t *title, wchar_t *ext, wchar_t *extFilter = L"");
wchar_t *getOpenPath(wchar_t *title, wchar_t *extFilter = L"");

//////////////////////////////////////////////////////////////////////////////
//  Ini File Service /////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
extern int iniExist; 

int iniLoad(wchar_t *path = NULL);
int iniGet(int retdef = -123456789);
void iniClear();
void iniPut(int i);
int iniSave();

//////////////////////////////////////////////////////////////////////////////
#endif
