// File _DRAW_2D.cpp
//  2D    DirectX  .  

//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "_DRAW_2D.h"

//////////////////////////////////////////////////////////////////////////////
tfloat DrawScale750 = 1;
tfloat DrawScale = 1;
tfloat DrawYScale = 1;  //        

dwRGB DrawColor = RGBis(255, 255, 255);
int DrawIntensityI = 255;
tfloat DrawIntensity = 1.0;

int DrawOver = Yes,
    DrawOverSafe = Yes;

//dwRGB *ptrRGB;
//dwRGB *endRGB;

int (*DrawClearReason)() = NULL; //   
//////////////////////////////////////////////////////////////////////////////
//unsigned DrawOut = DCOut;
int DrawAAlising = 0;

dwRGB *pRGB;
dwRGB *DrawYptr[MAXresY];
dwRGB_arr *DrawBits = NULL;

//////////////////////////////////////////////////////////////////////////////
void DrawOverdrawNo() {};
void (*DrawOverdraw)() = DrawOverdrawNo;

//////////////////////////////////////////////////////////////////////////////
void (*EScreenLoadDraw)() = NULL;
int ScreenLoadTime = 1000;
int ScreenLoadTimerID = getFreeTimer(Yes);

void ScreenLoadDraw() { if (EScreenLoadDraw) { EScreenLoadDraw(); TimerRun(ScreenLoadTimerID,ScreenLoadTime); } }
void ScreenLoadWait() { if (EScreenLoadDraw) while (Timer[ScreenLoadTimerID]) Sleep(100); }


//////////////////////////////////////////////////////////////////////////////
IDirectDraw* FC_DD = NULL;

int Draw2D_Init()
{
  DoneDCDraw();
  int r;
  if (!(r = InitDCDraw())) return no;
  DrawBits = ImageBits; DrawRegionSet();
  if (EScreenLoadDraw) ScreenLoadDraw(); else DCClear();
  return r;
}

void Draw2D_Done()
{
  DrawLCACHEdone(); 
  FLT_Done();
  DrawHRIdone(); DoneDCDraw(); DrawBits = NULL;
  if (FC_DD) FC_DD->Release();
  FC_DD = NULL;
}

//////////////////////////////////////////////////////////////////////////////
void DrawSet(unsigned fsxres, unsigned yr) //DDremove
{
  if (fsxres == FullScreen)
  { VS_FullScreen = Yes;
    fsxres = GetSystemMetrics(SM_CXSCREEN); yr = GetSystemMetrics(SM_CYSCREEN);
  } else VS_FullScreen = 0;
  int d = fsxres % 8; if (d) fsxres += 8 - d;
  DrawXSZ = VS_X = fsxres;
  DrawYSZ = VS_Y = yr;
  if (DrawBits) { DrawReplace = no; DrawRegionSet(); }
}  

////////////////////////////////////////////////////////////////////////////
int DrawOtherMonitor()
{ 
  if (!TryOtherMonitorOutput()) return no;
  DrawSet(VS_X, VS_Y); return Yes;
}

////////////////////////////////////////////////////////////////////////////
int DrawXR;
int DrawYR;
int DrawXL;
int DrawYL;
int DrawXC;
int DrawYC;
tfloat fDrawXL;
tfloat fDrawYL;
tfloat fDrawXC;
tfloat fDrawYC;
unsigned DrawSZ;
unsigned DrawXSZ;
unsigned DrawYSZ;
int DrawLOFFS;
int DrawXRfull;
int DrawYRfull;
int DrawPaintTrue;
dwRGB *DrawPTRnear;  //       
dwRGB *DrawPTRfar;   //        

tRegion DrawRegion = RegionIs(-1, -1, -1, -1);

////////////////////////////////////////////////////////////////////////////
void DrawScaleSet(tfloat s) { DrawScale = s; DrawScale750 = (tfloat)DrawXR / 750 * DrawScale; }

////////////////////////////////////////////////////////////////////////////
void (*EDrawClear)() = NULL;

////////////////////////////////////////////////////////////////////////////
void (*EDrawReplace)() = NULL;
int DrawYrevert = Yes;
int DrawReplace = Yes;
int DrawAlignX = 1, DrawAlignY = 1;

void DrawRegionSet(tRegion r, int align8, int yr)
{
  if (r.X == -1)
  { int f = 0, xr = DrawXSZ, yr = DrawYSZ;
    if (DrawAlignX > 1) { xr -= xr % DrawAlignX; f = Yes; }
    if (DrawAlignY > 1) { yr -= yr % DrawAlignY; f = Yes; }
    if (f) DrawRegion = RegionIs(DrawXSZ / 2 - xr / 2, DrawYSZ / 2 - yr / 2, DrawXSZ / 2 + xr / 2 - 1, DrawYSZ / 2 + yr / 2 - 1);
    else DrawRegion = RegionIs(0, 0, DrawXSZ - 1, DrawYSZ - 1);
  } else DrawRegion = RegionClip(RegionValidIs(r), RegionIs(0, 0, DrawXSZ - 1, DrawYSZ - 1));
                          
  if (align8) RegionAlign8(DrawRegion);
  DrawXL = DrawRegion.XL - DrawRegion.X; DrawXR = DrawXL + 1; fDrawXL = (tfloat)DrawXL + 0.5;
  DrawYL = DrawRegion.YL - DrawRegion.Y; DrawYR = DrawYL + 1; fDrawYL = (tfloat)DrawYL + 0.5;
  DrawXC = DrawXR / 2; fDrawXC = (tfloat)fDrawXC - 0.5;   
  DrawYC = DrawYR / 2; fDrawYC = (tfloat)fDrawYC - 0.5;
  DrawSZ = DrawXR * DrawYR;
  DrawYrevert = yr;
  DrawLOFFS = (DrawXSZ << 2) * (1 - 2 * DrawYrevert);
  DrawXRfull = (DrawXR == DrawXSZ);
  DrawYRfull = (DrawYR == DrawYSZ);
  DrawPaintTrue = (DrawXSZ == VS_X) && (DrawYSZ == VS_Y);

  dwRGB *start = (dwRGB *)DrawBits;
  if (yr)
  { start += (DrawYSZ - 1) * DrawXSZ - DrawRegion.Y * DrawXSZ + DrawRegion.X;
    for (int i = 0; i <= DrawYL; i++) { DrawYptr[i] = start; start -= DrawXSZ; } 
    DrawPTRnear = DrawYptr[DrawYL]; DrawPTRfar = DrawYptr[0] + DrawXL; 
  }  else { start += DrawRegion.Y * DrawXSZ + DrawRegion.X;
            for (int i = 0; i <= DrawYL; i++) { DrawYptr[i] = start; start += DrawXSZ; }
            DrawPTRnear = DrawYptr[0]; DrawPTRfar = DrawYptr[DrawYL] + DrawXL;  
          }
  DrawScaleSet(DrawScale);
  if (DrawReplace && EDrawReplace) EDrawReplace(); 
  DrawReplace = Yes;      
};

//////////////////////////////////////////////////////////////////////////////
// -   
tdrawdata DrawPort[8] = {0};

void DrawPortSave(int n)
{  
  DrawPortDone(n);
  tdrawdata *dd = &(DrawPort[n]);
  dd->DrawXSZ = DrawXSZ; dd->DrawYSZ = DrawYSZ;
  dd->DrawXL = DrawXL;   dd->DrawYL = DrawYL;
  dd->DrawXR = DrawXR;   dd->DrawYR = DrawYR;
  dd->DrawXC = DrawXC;   dd->DrawYC = DrawYC;
  dd->DrawSZ = DrawSZ;
  dd->DrawLOFFS = DrawLOFFS;
  dd->DrawXRfull = DrawXRfull; dd->DrawYRfull = DrawYRfull;
  dd->DrawPaintTrue = DrawPaintTrue;
  dd->DrawPTRnear = DrawPTRnear;
  dd->DrawPTRfar = DrawPTRfar;
  dd->DrawRegion = DrawRegion;
  dd->DrawScale750 = DrawScale750;
  dd->DrawScale = DrawScale;
  dd->DrawBits = DrawBits;
}

//////////////////////////////////////////////////////////////////////////////
int DrawPortLoad(int n)
{
  tdrawdata *dd = &(DrawPort[n]);
  if (!dd->DrawXSZ) return 0; 
  DrawXSZ = dd->DrawXSZ; DrawYSZ = dd->DrawYSZ;
  DrawXL = dd->DrawXL;   DrawYL = dd->DrawYL;
  DrawXR = dd->DrawXR;   DrawYR = dd->DrawYR;
  DrawXC = dd->DrawXC;   DrawYC = dd->DrawYC;
  DrawSZ = dd->DrawSZ;
  DrawLOFFS = dd->DrawLOFFS;
  DrawXRfull = dd->DrawXRfull; DrawYRfull = dd->DrawYRfull;
  DrawPaintTrue = dd->DrawPaintTrue;
  DrawPTRnear = dd->DrawPTRnear;
  DrawPTRfar = dd->DrawPTRfar;
  DrawRegion = dd->DrawRegion;
  DrawScale750 = dd->DrawScale750;
  DrawScale = dd->DrawScale;
  DrawBits = dd->DrawBits;
  DrawRegionSet();
  return 1;
}

//////////////////////////////////////////////////////////////////////////////
void DrawPortMake(int n, int xsz, int ysz, int ns)
{
  if (ns != -1) DrawPortSave(ns);
  DrawPortDone(n);
  DrawXSZ = xsz; DrawYSZ = ysz;
  DrawBits = (dwRGB_arr *)GetMemAlign(DrawXSZ * DrawYSZ * 4);
  DrawRegionSet(RegionIs(-1, 0, 0, 0));
  DrawPortSave(n);
}

//////////////////////////////////////////////////////////////////////////////
int DrawPortApply(int n, int mode) { return 1; }

//////////////////////////////////////////////////////////////////////////////
int DrawPortDone(int n)
{
  tdrawdata *dd = &(DrawPort[n]);
  if (!dd->DrawXSZ) return 0;
  if (ImageBits != dd->DrawBits) FreeMemAlign(dd->DrawBits);
  dd->DrawXSZ = 0;
  return 1;
}

/////////////////////////////////////////////////////////////////////////////
/////////////    - HRI ////////////////////////
struct tHRIdata { tdrawdata FR,HR;
                  dwRGB *FRdrawYptr[MAXresY]; 
                  dwRGB *HRdrawYptr[MAXresY / 2]; 
                };
                
int DrawHRIactive = Off;
int DrawHRIexist = Off;
int DrawHRIorder = no;
int DrawHRImode = HRIdouble;
int DrawMultiscope = no;

tHRIdata HRIdata = {0};

void DrawHRIscope()
{ 
  dwRGB *Hptr, *sHptr, *HptrEnd, *FptrDR, *FptrUR, *FptrDL, *FptrUL;
  dwRGB *sFptrDR, *sFptrUR, *sFptrDL, *sFptrUL;
  unsigned xr = DrawXR, yr = DrawYR, xsz = DrawXSZ, sz2, i1;
  
  int HptrI,HptrIv;
  switch (DrawHRImode)
  { case HRIscopeDR: Hptr = DrawPTRnear; HptrI = 1; HptrIv = 1; break;
    case HRIscopeUR: Hptr = DrawPTRfar - DrawXL; HptrI = 1; HptrIv = -1; break;
    case HRIscopeDL: Hptr = DrawPTRnear + DrawXL; HptrI = -1; HptrIv = 1; break;
    case HRIscopeUL: Hptr = DrawPTRfar; HptrI = -1; HptrIv = -1; break;
    default: Hptr = DrawPTRnear; HptrI = 1; HptrIv = 1;
  }
  sHptr = Hptr;
  
  DrawHRIoff();
  
  sz2 = DrawXSZ >> 1;
  
  FptrDR = DrawPointPtr(xr,yr); FptrUR = DrawPointPtr(xr,yr - 1); cSwap(FptrUR,FptrDR);
  
  sFptrDR = FptrDR; //  DR 
  sFptrUR = FptrUR; //  UR 
  sFptrDL = FptrDL = FptrDR - 1; //  DR 
  sFptrUL = FptrUL = FptrUR - 1; //  UR 
  
  if (yr <= xr)   
  { for (int i = 0; i < yr; i++)
    { Hptr = sHptr + i * xsz * HptrIv;
      HptrEnd = Hptr + xr * HptrI; Hptr += i * HptrI; FptrDR = sFptrDR + i + i * DrawXSZ;
      do { *FptrDR = *Hptr; Hptr += HptrI; FptrDR++; } while (Hptr != HptrEnd);
    }
    for (int i = 0; i < yr - 1; i++)
    { Hptr = sHptr + i * xsz * HptrIv; i1 = i + 1;
      HptrEnd = Hptr + yr * HptrI; Hptr += i1 * HptrI; FptrDR = sFptrDR + i + i1 * DrawXSZ;
      do { *FptrDR = *Hptr; Hptr += HptrI; FptrDR += DrawXSZ; } while (Hptr != HptrEnd);
    }
  } else { for (int i = 0; i < yr; i++)
           { Hptr = sHptr + i * xsz * HptrIv; FptrDR = sFptrDR + i * DrawXSZ; 
             if (i < xr) HptrEnd = Hptr + i * HptrI + 1; else HptrEnd = Hptr + xr * HptrI; 
             do { *FptrDR = *Hptr; Hptr += HptrI; FptrDR++; } while (Hptr != HptrEnd);
           }
           for (int i = 1; i < xr; i++)
           { Hptr = sHptr + i * xsz * HptrIv; FptrDR = sFptrDR + i; HptrEnd = Hptr + i * HptrI; 
             do { *FptrDR = *Hptr; Hptr += HptrI; FptrDR += DrawXSZ; } while (Hptr != HptrEnd);
           } 
         }  
  Hptr = sFptrDR; HptrEnd = Hptr + sz2; FptrDL -= 3; FptrUL -= 3;
  for (int i = 0; i < yr; i++)
  { _asm { mov eax,Hptr
           mov esi,HptrEnd
           mov ebx,FptrUR
           mov ecx,FptrDL
           mov edx,FptrUL
          _loop:
           movaps xmm0,[eax]
           movaps [ebx],xmm0
           pshufd xmm0,xmm0,0x1b// 1b
           movaps [ecx],xmm0
           movaps [edx],xmm0
           add eax,16
           add ebx,16
           sub ecx,16
           sub edx,16
           cmp eax,esi
           jne _loop
           mov Hptr,eax
           mov FptrUR,ebx
           mov FptrDL,ecx
           mov FptrUL,edx
         }
    Hptr += sz2; HptrEnd = Hptr + sz2;
    FptrUR -= sz2 * 3; FptrDL += sz2 * 3; FptrUL -= sz2;  
  }

}/**/

void DrawHRIdouble()
{
  dwRGB *Hptr, *HptrEnd, *HptrLEnd, *Fptr, *FptrLEnd, ysz, xrh, xrf;
  Hptr = DrawPTRnear; HptrLEnd = Hptr + DrawXR; xrh = (DrawXSZ - DrawXR) << 2;
  HptrEnd = Hptr + DrawSZ; ysz = DrawYR; 
  DrawHRIoff();
  Fptr = DrawPTRnear; FptrLEnd = Fptr + DrawXR; xrf = (2 * DrawXSZ - DrawXR) << 2; 
  
  if (DrawXRfull)
   { _asm { mov eax,Hptr
            mov esi,HptrEnd
            mov edx,Fptr
            mov ecx,FptrLEnd
            mov ebx,DrawXSZ
            shl ebx,2 
           _loop:
            movaps xmm1,[eax]
            pshufd xmm0,xmm1,0x50
            movaps [edx],xmm0
            movaps [edx + ebx],xmm0
            add edx,16
            pshufd xmm0,xmm1,0xfa
            movaps [edx],xmm0
            movaps [edx + ebx],xmm0
            add edx,16
            add eax,16
            cmp edx,ecx
            jne _loop
            add edx,ebx
            mov ecx,edx
            add ecx,ebx
            cmp eax,esi
            jne _loop 
          }  
   } else { _asm { mov eax,Hptr
                   mov edx,Fptr
                   mov esi,FptrLEnd
                   mov edi,ysz
                   mov ebx,DrawXSZ
                   shl ebx,2 
                  _loop2:
                   movaps xmm1,[eax]
                   pshufd xmm0,xmm1,0x50
                   movaps [edx],xmm0
                   movaps [edx + ebx],xmm0
                   add edx,16
                   pshufd xmm0,xmm1,0xfa
                   movaps [edx],xmm0
                   movaps [edx + ebx],xmm0
                   add edx,16
                   add eax,16
                   cmp edx,esi
                   jne _loop2
                   add eax,xrh
                   add edx,xrf
                   mov ecx,esi
                   add ecx,ebx
                   add ecx,ebx
                   mov esi,ecx
                   mov ecx,edi
                   dec ecx
                   mov edi,ecx
                   jnz _loop2 
                 }
          }         
    

/*  do { *FptrL1 = *Hptr; FptrL1++; *FptrL1 = *Hptr; FptrL1++; 
       *FptrL2 = *Hptr; FptrL2++; *FptrL2 = *Hptr; FptrL2++;
       if ((unsigned)FptrL1 == (unsigned)FptrEnd) { FptrL1 += DrawXSZ; FptrL2 += DrawXSZ; FptrEnd = FptrL2; };
       Hptr++;
     } while ((unsigned)Hptr != (unsigned)HptrEnd);/**/

}

int DrawHRIbreak = Yes;

void DrawHRItransit()
{
  unsigned hoffs = (DrawXSZ - DrawXR) << 2, hxsz = DrawXSZ << 2;
  unsigned foffs = ((HRIdata.FR.DrawXSZ << 1) - HRIdata.FR.DrawXR) << 2; 
  _asm { mov esi,DrawYR
         mov eax,HRIdata.FR.DrawPTRnear
         mov edx,DrawPTRnear
         mov ecx,DrawXR
         shl ecx,2
         add ecx,edx
         mov ebx,HRIdata.FR.DrawXSZ
         shl ebx,2 
        _loop:
         movaps xmm0,[eax]
         movaps xmm1,[eax + ebx]
         pavgb xmm0,xmm1
         pshufd xmm1,xmm0,0x8
         pshufd xmm0,xmm0,0xD
         pavgb xmm0,xmm1
         movlps [edx],xmm0
         add eax,16
         add edx,8
         cmp edx,ecx
         jne _loop
         add eax,foffs
         add edx,hoffs
          add ecx,hxsz
         dec esi
         jnz _loop 
       }
}
                            
void DrawHRIpaint()
{
  if (!DrawHRIactive) return;
  if (DrawHRImode) DrawHRIscope(); else DrawHRIdouble(); 
}

int (*DrawHRItransitReason)() = NULL;
int DrawHRIorderOld = no; 
dwRGB_arr *DrawHRIbits = NULL;
unsigned DrawHRIsize = 0;

void DrawHRIon()
{
  DrawHRIbreak = no;
  if (DrawHRIorder != DrawHRIorderOld) DrawHRIbreak = Yes; DrawHRIorderOld = DrawHRIorder; 
  if (!DrawHRIorder) { DrawHRIoff(); return; }

  if (DrawHRIactive) return;
  if (DrawHRIexist)
  { DrawXSZ = HRIdata.HR.DrawXSZ; DrawYSZ = HRIdata.HR.DrawYSZ;
    DrawXL = HRIdata.HR.DrawXL;   DrawYL = HRIdata.HR.DrawYL;
    DrawXR = HRIdata.HR.DrawXR;   DrawYR = HRIdata.HR.DrawYR;
    DrawXC = HRIdata.HR.DrawXC;   DrawYC = HRIdata.HR.DrawYC;
    DrawSZ = HRIdata.HR.DrawSZ;
    DrawLOFFS = HRIdata.HR.DrawLOFFS;
    DrawXRfull = HRIdata.HR.DrawXRfull; DrawYRfull = HRIdata.HR.DrawYRfull;
    DrawPaintTrue = HRIdata.HR.DrawPaintTrue;
    DrawPTRnear = HRIdata.HR.DrawPTRnear;
    DrawPTRfar = HRIdata.HR.DrawPTRfar;
    DrawRegion = HRIdata.HR.DrawRegion;
    DrawScale750 = HRIdata.HR.DrawScale750;
    DrawScale = HRIdata.HR.DrawScale;
    DrawBits = HRIdata.HR.DrawBits; 
    memcpy(&DrawYptr,&HRIdata.HRdrawYptr,HRIdata.HR.DrawYR * 4);
  } else { HRIdata.FR.DrawXSZ = DrawXSZ; HRIdata.FR.DrawYSZ = DrawYSZ;
           HRIdata.FR.DrawXL = DrawXL;   HRIdata.FR.DrawYL = DrawYL;
           HRIdata.FR.DrawXR = DrawXR;   HRIdata.FR.DrawYR = DrawYR;
           HRIdata.FR.DrawXC = DrawXC;   HRIdata.FR.DrawYC = DrawYC;
           HRIdata.FR.DrawSZ = DrawSZ;
           HRIdata.FR.DrawLOFFS = DrawLOFFS;
           HRIdata.FR.DrawXRfull = DrawXRfull; HRIdata.FR.DrawYRfull = DrawYRfull;
           HRIdata.FR.DrawPaintTrue = DrawPaintTrue;
           HRIdata.FR.DrawPTRnear = DrawPTRnear;
           HRIdata.FR.DrawPTRfar = DrawPTRfar;
           HRIdata.FR.DrawRegion = DrawRegion;
           HRIdata.FR.DrawScale750 = DrawScale750;
           HRIdata.FR.DrawScale = DrawScale;
           HRIdata.FR.DrawBits = DrawBits; 
           memcpy(&HRIdata.FRdrawYptr, &DrawYptr, DrawYR << 2);
            
           DrawXSZ /= 2; DrawYSZ /= 2;
            
           VS_FullScreen = on;
           AutoExpandMem((void **)&DrawHRIbits,DrawHRIsize,DrawSZ << 2,no);
           DrawBits = HRIdata.HR.DrawBits = DrawHRIbits;
           DrawReplace = no;
           DrawRegionSet(RegionIs(DrawRegion.X / 2, DrawRegion.Y / 2,(DrawRegion.XL + 1) / 2 - 1,(DrawRegion.YL + 1) / 2 - 1));
            
           HRIdata.HR.DrawXSZ = DrawXSZ; HRIdata.HR.DrawYSZ = DrawYSZ;
           HRIdata.HR.DrawXL = DrawXL;   HRIdata.HR.DrawYL = DrawYL;
           HRIdata.HR.DrawXR = DrawXR;   HRIdata.HR.DrawYR = DrawYR;
           HRIdata.HR.DrawXC = DrawXC;   HRIdata.HR.DrawYC = DrawYC;
           HRIdata.HR.DrawSZ = DrawSZ;
           HRIdata.HR.DrawLOFFS = DrawLOFFS;
           HRIdata.HR.DrawXRfull = DrawXRfull; HRIdata.HR.DrawYRfull = DrawYRfull;
           HRIdata.HR.DrawPaintTrue = DrawPaintTrue;
           HRIdata.HR.DrawPTRnear = DrawPTRnear;
           HRIdata.HR.DrawPTRfar = DrawPTRfar;
           HRIdata.HR.DrawRegion = DrawRegion;
           HRIdata.HR.DrawScale750 = DrawScale750;
           HRIdata.HR.DrawScale = DrawScale;
           memcpy(&HRIdata.HRdrawYptr, &DrawYptr, DrawYR << 2);
           DrawHRIexist = on;
         }
  DrawHRIactive = Yes;
  if (DrawHRItransitReason) if (DrawHRItransitReason()) DrawHRItransit();
  //DrawHRIbreak = No;
}

void DrawHRIoff()
{
  if (!DrawHRIactive | !DrawHRIexist) return;
  DrawXSZ = HRIdata.FR.DrawXSZ; DrawYSZ = HRIdata.FR.DrawYSZ;
  DrawXL = HRIdata.FR.DrawXL;   DrawYL = HRIdata.FR.DrawYL;
  DrawXR = HRIdata.FR.DrawXR;   DrawYR = HRIdata.FR.DrawYR;
  DrawXC = HRIdata.FR.DrawXC;   DrawYC = HRIdata.FR.DrawYC;
  DrawSZ = HRIdata.FR.DrawSZ;
  DrawLOFFS = HRIdata.FR.DrawLOFFS;
  DrawXRfull = HRIdata.FR.DrawXRfull; DrawYRfull = HRIdata.FR.DrawYRfull;
  DrawPaintTrue = HRIdata.FR.DrawPaintTrue;
  DrawPTRnear = HRIdata.FR.DrawPTRnear;
  DrawPTRfar = HRIdata.FR.DrawPTRfar;
  DrawRegion = HRIdata.FR.DrawRegion;
  DrawScale750 = HRIdata.FR.DrawScale750;
  DrawScale = HRIdata.FR.DrawScale;
  DrawBits = HRIdata.FR.DrawBits; 
  memcpy(&DrawYptr, &HRIdata.FRdrawYptr, HRIdata.FR.DrawYR << 2);  
  DrawHRIactive = no; 
}

void DrawHRIreset() { DrawHRIactive = DrawHRIexist = no; DrawHRIbreak = Yes; }
void DrawHRIdone() { FreeMemAlign(DrawHRIbits); DrawHRIreset(); }

////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//  " " 

void DrawImage_PUT(dwRGB *dest, dwRGB *source, unsigned szl, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { mov edx,szx
         shl edx,2
         mov ecx,szl
         shl ecx,2
         sub ecx,edx
         mov szl,ecx
         mov esi,edx
         mov eax,source 
         mov ebx,dest
         mov edi,ebx
        _line:
         mov edx,esi
         mov ecx,esi        
         and ecx,0xfffffff0 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movups xmm1,[eax]  
         movups [ebx],xmm1  
         add ebx,16
         add eax,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm1,[eax]
         movd [ebx],xmm1
         add ebx,4
         add eax,4
         cmp edx,ebx
         jne _loopr
        _ex: 
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         add eax,szl
         mov ecx,szy
         dec ecx
         mov szy,ecx
         jnz _line  
       }  
}

///////////////////////////////////////////////////////////////////////////
void DrawImage_ADD(dwRGB *dest, dwRGB *source, unsigned szl, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { mov edx,szx
         shl edx,2
         mov ecx,szl
         shl ecx,2
         sub ecx,edx
         mov szl,ecx
         mov esi,edx
         mov eax,source 
         mov ebx,dest
         mov edi,ebx
        _line:
         mov edx,esi
         mov ecx,esi        // 
         and ecx,0xfffffff0 //    SSE  
         jz _rem            //   .
         add ecx,ebx        //       
        _loop: 
         movups xmm0,[ebx]  //    
         movups xmm1,[eax]  // 
         paddusb xmm0,xmm1  // 
         movups [ebx],xmm0  //    
         add ebx,16
         add eax,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       //   
         jz _ex             //  
         add edx,ebx        //      
        _loopr:
         movd xmm0,[ebx]     //  ,  
         movd xmm1,[eax]
         paddusb xmm0,xmm1
         movd [ebx],xmm0
         add ebx,4
         add eax,4
         cmp edx,ebx
         jne _loopr
        _ex:
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         add eax,szl
         mov ecx,szy
         dec ecx
         mov szy,ecx
         jnz _line  
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawImage_SUB(dwRGB *dest, dwRGB *source, unsigned szl, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { mov edx,szx
         shl edx,2
         mov ecx,szl
         shl ecx,2
         sub ecx,edx
         mov szl,ecx
         mov esi,edx
         mov eax,source 
         mov ebx,dest
         mov edi,ebx
        _line:
         mov edx,esi
         mov ecx,esi         
         and ecx,0xfffffff0 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movups xmm0,[ebx]  
         movups xmm1,[eax]  
         psubusb xmm0,xmm1  
         movups [ebx],xmm0  
         add ebx,16
         add eax,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]     
         movd xmm1,[eax]
         psubusb xmm0,xmm1
         movd [ebx],xmm0
         add ebx,4
         add eax,4
         cmp edx,ebx
         jne _loopr
        _ex:
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         add eax,szl
         mov ecx,szy
         dec ecx
         mov szy,ecx
         jnz _line  
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawImage_MAX(dwRGB *dest, dwRGB *source, unsigned szl, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { mov edx,szx
         shl edx,2
         mov ecx,szl
         shl ecx,2
         sub ecx,edx
         mov szl,ecx
         mov esi,edx
         mov eax,source 
         mov ebx,dest
         mov edi,ebx
        _line:
         mov edx,esi
         mov ecx,esi        
         and ecx,0xfffffff0 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movups xmm0,[ebx]  
         movups xmm1,[eax]  
         pmaxub xmm0,xmm1  
         movups [ebx],xmm0  
         add ebx,16
         add eax,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]     
         movd xmm1,[eax]
         pmaxub xmm0,xmm1
         movd [ebx],xmm0
         add ebx,4
         add eax,4
         cmp edx,ebx
         jne _loopr
        _ex:
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         add eax,szl
         mov ecx,szy
         dec ecx
         mov szy,ecx
         jnz _line           
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawImage_AVR(dwRGB *dest, dwRGB *source, unsigned szl, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { mov edx,szx
         shl edx,2
         mov ecx,szl
         shl ecx,2
         sub ecx,edx
         mov szl,ecx
         mov esi,edx
         mov eax,source 
         mov ebx,dest
         mov edi,ebx
        _line:
         mov edx,esi
         mov ecx,esi        
         and ecx,0xfffffff0 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movups xmm0,[ebx]  
         movups xmm1,[eax]  
         pavgb xmm0,xmm1  
         movups [ebx],xmm0  
         add ebx,16
         add eax,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]     
         movd xmm1,[eax]
         pavgb xmm0,xmm1
         movd [ebx],xmm0
         add ebx,4
         add eax,4
         cmp edx,ebx
         jne _loopr
        _ex:
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         add eax,szl
         mov ecx,szy
         dec ecx
         mov szy,ecx
         jnz _line  
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawImage_AVRHARD(dwRGB *dest, dwRGB *source, unsigned szl, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { mov edx,szx
         shl edx,2
         mov ecx,szl
         shl ecx,2
         sub ecx,edx
         mov szl,ecx
         mov esi,edx
         mov eax,source 
         mov ebx,dest
         mov edi,ebx
        _line:
         mov edx,esi
         mov ecx,esi        
         and ecx,0xfffffff0 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movups xmm0,[ebx]  
         movups xmm1,[eax]  
         pavgb xmm0,xmm1  
         pavgb xmm0,xmm1  
         movups [ebx],xmm0  
         add ebx,16
         add eax,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]     
         movd xmm1,[eax]
         pavgb xmm0,xmm1
         pavgb xmm0,xmm1
         movd [ebx],xmm0
         add ebx,4
         add eax,4
         cmp edx,ebx
         jne _loopr
        _ex: 
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         add eax,szl
         mov ecx,szy
         dec ecx
         mov szy,ecx
         jnz _line 
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawImage_AVRSOFT(dwRGB *dest, dwRGB *source, unsigned szl, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { mov edx,szx
         shl edx,2
         mov ecx,szl
         shl ecx,2
         sub ecx,edx
         mov szl,ecx
         mov esi,edx
         mov eax,source 
         mov ebx,dest
         mov edi,ebx
        _line:
         mov edx,esi
         mov ecx,esi        
         and ecx,0xfffffff0 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movups xmm0,[ebx]  
         movups xmm1,[eax]  
         pavgb xmm1,xmm0  
         pavgb xmm1,xmm0  
         movups [ebx],xmm1  
         add ebx,16
         add eax,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]     
         movd xmm1,[eax]
         pavgb xmm1,xmm0
         pavgb xmm1,xmm0
         movd [ebx],xmm1
         add ebx,4
         add eax,4
         cmp edx,ebx
         jne _loopr
        _ex: 
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         add eax,szl
         mov ecx,szy
         dec ecx
         mov szy,ecx
         jnz _line         
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawImage_MUL(dwRGB *dest, dwRGB *source, unsigned szl, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { pxor xmm2,xmm2
         mov edx,szx
         shl edx,2
         mov ecx,szl
         shl ecx,2
         sub ecx,edx
         mov szl,ecx
         mov esi,edx
         mov eax,source 
         mov ebx,dest
         mov edi,ebx
        _line:
         mov edx,esi
         mov ecx,esi        
         and ecx,0xfffffff8 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movlps xmm0,[ebx]  
         movlps xmm1,[eax]
         punpcklbw xmm0,xmm2 
         punpcklbw xmm1,xmm2  
         pmullw xmm0,xmm1 
         psrlw xmm0,8
         packuswb xmm0,xmm0 
         movlps [ebx],xmm0  
         add ebx,8
         add eax,8
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x07       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]     
         movd xmm1,[eax]
         punpcklbw xmm0,xmm2 
         punpcklbw xmm1,xmm2 
         pmullw xmm0,xmm1 
         psrlw xmm0,8    
         packuswb xmm0,xmm0 
         movd [ebx],xmm0
         add ebx,4
         add eax,4
         cmp edx,ebx
         jne _loopr
        _ex:
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         add eax,szl
         mov ecx,szy
         dec ecx
         mov szy,ecx
         jnz _line          
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawImage_PUTALPHA(dwRGB *dest, dwRGB *source, unsigned szl, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS) 
{
  _asm { pxor xmm2,xmm2
         mov edx,szx
         shl edx,2
         mov ecx,szl
         shl ecx,2
         sub ecx,edx
         mov szl,ecx
         mov esi,edx
         mov eax,source 
         mov ebx,dest
         mov edi,ebx
        _line:
         mov edx,esi
         mov ecx,esi        
         and ecx,0xfffffff8 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movlps xmm0,[ebx]  
         movlps xmm1,[eax]
        /* pshufd xmm4,xmm1,0x50 //  -   
         psrld xmm4,24
         movaps xmm5,xmm4
         psllq xmm5,16
         por xmm4,xmm5    /**/
         pshufd xmm4,xmm1,0x00 
         pshufd xmm5,xmm1,0x55
         psrld xmm4,24
         psrld xmm5,24
         packssdw xmm4,xmm5  /**/  
         punpcklbw xmm0,xmm2 
         punpcklbw xmm1,xmm2  
         psubw xmm1,xmm0  
         psllw xmm0,8     
         pmullw xmm1,xmm4 
         paddw xmm0,xmm1  
         psrlw xmm0,8     
         packuswb xmm0,xmm0
         movlps [ebx],xmm0  
         add ebx,8
         add eax,8
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x07       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]     
         movd xmm1,[eax]
         pshufd xmm4,xmm1,0
         psrld xmm4,24
         packssdw xmm4,xmm4
         punpcklbw xmm0,xmm2 
         punpcklbw xmm1,xmm2 
         psubw xmm1,xmm0   
         psllw xmm0,8      
         pmullw xmm1,xmm4  
         paddw xmm0,xmm1   
         psrlw xmm0,8      
         packuswb xmm0,xmm0
         movd [ebx],xmm0
         add ebx,4
         add eax,4
         cmp edx,ebx
         jne _loopr
        _ex:
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         add eax,szl
         mov ecx,szy
         dec ecx
         mov szy,ecx
         jnz _line          
       }  
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//  
void DrawFRect_PUT(dwRGB *dest, dwRGB color, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { mov edx,szx
         shl edx,2
         mov esi,edx
         mov eax,szy
         mov ebx,dest
         mov edi,ebx
         movd xmm1,color
         pshufd xmm1,xmm1,0
        _line: 
         mov edx,esi
         mov ecx,esi
         and ecx,0xfffffff0 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movups [ebx],xmm1  
         add ebx,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd [ebx],xmm1
         add ebx,4
         cmp edx,ebx
         jne _loopr
        _ex:
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         dec eax
         jnz _line  
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawFRect_ADD(dwRGB *dest, dwRGB color, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { mov edx,szx
         shl edx,2
         mov esi,edx
         mov eax,szy
         mov ebx,dest
         mov edi,ebx
         movd xmm1,color
         pshufd xmm1,xmm1,0
        _line: 
         mov edx,esi
         mov ecx,esi
         and ecx,0xfffffff0 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movups xmm0,[ebx]  
         paddusb xmm0,xmm1  
         movups [ebx],xmm0  
         add ebx,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]     
         paddusb xmm0,xmm1
         movd [ebx],xmm0
         add ebx,4
         cmp edx,ebx
         jne _loopr
        _ex: 
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         dec eax
         jnz _line 
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawFRect_SUB(dwRGB *dest, dwRGB color, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { mov edx,szx
         shl edx,2
         mov esi,edx
         mov eax,szy
         mov ebx,dest
         mov edi,ebx
         movd xmm1,color
         pshufd xmm1,xmm1,0
        _line:
         mov edx,esi 
         mov ecx,esi    
         and ecx,0xfffffff0 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movups xmm0,[ebx]  
         psubusb xmm0,xmm1  
         movups [ebx],xmm0  
         add ebx,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]     
         psubusb xmm0,xmm1
         movd [ebx],xmm0
         add ebx,4
         cmp edx,ebx
         jne _loopr
        _ex: 
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         dec eax
         jnz _line 
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawFRect_MAX(dwRGB *dest, dwRGB color, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { mov edx,szx
         shl edx,2
         mov esi,edx
         mov eax,szy
         mov ebx,dest
         mov edi,ebx
         movd xmm1,color
         pshufd xmm1,xmm1,0
        _line:
         mov edx,esi 
         mov ecx,esi    
         and ecx,0xfffffff0 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movups xmm0,[ebx]  
         pmaxub xmm0,xmm1  
         movups [ebx],xmm0  
         add ebx,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]     
         pmaxub xmm0,xmm1
         movd [ebx],xmm0
         add ebx,4
         cmp edx,ebx
         jne _loopr
        _ex: 
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         dec eax
         jnz _line 
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawFRect_AVR(dwRGB *dest, dwRGB color, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { mov edx,szx
         shl edx,2
         mov esi,edx
         mov eax,szy
         mov ebx,dest
         mov edi,ebx
         movd xmm1,color
         pshufd xmm1,xmm1,0
        _line:
         mov edx,esi 
         mov ecx,esi    
         and ecx,0xfffffff0 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movups xmm0,[ebx]  
         pavgb xmm0,xmm1  
         movups [ebx],xmm0  
         add ebx,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]     
         pavgb xmm0,xmm1
         movd [ebx],xmm0
         add ebx,4
         cmp edx,ebx
         jne _loopr
        _ex: 
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         dec eax
         jnz _line 
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawFRect_AVRHARD(dwRGB *dest, dwRGB color, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { mov edx,szx
         shl edx,2
         mov esi,edx
         mov eax,szy
         mov ebx,dest
         mov edi,ebx
         movd xmm1,color
         pshufd xmm1,xmm1,0
        _line:
         mov edx,esi 
         mov ecx,esi    
         and ecx,0xfffffff0 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movups xmm0,[ebx]  
         pavgb xmm0,xmm1  
         pavgb xmm0,xmm1  
         movups [ebx],xmm0  
         add ebx,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]     
         pavgb xmm0,xmm1
         pavgb xmm0,xmm1
         movd [ebx],xmm0
         add ebx,4
         cmp edx,ebx
         jne _loopr
        _ex: 
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         dec eax
         jnz _line 
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawFRect_AVRSOFT(dwRGB *dest, dwRGB color, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS)
{
  _asm { mov edx,szx
         shl edx,2
         mov esi,edx
         mov eax,szy
         mov ebx,dest
         mov edi,ebx
         movd xmm2,color
         pshufd xmm2,xmm2,0
        _line:
         mov edx,esi 
         mov ecx,esi       
         and ecx,0xfffffff0 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movups xmm0,[ebx]
         movaps xmm1,xmm2  
         pavgb xmm1,xmm0  
         pavgb xmm1,xmm0  
         movups [ebx],xmm1  
         add ebx,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]     
         pavgb xmm1,xmm0
         pavgb xmm1,xmm0  
         movd [ebx],xmm1
         add ebx,4
         cmp edx,ebx
         jne _loopr
        _ex:
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         dec eax
         jnz _line  
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawFRect_MUL(dwRGB *dest, dwRGB color, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS) // size -  
{
  _asm { mov edx,szx
         shl edx,2
         mov esi,edx
         mov eax,szy
         mov ebx,dest
         mov edi,ebx
         pxor xmm2,xmm2
         movd xmm1,color
         pshufd xmm1,xmm1,0
         punpcklbw xmm1,xmm2
        _line:
         mov edx,esi 
         mov ecx,esi           
         and ecx,0xfffffff8 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movlps xmm0,[ebx]  
         punpcklbw xmm0,xmm2 
         pmullw xmm0,xmm1 
         psrlw xmm0,8
         packuswb xmm0,xmm0 
         movlps [ebx],xmm0  
         add ebx,8
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x07       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]     
         punpcklbw xmm0,xmm2 
         pmullw xmm0,xmm1 
         psrlw xmm0,8    
         packuswb xmm0,xmm0 
         movd [ebx],xmm0
         add ebx,4
         cmp edx,ebx
         jne _loopr
        _ex: 
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         dec eax
         jnz _line 
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawFRect_IMUL(dwRGB *dest, dwRGB color, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS) // size -  
{
  color ^=0xffffffff;
  int x[2] = {0xffffffff, 0xffffffff};
  _asm { mov edx,szx
         shl edx,2
         mov esi,edx
         mov eax,szy
         mov ebx,dest
         mov edi,ebx
         pxor xmm2,xmm2
         movlps xmm3,x
         movd xmm1,color
         pshufd xmm1,xmm1,0
         punpcklbw xmm1,xmm2
        _line:
         mov edx,esi 
         mov ecx,esi           
         and ecx,0xfffffff8 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movlps xmm0,[ebx]
         xorps xmm0,xmm3           
         punpcklbw xmm0,xmm2 
         pmullw xmm0,xmm1 
         psrlw xmm0,8
         packuswb xmm0,xmm0
         xorps xmm0,xmm3          
         movlps [ebx],xmm0  
         add ebx,8
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x07       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]
         xorps xmm0,xmm3              
         punpcklbw xmm0,xmm2 
         pmullw xmm0,xmm1 
         psrlw xmm0,8    
         packuswb xmm0,xmm0
         xorps xmm0,xmm3          
         movd [ebx],xmm0
         add ebx,4
         cmp edx,ebx
         jne _loopr
        _ex: 
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         dec eax
         jnz _line 
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawFRect_PUTALPHA(dwRGB *dest, dwRGB color, unsigned szx, unsigned szy = 1, int loffs = DrawLOFFS) // size -  
{
  _asm { mov edx,szx
         shl edx,2
         mov esi,edx
         mov eax,szy
         mov ebx,dest
         mov edi,ebx
         pxor xmm2,xmm2
         movd xmm3,color
         pshufd xmm3,xmm3,0
         movaps xmm4,xmm3 // 
         psrld xmm4,24
         movaps xmm5,xmm4
         psllq xmm5,16
         por xmm4,xmm5 
         punpcklbw xmm3,xmm2
        _line:
         mov edx,esi 
         mov ecx,esi 
         and ecx,0xfffffff8 
         jz _rem            
         add ecx,ebx        
        _loop:         
         movlps xmm0,[ebx]
         movaps xmm1,xmm3  
         punpcklbw xmm0,xmm2 
         psubw xmm1,xmm0  
         psllw xmm0,8     
         pmullw xmm1,xmm4 
         paddw xmm0,xmm1  
         psrlw xmm0,8     
         packuswb xmm0,xmm0
         movlps [ebx],xmm0  
         add ebx,8
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x07       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd xmm0,[ebx]
         movaps xmm1,xmm3  
         punpcklbw xmm0,xmm2 
         psubw xmm1,xmm0   
         psllw xmm0,8      
         pmullw xmm1,xmm4  
         paddw xmm0,xmm1   
         psrlw xmm0,8      
         packuswb xmm0,xmm0
         movd [ebx],xmm0
         add ebx,4
         cmp edx,ebx
         jne _loopr
        _ex:
         mov ebx,edi
         add ebx,loffs
         mov edi,ebx
         dec eax
         jnz _line  
       }  
}

////////////////////////////////////////////////////////////////////////////
//   
/*
void DrawHLine_PUT(dwRGB *dest, dwRGB color, unsigned szx)
{ 
  _asm { mov edx,szx
         mov ecx,edx
         mov ebx,dest
         movd xmm1,color
         pshufd xmm1,xmm1,0
         and ecx,0xfffffffc 
         jz _rem2            
         shr ecx,2        
        _loop: 
         movups [ebx],xmm1  
         add ebx,16
         dec ecx
         jnz _loop 
        _rem2: 
         bt edx,1
         jnc _rem
         movlps [ebx],xmm1
         add ebx,8
        _rem:
         bt edx,0
         jnc _ex
         movd [ebx],xmm1
        _ex: 
       }  
}/**/

void DrawHLine_PUT(dwRGB *dest, dwRGB color, unsigned szx)
{                                 
  _asm { mov ecx,szx             //  ()     - .. 1 = 4 
         mov ebx,dest            //  () -    
         movd xmm0,color         //  
         pshufd xmm0,xmm0,0      //      XMM 
         cmp ecx,27              //   27
         ja _over27              //   -     ""   
         mov edx,ecx             // 
         and ecx,0xfffffffc      //      "" XMM 
         jz _rem2                //   -        XMM 
         shr ecx,2               //     XMM   
        _loop: 
         movups [ebx],xmm0       //    
         add ebx,16              //   -
         dec ecx                 //  -
         jnz _loop               //  ? -    
        _rem2:                   //     XMM .
         bt edx,1                //    XMM ? 
         jnc _rem                //  -  ,      
         movlps [ebx],xmm0       //   
         add ebx,8               //   - 
        _rem:                    
         bt edx,0                //   XMM ?
         jnc _ex                 //  -    
         movd [ebx],xmm0
         jmp _ex 
        _over27:                 //      "" .
         bt ebx,2                //       16,  4  ?  
         jnc _m2                 //   -   
         movd [ebx],xmm0
         add ebx,4               //   -  4 
         dec ecx                 // -   1
        _m2:                     
         bt ebx,3                //  8  ?
         jnc _m                  //  -  
         movlps [ebx],xmm0
         add ebx,8               //   -  8
         sub ecx,2               // -   2
        _m:
         mov edx,ecx             //  
         shr ecx,4               //      XMM
        _looop:                         
         movaps [ebx],xmm0       //  4 
         movaps [ebx + 16],xmm0  
         movaps [ebx + 32],xmm0
         movaps [ebx + 48],xmm0
         add ebx,64              //   
         dec ecx
         jnz _looop              //   
         bt edx,3                //   2  XMM  ? 
         jnc _reem8              //  -   
         movaps [ebx],xmm0
         movaps [ebx + 16],xmm0
         add ebx,32              // 
        _reem8:
         bt edx,2                //    XMM  ? 
         jnc _reem4              //  -   
         movaps [ebx],xmm0
         add ebx,16              // 
        _reem4:
         bt edx,1                //  ? 
         jnc _reem               //  -  
         movlps [ebx],xmm0
         add ebx,8               // 
        _reem:
         bt edx,0                //  ?  
         jnc _ex
         movd [ebx],xmm0
        _ex: 
       }  
}

////////////////////////////////////////////////////////////////////////////
/*
void DrawHLine_ADD(dwRGB *dest, dwRGB color, unsigned szx) // optimum
{
  _asm { mov edx,szx
         mov ecx,edx
         mov ebx,dest
         movd xmm1,color
         pshufd xmm1,xmm1,0
         and ecx,0xfffffffc 
         jz _rem2            
         shr ecx,2        
        _loop: 
         movups xmm0,[ebx]  
         paddusb xmm0,xmm1  
         movups [ebx],xmm0
         add ebx,16
         dec ecx
         jnz _loop 
        _rem2: 
         bt edx,1
         jnc _rem
         movlps xmm0,[ebx]
         paddusb xmm0,xmm1
         movlps [ebx],xmm0
         add ebx,8
        _rem:
         bt edx,0
         jnc _ex
         movd xmm0,[ebx]
         paddusb xmm0,xmm1
         movd [ebx],xmm0
        _ex: 
       }  
}/**/


void DrawHLine_ADD(dwRGB *dest, dwRGB color, unsigned szx)
{   
  _asm { mov ecx,szx             //  ()     - .. 1 = 4 
         mov ebx,dest            //  () -    
         movd xmm4,color         //  
         pshufd xmm4,xmm4,0      //      XMM 
         cmp ecx,27              //   27
         ja _over27              //   -     ""   
         mov edx,ecx             // 
         and ecx,0xfffffffc      //      "" XMM 
         jz _rem2                //   -        XMM 
         shr ecx,2               //     XMM   
        _loop: 
         movups xmm0,[ebx]       //      
         paddusb xmm0,xmm4       //   
         movups [ebx],xmm0       //    
         add ebx,16              //   -
         dec ecx                 //  -
         jnz _loop               //  ? -    
        _rem2:                   //     XMM .
         bt edx,1                //    XMM ? 
         jnc _rem                //  -  ,      
         movlps xmm0,[ebx]       //     
         paddusb xmm0,xmm4       //    
         movlps [ebx],xmm0       //   
         add ebx,8               //   - 
        _rem:                    
         bt edx,0                //   XMM ?
         jnc _ex                 //  -    
         movd xmm0,[ebx]         //  ... 
         paddusb xmm0,xmm4
         movd [ebx],xmm0
         jmp _ex 
        _over27:                 //      "" .
         bt ebx,2                //       16,  4  ?  
         jnc _m2                 //   -   
         movd xmm0,[ebx]         //  ...
         paddusb xmm0,xmm4
         movd [ebx],xmm0
         add ebx,4               //   -  4 
         dec ecx                 // -   1
        _m2:                     
         bt ebx,3                //  8  ?
         jnc _m                  //  -  
         movlps xmm0,[ebx]       // ...   
         paddusb xmm0,xmm4        
         movlps [ebx],xmm0
         add ebx,8               //   -  8
         sub ecx,2               // -   2
        _m:
         mov edx,ecx             //  
         shr ecx,4               //      XMM
        _looop:                         
         movaps xmm0,[ebx]       //  4 
         movaps xmm1,[ebx + 16]
         movaps xmm2,[ebx + 32]
         movaps xmm3,[ebx + 48]
         paddusb xmm0,xmm4       //  4 
         paddusb xmm1,xmm4  
         paddusb xmm2,xmm4
         paddusb xmm3,xmm4  
         movaps [ebx],xmm0       //  4 
         movaps [ebx + 16],xmm1  
         movaps [ebx + 32],xmm2
         movaps [ebx + 48],xmm3
         add ebx,64              //   
         dec ecx
         jnz _looop              //   
         bt edx,3                //   2  XMM  ? 
         jnc _reem8              //  -   
         movaps xmm0,[ebx]       // ....
         movaps xmm1,[ebx + 16]
         paddusb xmm0,xmm4
         paddusb xmm1,xmm4  
         movaps [ebx],xmm0
         movaps [ebx + 16],xmm1
         add ebx,32              // 
        _reem8:
         bt edx,2                //    XMM  ? 
         jnc _reem4              //  -   
         movaps xmm0,[ebx]
         paddusb xmm0,xmm4
         movaps [ebx],xmm0
         add ebx,16              // 
        _reem4:
         bt edx,1                //  ? 
         jnc _reem               //  -  
         movlps xmm0,[ebx]
         paddusb xmm0,xmm4
         movlps [ebx],xmm0
         add ebx,8               // 
        _reem:
         bt edx,0                //  ?  
         jnc _ex
         movd xmm0,[ebx]
         paddusb xmm0,xmm4
         movd [ebx],xmm0
        _ex: 
       }  
}/**/

////////////////////////////////////////////////////////////////////////////
/*
void DrawHLine_SUB(dwRGB *dest, dwRGB color, unsigned szx)
{
  _asm { mov edx,szx
         mov ecx,edx
         mov ebx,dest
         movd xmm1,color
         pshufd xmm1,xmm1,0
         and ecx,0xfffffffc 
         jz _rem2            
         shr ecx,2        
        _loop: 
         movups xmm0,[ebx]  
         psubusb xmm0,xmm1  
         movups [ebx],xmm0  
         add ebx,16
         dec ecx
         jnz _loop 
        _rem2: 
         bt edx,1
         jnc _rem
         movlps xmm0,[ebx]
         psubusb xmm0,xmm1
         movlps [ebx],xmm0
         add ebx,8
        _rem:
         bt edx,0
         jnc _ex
         movd xmm0,[ebx]
         psubusb xmm0,xmm1
         movd [ebx],xmm0
        _ex: 
       }  
}/**/

void DrawHLine_SUB(dwRGB *dest, dwRGB color, unsigned szx)
{                                 
  _asm { mov ecx,szx             //  ()     - .. 1 = 4 
         mov ebx,dest            //  () -    
         movd xmm4,color         //  
         pshufd xmm4,xmm4,0      //      XMM 
         cmp ecx,27              //   27
         ja _over27              //   -     ""   
         mov edx,ecx             // 
         and ecx,0xfffffffc      //      "" XMM 
         jz _rem2                //   -        XMM 
         shr ecx,2               //     XMM   
        _loop: 
         movups xmm0,[ebx]       //      
         psubusb xmm0,xmm4       //   
         movups [ebx],xmm0       //    
         add ebx,16              //   -
         dec ecx                 //  -
         jnz _loop               //  ? -    
        _rem2:                   //     XMM .
         bt edx,1                //    XMM ? 
         jnc _rem                //  -  ,      
         movlps xmm0,[ebx]       //     
         psubusb xmm0,xmm4       //    
         movlps [ebx],xmm0       //   
         add ebx,8               //   - 
        _rem:                    
         bt edx,0                //   XMM ?
         jnc _ex                 //  -    
         movd xmm0,[ebx]         //  ... 
         psubusb xmm0,xmm4
         movd [ebx],xmm0
         jmp _ex 
        _over27:                 //      "" .
         bt ebx,2                //       16,  4  ?  
         jnc _m2                 //   -   
         movd xmm0,[ebx]         //  ...
         psubusb xmm0,xmm4
         movd [ebx],xmm0
         add ebx,4               //   -  4 
         dec ecx                 // -   1
        _m2:                     
         bt ebx,3                //  8  ?
         jnc _m                  //  -  
         movlps xmm0,[ebx]       // ...   
         psubusb xmm0,xmm4        
         movlps [ebx],xmm0
         add ebx,8               //   -  8
         sub ecx,2               // -   2
        _m:
         mov edx,ecx             //  
         shr ecx,4               //      XMM
        _looop:                         
         movaps xmm0,[ebx]       //  4 
         movaps xmm1,[ebx + 16]
         movaps xmm2,[ebx + 32]
         movaps xmm3,[ebx + 48]
         psubusb xmm0,xmm4       //  4 
         psubusb xmm1,xmm4  
         psubusb xmm2,xmm4
         psubusb xmm3,xmm4  
         movaps [ebx],xmm0       //  4 
         movaps [ebx + 16],xmm1  
         movaps [ebx + 32],xmm2
         movaps [ebx + 48],xmm3
         add ebx,64              //   
         dec ecx
         jnz _looop              //   
         bt edx,3                //   2  XMM  ? 
         jnc _reem8              //  -   
         movaps xmm0,[ebx]       // ....
         movaps xmm1,[ebx + 16]
         psubusb xmm0,xmm4
         psubusb xmm1,xmm4  
         movaps [ebx],xmm0
         movaps [ebx + 16],xmm1
         add ebx,32              // 
        _reem8:
         bt edx,2                //    XMM  ? 
         jnc _reem4              //  -   
         movaps xmm0,[ebx]
         psubusb xmm0,xmm4
         movaps [ebx],xmm0
         add ebx,16              // 
        _reem4:
         bt edx,1                //  ? 
         jnc _reem               //  -  
         movlps xmm0,[ebx]
         psubusb xmm0,xmm4
         movlps [ebx],xmm0
         add ebx,8               // 
        _reem:
         bt edx,0                //  ?  
         jnc _ex
         movd xmm0,[ebx]
         psubusb xmm0,xmm4
         movd [ebx],xmm0
        _ex: 
       }  
}/**/

////////////////////////////////////////////////////////////////////////////
/*void DrawHLine_MAX(dwRGB *dest, dwRGB color, unsigned szx)
{ _asm { mov edx,szx
         mov ecx,edx
         mov ebx,dest
         movd xmm1,color
         pshufd xmm1,xmm1,0
         and ecx,0xfffffffc 
         jz _rem2            
         shr ecx,2        
        _loop: 
         movups xmm0,[ebx]  
         pmaxub xmm0,xmm1  
         movups [ebx],xmm0  
         add ebx,16
         dec ecx
         jnz _loop 
        _rem2: 
         bt edx,1
         jnc _rem
         movlps xmm0,[ebx]
         pmaxub xmm0,xmm1
         movlps [ebx],xmm0
         add ebx,8
        _rem:
         bt edx,0
         jnc _ex
         movd xmm0,[ebx]
         pmaxub xmm0,xmm1
         movd [ebx],xmm0
        _ex: 
       }  
}/**/

void DrawHLine_MAX(dwRGB *dest, dwRGB color, unsigned szx)
{                                 
  _asm { mov ecx,szx             //  ()     - .. 1 = 4 
         mov ebx,dest            //  () -    
         movd xmm4,color         //  
         pshufd xmm4,xmm4,0      //      XMM 
         cmp ecx,27              //   27
         ja _over27              //   -     ""   
         mov edx,ecx             // 
         and ecx,0xfffffffc      //      "" XMM 
         jz _rem2                //   -        XMM 
         shr ecx,2               //     XMM   
        _loop: 
         movups xmm0,[ebx]       //      
         pmaxub xmm0,xmm4       //   
         movups [ebx],xmm0       //    
         add ebx,16              //   -
         dec ecx                 //  -
         jnz _loop               //  ? -    
        _rem2:                   //     XMM .
         bt edx,1                //    XMM ? 
         jnc _rem                //  -  ,      
         movlps xmm0,[ebx]       //     
         pmaxub xmm0,xmm4       //    
         movlps [ebx],xmm0       //   
         add ebx,8               //   - 
        _rem:                    
         bt edx,0                //   XMM ?
         jnc _ex                 //  -    
         movd xmm0,[ebx]         //  ... 
         pmaxub xmm0,xmm4
         movd [ebx],xmm0
         jmp _ex 
        _over27:                 //      "" .
         bt ebx,2                //       16,  4  ?  
         jnc _m2                 //   -   
         movd xmm0,[ebx]         //  ...
         pmaxub xmm0,xmm4
         movd [ebx],xmm0
         add ebx,4               //   -  4 
         dec ecx                 // -   1
        _m2:                     
         bt ebx,3                //  8  ?
         jnc _m                  //  -  
         movlps xmm0,[ebx]       // ...   
         pmaxub xmm0,xmm4        
         movlps [ebx],xmm0
         add ebx,8               //   -  8
         sub ecx,2               // -   2
        _m:
         mov edx,ecx             //  
         shr ecx,4               //      XMM
        _looop:                         
         movaps xmm0,[ebx]       //  4 
         movaps xmm1,[ebx + 16]
         movaps xmm2,[ebx + 32]
         movaps xmm3,[ebx + 48]
         pmaxub xmm0,xmm4       //  4 
         pmaxub xmm1,xmm4  
         pmaxub xmm2,xmm4
         pmaxub xmm3,xmm4  
         movaps [ebx],xmm0       //  4 
         movaps [ebx + 16],xmm1  
         movaps [ebx + 32],xmm2
         movaps [ebx + 48],xmm3
         add ebx,64              //   
         dec ecx
         jnz _looop              //   
         bt edx,3                //   2  XMM  ? 
         jnc _reem8              //  -   
         movaps xmm0,[ebx]       // ....
         movaps xmm1,[ebx + 16]
         pmaxub xmm0,xmm4
         pmaxub xmm1,xmm4  
         movaps [ebx],xmm0
         movaps [ebx + 16],xmm1
         add ebx,32              // 
        _reem8:
         bt edx,2                //    XMM  ? 
         jnc _reem4              //  -   
         movaps xmm0,[ebx]
         pmaxub xmm0,xmm4
         movaps [ebx],xmm0
         add ebx,16              // 
        _reem4:
         bt edx,1                //  ? 
         jnc _reem               //  -  
         movlps xmm0,[ebx]
         pmaxub xmm0,xmm4
         movlps [ebx],xmm0
         add ebx,8               // 
        _reem:
         bt edx,0                //  ?  
         jnc _ex
         movd xmm0,[ebx]
         pmaxub xmm0,xmm4
         movd [ebx],xmm0
        _ex: 
       }  
}/**/

////////////////////////////////////////////////////////////////////////////
/*void DrawHLine_AVR(dwRGB *dest, dwRGB color, unsigned szx)
{
  _asm { mov edx,szx
         mov ecx,edx
         mov ebx,dest
         movd xmm1,color
         pshufd xmm1,xmm1,0
         and ecx,0xfffffffc 
         jz _rem2            
         shr ecx,2        
        _loop: 
         movups xmm0,[ebx]  
         pavgb xmm0,xmm1  
         movups [ebx],xmm0  
         add ebx,16
         dec ecx
         jnz _loop 
        _rem2: 
         bt edx,1
         jnc _rem
         movlps xmm0,[ebx]
         pavgb xmm0,xmm1
         movlps [ebx],xmm0
         add ebx,8
        _rem:
         bt edx,0
         jnc _ex
         movd xmm0,[ebx]
         pavgb xmm0,xmm1
         movd [ebx],xmm0
        _ex: 
       }  
}/**/

void DrawHLine_AVR(dwRGB *dest, dwRGB color, unsigned szx)
{                                 
  _asm { mov ecx,szx             //  ()     - .. 1 = 4 
         mov ebx,dest            //  () -    
         movd xmm4,color         //  
         pshufd xmm4,xmm4,0      //      XMM 
         cmp ecx,27              //   27
         ja _over27              //   -     ""   
         mov edx,ecx             // 
         and ecx,0xfffffffc      //      "" XMM 
         jz _rem2                //   -        XMM 
         shr ecx,2               //     XMM   
        _loop: 
         movups xmm0,[ebx]       //      
         pavgb xmm0,xmm4       //   
         movups [ebx],xmm0       //    
         add ebx,16              //   -
         dec ecx                 //  -
         jnz _loop               //  ? -    
        _rem2:                   //     XMM .
         bt edx,1                //    XMM ? 
         jnc _rem                //  -  ,      
         movlps xmm0,[ebx]       //     
         pavgb xmm0,xmm4       //    
         movlps [ebx],xmm0       //   
         add ebx,8               //   - 
        _rem:                    
         bt edx,0                //   XMM ?
         jnc _ex                 //  -    
         movd xmm0,[ebx]         //  ... 
         pavgb xmm0,xmm4
         movd [ebx],xmm0
         jmp _ex 
        _over27:                 //      "" .
         bt ebx,2                //       16,  4  ?  
         jnc _m2                 //   -   
         movd xmm0,[ebx]         //  ...
         pavgb xmm0,xmm4
         movd [ebx],xmm0
         add ebx,4               //   -  4 
         dec ecx                 // -   1
        _m2:                     
         bt ebx,3                //  8  ?
         jnc _m                  //  -  
         movlps xmm0,[ebx]       // ...   
         pavgb xmm0,xmm4        
         movlps [ebx],xmm0
         add ebx,8               //   -  8
         sub ecx,2               // -   2
        _m:
         mov edx,ecx             //  
         shr ecx,4               //      XMM
        _looop:                         
         movaps xmm0,[ebx]       //  4 
         movaps xmm1,[ebx + 16]
         movaps xmm2,[ebx + 32]
         movaps xmm3,[ebx + 48]
         pavgb xmm0,xmm4       //  4 
         pavgb xmm1,xmm4  
         pavgb xmm2,xmm4
         pavgb xmm3,xmm4  
         movaps [ebx],xmm0       //  4 
         movaps [ebx + 16],xmm1  
         movaps [ebx + 32],xmm2
         movaps [ebx + 48],xmm3
         add ebx,64              //   
         dec ecx
         jnz _looop              //   
         bt edx,3                //   2  XMM  ? 
         jnc _reem8              //  -   
         movaps xmm0,[ebx]       // ....
         movaps xmm1,[ebx + 16]
         pavgb xmm0,xmm4
         pavgb xmm1,xmm4  
         movaps [ebx],xmm0
         movaps [ebx + 16],xmm1
         add ebx,32              // 
        _reem8:
         bt edx,2                //    XMM  ? 
         jnc _reem4              //  -   
         movaps xmm0,[ebx]
         pavgb xmm0,xmm4
         movaps [ebx],xmm0
         add ebx,16              // 
        _reem4:
         bt edx,1                //  ? 
         jnc _reem               //  -  
         movlps xmm0,[ebx]
         pavgb xmm0,xmm4
         movlps [ebx],xmm0
         add ebx,8               // 
        _reem:
         bt edx,0                //  ?  
         jnc _ex
         movd xmm0,[ebx]
         pavgb xmm0,xmm4
         movd [ebx],xmm0
        _ex: 
       }  
}/**/

////////////////////////////////////////////////////////////////////////////
void DrawHLine_AVRHARD(dwRGB *dest, dwRGB color, unsigned szx)
{
  _asm { mov edx,szx
         mov ecx,edx
         mov ebx,dest
         movd xmm1,color
         pshufd xmm1,xmm1,0
         and ecx,0xfffffffc 
         jz _rem2            
         shr ecx,2        
        _loop: 
         movups xmm0,[ebx]  
         pavgb xmm0,xmm1  
         pavgb xmm0,xmm1  
         movups [ebx],xmm0  
         add ebx,16
         dec ecx
         jnz _loop 
        _rem2: 
         bt edx,1
         jnc _rem
         movlps xmm0,[ebx]
         pavgb xmm0,xmm1
         pavgb xmm0,xmm1
         movlps [ebx],xmm0
         add ebx,8
        _rem:
         bt edx,0
         jnc _ex
         movd xmm0,[ebx]
         pavgb xmm0,xmm1
         pavgb xmm0,xmm1
         movd [ebx],xmm0
        _ex: 
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawHLine_AVRSOFT(dwRGB *dest, dwRGB color, unsigned szx)
{
  _asm { mov edx,szx
         mov ecx,edx
         mov ebx,dest
         movd xmm2,color
         pshufd xmm2,xmm2,0
         and ecx,0xfffffffc 
         jz _rem2            
         shr ecx,2        
        _loop: 
         movups xmm0,[ebx]
         movaps xmm1,xmm2  
         pavgb xmm1,xmm0  
         pavgb xmm1,xmm0  
         movups [ebx],xmm1  
         add ebx,16
         dec ecx
         jnz _loop 
        _rem2: 
         bt edx,1
         jnc _rem
         movlps xmm0,[ebx]
         movaps xmm1,xmm2  
         pavgb xmm1,xmm0
         pavgb xmm1,xmm0
         movlps [ebx],xmm1
         add ebx,8
        _rem:
         bt edx,0
         jnc _ex
         movd xmm0,[ebx]
         movaps xmm1,xmm2  
         pavgb xmm1,xmm0
         pavgb xmm1,xmm0
         movd [ebx],xmm1
        _ex: 
       }  
}

////////////////////////////////////////////////////////////////////////////
void DrawHLine_MUL(dwRGB *dest, dwRGB color, unsigned szx)
{
  _asm { mov edx,szx
         mov ecx,edx
         mov ebx,dest
         pxor xmm2,xmm2
         movd xmm1,color
         pshufd xmm1,xmm1,0
         punpcklbw xmm1,xmm2
         and ecx,0xfffffffe 
         jz _rem            
         shr ecx,1        
        _loop: 
         movlps xmm0,[ebx]  
         punpcklbw xmm0,xmm2 
         pmullw xmm0,xmm1 
         psrlw xmm0,8
         packuswb xmm0,xmm0 
         movlps [ebx],xmm0  
         add ebx,8
         dec ecx
         jnz _loop 
        _rem:
         and edx,0x01       
         jz _ex             
        _loopr:
         movd xmm0,[ebx]     
         punpcklbw xmm0,xmm2 
         pmullw xmm0,xmm1 
         psrlw xmm0,8    
         packuswb xmm0,xmm0 
         movd [ebx],xmm0
         add ebx,4
         dec edx
         jnz _loopr
        _ex: 
       };  
};

////////////////////////////////////////////////////////////////////////////
void DrawHLine_IMUL(dwRGB *dest, dwRGB color, unsigned szx)
{
  color ^=0xffffffff;
  int x[2] = {0xffffffff, 0xffffffff};
  _asm { mov edx,szx
         mov ecx,edx
         mov ebx,dest
         movlps xmm3,x
         pxor xmm2,xmm2
         movd xmm1,color
         pshufd xmm1,xmm1,0
         punpcklbw xmm1,xmm2
         and ecx,0xfffffffe 
         jz _rem            
         shr ecx,1        
        _loop: 
         movlps xmm0,[ebx] 
         xorps xmm0,xmm3 
         punpcklbw xmm0,xmm2 
         pmullw xmm0,xmm1 
         psrlw xmm0,8
         packuswb xmm0,xmm0 
         xorps xmm0,xmm3 
         movlps [ebx],xmm0  
         add ebx,8
         dec ecx
         jnz _loop 
        _rem:
         and edx,0x01       
         jz _ex             
        _loopr:
         movd xmm0,[ebx] 
         xorps xmm0,xmm3 
         punpcklbw xmm0,xmm2 
         pmullw xmm0,xmm1 
         psrlw xmm0,8    
         packuswb xmm0,xmm0 
         xorps xmm0,xmm3 
         movd [ebx],xmm0
         add ebx,4
         dec edx
         jnz _loopr
        _ex: 
       };  
};

////////////////////////////////////////////////////////////////////////////
void DrawHLine_PUTALPHA(dwRGB *dest, dwRGB color, unsigned szx) // size -  
{
  _asm { mov edx,szx
         mov ecx,edx
         mov ebx,dest
         pxor xmm2,xmm2
         movd xmm3,color
         pshufd xmm3,xmm3,0
         movaps xmm4,xmm3 // 
         psrld xmm4,24
         movaps xmm5,xmm4
         psllq xmm5,16
         por xmm4,xmm5 
         punpcklbw xmm3,xmm2
         and ecx,0xfffffffe 
         jz _rem            
         shr ecx,1        
        _loop:         
         movlps xmm0,[ebx]
         movaps xmm1,xmm3  
         punpcklbw xmm0,xmm2 
         psubw xmm1,xmm0  
         psllw xmm0,8     
         pmullw xmm1,xmm4 
         paddw xmm0,xmm1  
         psrlw xmm0,8     
         packuswb xmm0,xmm0
         movlps [ebx],xmm0  
         add ebx,8
         dec ecx
         jnz _loop 
        _rem:
         and edx,0x01       
         jz _ex             
        _loopr:
         movd xmm0,[ebx]
         movaps xmm1,xmm3  
         punpcklbw xmm0,xmm2 
         psubw xmm1,xmm0   
         psllw xmm0,8      
         pmullw xmm1,xmm4  
         paddw xmm0,xmm1   
         psrlw xmm0,8      
         packuswb xmm0,xmm0
         movd [ebx],xmm0
         add ebx,4
         dec edx
         jnz _loopr
        _ex: 
       };  
};

////////////////////////////////////////////////////////////////////////////
//   
void DrawVLine_PUT(dwRGB *dest, dwRGB color, unsigned vsz, int loffs = DrawLOFFS)
{
  _asm { mov ebx,dest    
         mov ecx,loffs
         mov edx,color         
         mov eax,vsz
        _loop:
         mov [ebx],edx
         add ebx,ecx
         dec eax
         jnz _loop
       };  
};

////////////////////////////////////////////////////////////////////////////
void DrawVLine_ADD(dwRGB *dest, dwRGB color, unsigned vsz, int loffs = DrawLOFFS)
{
  _asm { movd xmm1,color
         mov ebx,dest    
         mov ecx,loffs
         mov eax,vsz
        _loop:
         movd xmm0,[ebx]  
         paddusb xmm0,xmm1  
         movd [ebx],xmm0
         add ebx,ecx
         dec eax
         jnz _loop
       };  
};


////////////////////////////////////////////////////////////////////////////
void DrawVLine_SUB(dwRGB *dest, dwRGB color, unsigned vsz, int loffs = DrawLOFFS)
{
  _asm { movd xmm1,color
         mov ebx,dest    
         mov ecx,loffs
         mov eax,vsz
        _loop:
         movd xmm0,[ebx]  
         psubusb xmm0,xmm1  
         movd [ebx],xmm0
         add ebx,ecx
         dec eax
         jnz _loop
       };  
};

////////////////////////////////////////////////////////////////////////////
void DrawVLine_MAX(dwRGB *dest, dwRGB color, unsigned vsz, int loffs = DrawLOFFS)
{
  _asm { movd xmm1,color
         mov ebx,dest    
         mov ecx,loffs
         mov eax,vsz
        _loop:
         movd xmm0,[ebx]  
         pmaxub xmm0,xmm1  
         movd [ebx],xmm0
         add ebx,ecx
         dec eax
         jnz _loop
       };  
};

////////////////////////////////////////////////////////////////////////////
void DrawVLine_AVR(dwRGB *dest, dwRGB color, unsigned vsz, int loffs = DrawLOFFS)
{
  _asm { movd xmm1,color
         mov ebx,dest    
         mov ecx,loffs
         mov eax,vsz
        _loop:
         movd xmm0,[ebx]  
         pavgb xmm0,xmm1  
         movd [ebx],xmm0
         add ebx,ecx
         dec eax
         jnz _loop
       };  
};

////////////////////////////////////////////////////////////////////////////
void DrawVLine_AVRHARD(dwRGB *dest, dwRGB color, unsigned vsz, int loffs = DrawLOFFS)
{
  _asm { movd xmm1,color
         mov ebx,dest    
         mov ecx,loffs
         mov eax,vsz
        _loop:
         movd xmm0,[ebx]  
         pavgb xmm0,xmm1  
         pavgb xmm0,xmm1
         movd [ebx],xmm0
         add ebx,ecx
         dec eax
         jnz _loop
       };  
};

////////////////////////////////////////////////////////////////////////////
void DrawVLine_AVRSOFT(dwRGB *dest, dwRGB color, unsigned vsz, int loffs = DrawLOFFS)
{
  _asm { movd xmm2,color
         mov ebx,dest    
         mov ecx,loffs
         mov eax,vsz
        _loop:
         movd xmm0,[ebx]  
         movaps xmm1,xmm2  
         pavgb xmm1,xmm0  
         pavgb xmm1,xmm0
         movd [ebx],xmm1
         add ebx,ecx
         dec eax
         jnz _loop
       };  
};


////////////////////////////////////////////////////////////////////////////
void DrawVLine_MUL(dwRGB *dest, dwRGB color, unsigned vsz, int loffs = DrawLOFFS)
{
  _asm { pxor xmm2,xmm2
         movd xmm1,color
         punpcklbw xmm1,xmm2 
         mov ebx,dest    
         mov ecx,loffs
         mov eax,vsz
        _loop:
         movd xmm0,[ebx]
         punpcklbw xmm0,xmm2 
         pmullw xmm0,xmm1 
         psrlw xmm0,8
         packuswb xmm0,xmm0
         movd [ebx],xmm0  
         add ebx,ecx
         dec eax
         jnz _loop
       };  
};

////////////////////////////////////////////////////////////////////////////
void DrawVLine_IMUL(dwRGB *dest, dwRGB color, unsigned vsz, int loffs = DrawLOFFS)
{
  color ^=0xffffffff;
  int x[2] = {0xffffffff, 0xffffffff};
  _asm { pxor xmm2,xmm2
         movlps xmm3,x
         movd xmm1,color
         punpcklbw xmm1,xmm2 
         mov ebx,dest    
         mov ecx,loffs
         mov eax,vsz
        _loop:
         movd xmm0,[ebx] 
         xorps xmm0,xmm3  
         punpcklbw xmm0,xmm2 
         pmullw xmm0,xmm1 
         psrlw xmm0,8
         packuswb xmm0,xmm0 
         xorps xmm0,xmm3  
         movd [ebx],xmm0  
         add ebx,ecx
         dec eax
         jnz _loop
       };  
};

////////////////////////////////////////////////////////////////////////////
void DrawVLine_PUTALPHA(dwRGB *dest, dwRGB color, unsigned vsz, int loffs = DrawLOFFS)
{
  _asm { pxor xmm2,xmm2
         movd xmm3,color
         movaps xmm4,xmm3 
         pshufd xmm4,xmm4,0
         psrld xmm4,24
         movaps xmm5,xmm4
         psllq xmm5,16
         por xmm4,xmm5
         punpcklbw xmm3,xmm2    
         mov ebx,dest    
         mov ecx,loffs
         mov eax,vsz
        _loop:
         movd xmm0,[ebx]
         movaps xmm1,xmm3  
         punpcklbw xmm0,xmm2 
         psubw xmm1,xmm0  
         psllw xmm0,8     
         pmullw xmm1,xmm4 
         paddw xmm0,xmm1  
         psrlw xmm0,8     
         packuswb xmm0,xmm0
         movd [ebx],xmm0   
         add ebx,ecx
         dec eax
         jnz _loop
       };  
};

////////////////////////////////////////////////////////////////////////////
//  
inline void DrawPoint_PUT(dwRGB *dest, dwRGB color)
{
  _asm { mov edx,color
         mov ebx,dest    
         mov [ebx],edx
       };  
};

////////////////////////////////////////////////////////////////////////////
inline void DrawPoint_ADD(dwRGB *dest, dwRGB color)
{
  _asm { movd xmm1,color
         mov ebx,dest    
         movd xmm0,[ebx]
         paddusb xmm0,xmm1  
         movd [ebx],xmm0
       };  
};

////////////////////////////////////////////////////////////////////////////
inline void DrawPoint_SUB(dwRGB *dest, dwRGB color)
{
  _asm { movd xmm1,color
         mov ebx,dest    
         movd xmm0,[ebx]
         psubusb xmm0,xmm1   
         movd [ebx],xmm0
       };  
};

////////////////////////////////////////////////////////////////////////////
inline void DrawPoint_MAX(dwRGB *dest, dwRGB color)
{
  _asm { movd xmm1,color
         mov ebx,dest    
         movd xmm0,[ebx]
         pmaxub xmm0,xmm1   
         movd [ebx],xmm0
       };  
};

////////////////////////////////////////////////////////////////////////////
inline void DrawPoint_AVR(dwRGB *dest, dwRGB color)
{
  _asm { movd xmm1,color
         mov ebx,dest    
         movd xmm0,[ebx]
         pavgb xmm0,xmm1    
         movd [ebx],xmm0
       };  
};

////////////////////////////////////////////////////////////////////////////
inline void DrawPoint_AVRHARD(dwRGB *dest, dwRGB color)
{
  _asm { movd xmm1,color
         mov ebx,dest    
         movd xmm0,[ebx]
         pavgb xmm0,xmm1    
         pavgb xmm0,xmm1    
         movd [ebx],xmm0
       };  
};

////////////////////////////////////////////////////////////////////////////
inline void DrawPoint_AVRSOFT(dwRGB *dest, dwRGB color)
{
  _asm { movd xmm1,color
         mov ebx,dest    
         movd xmm0,[ebx]
         pavgb xmm1,xmm0    
         pavgb xmm1,xmm0    
         movd [ebx],xmm1
       };  
};

////////////////////////////////////////////////////////////////////////////
inline void DrawPoint_MUL(dwRGB *dest, dwRGB color)
{
  _asm { pxor xmm2,xmm2
         mov ebx,dest
         movd xmm1,color
         pshufd xmm1,xmm1,0
         punpcklbw xmm1,xmm2 
         movd xmm0,[ebx]  
         punpcklbw xmm0,xmm2 
         pmullw xmm0,xmm1 
         psrlw xmm0,8
         packuswb xmm0,xmm0 
         movd [ebx],xmm0
       };  
};

////////////////////////////////////////////////////////////////////////////
inline void DrawPoint_IMUL(dwRGB *dest, dwRGB color)
{
  color ^=0xffffffff;
  int x = 0xffffffff;
  _asm { pxor xmm2,xmm2
         mov ebx,dest
         movd xmm3,x
         movd xmm1,color
         pshufd xmm1,xmm1,0
         punpcklbw xmm1,xmm2 
         movd xmm0,[ebx]
         xorps xmm0,xmm3           
         punpcklbw xmm0,xmm2 
         pmullw xmm0,xmm1 
         psrlw xmm0,8
         packuswb xmm0,xmm0 
         xorps xmm0,xmm3           
         movd [ebx],xmm0
       };  
};

////////////////////////////////////////////////////////////////////////////
inline void DrawPoint_PUTALPHA(dwRGB *dest, dwRGB color)
{
  _asm { mov ebx,dest    
         movd xmm1,color
         movaps xmm3,xmm1 
         pshufd xmm3,xmm3,0
         psrld xmm3,24
         movaps xmm2,xmm3
         psllq xmm2,16
         por xmm3,xmm2
         pxor xmm2,xmm2
         punpcklbw xmm1,xmm2    
         movd xmm0,[ebx]
         punpcklbw xmm0,xmm2 
         psubw xmm1,xmm0  
         psllw xmm0,8     
         pmullw xmm1,xmm3 
         paddw xmm0,xmm1  
         psrlw xmm0,8     
         packuswb xmm0,xmm0
         movd [ebx],xmm0   
       };  
};

///////////////////////////////////////////////////////////////////////////
inline unsigned ALPHAsp(unsigned alpha) { return alpha | (alpha << 16);};

////////////////////////////////////////////////////////////////////////////
inline void DrawPoint_PUTALPHASP(dwRGB *dest, dwRGB color, unsigned alphasp)
{
  _asm { mov ebx,dest    
         movd xmm1,color
         pxor xmm2,xmm2
         punpcklbw xmm1,xmm2    
         movd xmm0,[ebx]
         punpcklbw xmm0,xmm2 
         psubw xmm1,xmm0  
         psllw xmm0,8
         movd  xmm2,alphasp
         pshufd xmm2,xmm2,0     
         pmullw xmm1,xmm2 
         paddw xmm0,xmm1  
         psrlw xmm0,8     
         packuswb xmm0,xmm0
         movd [ebx],xmm0   
       };  
};

///////////////////////////////////////////////////////////////////////////
void DrawPoint(dwRGB *dest, dwRGB c, int mode)
{ 
  switch (mode) 
  { case modePUT:      DrawPoint_PUT(dest,c); break;
    case modePUTALPHA: DrawPoint_PUTALPHA(dest,c); break;
    case modeADD:      DrawPoint_ADD(dest,c); break;
    case modeSUB:      DrawPoint_SUB(dest,c); break;
    case modeMUL:      DrawPoint_MUL(dest,c);  break;
    case modeAVR:      DrawPoint_AVR(dest,c); break;
    case modeAVRHARD:  DrawPoint_AVRHARD(dest,c); break;
    case modeAVRSOFT:  DrawPoint_AVRSOFT(dest,c); break;
    case modeMAX:      DrawPoint_MAX(dest,c); break;
    case modeIMUL:     DrawPoint_IMUL(dest,c); break;
    default:           DrawPoint_PUT(dest,c); 
  };
};

///////////////////////////////////////////////////////////////////////////
//   
void DrawFill(dwRGB c, int mode) { DrawRect(RegionIs(0, 0, DrawXR, DrawYR), c, mode); };

///////////////////////////////////////////////////////////////////////////
//  
void DrawHLine(dwRGB *dest, dwRGB c, unsigned sz, int mode)
{ 
  switch (mode) 
  { case modePUT:      DrawHLine_PUT(dest,c,sz); break;
    case modePUTALPHA: DrawHLine_PUTALPHA(dest,c,sz); break;
    case modeADD:      DrawHLine_ADD(dest,c,sz); break;
    case modeSUB:      DrawHLine_SUB(dest,c,sz); break;
    case modeMUL:      DrawHLine_MUL(dest,c,sz);  break;
    case modeAVR:      DrawHLine_AVR(dest,c,sz); break;
    case modeAVRHARD:  DrawHLine_AVRHARD(dest,c,sz); break;
    case modeAVRSOFT:  DrawHLine_AVRSOFT(dest,c,sz); break;
    case modeMAX:      DrawHLine_MAX(dest,c,sz); break;
    case modeIMUL:     DrawHLine_IMUL(dest,c,sz); break;
    default:           DrawHLine_PUT(dest,c,sz); 
  };
};

///////////////////////////////////////////////////////////////////////////
//  
void DrawVLine(dwRGB *dest, dwRGB c, unsigned vsz, int mode)
{ 
  switch (mode) 
  { case modePUT:      DrawVLine_PUT(dest,c,vsz); break;
    case modePUTALPHA: DrawVLine_PUTALPHA(dest,c,vsz); break;
    case modeADD:      DrawVLine_ADD(dest,c,vsz); break;
    case modeSUB:      DrawVLine_SUB(dest,c,vsz); break;
    case modeMUL:      DrawVLine_MUL(dest,c,vsz);  break;
    case modeAVR:      DrawVLine_AVR(dest,c,vsz); break;
    case modeAVRHARD:  DrawVLine_AVRHARD(dest,c,vsz); break;
    case modeAVRSOFT:  DrawVLine_AVRSOFT(dest,c,vsz); break;
    case modeMAX:      DrawVLine_MAX(dest,c,vsz); break;
    case modeIMUL:     DrawVLine_IMUL(dest,c,vsz);  break;
    default:           DrawVLine_PUT(dest,c,vsz); 
  };
};

///////////////////////////////////////////////////////////////////////////
//  
void DrawRect(tRegion r, dwRGB c, int mode)
{ 
  unsigned xsz,ysz;
  
  DrawRegionClipSZ(r,xsz,ysz); if (!RegionValid(r)) return;
  dwRGB *dest = DrawPointPtr(r.X,r.Y);
  
  if (xsz == 1)
   switch (mode) 
    { case modePUT:      DrawVLine_PUT(dest,c,ysz); return;
      case modePUTALPHA: DrawVLine_PUTALPHA(dest,c,ysz); return;
      case modeADD:      DrawVLine_ADD(dest,c,ysz); return;
      case modeSUB:      DrawVLine_SUB(dest,c,ysz); return;
      case modeMUL:      DrawVLine_MUL(dest,c,ysz);  return;
      case modeAVR:      DrawVLine_AVR(dest,c,ysz); return;
      case modeAVRHARD:  DrawVLine_AVRHARD(dest,c,ysz); return;
      case modeAVRSOFT:  DrawVLine_AVRSOFT(dest,c,ysz); return;
      case modeMAX:      DrawVLine_MAX(dest,c,ysz); return;
      case modeIMUL:     DrawVLine_IMUL(dest,c,ysz);  return;
      default:           DrawVLine_PUT(dest,c,ysz); return;
    };
  
  switch (mode) 
  { case modePUT:      DrawFRect_PUT(dest,c,xsz,ysz); break;
    case modePUTALPHA: DrawFRect_PUTALPHA(dest,c,xsz,ysz); break;
    case modeADD:      DrawFRect_ADD(dest,c,xsz,ysz); break;
    case modeSUB:      DrawFRect_SUB(dest,c,xsz,ysz); break;
    case modeMUL:      DrawFRect_MUL(dest,c,xsz,ysz); break;
    case modeAVR:      DrawFRect_AVR(dest,c,xsz,ysz); break;
    case modeAVRHARD:  DrawFRect_AVRHARD(dest,c,xsz,ysz); break;
    case modeAVRSOFT:  DrawFRect_AVRSOFT(dest,c,xsz,ysz); break;
    case modeMAX:      DrawFRect_MAX(dest,c,xsz,ysz); break;
    case modeIMUL:     DrawFRect_IMUL(dest,c,xsz,ysz); break;
    default:           DrawFRect_PUT(dest,c,xsz,ysz); break;
  };
};

///////////////////////////////////////////////////////////////////////////
void DrawRect(tfRegion r, dwRGB c, int mode)
{ 
};

////////////////////////////////////////////////////////////////////////////
//  
void DrawImage(dwRGB *dest, dwRGB *source, unsigned sz, int mode)
{
  switch (mode) 
  { case modePUT:      DrawImage_PUT(dest,source,sz,sz); break;
    case modePUTALPHA: DrawImage_PUTALPHA(dest,source,sz,sz); break;
    case modeADD:      DrawImage_ADD(dest,source,sz,sz); break;
    case modeSUB:      DrawImage_SUB(dest,source,sz,sz); break;
    case modeMUL:      DrawImage_MUL(dest,source,sz,sz); break;
    case modeAVR:      DrawImage_AVR(dest,source,sz,sz); break;
    case modeAVRHARD:  DrawImage_AVRHARD(dest,source,sz,sz); break;
    case modeAVRSOFT:  DrawImage_AVRSOFT(dest,source,sz,sz); break;
    case modeMAX:      DrawImage_MAX(dest,source,sz,sz); break;
    default:           DrawImage_PUT(dest,source,sz,sz,sz); break;
  };
};

////////////////////////////////////////////////////////////////////////////
void DrawImage(tRegion r, dwRGB *bits, int mode, int linesz)
{ 
  unsigned bsz, xsz, ysz;
  
  DrawRegionImageClip(r,&bits,bsz,xsz,ysz,linesz); if (!RegionValid(r)) return;
  dwRGB *dest = DrawPointPtr(r.X,r.Y);
  
  switch (mode) 
  { case modePUT:      DrawImage_PUT(dest,bits,bsz,xsz,ysz); break;
    case modePUTALPHA: DrawImage_PUTALPHA(dest,bits,bsz,xsz,ysz); break;
    case modeADD:      DrawImage_ADD(dest,bits,bsz,xsz,ysz); break;
    case modeSUB:      DrawImage_SUB(dest,bits,bsz,xsz,ysz); break;
    case modeMUL:      DrawImage_MUL(dest,bits,bsz,xsz,ysz); break;
    case modeAVR:      DrawImage_AVR(dest,bits,bsz,xsz,ysz); break;
    case modeAVRHARD:  DrawImage_AVRHARD(dest,bits,bsz,xsz,ysz); break;
    case modeAVRSOFT:  DrawImage_AVRSOFT(dest,bits,bsz,xsz,ysz); break;
    case modeMAX:      DrawImage_MAX(dest,bits,bsz,xsz,ysz); break;
    default:           DrawImage_PUT(dest,bits,bsz,xsz,ysz); break;
  };
};

///////////////////////////////////////////////////////////////////////////
void DrawImage(tRegion fr, tRegion r, dwRGB *bits, int mode)
{
};

///////////////////////////////////////////////////////////////////////////
void DrawImageGet(dwRGB_arr *bits, tRegion r) //           
{ 
  int xr, yr, loffs = DrawLOFFS;
  dwRGB *source;
  if (r.X == -1) { xr = DrawXR; yr = DrawYR; loffs = abs(loffs); source = DrawPTRnear;
                 } else { xr = r.XL - r.X + 1; yr = r.YL - r.Y + 1; source = DrawPointPtr(r.X,r.Y);
                        };
/*  if ((xr == DrawXSZ) && (yr == DrawYSZ)) MemMoveA16(bits, source, DrawSZ << 2);
   else*/ { _asm { mov edx,xr
                 shl edx,2
                 mov esi,edx
                 mov eax,bits 
                 mov ebx,source
                 mov edi,ebx
                _line:
                 mov edx,esi
                 mov ecx,esi        
                 and ecx,0xfffffff0 
                 jz _rem            
                 add ecx,ebx        
                _loop: 
                 movups xmm1,[ebx]  
                 movups [eax],xmm1  
                 add ebx,16
                 add eax,16
                 cmp ecx,ebx
                 jne _loop 
                _rem:
                 and edx,0x0f       
                 jz _ex             
                 add edx,ebx        
                _loopr:
                 mov ecx,[ebx]
                 mov [eax],ecx
                 add ebx,4
                 add eax,4
                 cmp edx,ebx
                 jne _loopr
                _ex: 
                 mov ebx,edi
                 add ebx,loffs
                 mov edi,ebx
                 mov ecx,yr
                 dec ecx
                 mov yr,ecx
                 jnz _line  
               };/**/
         };    
};

void DrawImagePut(dwRGB_arr *bits, tRegion r) //           
{ 
  dwRGB *dest = DrawPTRnear;
  unsigned szx,szy;
  int loffs = DrawLOFFS;
  if (r.X == -1) { szx = DrawXR; szy = DrawYR; loffs = abs(loffs); dest = DrawPTRnear;
                 } else { szx = r.XL - r.X + 1; szy = r.YL - r.Y + 1; dest = DrawPointPtr(r.X,r.Y);
                        };
/*  if (szx == DrawXSZ) MemMoveA16(dest, bits, DrawSZ << 2);
   else*/ { _asm { mov edx,DrawXR
                 shl edx,2
                 mov esi,edx
                 mov eax,bits 
                 mov ebx,dest
                 mov edi,ebx
                _line:
                 mov edx,esi
                 mov ecx,esi        
                 and ecx,0xfffffff0 
                 jz _rem            
                 add ecx,ebx        
                _loop: 
                 movups xmm1,[eax]  
                 movups [ebx],xmm1  
                 add ebx,16
                 add eax,16
                 cmp ecx,ebx
                 jne _loop 
                _rem:
                 and edx,0x0f       
                 jz _ex             
                 add edx,ebx        
                _loopr:
                 mov ecx,[eax]
                 mov [ebx],ecx
                 add ebx,4
                 add eax,4
                 cmp edx,ebx
                 jne _loopr
                _ex: 
                 mov ebx,edi
                 add ebx,loffs
                 mov edi,ebx
                 mov ecx,szy
                 dec ecx
                 mov szy,ecx
                 jnz _line  
               };  
        };        
};

////////////////////////////////////////////////////////////////////////////////////////////////////////
//   |modePUT|
void DrawAA1_PUT(int x, int y, unsigned c, unsigned a)
{ DrawPoint_PUTALPHASP(DrawPointPtr(x, y), c, ALPHAsp(a));
};

void DrawAA4_PUT_CLIP(int x, int y, int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a, int f)
{ a = ALPHAsp(a);
  if ibits(f,0x21) DrawPoint_PUTALPHASP(DrawPointPtr(x_m_ix, y), c, a);
  if ibits(f,0x22) DrawPoint_PUTALPHASP(DrawPointPtr(x_p_ix, y), c, a);
  if ibits(f,0x14) DrawPoint_PUTALPHASP(DrawPointPtr(x, y_m_ix), c, a);
  if ibits(f,0x18) DrawPoint_PUTALPHASP(DrawPointPtr(x, y_p_ix), c, a);
  if (f & 0x20) { x_m_ix = mzero(x_m_ix + 1); x_p_ix += pzero(DrawXR - x_p_ix);
                  DrawHLine_PUT(DrawLinePtr(y) + x_m_ix, c, x_p_ix - x_m_ix); 
                }; 
};

void DrawAA4_PUT(int x, int y, int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a)
{
  a = ALPHAsp(a);
  dwRGB *p1m = DrawPointPtr(x_m_ix, y), *p1p = DrawPointPtr(x_p_ix, y),
        *p2m = DrawPointPtr(x, y_m_ix), *p2p = DrawPointPtr(x, y_p_ix);
  DrawPoint_PUTALPHASP(p1m, c, a); DrawPoint_PUTALPHASP(p1p, c, a);
  DrawPoint_PUTALPHASP(p2m, c, a); DrawPoint_PUTALPHASP(p2p, c, a);
  DrawHLine_PUT(p1m + 1,c, x_p_ix - x_m_ix - 1); 
};

void DrawAA4D_PUT_CLIP(int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a, int f)
{ a = ALPHAsp(a);
  if ibits(f,0x05) DrawPoint_PUTALPHASP(DrawPointPtr(x_m_ix, y_m_ix), c, a);
  if ibits(f,0x06) DrawPoint_PUTALPHASP(DrawPointPtr(x_p_ix, y_m_ix), c, a);
  if ibits(f,0x09) DrawPoint_PUTALPHASP(DrawPointPtr(x_m_ix, y_p_ix), c, a);
  if ibits(f,0x0a) DrawPoint_PUTALPHASP(DrawPointPtr(x_p_ix, y_p_ix), c, a);
};

void DrawAA4D_PUT(int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a)
{
  a = ALPHAsp(a);
  dwRGB *p1m = DrawPointPtr(x_m_ix, y_m_ix), *p1p = DrawPointPtr(x_p_ix, y_m_ix),
        *p2m = DrawPointPtr(x_m_ix, y_p_ix), *p2p = DrawPointPtr(x_p_ix, y_p_ix);
  DrawPoint_PUTALPHASP(p1m, c, a); DrawPoint_PUTALPHASP(p1p, c, a);
  DrawPoint_PUTALPHASP(p2m, c, a); DrawPoint_PUTALPHASP(p2p, c, a);
};

void DrawAA8_PUT_CLIP(int x_m_ix, int x_p_ix, int x_m_i, int x_p_i, int y_m_ix, int y_p_ix, int y_m_i, int y_p_i, unsigned c, unsigned a, int fi)
{
  int x1, x2, sz1, sz2, f = Draw4XRin4YRin(x_m_ix,x_p_ix,x_m_i,x_p_i,y_m_ix,y_p_ix,y_m_i,y_p_i);
  a = ALPHAsp(a);
  if ibits(f,0x41) DrawPoint_PUTALPHASP(DrawPointPtr(x_m_ix, y_m_i), c, a);
  if ibits(f,0x42) DrawPoint_PUTALPHASP(DrawPointPtr(x_p_ix, y_m_i), c, a);
  if ibits(f,0x81) DrawPoint_PUTALPHASP(DrawPointPtr(x_m_ix, y_p_i), c, a);
  if ibits(f,0x82) DrawPoint_PUTALPHASP(DrawPointPtr(x_p_ix, y_p_i), c, a);
  if (x_m_ix != x_m_i) { if ibits(f,0x14) DrawPoint_PUTALPHASP(DrawPointPtr(x_m_i, y_m_ix), c, a);
                         if ibits(f,0x18) DrawPoint_PUTALPHASP(DrawPointPtr(x_p_i, y_m_ix), c, a);
                         if ibits(f,0x24) DrawPoint_PUTALPHASP(DrawPointPtr(x_m_i, y_p_ix), c, a);
                         if ibits(f,0x28) DrawPoint_PUTALPHASP(DrawPointPtr(x_p_i, y_p_ix), c, a);
                       } else fi = no;   
  x1 = mzero(x_m_ix + 1); sz1 = x_p_ix + pzero(DrawXR - x_p_ix) - x1;
  x2 = mzero(x_m_i + 1); sz2 = x_p_i + pzero(DrawXR - x_p_i) - x2;            
  if (!mI(sz1)) { if ibits(f,0x40) DrawHLine_PUT(DrawLinePtr(y_m_i) + x1, c, sz1); 
                  if ibits(f,0x80) DrawHLine_PUT(DrawLinePtr(y_p_i) + x1, c, sz1); 
                };
  if (fi & !mI(sz2)) { if ibits(f,0x10) DrawHLine_PUT(DrawLinePtr(y_m_ix) + x2, c, sz2); 
                       if ibits(f,0x20) DrawHLine_PUT(DrawLinePtr(y_p_ix) + x2, c, sz2); 
                     };  

};

void DrawAA8_PUT(int x_m_ix, int x_p_ix, int x_m_i, int x_p_i, int y_m_ix, int y_p_ix, int y_m_i, int y_p_i, unsigned c, unsigned a, int fi)
{
  a = ALPHAsp(a);
  int szix = x_p_ix - x_m_ix, szi = x_p_i - x_m_i; 
  dwRGB *p1m = DrawPointPtr(x_m_ix, y_m_i), *p1p = p1m + szix,
        *p2m = DrawPointPtr(x_m_ix, y_p_i), *p2p = p2m + szix,
        *p3m = DrawPointPtr(x_m_i, y_m_ix), *p3p = p3m + szi,
        *p4m = DrawPointPtr(x_m_i, y_p_ix), *p4p = p4m + szi; 
  DrawPoint_PUTALPHASP(p1m, c, a); DrawPoint_PUTALPHASP(p1p, c, a);
  DrawPoint_PUTALPHASP(p2m, c, a); DrawPoint_PUTALPHASP(p2p, c, a);
  if (x_m_ix != x_m_i) { DrawPoint_PUTALPHASP(p3m, c, a); DrawPoint_PUTALPHASP(p3p, c, a);
                         DrawPoint_PUTALPHASP(p4m, c, a); DrawPoint_PUTALPHASP(p4p, c, a);
                       } else fi = no;   
  p1m += 1; p2m += 1; p3m += 1; p4m += 1; szix -= 1; szi -= 1;
  DrawHLine_PUT(p1m,c,szix); DrawHLine_PUT(p2m,c,szix);
  if (fi) { DrawHLine_PUT(p3m,c,szi); DrawHLine_PUT(p4m,c,szi); };
};/**/

////////////////////////////////////////////////////////////////////////////////////////////////////////
//   |modePUTALPHA|
void DrawAA1_PUTALPHA(int x, int y, unsigned c, unsigned a)
{ DrawPoint_PUTALPHASP(DrawPointPtr(x, y), c, ALPHAsp(a * RGBalpha(c) >> 8));
};

void DrawAA4_PUTALPHA_CLIP(int x, int y, int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a, int f)
{ a = ALPHAsp(a * RGBalpha(c) >> 8);
  if ibits(f,0x21) DrawPoint_PUTALPHASP(DrawPointPtr(x_m_ix, y), c, a);
  if ibits(f,0x22) DrawPoint_PUTALPHASP(DrawPointPtr(x_p_ix, y), c, a);
  if ibits(f,0x14) DrawPoint_PUTALPHASP(DrawPointPtr(x, y_m_ix), c, a);
  if ibits(f,0x18) DrawPoint_PUTALPHASP(DrawPointPtr(x, y_p_ix), c, a);
  if (f & 0x20) { x_m_ix = mzero(x_m_ix + 1); x_p_ix += pzero(DrawXR - x_p_ix);
                  DrawHLine_PUTALPHA(DrawLinePtr(y) + x_m_ix, c, x_p_ix - x_m_ix); 
                }; 
};

void DrawAA4_PUTALPHA(int x, int y, int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a)
{
  a = ALPHAsp(a * RGBalpha(c) / 255);
  dwRGB *p1m = DrawPointPtr(x_m_ix, y), *p1p = DrawPointPtr(x_p_ix, y),
        *p2m = DrawPointPtr(x, y_m_ix), *p2p = DrawPointPtr(x, y_p_ix);
  DrawPoint_PUTALPHASP(p1m, c, a); DrawPoint_PUTALPHASP(p1p, c, a);
  DrawPoint_PUTALPHASP(p2m, c, a); DrawPoint_PUTALPHASP(p2p, c, a);
  DrawHLine_PUTALPHA(p1m + 1,c, x_p_ix - x_m_ix - 1); 
};

void DrawAA4D_PUTALPHA_CLIP(int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a, int f)
{ a = ALPHAsp(a * RGBalpha(c) / 255);
  if ibits(f,0x05) DrawPoint_PUTALPHASP(DrawPointPtr(x_m_ix, y_m_ix), c, a);
  if ibits(f,0x06) DrawPoint_PUTALPHASP(DrawPointPtr(x_p_ix, y_m_ix), c, a);
  if ibits(f,0x09) DrawPoint_PUTALPHASP(DrawPointPtr(x_m_ix, y_p_ix), c, a);
  if ibits(f,0x0a) DrawPoint_PUTALPHASP(DrawPointPtr(x_p_ix, y_p_ix), c, a);
};

void DrawAA4D_PUTALPHA(int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a)
{
  a = ALPHAsp(a * RGBalpha(c) / 255);
  dwRGB *p1m = DrawPointPtr(x_m_ix, y_m_ix), *p1p = DrawPointPtr(x_p_ix, y_m_ix),
        *p2m = DrawPointPtr(x_m_ix, y_p_ix), *p2p = DrawPointPtr(x_p_ix, y_p_ix);
  DrawPoint_PUTALPHASP(p1m, c, a); DrawPoint_PUTALPHASP(p1p, c, a);
  DrawPoint_PUTALPHASP(p2m, c, a); DrawPoint_PUTALPHASP(p2p, c, a);
};

void DrawAA8_PUTALPHA_CLIP(int x_m_ix, int x_p_ix, int x_m_i, int x_p_i, int y_m_ix, int y_p_ix, int y_m_i, int y_p_i, unsigned c, unsigned a, int fi)
{
  int x1, x2, sz1, sz2, f = Draw4XRin4YRin(x_m_ix,x_p_ix,x_m_i,x_p_i,y_m_ix,y_p_ix,y_m_i,y_p_i);
  a = ALPHAsp(a * RGBalpha(c) / 255);
  if ibits(f,0x41) DrawPoint_PUTALPHASP(DrawPointPtr(x_m_ix, y_m_i), c, a);
  if ibits(f,0x42) DrawPoint_PUTALPHASP(DrawPointPtr(x_p_ix, y_m_i), c, a);
  if ibits(f,0x81) DrawPoint_PUTALPHASP(DrawPointPtr(x_m_ix, y_p_i), c, a);
  if ibits(f,0x82) DrawPoint_PUTALPHASP(DrawPointPtr(x_p_ix, y_p_i), c, a);
  if (x_m_ix != x_m_i) { if ibits(f,0x14) DrawPoint_PUTALPHASP(DrawPointPtr(x_m_i, y_m_ix), c, a);
                         if ibits(f,0x18) DrawPoint_PUTALPHASP(DrawPointPtr(x_p_i, y_m_ix), c, a);
                         if ibits(f,0x24) DrawPoint_PUTALPHASP(DrawPointPtr(x_m_i, y_p_ix), c, a);
                         if ibits(f,0x28) DrawPoint_PUTALPHASP(DrawPointPtr(x_p_i, y_p_ix), c, a);
                       } else fi = no;  
  x1 = mzero(x_m_ix + 1); sz1 = x_p_ix + pzero(DrawXR - x_p_ix) - x1;
  x2 = mzero(x_m_i + 1); sz2 = x_p_i + pzero(DrawXR - x_p_i) - x2;            
  if (!mI(sz1)) { if ibits(f,0x40) DrawHLine_PUTALPHA(DrawLinePtr(y_m_i) + x1, c, sz1); 
                  if ibits(f,0x80) DrawHLine_PUTALPHA(DrawLinePtr(y_p_i) + x1, c, sz1); 
                };
  if (fi & !mI(sz2)) { if ibits(f,0x10) DrawHLine_PUTALPHA(DrawLinePtr(y_m_ix) + x2, c, sz2); 
                       if ibits(f,0x20) DrawHLine_PUTALPHA(DrawLinePtr(y_p_ix) + x2, c, sz2); 
                     };  
};

void DrawAA8_PUTALPHA(int x_m_ix, int x_p_ix, int x_m_i, int x_p_i, int y_m_ix, int y_p_ix, int y_m_i, int y_p_i, unsigned c, unsigned a, int fi)
{
  a = ALPHAsp(a * RGBalpha(c) / 255);
  int szix = x_p_ix - x_m_ix, szi = x_p_i - x_m_i; 
  dwRGB *p1m = DrawPointPtr(x_m_ix, y_m_i), *p1p = p1m + szix,
        *p2m = DrawPointPtr(x_m_ix, y_p_i), *p2p = p2m + szix,
        *p3m = DrawPointPtr(x_m_i, y_m_ix), *p3p = p3m + szi,
        *p4m = DrawPointPtr(x_m_i, y_p_ix), *p4p = p4m + szi; 
  DrawPoint_PUTALPHASP(p1m, c, a); DrawPoint_PUTALPHASP(p1p, c, a);
  DrawPoint_PUTALPHASP(p2m, c, a); DrawPoint_PUTALPHASP(p2p, c, a);
  if (x_m_ix != x_m_i) { DrawPoint_PUTALPHASP(p3m, c, a); DrawPoint_PUTALPHASP(p3p, c, a);
                         DrawPoint_PUTALPHASP(p4m, c, a); DrawPoint_PUTALPHASP(p4p, c, a);
                       } else fi = no;  
  p1m += 1; p2m += 1; p3m += 1; p4m += 1; szix -= 1; szi -= 1;
  DrawHLine_PUTALPHA(p1m,c,szix); DrawHLine_PUTALPHA(p2m,c,szix);
  if (fi) { DrawHLine_PUTALPHA(p3m,c,szi); DrawHLine_PUTALPHA(p4m,c,szi); };
};/**/

////////////////////////////////////////////////////////////////////////////////////////////////////////
//   |modeADD|
void DrawAA1_ADD(int x, int y, unsigned c, unsigned a)
{ DrawPoint_ADD(DrawPointPtr(x, y), RGBmultV(c,a));
};

void DrawAA4_ADD_CLIP(int x, int y, int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a, int f)
{ a = RGBmultV(c,a);
  if ibits(f,0x21) DrawPoint_ADD(DrawPointPtr(x_m_ix, y), a);
  if ibits(f,0x22) DrawPoint_ADD(DrawPointPtr(x_p_ix, y), a);
  if ibits(f,0x14) DrawPoint_ADD(DrawPointPtr(x, y_m_ix), a);
  if ibits(f,0x18) DrawPoint_ADD(DrawPointPtr(x, y_p_ix), a);
  if (f & 0x20) { x_m_ix = mzero(x_m_ix + 1); x_p_ix += pzero(DrawXR - x_p_ix);
                  DrawHLine_ADD(DrawLinePtr(y) + x_m_ix, c, x_p_ix - x_m_ix); 
                }; 
};

void DrawAA4_ADD(int x, int y, int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a)
{
  a = RGBmultV(c,a);
  dwRGB *p1m = DrawPointPtr(x_m_ix, y), *p1p = DrawPointPtr(x_p_ix, y),
        *p2m = DrawPointPtr(x, y_m_ix), *p2p = DrawPointPtr(x, y_p_ix);
  DrawPoint_ADD(p1m, a); DrawPoint_ADD(p1p, a);
  DrawPoint_ADD(p2m, a); DrawPoint_ADD(p2p, a);
  DrawHLine_ADD(p1m + 1, c, x_p_ix - x_m_ix - 1); 
};

void DrawAA4D_ADD_CLIP(int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a, int f)
{ a = RGBmultV(c,a);
  if ibits(f,0x05) DrawPoint_ADD(DrawPointPtr(x_m_ix, y_m_ix), a);
  if ibits(f,0x06) DrawPoint_ADD(DrawPointPtr(x_p_ix, y_m_ix), a);
  if ibits(f,0x09) DrawPoint_ADD(DrawPointPtr(x_m_ix, y_p_ix), a);
  if ibits(f,0x0a) DrawPoint_ADD(DrawPointPtr(x_p_ix, y_p_ix), a);
};


void DrawAA4D_ADD(int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a)
{
  a = RGBmultV(c,a);
  dwRGB *p1m = DrawPointPtr(x_m_ix, y_m_ix) , *p1p = DrawPointPtr(x_p_ix, y_m_ix),
        *p2m = DrawPointPtr(x_m_ix, y_p_ix), *p2p = DrawPointPtr(x_p_ix, y_p_ix);
  DrawPoint_ADD(p1m, a); DrawPoint_ADD(p1p, a);
  DrawPoint_ADD(p2m, a); DrawPoint_ADD(p2p, a);
};

void DrawAA8_ADD_CLIP(int x_m_ix, int x_p_ix, int x_m_i, int x_p_i, int y_m_ix, int y_p_ix, int y_m_i, int y_p_i, unsigned c, unsigned a, int fi)
{
  int x1, x2, sz1, sz2, f = Draw4XRin4YRin(x_m_ix,x_p_ix,x_m_i,x_p_i,y_m_ix,y_p_ix,y_m_i,y_p_i);
  a = RGBmultV(c,a);
  if ibits(f,0x41) DrawPoint_ADD(DrawPointPtr(x_m_ix, y_m_i), a);
  if ibits(f,0x42) DrawPoint_ADD(DrawPointPtr(x_p_ix, y_m_i), a);
  if ibits(f,0x81) DrawPoint_ADD(DrawPointPtr(x_m_ix, y_p_i), a);
  if ibits(f,0x82) DrawPoint_ADD(DrawPointPtr(x_p_ix, y_p_i), a);
  if (x_m_ix != x_m_i) { if ibits(f,0x14) DrawPoint_ADD(DrawPointPtr(x_m_i, y_m_ix), a);
                         if ibits(f,0x18) DrawPoint_ADD(DrawPointPtr(x_p_i, y_m_ix), a);
                         if ibits(f,0x24) DrawPoint_ADD(DrawPointPtr(x_m_i, y_p_ix), a);
                         if ibits(f,0x28) DrawPoint_ADD(DrawPointPtr(x_p_i, y_p_ix), a); 
                       } else fi = no; 
  x1 = mzero(x_m_ix + 1); sz1 = x_p_ix + pzero(DrawXR - x_p_ix) - x1;
  x2 = mzero(x_m_i + 1); sz2 = x_p_i + pzero(DrawXR - x_p_i) - x2;            
  if (!mI(sz1)) { if ibits(f,0x40) DrawHLine_ADD(DrawLinePtr(y_m_i) + x1, c, sz1); 
                  if ibits(f,0x80) DrawHLine_ADD(DrawLinePtr(y_p_i) + x1, c, sz1); 
                };
  if (fi & !mI(sz2)) { if ibits(f,0x10) DrawHLine_ADD(DrawLinePtr(y_m_ix) + x2, c, sz2); 
                       if ibits(f,0x20) DrawHLine_ADD(DrawLinePtr(y_p_ix) + x2, c, sz2); 
                     };  
};

void DrawAA8_ADD(int x_m_ix, int x_p_ix, int x_m_i, int x_p_i, int y_m_ix, int y_p_ix, int y_m_i, int y_p_i, unsigned c, unsigned a, int fi)
{
  a = RGBmultV(c,a);
  int szix = x_p_ix - x_m_ix, szi = x_p_i - x_m_i; 
  dwRGB *p1m = DrawPointPtr(x_m_ix, y_m_i), *p1p = p1m + szix,
        *p2m = DrawPointPtr(x_m_ix, y_p_i), *p2p = p2m + szix,
        *p3m = DrawPointPtr(x_m_i, y_m_ix), *p3p = p3m + szi,
        *p4m = DrawPointPtr(x_m_i, y_p_ix), *p4p = p4m + szi; 
  DrawPoint_ADD(p1m, a); DrawPoint_ADD(p1p, a);
  DrawPoint_ADD(p2m, a); DrawPoint_ADD(p2p, a);
  if (x_m_ix != x_m_i) { DrawPoint_ADD(p3m, a); DrawPoint_ADD(p3p, a);
                         DrawPoint_ADD(p4m, a); DrawPoint_ADD(p4p, a);
                       } else fi = no;
  p1m += 1; p2m += 1; p3m += 1; p4m += 1; szix -= 1; szi -= 1;
  DrawHLine_ADD(p1m,c,szix); DrawHLine_ADD(p2m,c,szix);
  if (fi) { DrawHLine_ADD(p3m,c,szi); DrawHLine_ADD(p4m,c,szi); };
};

/*
struct tcadz { unsigned c, a, ad, z; };
void DrawAA9_ADD(int xs, int ys, dwRGB c, unsigned a, unsigned ad)
{
  a = RGBmultV(c,a); if (ad) ad = RGBmultV(c,ad);
  tcadz m; m.c = c; m.a = a; m.ad = ad; m.z = 0;
  dwRGB *bits = DrawPointPtr(xs, ys);
  _asm { movups xmm0,m
         pshufd xmm1,xmm0,0xd1
         pshufd xmm2,xmm0,0xe6
         mov eax,bits
         mov ebx,DrawLOFFS
         movups xmm0,[eax]
         paddusb xmm0,xmm2
         movups [eax],xmm0
         add eax,ebx
         movups xmm0,[eax]
         paddusb xmm0,xmm1
         movups [eax],xmm0
         add eax,ebx
         movups xmm0,[eax]
         paddusb xmm0,xmm2
         movups [eax],xmm0
       };  
};/**/

////////////////////////////////////////////////////////////////////////////////////////////////////////
//   |modeSUB|
void DrawAA1_SUB(int x, int y, unsigned c, unsigned a)
{ DrawPoint_SUB(DrawPointPtr(x, y), RGBmultV(c,a));
};

void DrawAA4_SUB_CLIP(int x, int y, int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a, int f)
{ a = RGBmultV(c,a);
  if ibits(f,0x21) DrawPoint_SUB(DrawPointPtr(x_m_ix, y), a);
  if ibits(f,0x22) DrawPoint_SUB(DrawPointPtr(x_p_ix, y), a);
  if ibits(f,0x14) DrawPoint_SUB(DrawPointPtr(x, y_m_ix), a);
  if ibits(f,0x18) DrawPoint_SUB(DrawPointPtr(x, y_p_ix), a);
  if (f & 0x20) { x_m_ix = mzero(x_m_ix + 1); x_p_ix += pzero(DrawXR - x_p_ix);
                  DrawHLine_SUB(DrawLinePtr(y) + x_m_ix, c, x_p_ix - x_m_ix); 
                }; 
};

void DrawAA4_SUB(int x, int y, int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a)
{
  a = RGBmultV(c,a);
  dwRGB *p1m = DrawPointPtr(x_m_ix, y), *p1p = DrawPointPtr(x_p_ix, y),
        *p2m = DrawPointPtr(x, y_m_ix), *p2p = DrawPointPtr(x, y_p_ix);
  DrawPoint_SUB(p1m, a); DrawPoint_SUB(p1p, a);
  DrawPoint_SUB(p2m, a); DrawPoint_SUB(p2p, a);
  DrawHLine_SUB(p1m + 1, c, x_p_ix - x_m_ix - 1); 
};

void DrawAA4D_SUB_CLIP(int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a, int f)
{ a = RGBmultV(c,a);
  if ibits(f,0x05) DrawPoint_SUB(DrawPointPtr(x_m_ix, y_m_ix), a);
  if ibits(f,0x06) DrawPoint_SUB(DrawPointPtr(x_p_ix, y_m_ix), a);
  if ibits(f,0x09) DrawPoint_SUB(DrawPointPtr(x_m_ix, y_p_ix), a);
  if ibits(f,0x0a) DrawPoint_SUB(DrawPointPtr(x_p_ix, y_p_ix), a);
};

void DrawAA4D_SUB(int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a)
{
  a = RGBmultV(c,a);
  dwRGB *p1m = DrawPointPtr(x_m_ix, y_m_ix), *p1p = DrawPointPtr(x_p_ix, y_m_ix),
        *p2m = DrawPointPtr(x_m_ix, y_p_ix), *p2p = DrawPointPtr(x_p_ix, y_p_ix);
  DrawPoint_SUB(p1m, a); DrawPoint_SUB(p1p, a);
  DrawPoint_SUB(p2m, a); DrawPoint_SUB(p2p, a);
};

void DrawAA8_SUB_CLIP(int x_m_ix, int x_p_ix, int x_m_i, int x_p_i, int y_m_ix, int y_p_ix, int y_m_i, int y_p_i, unsigned c, unsigned a, int fi)
{
  int x1, x2, sz1, sz2, f = Draw4XRin4YRin(x_m_ix,x_p_ix,x_m_i,x_p_i,y_m_ix,y_p_ix,y_m_i,y_p_i);
  a = RGBmultV(c,a);
  if ibits(f,0x41) DrawPoint_SUB(DrawPointPtr(x_m_ix, y_m_i), a);
  if ibits(f,0x42) DrawPoint_SUB(DrawPointPtr(x_p_ix, y_m_i), a);
  if ibits(f,0x81) DrawPoint_SUB(DrawPointPtr(x_m_ix, y_p_i), a);
  if ibits(f,0x82) DrawPoint_SUB(DrawPointPtr(x_p_ix, y_p_i), a);
  if (x_m_ix != x_m_i) { if ibits(f,0x14) DrawPoint_SUB(DrawPointPtr(x_m_i, y_m_ix), a);
                         if ibits(f,0x18) DrawPoint_SUB(DrawPointPtr(x_p_i, y_m_ix), a);
                         if ibits(f,0x24) DrawPoint_SUB(DrawPointPtr(x_m_i, y_p_ix), a);
                         if ibits(f,0x28) DrawPoint_SUB(DrawPointPtr(x_p_i, y_p_ix), a);
                       } else fi = no;   
  x1 = mzero(x_m_ix + 1); sz1 = x_p_ix + pzero(DrawXR - x_p_ix) - x1;
  x2 = mzero(x_m_i + 1); sz2 = x_p_i + pzero(DrawXR - x_p_i) - x2;            
  if (!mI(sz1)) { if ibits(f,0x40) DrawHLine_SUB(DrawLinePtr(y_m_i) + x1, c, sz1); 
                  if ibits(f,0x80) DrawHLine_SUB(DrawLinePtr(y_p_i) + x1, c, sz1); 
                };
  if (fi & !mI(sz2)) { if ibits(f,0x10) DrawHLine_SUB(DrawLinePtr(y_m_ix) + x2, c, sz2); 
                       if ibits(f,0x20) DrawHLine_SUB(DrawLinePtr(y_p_ix) + x2, c, sz2); 
                     }; 
};

void DrawAA8_SUB(int x_m_ix, int x_p_ix, int x_m_i, int x_p_i, int y_m_ix, int y_p_ix, int y_m_i, int y_p_i, unsigned c, unsigned a, int fi)
{
  a = RGBmultV(c,a);
  int szix = x_p_ix - x_m_ix, szi = x_p_i - x_m_i; 
  dwRGB *p1m = DrawPointPtr(x_m_ix, y_m_i), *p1p = p1m + szix,
        *p2m = DrawPointPtr(x_m_ix, y_p_i), *p2p = p2m + szix,
        *p3m = DrawPointPtr(x_m_i, y_m_ix), *p3p = p3m + szi,
        *p4m = DrawPointPtr(x_m_i, y_p_ix), *p4p = p4m + szi; 
  DrawPoint_SUB(p1m, a); DrawPoint_SUB(p1p, a);
  DrawPoint_SUB(p2m, a); DrawPoint_SUB(p2p, a);
  if (x_m_ix != x_m_i) { DrawPoint_SUB(p3m, a); DrawPoint_SUB(p3p, a);
                         DrawPoint_SUB(p4m, a); DrawPoint_SUB(p4p, a);
                       } else fi = no;   
  p1m += 1; p2m += 1; p3m += 1; p4m += 1; szix -= 1; szi -= 1;
  DrawHLine_SUB(p1m,c,szix); DrawHLine_SUB(p2m,c,szix);
  if (fi) { DrawHLine_SUB(p3m,c,szi); DrawHLine_SUB(p4m,c,szi); };
};

////////////////////////////////////////////////////////////////////////////////////////////////////////
//   |modeMUL|
void DrawAA1_MUL(int x, int y, unsigned c, unsigned a)
{ DrawPoint_MUL(DrawPointPtr(x, y), RGBblend(0x00ffffff,c,a));
};

void DrawAA4_MUL_CLIP(int x, int y, int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a, int f)
{ a = RGBblend(0x00ffffff,c,a);
  if ibits(f,0x21) DrawPoint_MUL(DrawPointPtr(x_m_ix, y), a);
  if ibits(f,0x22) DrawPoint_MUL(DrawPointPtr(x_p_ix, y), a);
  if ibits(f,0x14) DrawPoint_MUL(DrawPointPtr(x, y_m_ix), a);
  if ibits(f,0x18) DrawPoint_MUL(DrawPointPtr(x, y_p_ix), a);
  if (f & 0x20) { x_m_ix = mzero(x_m_ix + 1); x_p_ix += pzero(DrawXR - x_p_ix);
                  DrawHLine_MUL(DrawLinePtr(y) + x_m_ix, c, x_p_ix - x_m_ix); 
                }; 
};

void DrawAA4_MUL(int x, int y, int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a)
{
  a = RGBblend(0x00ffffff,c,a);
  dwRGB *p1m = DrawPointPtr(x_m_ix, y), *p1p = DrawPointPtr(x_p_ix, y),
        *p2m = DrawPointPtr(x, y_m_ix), *p2p = DrawPointPtr(x, y_p_ix);
  DrawPoint_MUL(p1m, a); DrawPoint_MUL(p1p, a);
  DrawPoint_MUL(p2m, a); DrawPoint_MUL(p2p, a);
  DrawHLine_MUL(p1m + 1, c, x_p_ix - x_m_ix - 1); 
};

void DrawAA4D_MUL_CLIP(int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a, int f)
{ a = RGBblend(0x00ffffff,c,a);
  if ibits(f,0x05) DrawPoint_MUL(DrawPointPtr(x_m_ix, y_m_ix), a);
  if ibits(f,0x06) DrawPoint_MUL(DrawPointPtr(x_p_ix, y_m_ix), a);
  if ibits(f,0x09) DrawPoint_MUL(DrawPointPtr(x_m_ix, y_p_ix), a);
  if ibits(f,0x0a) DrawPoint_MUL(DrawPointPtr(x_p_ix, y_p_ix), a);
};

void DrawAA4D_MUL(int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a)
{
  a = RGBblend(0x00ffffff,c,a);
  dwRGB *p1m = DrawPointPtr(x_m_ix, y_m_ix), *p1p = DrawPointPtr(x_p_ix, y_m_ix),
        *p2m = DrawPointPtr(x_m_ix, y_p_ix), *p2p = DrawPointPtr(x_p_ix, y_p_ix);
  DrawPoint_MUL(p1m, a); DrawPoint_MUL(p1p, a);
  DrawPoint_MUL(p2m, a); DrawPoint_MUL(p2p, a);
};


void DrawAA8_MUL_CLIP(int x_m_ix, int x_p_ix, int x_m_i, int x_p_i, int y_m_ix, int y_p_ix, int y_m_i, int y_p_i, unsigned c, unsigned a, int fi)
{
  int x1, x2, sz1, sz2, f = Draw4XRin4YRin(x_m_ix,x_p_ix,x_m_i,x_p_i,y_m_ix,y_p_ix,y_m_i,y_p_i);
  a = RGBblend(0x00ffffff,c,a);
  if ibits(f,0x41) DrawPoint_MUL(DrawPointPtr(x_m_ix, y_m_i), a);
  if ibits(f,0x42) DrawPoint_MUL(DrawPointPtr(x_p_ix, y_m_i), a);
  if ibits(f,0x81) DrawPoint_MUL(DrawPointPtr(x_m_ix, y_p_i), a);
  if ibits(f,0x82) DrawPoint_MUL(DrawPointPtr(x_p_ix, y_p_i), a);
  if (x_m_ix != x_m_i) { if ibits(f,0x14) DrawPoint_MUL(DrawPointPtr(x_m_i, y_m_ix), a);
                         if ibits(f,0x18) DrawPoint_MUL(DrawPointPtr(x_p_i, y_m_ix), a);
                         if ibits(f,0x24) DrawPoint_MUL(DrawPointPtr(x_m_i, y_p_ix), a);
                         if ibits(f,0x28) DrawPoint_MUL(DrawPointPtr(x_p_i, y_p_ix), a);
                       } else fi = no;   
  x1 = mzero(x_m_ix + 1); sz1 = x_p_ix + pzero(DrawXR - x_p_ix) - x1;
  x2 = mzero(x_m_i + 1); sz2 = x_p_i + pzero(DrawXR - x_p_i) - x2;            
  if (!mI(sz1)) { if ibits(f,0x40) DrawHLine_MUL(DrawLinePtr(y_m_i) + x1, c, sz1); 
                  if ibits(f,0x80) DrawHLine_MUL(DrawLinePtr(y_p_i) + x1, c, sz1); 
                };
  if (fi & !mI(sz2)) { if ibits(f,0x10) DrawHLine_MUL(DrawLinePtr(y_m_ix) + x2, c, sz2); 
                       if ibits(f,0x20) DrawHLine_MUL(DrawLinePtr(y_p_ix) + x2, c, sz2); 
                     };                         
};

void DrawAA8_MUL(int x_m_ix, int x_p_ix, int x_m_i, int x_p_i, int y_m_ix, int y_p_ix, int y_m_i, int y_p_i, unsigned c, unsigned a, int fi)
{
  a = RGBblend(0x00ffffff,c,a);
  int szix = x_p_ix - x_m_ix, szi = x_p_i - x_m_i; 
  dwRGB *p1m = DrawPointPtr(x_m_ix, y_m_i), *p1p = p1m + szix,
        *p2m = DrawPointPtr(x_m_ix, y_p_i), *p2p = p2m + szix,
        *p3m = DrawPointPtr(x_m_i, y_m_ix), *p3p = p3m + szi,
        *p4m = DrawPointPtr(x_m_i, y_p_ix), *p4p = p4m + szi; 
  DrawPoint_MUL(p1m, a); DrawPoint_MUL(p1p, a);
  DrawPoint_MUL(p2m, a); DrawPoint_MUL(p2p, a);
  if (x_m_ix != x_m_i) { DrawPoint_MUL(p3m, a); DrawPoint_MUL(p3p, a);
                         DrawPoint_MUL(p4m, a); DrawPoint_MUL(p4p, a);
                       } else fi = no;   
  p1m += 1; p2m += 1; p3m += 1; p4m += 1; szix -= 1; szi -= 1;
  DrawHLine_MUL(p1m,c,szix); DrawHLine_MUL(p2m,c,szix);
  if (fi) { DrawHLine_MUL(p3m,c,szi); DrawHLine_MUL(p4m,c,szi); };
};

////////////////////////////////////////////////////////////////////////////////////////////////////////
//   |modeMUL|
void DrawAA1_IMUL(int x, int y, unsigned c, unsigned a)
{ DrawPoint_IMUL(DrawPointPtr(x, y), RGBmultV(c,a));
};

void DrawAA4_IMUL_CLIP(int x, int y, int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a, int f)
{ a = RGBmultV(c,a);
  if ibits(f,0x21) DrawPoint_IMUL(DrawPointPtr(x_m_ix, y), a);
  if ibits(f,0x22) DrawPoint_IMUL(DrawPointPtr(x_p_ix, y), a);
  if ibits(f,0x14) DrawPoint_IMUL(DrawPointPtr(x, y_m_ix), a);
  if ibits(f,0x18) DrawPoint_IMUL(DrawPointPtr(x, y_p_ix), a);
  if (f & 0x20) { x_m_ix = mzero(x_m_ix + 1); x_p_ix += pzero(DrawXR - x_p_ix);
                  DrawHLine_IMUL(DrawLinePtr(y) + x_m_ix, c, x_p_ix - x_m_ix); 
                }; 
};

void DrawAA4_IMUL(int x, int y, int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a)
{
  a = RGBmultV(c,a);
  dwRGB *p1m = DrawPointPtr(x_m_ix, y), *p1p = DrawPointPtr(x_p_ix, y),
        *p2m = DrawPointPtr(x, y_m_ix), *p2p = DrawPointPtr(x, y_p_ix);
  DrawPoint_IMUL(p1m, a); DrawPoint_IMUL(p1p, a);
  DrawPoint_IMUL(p2m, a); DrawPoint_IMUL(p2p, a);
  DrawHLine_IMUL(p1m + 1, c, x_p_ix - x_m_ix - 1); 
};

void DrawAA4D_IMUL_CLIP(int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a, int f)
{ a = RGBmultV(c,a);
  if ibits(f,0x05) DrawPoint_IMUL(DrawPointPtr(x_m_ix, y_m_ix), a);
  if ibits(f,0x06) DrawPoint_IMUL(DrawPointPtr(x_p_ix, y_m_ix), a);
  if ibits(f,0x09) DrawPoint_IMUL(DrawPointPtr(x_m_ix, y_p_ix), a);
  if ibits(f,0x0a) DrawPoint_IMUL(DrawPointPtr(x_p_ix, y_p_ix), a);
};

void DrawAA4D_IMUL(int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a)
{
  a = RGBmultV(c,a);
  dwRGB *p1m = DrawPointPtr(x_m_ix, y_m_ix), *p1p = DrawPointPtr(x_p_ix, y_m_ix),
        *p2m = DrawPointPtr(x_m_ix, y_p_ix), *p2p = DrawPointPtr(x_p_ix, y_p_ix);
  DrawPoint_IMUL(p1m, a); DrawPoint_IMUL(p1p, a);
  DrawPoint_IMUL(p2m, a); DrawPoint_IMUL(p2p, a);
};


void DrawAA8_IMUL_CLIP(int x_m_ix, int x_p_ix, int x_m_i, int x_p_i, int y_m_ix, int y_p_ix, int y_m_i, int y_p_i, unsigned c, unsigned a, int fi)
{
  int x1, x2, sz1, sz2, f = Draw4XRin4YRin(x_m_ix,x_p_ix,x_m_i,x_p_i,y_m_ix,y_p_ix,y_m_i,y_p_i);
  a = RGBmultV(c,a);
  if ibits(f,0x41) DrawPoint_IMUL(DrawPointPtr(x_m_ix, y_m_i), a);
  if ibits(f,0x42) DrawPoint_IMUL(DrawPointPtr(x_p_ix, y_m_i), a);
  if ibits(f,0x81) DrawPoint_IMUL(DrawPointPtr(x_m_ix, y_p_i), a);
  if ibits(f,0x82) DrawPoint_IMUL(DrawPointPtr(x_p_ix, y_p_i), a);
  if (x_m_ix != x_m_i) { if ibits(f,0x14) DrawPoint_IMUL(DrawPointPtr(x_m_i, y_m_ix), a);
                         if ibits(f,0x18) DrawPoint_IMUL(DrawPointPtr(x_p_i, y_m_ix), a);
                         if ibits(f,0x24) DrawPoint_IMUL(DrawPointPtr(x_m_i, y_p_ix), a);
                         if ibits(f,0x28) DrawPoint_IMUL(DrawPointPtr(x_p_i, y_p_ix), a);
                       } else fi = no;   
  x1 = mzero(x_m_ix + 1); sz1 = x_p_ix + pzero(DrawXR - x_p_ix) - x1;
  x2 = mzero(x_m_i + 1); sz2 = x_p_i + pzero(DrawXR - x_p_i) - x2;            
  if (!mI(sz1)) { if ibits(f,0x40) DrawHLine_IMUL(DrawLinePtr(y_m_i) + x1, c, sz1); 
                  if ibits(f,0x80) DrawHLine_IMUL(DrawLinePtr(y_p_i) + x1, c, sz1); 
                };
  if (fi & !mI(sz2)) { if ibits(f,0x10) DrawHLine_IMUL(DrawLinePtr(y_m_ix) + x2, c, sz2); 
                       if ibits(f,0x20) DrawHLine_IMUL(DrawLinePtr(y_p_ix) + x2, c, sz2); 
                     };                         
};

void DrawAA8_IMUL(int x_m_ix, int x_p_ix, int x_m_i, int x_p_i, int y_m_ix, int y_p_ix, int y_m_i, int y_p_i, unsigned c, unsigned a, int fi)
{
  a = RGBmultV(c,a);
  int szix = x_p_ix - x_m_ix, szi = x_p_i - x_m_i; 
  dwRGB *p1m = DrawPointPtr(x_m_ix, y_m_i), *p1p = p1m + szix,
        *p2m = DrawPointPtr(x_m_ix, y_p_i), *p2p = p2m + szix,
        *p3m = DrawPointPtr(x_m_i, y_m_ix), *p3p = p3m + szi,
        *p4m = DrawPointPtr(x_m_i, y_p_ix), *p4p = p4m + szi; 
  DrawPoint_IMUL(p1m, a); DrawPoint_IMUL(p1p, a);
  DrawPoint_IMUL(p2m, a); DrawPoint_IMUL(p2p, a);
  if (x_m_ix != x_m_i) { DrawPoint_IMUL(p3m, a); DrawPoint_IMUL(p3p, a);
                         DrawPoint_IMUL(p4m, a); DrawPoint_IMUL(p4p, a);
                       } else fi = no;   
  p1m += 1; p2m += 1; p3m += 1; p4m += 1; szix -= 1; szi -= 1;
  DrawHLine_IMUL(p1m,c,szix); DrawHLine_IMUL(p2m,c,szix);
  if (fi) { DrawHLine_IMUL(p3m,c,szi); DrawHLine_IMUL(p4m,c,szi); };
};

//////////////////////////////////////////////////////////////////////////////////////
void (*DrawAA1)(int x, int y, unsigned c, unsigned a);
void (*DrawAA4)(int x, int y, int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a);
void (*DrawAA4D)(int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a);
void (*DrawAA8)(int x_m_ix, int x_p_ix, int x_m_i, int x_p_i, int y_m_ix, int y_p_ix, int y_m_i, int y_p_i, unsigned c, unsigned a, int fi); 
//void (*DrawAA9)(int xs, int ys, dwRGB c, unsigned a, unsigned ad); 

void (*DrawAA4_CLIP)(int x, int y, int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a, int f);
void (*DrawAA4D_CLIP)(int x_m_ix, int x_p_ix, int y_m_ix, int y_p_ix, unsigned c, unsigned a, int f);
void (*DrawAA8_CLIP)(int x_m_ix, int x_p_ix, int x_m_i, int x_p_i, int y_m_ix, int y_p_ix, int y_m_i, int y_p_i, unsigned c, unsigned a, int fi); 


int DrawCircleMode = -1; 

void DrawCircleRelink(unsigned m)
{ 
  if (m != DrawCircleMode)
   { switch (m)
       { default:
         case modePUT: DrawAA1 = DrawAA1_PUT; DrawAA4 = DrawAA4_PUT; DrawAA4D = DrawAA4D_PUT; DrawAA8 = DrawAA8_PUT;
                       DrawAA4_CLIP = DrawAA4_PUT_CLIP; DrawAA4D_CLIP = DrawAA4D_PUT_CLIP; DrawAA8_CLIP = DrawAA8_PUT_CLIP; break;
         case modePUTALPHA: DrawAA1 = DrawAA1_PUTALPHA; DrawAA4 = DrawAA4_PUTALPHA; DrawAA4D = DrawAA4D_PUTALPHA; DrawAA8 = DrawAA8_PUTALPHA;
                            DrawAA4_CLIP = DrawAA4_PUTALPHA_CLIP; DrawAA4D_CLIP = DrawAA4D_PUTALPHA_CLIP; DrawAA8_CLIP = DrawAA8_PUTALPHA_CLIP; break;
         case modeADD: DrawAA1 = DrawAA1_ADD; DrawAA4 = DrawAA4_ADD; DrawAA4D = DrawAA4D_ADD; DrawAA8 = DrawAA8_ADD; //DrawAA9 = DrawAA9_ADD;
                       DrawAA4_CLIP = DrawAA4_ADD_CLIP; DrawAA4D_CLIP = DrawAA4D_ADD_CLIP; DrawAA8_CLIP = DrawAA8_ADD_CLIP; break;
         case modeSUB: DrawAA1 = DrawAA1_SUB; DrawAA4 = DrawAA4_SUB; DrawAA4D = DrawAA4D_SUB; DrawAA8 = DrawAA8_SUB;
                       DrawAA4_CLIP = DrawAA4_SUB_CLIP; DrawAA4D_CLIP = DrawAA4D_SUB_CLIP; DrawAA8_CLIP = DrawAA8_SUB_CLIP; break;
         case modeMUL: DrawAA1 = DrawAA1_MUL; DrawAA4 = DrawAA4_MUL; DrawAA4D = DrawAA4D_MUL; DrawAA8 = DrawAA8_MUL;
                       DrawAA4_CLIP = DrawAA4_MUL_CLIP; DrawAA4D_CLIP = DrawAA4D_MUL_CLIP; DrawAA8_CLIP = DrawAA8_MUL_CLIP; break;
         case modeIMUL: DrawAA1 = DrawAA1_IMUL; DrawAA4 = DrawAA4_IMUL; DrawAA4D = DrawAA4D_IMUL; DrawAA8 = DrawAA8_IMUL;
                        DrawAA4_CLIP = DrawAA4_IMUL_CLIP; DrawAA4D_CLIP = DrawAA4D_IMUL_CLIP; DrawAA8_CLIP = DrawAA8_IMUL_CLIP; break;
       };                  
     DrawCircleMode = m; 
   };
};

#define PIdiv4 M_PI / 4

inline int CIRC15Dalpha(tfloat r2) { if (r2 <= 0.575) return 0; else { r2 = sqrt(r2 - 0.25) - 0.5; return PIdiv4 * r2 * r2 * 255; }; };
//////////////////////////////////////////////////////////////////////////////////////
void DrawCircle(int x, int y, tfloat rad, dwRGB color, int mode)
{ 
  int f = DrawXRinYRin(x,y);
  DrawCircleRelink(mode);
  if (rad <= 0.501) { if ibits(f,0x03) DrawAA1(x,y,color,rad * 510); return; };
  tfloat rx = rad + 0.5, r2;
  int i, pix, ix = rx, x_m_ix = x - ix, x_p_ix = x + ix, y_m_ix = y - ix, y_p_ix = y + ix;
  if (mI(x_p_ix | y_p_ix) || (x_m_ix > DrawXL) || (y_m_ix > DrawYL)) return;
  f = Draw2XRin2YRin(x_m_ix,x_p_ix,y_m_ix,y_p_ix) | (f << 4);
  r2 = rad * rad; 
  if ibits(f,0x0f)
   { DrawAA4(x,y,x_m_ix, x_p_ix, y_m_ix, y_p_ix, color,(rx - ix) * 255); pix = ix;
     if (rad < 1.500) { if (ix = CIRC15Dalpha(r2)) DrawAA4D(x_m_ix, x_p_ix, y_m_ix, y_p_ix, color, ix); return; }; 
     for (i = 1; i < ix; i++)
      { ix = rx = sqrt(r2 - i*i) + 0.5; 
        DrawAA8(x - ix, x + ix, x - i, x + i, y - ix, y + ix, y - i, y + i, color,(rx - ix) * 255, ix != pix);
        pix = ix;
      };
     return;
   };
  DrawAA4_CLIP(x,y,x_m_ix, x_p_ix, y_m_ix, y_p_ix, color,(rx - ix) * 255, f); pix = ix;
  if (rad < 1.500) { if (ix = CIRC15Dalpha(r2)) DrawAA4D_CLIP(x_m_ix, x_p_ix, y_m_ix, y_p_ix, color, ix, f); return; }; 
  for (i = 1; i < ix; i++)
   { ix = rx = sqrt(r2 - i*i) + 0.5; 
     DrawAA8_CLIP(x - ix, x + ix, x - i, x + i, y - ix, y + ix, y - i, y + i, color,(rx - ix) * 255, ix != pix);
     pix = ix;
   }; 
};/**/

/*
void DrawAA9(int xs, int ys, dwRGB c, unsigned a, unsigned ad)
{
  a = RGBmultV(c,a); if (ad) ad = RGBmultV(c,ad);
  dwRGB *bits = DrawPointPtr(xs, ys);
  _asm { movd  xmm1,c
         psllq xmm1,32                       
         movd xmm0,a                     
         movaps xmm2,xmm0
         orps xmm1,xmm0
         pshufd xmm1,xmm1,b11000100
         psllq xmm2,32
         movd xmm0,ad
         orps xmm2,xmm0
         pshufd xmm2,xmm2,b11000100
         mov eax,bits
         mov ebx,DrawLOFFS
         movups xmm0,[eax]
         paddusb xmm0,xmm2
         movups [eax],xmm0
         add eax,ebx
         movups xmm0,[eax]
         paddusb xmm0,xmm1
         movups [eax],xmm0
         add eax,ebx
         movups xmm0,[eax]
         paddusb xmm0,xmm2
         movups [eax],xmm0
       };  
};/**/

//////////////////////////////////////////////////////////////////////////////////////
/*void DrawCircle(int x, int y, tfloat rad, dwRGB color, unsigned mode)
{ 
  tfloat rx = rad + 0.5, r2;
  int i, f, pix, ix = rx, x_m_ix = x - ix, x_p_ix = x + ix, y_m_ix = y - ix, y_p_ix = y + ix;
  if (mI(x_p_ix | y_p_ix) || (x_m_ix > DrawXL) || (y_m_ix > DrawYL)) return;
  f = Draw2XRin2YRin(x_m_ix,x_p_ix,y_m_ix,y_p_ix) | (DrawXRinYRin(x,y) << 4);
  color &= 0x00ffffff;
  DrawCircleRelink(mode);
  if (rad <= 0.5) { if ibits(f,0x30) DrawAA1(x,y,color,rad * 510); return; };
  r2 = rad * rad; 
  if ibits(f,0x3f)
   { if (rad < 1.5) { DrawAA9(x_m_ix, y_m_ix, color,(rx - ix) * 255, CIRC15Dalpha(r2)); return; }; 
     DrawAA4(x,y,x_m_ix, x_p_ix, y_m_ix, y_p_ix, color,(rx - ix) * 255); pix = ix; ix = 2;               
     for (i = 1; i < ix; i++)
      { ix = rx = sqrt(r2 - i*i) + 0.5; 
        DrawAA8(x - ix, x + ix, x - i, x + i, y - ix, y + ix, y - i, y + i, color,(rx - ix) * 255, ix != pix);
        pix = ix;
      };
     return;
   };
  DrawAA4_CLIP(x,y,x_m_ix, x_p_ix, y_m_ix, y_p_ix, color,(rx - ix) * 255, f); pix = ix;
  if (rad <= 1.5) { if (ix = CIRC15Dalpha(r2)) DrawAA4D_CLIP(x_m_ix, x_p_ix, y_m_ix, y_p_ix, color, ix, f); return; }; 
  ix = 2;               
  for (i = 1; i < ix; i++)
   { ix = rx = sqrt(r2 - i*i) + 0.5; 
     DrawAA8_CLIP(x - ix, x + ix, x - i, x + i, y - ix, y + ix, y - i, y + i, color,(rx - ix) * 255, ix != pix);
     pix = ix;
   }; 
};/**/

////////////////////////////////////////////////////////////////////////////
void DrawFalloff(int foff)
{
  dwRGB *bits = DrawPTRnear;
  unsigned xsz,ysz;
  int loffs = abs(DrawLOFFS);
  if (DrawXRfull) { xsz = DrawSZ; ysz = 1; } else { xsz = DrawXR; ysz = DrawYR; };  
  DrawFRect_PUTALPHA(bits,(VS_CColor & 0x00ffffff) | ((1 - foff) << 24), xsz, ysz, loffs);
};

////////////////////////////////////////////////////////////////////////////
int DrawRepaint = no;

void DrawClearBorder(int force)
{
  int sz; 
  dwRGB *np = DrawPTRnear, *fp = DrawPTRfar + 1;
  sz = (unsigned)np - (unsigned)DrawBits;
  if (sz) { dwMemSet(DrawBits,VS_BColor,sz); DrawRepaint = Yes; };
  sz = (unsigned)DrawBits + (DrawXSZ * DrawYSZ << 2) - (unsigned)fp;
  if (sz) { dwMemSet(fp,VS_BColor,sz); DrawRepaint = Yes; };
  if (!DrawXRfull) { np += DrawXR; sz = (DrawXSZ - DrawXR) << 2;
                     for (int i = 0; i < DrawYL; i++) { dwMemSet(np,VS_BColor,sz); np += DrawXSZ; };
                     DrawRepaint = Yes;
                   }; /**/  
};

int DrawClearForce = no; 
void DrawClear()
{ 
  if (!DrawClearForce && DrawClearReason) if (!DrawClearReason()) { DrawClearForce = no; return; };
  DrawClearForce = no;
  if (EDrawClear) EDrawClear();
   else { if (DrawXRfull) dwMemSetA16(DrawPTRnear,VS_CColor,DrawSZ << 2);
           else DrawFRect_PUT(DrawLinePtr(0),VS_CColor,DrawXR,DrawYR);
        };
};

////////////////////////////////////////////////////////////////////////////
/////////////  //////////////////////////////////////////////////////
// 
dwRGB_arr *FLT_ImageBits = NULL;
unsigned FLT_ImageSize = 0;

//////////////////////////////////////
int FLT_GhostEffect = effNO;
int FLT_GhostMode = no;

void preFLT_Ghost()
{
  if (!FLT_GhostEffect) return;
  
  dwRGB *bits = DrawPTRnear;
  unsigned xsz,ysz;
  int loffs = abs(DrawLOFFS);
  if (DrawXRfull) { xsz = DrawSZ; ysz = 1; } else { xsz = DrawXR; ysz = DrawYR; };  

  if (FLT_GhostMode)
   switch (FLT_GhostEffect)
     { case effNO: break;
       case effNOTHING: break;
       case effEXPONENT: DrawFRect_PUTALPHA(bits,(VS_CColor & 0x00ffffff) | 0xa0000000, xsz, ysz, loffs); break;
       case effSEXPONENT: DrawFRect_AVR(bits, VS_CColor, xsz, ysz, loffs); break;
       case effVSEXPONENT: DrawFRect_PUTALPHA(bits,(VS_CColor & 0x00ffffff) | 0x5a000000, xsz, ysz, loffs); break;
       case effVVSEXPONENT: DrawFRect_AVRSOFT(bits, VS_CColor, xsz, ysz, loffs); break;
       case effVVVSEXPONENT: DrawFRect_PUTALPHA(bits,(VS_CColor & 0x00ffffff) | 0x2a000000, xsz, ysz, loffs); break; 
       default: break;  
     } else switch (FLT_GhostEffect)
           { case effNO: break;
             case effNOTHING: break;
             case effEXPONENT: DrawFRect_AVR(bits, VS_CColor, xsz, ysz, loffs); break;
             case effSEXPONENT: DrawFRect_AVRSOFT(bits, VS_CColor, xsz, ysz, loffs);  break;
             case effVSEXPONENT: DrawFRect_PUTALPHA(bits,(VS_CColor & 0x00ffffff) | 0x20000000, xsz, ysz, loffs); break;
             case effVVSEXPONENT: DrawFRect_PUTALPHA(bits,(VS_CColor & 0x00ffffff) | 0x10000000, xsz, ysz, loffs); break; 
             case effVVVSEXPONENT: DrawFRect_PUTALPHA(bits,(VS_CColor & 0x00ffffff) | 0x08000000, xsz, ysz, loffs); break;
             default: break;  
           };
};


////////////////////////////////////////////////////////////////////////////
/*int FLT_BlurMode = 0;
int FLT_BlurRadius = 0;

void FLT_Blur()
{
  if (!FLT_BlurMode) return;
  dwRGB *lineC, *lineU, *lineD, *lineL, *lineR, *dest1, *dest2;
  unsigned sz = DrawXR >> 2;
  DrawLCACHEstart();
  for (int i = 1; i < DrawYL; i++)
   { lineU = DrawPointPtr(0,i - 1);
     lineD = DrawPointPtr(0,i + 1);
     dest1 = DrawLCACHEget(DrawPointPtr(0,i));
     _asm { mov ecx,sz
            mov eax,lineU
            mov ebx,lineD 
            mov edx,dest1 
           _loop1: 
            movaps xmm0,[eax]
            movaps xmm1,[ebx]
            pavgb xmm0,xmm1
            movaps [edx],xmm0
            add eax,16
            add ebx,16
            add edx,16
            dec ecx
            jnz _loop1 
          };
     lineL = DrawPointPtr(0,i);
     lineR = DrawPointPtr(2,i);    
     dest2 = DrawLCACHEget(); 
     _asm { mov ecx,sz
            sub ecx,1
            mov eax,lineL
            mov ebx,lineR 
            mov edx,dest2
            add edx,4 
           _loop2: 
            movups xmm0,[eax]
            movups xmm1,[ebx]
            pavgb xmm0,xmm1
            movups [edx],xmm0
            add eax,16
            add ebx,16
            add edx,16
            dec ecx
            jnz _loop2 
          };
     lineC = DrawPointPtr(0,i);     
     _asm { mov ecx,sz
            mov eax,dest1
            mov ebx,dest2 
            mov edx,lineC
           _loop3: 
            movups xmm0,[eax]
            movups xmm1,[ebx]
            pavgb xmm0,xmm1
            movups xmm1,[edx]
            pavgb xmm0,xmm1
            movups [eax],xmm0
            add eax,16
            add ebx,16
            add edx,16
            dec ecx
            jnz _loop3 
          };
         
    
   
   };
  DrawLCACHEfinal();

};/**/

////////////////////////////////////////////////////////////////////////////
void FLT_Done()
{
  FreeMem(FLT_ImageBits);
};


///////////////////////////////////////////////////////////////////////////////
//   -    ,       

dwRGB *LCACHEbits = NULL;
unsigned LCACHEsize = 0;
unsigned DrawLCACHElines = 0;
unsigned LCACHEline = 0;

dwRGB *LCACHEputBack[32];

void DrawLCACHEstart(int linecount)
{
  DrawLCACHElines = linecount;
  AutoExpandMem((void **)&LCACHEbits,LCACHEsize,DrawXR * linecount * 4,No);
  for (int i = 0; i < linecount; i++) LCACHEputBack[i] = NULL;
  LCACHEline = linecount - 1;
};

dwRGB *DrawLCACHEget(dwRGB *putback)
{
  LCACHEline++; LCACHEline = LCACHEline % DrawLCACHElines;
  if (LCACHEputBack[LCACHEline]) MemMoveA16((void *)LCACHEputBack[LCACHEline],(void *)(LCACHEbits + LCACHEline * DrawXR), DrawXR << 2);
  LCACHEputBack[LCACHEline] = putback;
  return LCACHEbits + LCACHEline * DrawXR;
};                                          

void DrawLCACHEfinal()
{
  for (int i = 0; i < DrawLCACHElines; i++) 
     if (LCACHEputBack[i]) { MemMoveA16((void *)LCACHEputBack[i],(void *)(LCACHEbits + i * DrawXR), DrawXR << 2);
                             LCACHEputBack[i] = NULL;
                           };  
  LCACHEline = DrawLCACHElines - 1;
};

void DrawLCACHEdone()
{
  FreeMem((void *)LCACHEbits);
  LCACHEsize = DrawLCACHElines = LCACHEline = 0;
};

//////////////////////////////////////////////////////////////////////////////
//   
cRegionStore DrawRegionStore;

//////////////////////////////////////////////////////////////////////////////
void DrawFROMconv(int x, int y, int xr, int yr, unsigned das, tRegion &r, int pixSize = 0, int pixSpace = 1)
     //  ,    ,      .
{
  if (pixSize) { xr = xr * (pixSize + pixSpace) - pixSpace;
                 yr = yr * (pixSize + pixSpace) - pixSpace;
               };
  
  switch (getFROMx(das))
  { case fromXZERO: r.X = x; break;
    case fromXLAST: r.X = DrawXR - x - xr; break;
    case fromXCENTER: r.X = DrawXR / 2 - xr / 2 + x; break;
    default: r.X = x;
  };
  switch (getFROMy(das))
  { case fromYZERO: r.Y = y; break;
    case fromYLAST: r.Y = DrawYR - y - yr; break;
    case fromYCENTER: r.Y = DrawYR / 2 - yr / 2 + y; break;
    default: r.Y = y;
  };
  r.XL = r.X + xr - 1;
  r.YL = r.Y + yr - 1;
};

void DrawFROMconv(int x, int y, unsigned das, int &px, int &py)
     //  .
{
  switch (getFROMx(das))
  { case fromXZERO: px = x; break;
    case fromXLAST: px = DrawXL - x; break;
    case fromXCENTER: px = DrawXR / 2 + x; break;
    default: px = x;
  };
  switch (getFROMy(das))
  { case fromYZERO: py = y; break;
    case fromYLAST: py = DrawYL - y; break;
    case fromYCENTER: py = DrawYR / 2 + y; break;
    default: py = y;
  };
};

//////////////////////////////////////////////////////////////////////////////
dwRGB DrawRastrColor = RGBis(255,255,255);
int DrawRastrColorJitter = 0;
extern int DrawRastrColorJitterMono = Yes;

void DrawRastr(int x, int y, unsigned mode, int xr, int yr, dwRGB_arr *bits, int pixSize = 3, int pixSpace = 1, int pixShift = 0)
{
  tfloat r = (tfloat)pixSize / 2;
  int sx = x + (r + 0.501), sy = y + (r + 0.501), i = pixSize + pixSpace;
  
  if (((DrawRastrColor & 0x00ffffff) == 0x00ffffff) && !DrawRastrColorJitter)
  { for (int yi = 0; yi < yr; yi++)
     { int xs = (yr - 1 - yi) * pixShift;
       for (int xi = 0; xi < xr; xi++)
        DrawCircle(sx + xi * i + xs, sy + yi * i, r,(*bits)[yi * xr + xi], mode);  
     };   
  } else if (!DrawRastrColorJitter)
          { for (int yi = 0; yi < yr; yi++)
             { int xs;
               if (pixShift == 347) xs = (yi & 0x01) * (pixSize + pixSpace) >> 1; 
                 else xs = (yr - 1 - yi) * pixShift;
               for (int xi = 0; xi < xr; xi++)
                DrawCircle(sx + xi * i + xs, sy + yi * i, r, RGBmult((*bits)[yi * xr + xi],DrawRastrColor), mode);  
             };   
          } else if (DrawRastrColorJitterMono)
                  { for (int yi = 0; yi < yr; yi++)
                          { int xs;
                            if (pixShift == 347) xs = (yi & 0x01) * (pixSize + pixSpace) >> 1; 
                             else xs = (yr - 1 - yi) * pixShift;
                            for (int xi = 0; xi < xr; xi++)
                             DrawCircle(sx + xi * i + xs, sy + yi * i, r, RGBmult((*bits)[yi * xr + xi],mBJitter(BJ(DrawRastrColor,DrawRastrColorJitter))), mode);  
                          };
                  } else for (int yi = 0; yi < yr; yi++)
                          { int xs;
                            if (pixShift == 347) xs = (yi & 0x01) * (pixSize + pixSpace) >> 1; 
                             else xs = (yr - 1 - yi) * pixShift;
                            for (int xi = 0; xi < xr; xi++)
                             DrawCircle(sx + xi * i + xs, sy + yi * i, r, RGBmult((*bits)[yi * xr + xi],BJitter(BJ(DrawRastrColor,DrawRastrColorJitter))), mode);  
                          };    
};

inline int pixSizeFix(int s) { if (s) return s + !(s & 0x01); else return 0; };

//////////////////////////////////////////////////////////////////////////////
//////////////// Sprite Support Object ///////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
tRegion SPRregion;
dwRGB SPRforceColor = RGBis(255,255,255);
int SPRforceMode = 0;
int SPRerrorReport = Yes;
int SPRpixSize = 0;
int SPRpixSpace = 1;
int SPRpixShift = 1;

BaseSPR :: BaseSPR(wchar_t* name, wchar_t* name_mask, int xr, int yr)
{
  Alpha = XR = YR = 0;
  Region = RegionIs(0,0,0,0);
  pixSize = pixShift = 0;
  pixSpace = 1;
  Shift = ShiftAcc = ShiftDir = 0;
  Mode = modePUT;
  Bits = NULL; Name[0] = 0;
  Load(name,name_mask,xr,yr);
};

//////////////////////////////////////////////////////////////////////////////
BaseSPR :: ~BaseSPR()
{
  FreeMem(Bits);
};

//////////////////////////////////////////////////////////////////////////////
void BaseSPR :: Done()
{
  FreeMem(Bits); Bits = NULL;
};

//////////////////////////////////////////////////////////////////////////////
int BaseSPR :: Load(wchar_t* name, wchar_t* name_mask, int xr, int yr)
{
  unsigned pAlpha;
  dwRGB c;
  FreeMem(Bits); Bits = NULL; Name[0] = 0; Place(Region.X,Region.Y,Mode); Alpha = no;
  if (name)
  { GDIrun();
    if (GDIbitmapLoad(name))
    { if (xr != -1) GDIbitmapResize(xr, yr);
      GDIbitmapLock();
      XR = GDIbitmapXres; YR = GDIbitmapYres;  Bits = (dwRGB_arr *)GetMem(GDIbitmapSize);
      pAlpha = (*GDIbits)[0] & 0xff000000; 
      if ((SPRforceColor & 0x00ffffff) == 0x00ffffff)
       { for (int i = 0; i < (GDIbitmapSize >> 2); i++) { c = (*Bits)[i] = (*GDIbits)[i]; Alpha |= (c & 0xff000000) != pAlpha; };
       } else for (int i = 0; i < (GDIbitmapSize >> 2); i++) { c = (*Bits)[i] = RGBmult((*GDIbits)[i], SPRforceColor) | ((*GDIbits)[i] & 0xff000000); Alpha |= (c & 0xff000000) != pAlpha; };
      GDIbitmapUnlock();
      wcscpy(Name, name);
    } else { GDIstop();
             if (SPRerrorReport) HaltError(L"BaseSPR : Load : JPG, GIF, PNG or BMP Resource Not Found"); else { SPRerrorReport = Yes; return 0; };
           };                    
    GDIbitmapRelase();
    GDIstop();
  };
  if (name_mask)
  {  GDIrun();
    if (GDIbitmapLoad(name_mask))
    { Alpha = Yes;
      if (xr != -1) GDIbitmapResize(xr, yr);
      GDIbitmapLock();
      if (!Bits)
       { XR = GDIbitmapXres; YR = GDIbitmapYres; Bits = (dwRGB_arr *)GetMem(GDIbitmapSize);
         if ((SPRforceColor & 0x00ffffff) == 0x00ffffff)
          { for (int i = 0; i < (GDIbitmapSize >> 2); i++)(*Bits)[i] = (*GDIbits)[i] | 0xff000000;
          } else for (int i = 0; i < (GDIbitmapSize >> 2); i++)(*Bits)[i] = RGBmult((*GDIbits)[i], SPRforceColor) | 0xff000000;
       } else for (int i = 0; i < (GDIbitmapSize >> 2); i++)(*Bits)[i] = ((*Bits)[i] & 0x00ffffff) | (((*GDIbits)[i] & 0x000000ff) << 24);
      GDIbitmapUnlock();
      if (!Name) wcscpy (Name, name_mask);
    } else { GDIstop();
             if (SPRerrorReport) HaltError(L"JPG, GIF, PNG or BMP Resource Not Found"); else { SPRerrorReport = Yes; return 0; };
           };
    GDIbitmapRelase();
    GDIstop();
  };
  pixSize = pixSizeFix(SPRpixSize);
  pixSpace = SPRpixSpace; 
  pixShift = SPRpixShift;
  SPRforceColor = RGBis(255,255,255);
  SPRpixSize = SPRpixShift = 0;
  SPRpixSpace = 1;
  SPRerrorReport = Yes;
  return (Bits != NULL);
};

//////////////////////////////////////////////////////////////////////////////
int BaseSPR :: LoadData(void *p, int xr, int yr)
{
  int pAlpha;
  FreeMem(Bits); Bits = NULL; Place(Region.X,Region.Y,Mode);
  dwRGB c;  
  XR = xr; YR = yr;
  Bits = (dwRGB_arr *)GetMem(xr * yr * 4);
  dwRGB_arr *bits = (dwRGB_arr *)p;
  pAlpha = (*bits)[0] & 0xff000000; 
  if ((SPRforceColor & 0x00ffffff) == 0x00ffffff)
   { for (int i = 0; i < (xr * yr); i++) { c = (*Bits)[i] = (*bits)[i]; Alpha |= (c & 0xff000000) != pAlpha; };
   } else for (int i = 0; i < (xr * yr); i++) { c = (*Bits)[i] = RGBmult((*bits)[i], SPRforceColor) | ((*bits)[i] & 0xff000000); Alpha |= (c & 0xff000000) != pAlpha; };
  SPRforceColor = RGBis(255,255,255);
  return (Bits != NULL);
};

//////////////////////////////////////////////////////////////////////////////
int BaseSPR :: LoadDraw(tRegion r)
{
  int x, y, i = 0, xr = r.XL - r.X + 1, yr = r.YL - r.Y + 1;

  FreeMem(Bits); Bits = NULL; Place(Region.X,Region.Y,Mode);
  dwRGB *bits;  
  XR = xr; YR = yr;
  Bits = (dwRGB_arr *)GetMem(xr * yr * 4);
  if ((SPRforceColor & 0x00ffffff) == 0x00ffffff)
  { for (y = 0; y < yr; y++)
     { bits = DrawYptr[y];
       for (x = 0; x < xr; x++) {(*Bits)[i] = (*bits) | 0xff000000; bits++; i++; }
     }
  } else for (y = 0; y < yr; y++)
         { bits = DrawYptr[y];
           for (x = 0; i < xr; x++) {(*Bits)[i] = RGBmult((*bits) | 0xff000000, SPRforceColor) | 0xff000000; bits++; i++; }
         }
  SPRforceColor = RGBis(255,255,255); Alpha = no;
  return (Bits != NULL);
};

//////////////////////////////////////////////////////////////////////////////
void BaseSPR :: Place(int x, int y, unsigned das)
{
  if (!Bits) return;
  Mode = getMODE(das);
  if (Alpha && (Mode == modePUT)) Mode = modePUTALPHA; 
  DrawFROMconv(x,y,XR,YR,das,Region,pixSize,pixSpace);
};

dwRGB BaseSPR :: GetColor(int x, int y)
{
  if (!Bits) return 0;
  if (x < 0) x = 0; 
   else if (x >= XR) x = XR - 1;
  if (y < 0) y = 0; 
   else if (y >= YR) y = YR - 1;
/*  if (x < 0) x = (-x) % XR; 
   else if (x >= XR) x = XR - 1 - (x - XR) % XR;
  if (y < 0) y = (-y) % YR; 
   else if (y >= YR) y = YR - 1 - (y - YR) % YR;/**/

  return (*Bits)[y * XR + x];
};
//////////////////////////////////////////////////////////////////////////////
int BaseSPR :: MouseIn()
{
  if (!Bits) return no;
  return RegionMouseIn(Region);
};

//////////////////////////////////////////////////////////////////////////////
void BaseSPR :: Flip(int dir)
{
  if (!Bits) return;
  unsigned sz = XR * 4;
  if (dir)
  { dwRGB *pline = NULL, *p = (dwRGB *)Bits, *pl = (dwRGB *)((unsigned)Bits + (YR - 1) * sz), line[3200 * 4];
    if (XR > 3200) pline = (dwRGB *)GetMem(sz); else pline = &(line[0]);
    for (int y = 0; y < YR / 2; y++)
    { memcpy(pline, p, sz);
      memcpy(p, pl, sz);
      memcpy(pl, pline, sz);
      p += XR; pl -= XR;
    };
    if (XR > 3200) FreeMem(pline);
  } else { dwRGB *p, *pl, c;
           for (int y = 0; y < YR; y++)
           { p = (dwRGB *)((unsigned)Bits + y * sz); pl = p + XR - 1;
             for (int x = 0; x < XR / 2; x++) { c = *p; *p = *pl; *pl = c; p++; pl--; };
           };
         };
};

//////////////////////////////////////////////////////////////////////////////
void BaseSPR :: Draw(unsigned das)
{
  if (!Bits) return;
  int m;
  if (das != 0xffffffff) { Mode = getMODE(das);
                           if (Alpha && (Mode == modePUT)) Mode = modePUTALPHA; 
                         };
  SPRregionUpdate(Region);
  if (SPRforceMode) m = SPRforceMode; else m = Mode;
  if (pixSize) DrawRastr(Region.X, Region.Y, m, XR, YR, Bits, pixSize, pixSpace, pixShift);
   else DrawImage(Region,(dwRGB *)Bits,m);  
};

//////////////////////////////////////////////////////////////////////////////
void BaseSPR :: DrawShifted(unsigned das)
{
  if (!Bits) return;
  int m,y;
  if (das != 0xffffffff) { Mode = getMODE(das);
                           if (Alpha && (Mode == modePUT)) Mode = modePUTALPHA; 
                         };
  SPRregionUpdate(Region);
  if (SPRforceMode) m = SPRforceMode; else m = Mode;
   
  int lnsz = Region.XL - Region.X + 1;
  tRegion reg = Region, Reg = Region;
  dwRGB* bits; 
  
  if (ShiftDir == shiftX)
   { bits = (dwRGB *)Bits + ShiftAcc;
     reg.XL -= ShiftAcc;
     Reg.X = Reg.XL - ShiftAcc;
   } else { bits = (dwRGB *)Bits + ShiftAcc * lnsz;
            reg.YL -= ShiftAcc;
            Reg.Y = Reg.YL - ShiftAcc;
          }; 
  DrawImage(reg,bits,m,lnsz);  
  if (ShiftAcc) DrawImage(Reg,(dwRGB *)Bits,m,lnsz);  
  ShiftAcc += Shift;
  if (ShiftAcc >= XR) ShiftAcc -= XR;
  if (ShiftAcc < 0) ShiftAcc += XR;

};

//////////////////////////////////////////////////////////////////////////////
BaseSPR BImage;
int Draw_BImageBlend = 32;
int Draw_BImageUse = no;
int Draw_BImageStart = Yes;
wchar_t Draw_BImagePath[1024];

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
///// C     ////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
NumsSPR :: ~NumsSPR()
{ delete Nums;
};

//////////////////////////////////////////////////////////////////////////////
NumsSPR :: NumsSPR(wchar_t* name, wchar_t* name_mask) 
{
  XRD = YRD = XR = YR = 0;
  Region = RegionIs(0,0,0,0);
  Digits = 2;
  Mode = modePUT;
  Nums = NULL;
  Load(name,name_mask);
}

//////////////////////////////////////////////////////////////////////////////
void NumsSPR :: Load(wchar_t* name, wchar_t* name_mask) 
{
  delete Nums;
  Nums = new BaseSPR(name,name_mask);
  XRD = Nums->XR + 2;
  YRD = Nums->YR / 11;
  SetDigits(Digits);
};

//////////////////////////////////////////////////////////////////////////////
void NumsSPR :: SetDigits(unsigned digits)
{
  Digits = digits;
  XR = XRD * Digits;
  YR = YRD;
};

//////////////////////////////////////////////////////////////////////////////
void NumsSPR :: Place(int x, int y, unsigned das)
{
  Mode = getMODE(das);
  DrawFROMconv(x,y,XR,YR,das,Region,Nums->pixSize,Nums->pixSpace);
};

//////////////////////////////////////////////////////////////////////////////
void NumsSPR :: Draw(unsigned num)
{
  dwRGB *pbits = (dwRGB *)Nums->Bits; 
  int yr = Nums->YR; Nums->YR = YRD;
  int sz = Nums->XR * YRD;
  
  SPRregionUpdate(Region);    
  int xrd,yrd;
  if (Nums->pixSize) { xrd = (XRD - 1) * (Nums->pixSize + Nums->pixSpace);
                       yrd = YRD * (Nums->pixSize + Nums->pixSpace);   
                     } else { xrd = XRD; yrd = YRD; };
  int x = Region.XL + 1 - xrd, y = Region.YL + 1 - yrd;
  for (int i = 0; i < Digits; i++)   
  { unsigned n = num % 10;
    if ((n == 0) && !num) n = 10;
    Nums->Bits = (dwRGB_arr *)(pbits + n * sz);
    Nums->Place(x,y,Mode); Nums->Draw();
    num /= 10;
    x -= xrd;
  };
  Nums->Bits = (dwRGB_arr *)pbits; Nums->YR = yr;
};
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
///// C    ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
TextSPR :: ~TextSPR()
{ delete TSpr;
};

//////////////////////////////////////////////////////////////////////////////
TextSPR :: TextSPR(wchar_t* name, wchar_t* name_mask) 
{
//  EDrawBefore = NULL;
  LineSpace = PX = PY = XRD = YRD = XR = YR = 0;
  CharSpace =  1;
  Region = RegionIs(0,0,0,0);
  Text = NULL;
  TSpr = NULL;
  Mode = -1;
  Load(name,name_mask);
}

//////////////////////////////////////////////////////////////////////////////
void TextSPR :: Load(wchar_t* name, wchar_t* name_mask) 
{
  delete TSpr;
  TSpr = new BaseSPR(name,name_mask);
  dwRGB *bits = (dwRGB *)TSpr->Bits;
  dwRGB *sbits = bits;
  XRD = TSpr->XR;
  YRD = TSpr->YR / 256;
  dwRGB fonc = * (bits + 2 * XRD - 1);
  for (int i = 0; i < 256; i++)
   { bits = sbits + XRD * YRD * i; 
     for (int j = 0; j < XRD; j++)
      { if ((*bits & 0x00ffffff) == 0x00ff00ff) { Space[i] = j; *bits = fonc; break; };
        bits++; 
      };
   };
};

//////////////////////////////////////////////////////////////////////////////
void TextSPR :: Place(int x, int y, unsigned das, char *text)
{
  PX = x; PY = y; Mode = das; if (text) Text = text;
  TSpr->Mode = getMODE(das);
  if (Text && (Mode > 0)) { SizeCalc(); DrawFROMconv(x,y,XR,YR,das,Region,TSpr->pixSize,TSpr->pixSpace); };  
};

//////////////////////////////////////////////////////////////////////////////
void TextSPR :: SetText(char *text)
{
  Text = text;
  Place(PX,PY,Mode);
};

//////////////////////////////////////////////////////////////////////////////
int xslineL(int xs, int twide, int wide) { return xs; };
int xslineR(int xs, int twide, int wide) { return xs + wide - twide; };
int xslineC(int xs, int twide, int wide) { return xs + wide / 2 - twide / 2; };

void TextSPR :: Draw()
{
  int c, xs, line = 0, ys = Region.Y, yr = TSpr->YR, sz = TSpr->XR * YRD;
  int (*xsline)(int,int,int);
  
  switch (getALIGNx(Mode)) 
   { default:
     case alignL: xsline = xslineL; break;
     case alignR: xsline = xslineR; break;
     case alignLRC: xsline = xslineC; 
   };
  dwRGB *pbits = (dwRGB *)TSpr->Bits; TSpr->YR = YRD;

  //if (EDrawBefore) EDrawBefore(Region); 
  SPRregionUpdate(Region);
  
  int pix = 1;
  if (TSpr->pixSize) pix = TSpr->pixSize + TSpr->pixSpace;
  
  xs = xsline(Region.X,LineWide[0] * pix,XR * pix);
  for (int i = 0; i < strlen(Text); i++)
   if ((c = Text[i] & 0xff) == 0x0a)
    { ys += LineSpace + YRD * pix; line++; xs = xsline(Region.X,LineWide[line] * pix,XR * pix);
    } else { TSpr->Bits = (dwRGB_arr *)(pbits + c * sz);
             TSpr->Region = RegionIs(xs, ys, xs + XRD * pix - 1, ys + YRD * pix - 1); 
             TSpr->Draw();
             xs += Space[c] * pix + CharSpace * pix;
           };  
  TSpr->Bits = (dwRGB_arr *)pbits; TSpr->YR = yr;/**/
};

//////////////////////////////////////////////////////////////////////////////
void TextSPR :: SizeCalc()
{
  XR = YR = 0;
  if (!Text) return;
  YR = YRD;
  int xr = 0, c;
  LineCount = 0;
  for (int i = 0; i < strlen(Text); i++)
   if ((c = Text[i] & 0xff) == 0x0a) 
    { YR += LineSpace + YRD; xr -= CharSpace; if (xr > XR) XR = xr; LineWide[LineCount] = xr; xr = 0; LineCount++; 
    } else xr += Space[c] + CharSpace; 
  xr -= CharSpace;   
  if (xr > XR) XR = xr; LineWide[LineCount] = xr; LineCount++; 
};
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
/////          /////////////
//////////////////////////////////////////////////////////////////////////////
TileSPR :: ~TileSPR()
{ 
  Clear(); 
}

//////////////////////////////////////////////////////////////////////////////
TileSPR :: TileSPR(wchar_t* name, unsigned space) 
{
  EDrawBefore = NULL;
  XR = YR = XRD = YRD = 0;
  Region = RegionIs(0,0,0,0);
  Mode = modePUT | fromUL | alignL | arrangeUD;
  Items = 0;
  DefaultSpace = 4;
  memset(Sprite,0,sizeof(Sprite));
  memset(Space,0,sizeof(Space));
  Add(name,space);
}

//////////////////////////////////////////////////////////////////////////////
void TileSPR :: Clear()
{ 
  for (int i = 0; i < 256; i++) if (Sprite[i]) {delete Sprite[i]; Sprite[i] = NULL;} else break;
  Items = 0;
}

//////////////////////////////////////////////////////////////////////////////
int TileSPR :: AddWm(wchar_t* name, wchar_t* name_mask, unsigned space) 
{
  if (!name) return -1;
  if (Items > 255) return -1;
  Sprite[Items] = new BaseSPR(name,name_mask);
  if (space == -1) { if (!Items) Space[Items] = 0; else Space[Items] = DefaultSpace;
                   } else Space[Items] = space;
  Items++;
  return Items - 1;
}

//////////////////////////////////////////////////////////////////////////////
int TileSPR :: Add(wchar_t* name, unsigned space) 
{
  return AddWm(name,NULL,space);
}

//////////////////////////////////////////////////////////////////////////////
void TileSPR :: Place(int x, int y, unsigned das)
{
  Mode = das; PX = x; PY = y;
  SizeCalc();
  DrawFROMconv(x,y,XR,YR,das,Region);
  
  int cx, cy, mode = getMODE(das), from = 0;
  
  if (getARRANGEy(Mode))
  { switch (getALIGNx(Mode))
     { case alignL: cx = Region.X; from = fromL; break;
       case alignR: cx = DrawXL - Region.XL; from = fromR; break;
       case alignLRC: cx = Region.X + (Region.XL - Region.X) /2 - DrawXR / 2; from = fromLRC; break;
     };
    switch (getARRANGEy(Mode)) 
     { case arrangeUD: cy = Region.Y; from = from | fromU; break;
       case arrangeDU: cy = DrawYL - Region.YL; from = from | fromD; break;
     };
    for (int i = 0; i < Items; i++)
     { cy += Space[i];
       Sprite[i]->Place(cx,cy,mode | from);
       cy += Sprite[i]->YR;
     };
  } else
  { switch (getALIGNy(Mode))
     { case alignU: cy = Region.Y; from = fromU; break;
       case alignD: cy = DrawYL - Region.YL; from = fromD; break;
       case alignUDC: cy = Region.Y + (Region.YL - Region.Y) /2 - DrawYR / 2; from = fromUDC; break;
     };
     switch (getARRANGEx(Mode)) 
     { case arrangeLR: cx = Region.X; from = from | fromL; break;
       case arrangeRL: cx = DrawXL - Region.XL; from = from | fromR; break;
     };
    for (int i = 0; i < Items; i++)
     { cx += Space[i];
       Sprite[i]->Place(cx,cy,mode | from);
       cx += Sprite[i]->XR;
     };   
  };  
};

//////////////////////////////////////////////////////////////////////////////
void TileSPR :: SizeCalc()
{
  XR = 0; YR = 0;
  if (getARRANGEy(Mode))
   { for (int i = 0; i < Items; i++)
      { YR += Space[i];
        YR += Sprite[i]->YR;
        if (Sprite[i]->XR > XR) XR = Sprite[i]->XR;
      };
   } else for (int i = 0; i < Items; i++)
           { XR += Space[i];
             XR += Sprite[i]->XR;
             if (Sprite[i]->YR > YR) YR = Sprite[i]->YR;
           };   
};

//////////////////////////////////////////////////////////////////////////////
void TileSPR :: Draw(int i)
{
  int xr,yr,putas;
  tRegion r;
  BaseSPR *spr;
  if (i != -1)
   { if (i >= Items) return;
     spr = Sprite[i];
     r = spr->Region; xr = spr->XR; yr = spr->YR; putas = spr->Mode;
     spr->Place(PX,PY,Mode); 
     if (EDrawBefore) EDrawBefore(spr->Region);
     spr->Draw();
     spr->Region = r; spr->XR = xr; spr->YR = yr; spr->Mode = putas;
     return;
   };
  if (EDrawBefore) EDrawBefore(Region); 
  for (int i = 0; i < Items; i++) Sprite[i]->Draw();
};

//////////////////////////////////////////////////////////////////////////////
void TileSPR :: Draw(wchar_t* name)
{
  int i = getNum(name); if (i != -1) Draw(getNum(name));
};

//////////////////////////////////////////////////////////////////////////////
int TileSPR :: getNum(wchar_t* name)
{
  for (int i = 0; i < Items; i++) if (!wcscmp(Sprite[i]->Name, name)) return i;
  return -1; 
};

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
/////       ///////////////////
//////////////////////////////////////////////////////////////////////////////
thispritem *imItem;

IMouseSPR :: ~IMouseSPR()
{ 
  Clear();
  delete MRP;    delete dMRP;
  delete MP;     delete dMP;
  delete Button; delete dButton;
  if (Text) delete Text;
}

//////////////////////////////////////////////////////////////////////////////
IMouseSPR :: IMouseSPR(wchar_t* mrp, wchar_t* mp, wchar_t* button, wchar_t* text) 
{
  XR = YR = XRD = YRD = 0;
  Region = RegionIs(0,0,0,0);
  Mode = modePUT | fromUL | alignL | arrangeUD;
  Items = 0; Key = 0;
  ClickNow = no;
  DefaultSpace = 4;
  IndShift = -1;
  EDrawBefore = NULL;
  EDrawChanges = NULL;
  memset(Item,0,sizeof(Item));
  memset(Space,0,sizeof(Space));
  MRP = MP = dMRP = dMP = Button = dButton = NULL; Text = NULL;
  MRP = new BaseSPR(mrp);
  SPRforceColor = RGBis(70,70,70); dMRP = new BaseSPR(mrp);
  MP = new BaseSPR(mp);
  SPRforceColor = RGBis(70,70,70); dMP = new BaseSPR(mp);
  Button = new BaseSPR(button);
  SPRforceColor = RGBis(70,70,70); dButton = new BaseSPR(button);
  if (!MRP || !MP || !Button) HaltError(L"IMouseSPR : Constructor : Some images - missing");
  if (text) { Text = new TextSPR(text); fromText = (Text != NULL); } else { Text = NULL; fromText = no; };
  XRD = MRP->XR;
  YRD = MRP->YR;
}

//////////////////////////////////////////////////////////////////////////////
void IMouseSPR :: Clear()
{ 
  for (int i = 0; i < 256; i++)
   if (Item[i])
    { if (Item[i]->Text) { delete Item[i]->Text; delete Item[i]->dText; };
      delete Item[i]; Item[i] = NULL;
    } else break;
  Items = 0;
}

void HIloadText(wchar_t *name, thispritem *sp, int fromtext, TextSPR *text)
{
  tRegion r = RegionIs(0,0,DrawXL,text->YRD);
  char cname[256];
  sp->Text = sp->dText = NULL;
  if (!fromtext || !DrawBits)
  { sp->Text = new BaseSPR(name);
    SPRforceColor = RGBis(127,127,127);
    sp->dText = new BaseSPR(name);
  if (!sp->Text) HaltError(L"IMouseSPR : iAdd : Some images - missing");
  } else { DrawRegionStore.Save(r);
           DrawRect(r,0,fromUL | modePUT);
           wchar2char(name,cname);
           text->Place(0, 0, modePUT | fromUL, cname); text->Draw();
           sp->Text = new BaseSPR();
           sp->Text->LoadDraw(text->Region);
           DrawRect(r, RGBis(100,100,100), fromUL | modeMUL);
           sp->dText = new BaseSPR();
           sp->dText->LoadDraw(text->Region);
           DrawRegionStore.Restore();
         };
};

//////////////////////////////////////////////////////////////////////////////
int IMouseSPR :: addValue(wchar_t* name, int mkey, int rkey, int pkey, int (*depend)(), unsigned space)
{
  if (!name) return -1;
  if (Items > 255) return -1;
  thispritem *sp = Item[Items] = new thispritem; sp->Text = sp->dText = NULL;
  HIloadText(name, sp, fromText, Text);
  if (space == -1) { if (!Items) Space[Items] = 0; else Space[Items] = DefaultSpace;
                   } else Space[Items] = space;
  sp->Name = name;
  sp->Button = no;
  sp->Delimiter = no;
  sp->Active = Yes;
  sp->funcDepend = depend;
  sp->mKey = mkey; sp->rKey = rkey; sp->pKey = pkey;
  Items++;
  imItem = sp;
  return Items - 1;
};

//////////////////////////////////////////////////////////////////////////////
int IMouseSPR :: addButton(wchar_t* name, int bkey, int (*depend)(), unsigned space)
{
  if (!name) return -1;
  if (Items > 255) return -1;
  thispritem *sp = Item[Items] = new thispritem; sp->Text = sp->dText = NULL;
  HIloadText(name, sp, fromText, Text);
  if (space == -1) { if (!Items) Space[Items] = 0; else Space[Items] = DefaultSpace;
                   } else Space[Items] = space;
  sp->Name = name;
  sp->Button = Yes;
  sp->Delimiter = no;
  sp->Active = Yes;
  sp->funcDepend = depend;
  sp->bKey = bkey;
  Items++;
  imItem = sp;
  return Items - 1;
};

//////////////////////////////////////////////////////////////////////////////
int IMouseSPR :: addDelimiter(unsigned space)
{
  if (Items > 255) return -1;
  thispritem *sp = Item[Items] = new thispritem; sp->Text = sp->dText = NULL;
  if (space == -1) { if (!Items) Space[Items] = 0; else Space[Items] = DefaultSpace;
                   } else Space[Items] = space;
  sp->Delimiter = Yes;
  Items++;
  imItem = sp;
  return Items - 1;
};

//////////////////////////////////////////////////////////////////////////////
void IMouseSPR :: Place(int x, int y, unsigned das)
{
  Mode = das; PX = x; PY = y;
  SizeCalc();
  DrawFROMconv(x,y,XR,YR,das,Region);
  int d, cx = Region.X + XS - 6, cy = Region.Y, mode = getMODE(das);
  thispritem *sp;
  for (int i = 0; i < Items; i++)
   { cy += Space[i]; sp = Item[i]; sp->X = Region.X; sp->Y = cy; 
     if (!sp->Delimiter) { sp->Text->Place(d = (cx - sp->Text->XR), cy, mode | fromUL);
                         sp->dText->Place(d, cy, mode | fromUL);
                           cy += YRD;
                       } else cy += 1;
   };
  MRP->Place(XS + Region.X, 0, getMODE(Mode) | fromUL);
  dMRP->Place(XS + Region.X, 0, getMODE(Mode) | fromUL);
  MP->Place(XS + Region.X, 0, getMODE(Mode) | fromUL);
  dMP->Place(XS + Region.X, 0, getMODE(Mode) | fromUL);
  Button->Place(XS + Region.X, 0, getMODE(Mode) | fromUL);
  dButton->Place(XS + Region.X, 0, getMODE(Mode) | fromUL);
  d = (MRP->XR - YRD * 3) / 2;
  mX = MRP->Region.X; mXL = mX + YRD - 1;
  pXL = MRP->Region.XL; pX = pXL - YRD + 1;
  rX = mXL + d + 1; rXL = pX - d - 1;
  iRegion = RegionIs(mX, Region.Y, pXL, Region.YL);
};

//////////////////////////////////////////////////////////////////////////////
void IMouseSPR :: SizeCalc()
{
  thispritem *sp;
  XR = Button->XR; YR = 0; XS = 0;
  for (int i = 0; i < Items; i++) { sp = Item[i];
                                  YR += Space[i]; if (!sp->Delimiter) YR += YRD; else YR += 1;
                                    if (sp->Text && (sp->Text->XR > XS)) XS = sp->Text->XR; 
                                  };
  XS += 6; XR += XS;
};

//////////////////////////////////////////////////////////////////////////////
void IMouseSPR :: IndSet(int y, int yl)
{
  if (IndShift < 0) IX = Region.X - 1; else IX = Region.XL + 1;
  IY = y; IYL = yl;
};

//////////////////////////////////////////////////////////////////////////////
void IMouseSPR :: DrawDelimiter(thispritem *sp)
{
  if ((unsigned)sp->Y > DrawYL) return;
  int x1 = Region.X, x2 = Region.X + XR;
  if ((x1 > DrawXL) || (x2 < 0)) return;
  if (x1 < 0) x1 = 0 + (abs(x1) & 0x01);
  if (x2 > DrawXL) x2 = DrawXL;
  dwRGB *p = DrawPointPtr(x1, sp->Y); 
  int sz = (x2 - x1) / 2, mode = getMODE(Mode);
  while (sz) { DrawPoint(p, 0xff282828, mode); p += 2; sz--; }; 
};

void IMouseSPR :: DrawButton(thispritem *sp)
{ 
  int y, yl, mode = getMODE(Mode);
  if (sp->funcDepend) sp->Active = sp->funcDepend();
  if (sp->Active) sp->Text->Draw(); else sp->dText->Draw(); 
  BaseSPR *spr;
  if (sp->Active) spr = Button; else spr = dButton;
  y = spr->Region.Y = sp->Y; yl = spr->Region.YL = y + YRD - 1; spr->Draw();
  if (MouseIn && sp->Active && YMouseIn(y,yl))
  { MouseIn = no; DrawRect(spr->Region,0xff505050,modeADD); Key = sp->bKey;
    IndSet(y, yl);
  }; 
};

void IMouseSPR :: DrawValue(thispritem *sp)
{ 
  int x, y, yl, mode = getMODE(Mode);
  if (sp->funcDepend) sp->Active = sp->funcDepend();
  if (sp->Active) sp->Text->Draw(); else sp->dText->Draw(); 
  BaseSPR *spr;
  if (sp->Active) { if (sp->rKey) spr = MRP; else spr = MP;
                  } else if (sp->rKey) spr = dMRP; else spr = dMP;
  y = spr->Region.Y = sp->Y; yl = spr->Region.YL = y + YRD - 1; spr->Draw();
  if (MouseIn && sp->Active && YMouseIn(y,yl))
  { MouseIn = no;
    if (XMouseIn(mX, rX))
  { DrawRect(RegionIs(mX, y, mXL, yl),0xff505050,modeADD); Key = sp->mKey;
  } else if (XMouseIn(rX, rXL) && sp->rKey) 
         { DrawRect(RegionIs(rX, y, rXL, yl),0xff505050,modeADD); Key = sp->rKey;
         } else if (XMouseIn(rXL, pXL)) { DrawRect(RegionIs(pX, y, pXL, yl),0xff505050,modeADD); Key = sp->pKey;
                                         };
    IndSet(y, yl);
  }; 
};

//////////////////////////////////////////////////////////////////////////////
void IMouseSPR :: Draw()
{
  thispritem *sp;
  int mode = getMODE(Mode);
  if (EDrawBefore) EDrawBefore(Region); 
  if (!ClickNow) MouseIn = RegionMouseIn(iRegion); else MouseIn = no;
  for (int i = 0; i < Items; i++) 
  { sp = Item[i];
    if (sp->Delimiter) DrawDelimiter(sp); //DrawHLine(DrawPointPtr(Region.X, sp->Y), 0xff101010, XR, mode);
   else if (sp->Button) DrawButton(sp);
         else DrawValue(sp);
  };
  if (MouseIn) Key = 0;
};

//////////////////////////////////////////////////////////////////////////////
int IMouseSPR :: LBDown()
{
  ClickNow = Yes; II.AsyncOrder = no; II.KeyDownSet(Key,II.AsyncKey[Key]);
  if (EDrawChanges && II.AsyncKey[Key]) EDrawChanges(IX, IY, IYL, IndShift);
  return Yes;
};

//////////////////////////////////////////////////////////////////////////////
int IMouseSPR :: LBUp()
{
  ClickNow = no; II.KeyUpSet(Key,II.AsyncKey[Key]); II.AsyncOrder = Yes; Key = 0;
  if (EDrawChanges && !II.AsyncKey[Key]) EDrawChanges(IX, IY, IYL, IndShift);
  return Yes;
};

//////////////////////////////////////////////////////////////////////////////
int IMouseSPR :: RBDown()
{
  ClickNow = Yes;
  return Yes;
};

//////////////////////////////////////////////////////////////////////////////
int IMouseSPR :: RBUp()
{
  ClickNow = no;
  return Yes;
};

/**/
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
///////       ////////////////////////
//////////////////////////////////////////////////////////////////////////////
LayerSPR :: LayerSPR(int x, int y, int xr, int yr, int sourcexr, int sourceyr, int mode)
{ 
  scaleX = scaleY = 0;
  Place(x,y,xr,yr,sourcexr,sourceyr,mode);
  Items = 0;
  for (int i = 0; i < 256; i++) Sprite[i] = NULL; 
}

//////////////////////////////////////////////////////////////////////////////
LayerSPR :: ~LayerSPR() 
{
  Clear();
}

//////////////////////////////////////////////////////////////////////////////
void LayerSPR :: Clear()
{ 
  for (int i = 0; i < 256; i++) if (Sprite[i]) { delete Sprite[i]; Sprite[i] = NULL; } else break;
  Items = 0;
}

//////////////////////////////////////////////////////////////////////////////
void LayerSPR :: Place(int x, int y, int xr, int yr, int sourcexr, int sourceyr, int mode)
{ 
  DrawFROMconv(x,y,xr,yr,mode,Region);
  if (sourcexr != -1) { scaleX = (tfloat)xr / sourcexr;
                        if (sourceyr != -1) scaleY = (tfloat)yr / sourceyr; else scaleY = scaleX;
                      } else scaleX = scaleY = 0;
}

//////////////////////////////////////////////////////////////////////////////
void LayerSPR :: SetShiftDir(int shiftdir)
{ 
  if (shiftdir == -1) Sprite[Items - 1]->ShiftDir = Sprite[Items - 1]->ShiftDir ^ 0x01;
   else Sprite[Items - 1]->ShiftDir = shiftdir;
}

//////////////////////////////////////////////////////////////////////////////
int LayerSPR :: AddWm(wchar_t* name, wchar_t* name_mask, int place, int shift, int mode) 
{
  if (!name) return -1;
  if (Items > 255) return -1;
  int xsz = Region.XL - Region.X + 1;
  int ysz = Region.YL - Region.Y + 1;
  GDIbitmapScaleX = scaleX;
  GDIbitmapScaleY = scaleY;
  Sprite[Items] = new BaseSPR(name,name_mask,xsz);
  switch (getARRANGE(mode))
   { default:
     case arrangeLR: Sprite[Items]->Place(place * GDIbitmapScaleXres + Region.X, 0, fromCL + getMODE(mode));
                     Sprite[Items]->ShiftDir = shiftY; break;
     case arrangeRL: Sprite[Items]->Place(place * GDIbitmapScaleXres + (DrawXL - Region.XL), 0, fromCR + getMODE(mode));
                     Sprite[Items]->ShiftDir = shiftY; break;
     case arrangeUD: Sprite[Items]->Place(0, place * GDIbitmapScaleYres + Region.Y, fromUC + getMODE(mode));
                     Sprite[Items]->ShiftDir = shiftX; break;
     case arrangeDU: Sprite[Items]->Place(0, place * GDIbitmapScaleYres + (DrawYL - Region.YL), fromDC + getMODE(mode));
                     Sprite[Items]->ShiftDir = shiftX; break;
   };
  Sprite[Items]->Shift = shift; 
  Items++;
  return Items - 1; 
}

//////////////////////////////////////////////////////////////////////////////
int LayerSPR :: Add(wchar_t* name, int place, int shift, int mode) 
{
  return AddWm(name,NULL,place,shift,mode);
}

//////////////////////////////////////////////////////////////////////////////
void LayerSPR :: Draw(int i)
{
  if (i != -1)
   { if (i >= Items) return;
     Sprite[i]->DrawShifted();
     return;
   };
  for (int i = 0; i < Items; i++) Sprite[i]->DrawShifted();
};

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////// Gradient Support Object /////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
BaseGRD :: BaseGRD(wchar_t* name)
{
  Bits = NULL;
  Size = 0;
  Load(name);
  Color = RGBis(255,255,255);
};

//////////////////////////////////////////////////////////////////////////////
BaseGRD :: ~BaseGRD()
{
  FreeMem(Bits);
};

//////////////////////////////////////////////////////////////////////////////
int BaseGRD :: Load(wchar_t* name)
{
  FreeMem(Bits); Bits = NULL; Size = 0;
  if (wcscmp(name,L""))
  { GDIrun();
    if (GDIbitmapFromResource(name))
    { GDIbitmapLock();
      if (GDIbitmapXres == 1)
      { Size = GDIbitmapYres;
        Bits = (dwRGB_arr *)GetMem(GDIbitmapSize);
        for (int i = 0; i < (GDIbitmapSize >> 2); i++)(*Bits)[i] = (*GDIbits)[i] | 0xff000000;
      } else HaltError(L"File for Gradient not 1 pixel width");  
      GDIbitmapUnlock();
    } else HaltError(L"JPG or BMP Resource Not Found");
    GDIbitmapRelase();
    GDIstop();
  };
  return (Bits != NULL);
};

//////////////////////////////////////////////////////////////////////////////
int BaseGRD :: LoadData(void *p, int size)
{
  FreeMem(Bits); Bits = NULL;
  Size = size; Bits = (dwRGB_arr *)GetMem(Size * 4);
  memcpy(Bits,p,Size * 4);
  return (Bits != NULL);
};

//////////////////////////////////////////////////////////////////////////////
void BaseGRD :: Draw(int x, int y, int xl, int yl)
{
  dwRGB val, *end, *ptr;
  if (!(y | xl | yl)) {y = x; xl = DrawXL - x; yl = DrawYL - y;};
  int xr = xl - x + 1;
  int yr = yl - y + 1;
  for (int yi = y; yi <= yl; yi++)
  { ptr = DrawPointPtr(x,yi);
    end = ptr + xr; 
    val = RGBmult(getColor(yi - y, yr),Color);
    do { *ptr = val; ptr++;
       } while ((unsigned)ptr != (unsigned)end);
  };
};

//////////////////////////////////////////////////////////////////////////////
dwRGB BaseGRD :: getColor(int y, int yr)
{
  if (yr == Size) return (*Bits)[y];
  yr--; 
  y = (Size - 1) * y;
  int pi = y / yr;
  if (Size > 255) return (*Bits)[pi];
  if (pi == (Size - 1)) return (*Bits)[pi]; else return RGBblend((*Bits)[pi],(*Bits)[pi+1], 255 * (y % yr) / (yr -1));
};

//////////////////////////////////////////////////////////////////////////////
int BaseGRD :: Make(dwRGB c1, dwRGB c2, unsigned size, tfloat low)
{
  FreeMem(Bits); Bits = NULL;
  Size = size; Bits = (dwRGB_arr *)GetMem(Size * 4);
  for (int i = 0; i < Size; i++)(*Bits)[i] = RGBblend(c1,c2,(tfloat)255 * Lower((tfloat)i / (Size - 1),low) + 0.5);
  return (Bits != NULL);
 
};

//////////////////////////////////////////////////////////////////////////////
////  TGA:  - .../////////////////////////////
//////////////////////////////////////////////////////////////////////////////
struct tTGAheader
{ char IdLeight, ColorMap, DataType;
  char ColorMapInfo[5];
  unsigned short X_Origin, Y_Origin, Width, Height;
  char BitPerPixel, Description;
};

tchar_arr *TGAline = NULL;
dwRGB_arr *TGAlineRGBA = NULL;
int TGAlineItems = 0;

//////////////////////////////////////////////////////////////////////////////
void TGAsaveStart(wchar_t *path, int xr, int yr)
{ tTGAheader h;
  TGAlineItems = 0;
  if (!FileWOpen(path)) return;
  memset(&h, 0, sizeof(h));
  h.IdLeight = 0; int e = sizeof(h);
  h.Width = xr; h.Height = yr;
  h.BitPerPixel = 24;
  h.DataType = 2;
  TGAline = (tchar_arr *)malloc(xr * 3 + 1);
  TGAlineItems = xr;
  FileWrite((char *)&h, 18);
};

//////////////////////////////////////////////////////////////////////////////
void TGAsaveLine(dwRGB *lp)
{
  if (!TGAlineItems) return;
  for (int i = 0; i < TGAlineItems; i++) { * (dwRGB *)(&(*TGAline)[i * 3]) = *lp; lp++; };
  FileWrite((char *)TGAline, TGAlineItems * 3);
};

//////////////////////////////////////////////////////////////////////////////
void TGAsaveFinish()
{
  if (!TGAlineItems) return;
  FileClose();
  free(TGAline);
};

//////////////////////////////////////////////////////////////////////////////
int TGAloadStart(wchar_t *path, int &xr, int &yr)
{ tTGAheader h;
  TGAlineItems = 0;
  if (!FileROpen(path)) return no;
  memset(&h, 0, sizeof(h));
  FileRead((char *)&h, 18);
  xr = h.Width; yr = h.Height;
  TGAline = (tchar_arr *)malloc(xr * 3 + 4);
  TGAlineRGBA = (dwRGB_arr *)GetMemAlign(xr * 4 + 4); 
  TGAlineItems = xr;
  return TGAlineItems;
};

//////////////////////////////////////////////////////////////////////////////
dwRGB *TGAloadLine()
{
  if (!TGAlineItems) return NULL;
  FileRead((char *)TGAline, TGAlineItems * 3);
  for (int i = 0; i < TGAlineItems; i++) {(*TGAlineRGBA)[i] = * (dwRGB *)(&(*TGAline)[i * 3]) | 0xff000000; };
  return (dwRGB *)TGAlineRGBA;
};

//////////////////////////////////////////////////////////////////////////////
void TGAloadFinish()
{
  if (!TGAlineItems) return;
  FileClose();
  free(TGAline); FreeMemAlign(TGAlineRGBA);
};

//////////////////////////////////////////////////////////////////////////////
////////// Flip control //////////////////////////////////////////////////////
int FC_Stop = Yes; 
int FC_Time, FC_TimeFree;
int FC_Prepared = no;
int FC_DrawPaint = Yes;
int FC_HQ = no; 
_int64 FC_Data, FC_FQ;
int FC_VSync = Yes;
int FC_VSyncTime, FC_VSyncTimeMin, FC_VSyncTimeMax;


//////////////////////////////////////////////////////////////////////////////
int FC_Fps = 30, FC_FpsMin = 15, FC_FpsMax, // () Fps
    FC_FpsReal = 0;
int FC_CPUlock = no, FC_CPUtryUp;      //    -  
tfloat FC_CPUlevel, FC_CPUlevelUp;     // 0..1         
int FC_Lock;

//////////////////////////////////////////////////////////////////////////////
inline _int64 FC_GetTime()
{
  _int64 t; 
  if (FC_HQ && !(FC_VSync && !(FC_FpsMax % FC_Fps))) QueryPerformanceCounter((LARGE_INTEGER *)&t); else t = (_int64)timeGetTime();
  return t;
};

///////////////////////////////////////////////////////////////////////////////
void FC_Prepare()
{
  FC_Prepared = no; if (FC_Stop) return;
  FC_Data = FC_GetTime(); FC_Prepared = Yes;
}

///////////////////////////////////////////////////////////////////////////////
tfloat FC_CPUload;

int FC_Wait(int fps) //    FPS - fps
{
  if (!FC_Prepared) return 0;  
  FC_Prepared = no; FC_Time = FC_GetTime() - FC_Data; 
  double t;
  if (FC_VSync && !(FC_FpsMax % FC_Fps))
  { FC_TimeFree = FC_VSyncTime - FC_Time;
    FC_CPUload = 1 - (double)FC_TimeFree / FC_VSyncTime;
    if (FC_TimeFree >= 0) { Sleep(max(FC_TimeFree - 1, 0)); FC_DD->WaitForVerticalBlank(DDWAITVB_BLOCKEND, 0); }
  } else if (FC_HQ)
         { _int64 f = FC_FQ / fps, tf, tw;
           t = (double)FC_FQ / fps;
           t = (t - FC_Time) / t; if (t > 1.0) t = 0.25;
           FC_CPUload = 1 - t;
           FC_TimeFree = t * 1000 / fps;
           if (FC_TimeFree >= 0) 
           { Sleep(max(FC_TimeFree - 1, 0)); tw = FC_Data + f;  
             while ((tf = tw - FC_GetTime()) > 0) { Sleep(0); if (tf > f) return 1; };
           }
         } else { FC_TimeFree = (t = (double)1000.0 / fps) - FC_Time;
                  FC_CPUload = 1 - FC_TimeFree / t;  
                  if (FC_TimeFree > 0) Sleep(FC_TimeFree); 
                }
  return 1;
}

///////////////////////////////////////////////////////////////////////////////
void FC_Reset()
{ 
  FC_VSyncTime = 0; FC_Fps = 30; FC_FpsReal = 0;
  if (FC_HQ) FC_HQ = QueryPerformanceFrequency((LARGE_INTEGER *)&FC_FQ);
  FC_Stop = FC_Prepared = 0;
  if (FC_CPUlock) EFC_CPUreload(FC_CPUlock = no);
  FC_CPUlock = FC_CPUtryUp = 0; FC_CPUlevel = 0.7; FC_CPUlevelUp = 0.75; FC_Lock = 10;
  if (FC_DD) { FC_DD->Release(); FC_DD = NULL; };
  if (FC_VSync && (GetWinVersion() >= 6)) 
  { if (FC_DD == NULL) if (DirectDrawCreate(0, &FC_DD, 0) != DD_OK) { FC_VSync = no; return; };
    int m = no, t, r = 1000;
    FC_DD->WaitForVerticalBlank(DDWAITVB_BLOCKEND, 0); // DDWAITVB_BLOCKBEGIN / DDWAITVB_BLOCKEND
    _int64 tr, te, tm, ts = timeGetTime();
    for (int i = 0; i < 30; i++)
    { FC_DD->WaitForVerticalBlank(DDWAITVB_BLOCKEND, 0);
      t = abs((tm = ((te = timeGetTime())) - ts) - 33);
      if (!i) FC_VSyncTimeMin = tm;
      if (t < r) { r = t; tr = te; m = Yes; } else if (m) break;
    }
    FC_VSyncTimeMax = FC_VSyncTime = tr - ts; FC_Fps = 1000.0 / FC_VSyncTime + 0.6;
    if ((FC_Fps < 24) || (FC_Fps > 31)) { FC_VSync = no; FC_Fps = 30; }
  } else FC_VSync = no;
}

//////////////////////////////////////////////////////////////////////////////
void EFC_CPUreloadDefault(int lock) {}
void (*EFC_CPUreload)(int lock) = EFC_CPUreloadDefault;
                                         //        
                                         // lock = no ,   
                                         // ( ,    , )
                                         // lock = yes,   ().  

///////////////////////////////////////////////////////////////////////////////
/*int FC_Msg()
{ wchar_t num[65];
  _itow(FC_Time, num, 10); msgMain(num); return 1;
};/**/

///////////////////////////////////////////////////////////////////////////////
void FC_FpsHold()
{
  if (!FC_Wait(FC_Fps)) return;
  if (FC_CPUload > FC_CPUlevel)
  { if (FC_CPUload > 8.0) return;
    if (FC_Lock) FC_Lock--; else 
    FC_CPUlevel = FC_CPUlevel + (FC_CPUload - FC_CPUlevel) / 32; 
    if (FC_CPUtryUp && (FC_CPUlevel > 0.9)) { floatLdec(FC_CPUlevelUp, 0.15, 0.1); FC_CPUtryUp = 0; };
    if (!FC_CPUlock && (FC_CPUlevel > 1)) EFC_CPUreload(FC_CPUlock = Yes);
  } else { FC_CPUlevel = FC_CPUlevel + (FC_CPUload - FC_CPUlevel) / 128;
           if (FC_CPUlock && (FC_CPUlevel < FC_CPUlevelUp)) { EFC_CPUreload(FC_CPUlock = no); FC_CPUtryUp = 1024; }
         }
  if (FC_CPUtryUp) { FC_CPUtryUp--;
                     if (!FC_CPUtryUp && (FC_CPUlevel < 0.85)) floatLinc(FC_CPUlevelUp, 0.85, 0.1);
                   }       
  if (FC_CPUlevel > 1) { FC_FpsReal = 1 / FC_CPUlevel * FC_Fps + 0.5; } else FC_FpsReal = FC_Fps;
}

///////////////////////////////////////////////////////////////////////////////
void FC_FpsSet(int fps, void (*efunc)(int))
{
  FC_Reset();
  if (fps == AUTO)
  { if (!FC_VSync) { int f; if (f = GetMonitorFq()) if ((f % 25) == 0) FC_Fps = 25; }
  } else if (FC_Fps != fps) { FC_Fps = fps; FC_VSync = no; };
  if (efunc) EFC_CPUreload = efunc; else EFC_CPUreload = EFC_CPUreloadDefault; 
  FC_FpsMax = FC_Fps;
}

void FC_FpsChange(int fps) { fps = Clamp(fps, FC_FpsMin, FC_FpsMax); FC_Fps = fps; FC_VSyncTime = FC_VSyncTimeMax * FC_FpsMax / fps; }

///////////////////////////////////////////////////////////////////////////////
//    
///////////////////////////////////////////////////////////////////////////////
int DrawRecord = off;
int DrawShot = off;
unsigned DrawRecordCount = 0;

////////////////////////////////////////////////////////////////////////////
int DrawBitsToClipboard(dwRGB *bits, int xr, int yr, int loffs)
{
 if (!OpenClipboard(NULL)) return no;
 if (!EmptyClipboard()) return no;

 unsigned szh = sizeof(BITMAPINFOHEADER), szi = xr * yr * 4, sza = szi + szh;
 HGLOBAL hResult = GlobalAlloc(GMEM_MOVEABLE, sza); if (hResult == NULL) return 0;
 
 dwRGB *b = (dwRGB *)GlobalLock(hResult);
 BITMAPINFOHEADER *h = (BITMAPINFOHEADER *)b;
 b += szh / 4;
 
 h->biSize = szh;
 h->biWidth = xr;
 h->biHeight = yr;
 h->biPlanes = 1;
 h->biBitCount = 32;
 h->biCompression = BI_RGB;
 h->biSizeImage = szi;
 h->biXPelsPerMeter = 3780;
 h->biYPelsPerMeter = 3780;
 h->biClrUsed = 0;
 h->biClrImportant = 0;

 loffs /= 4;
 for (int y = 0; y < yr; y++)
 { memcpy(b, bits, xr * 4);
   bits += loffs; b += xr; 
 };

 GlobalUnlock(hResult);
 int r = (SetClipboardData(CF_DIB, hResult) != NULL);
 CloseClipboard(); GlobalFree(hResult);
 return r;
};

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
// Anti-Grain Geometry - Version 2.1 Lite 
// Copyright(C) 2002-2003 Maxim Shemanarev(McSeem)
//
// Permission to copy, use, modify, sell and distribute this software 
// is granted provided this copyright notice appears in all copies. 
// This software is provided "as is" without express or implied
// warranty, and with no claim as to its suitability for any purpose.
//
// The author gratefully acknowleges the support of David Turner, 
// Robert Wilhelm, and Werner Lemberg - the authors of the FreeType 
// libray - in producing this work. See http://www.freetype.org for details.
//
////////////////////////////////////////////////////////////////////////////////////////
// Contact: mcseem@antigrain.com
//          mcseemagg@yahoo.com
//          http://www.antigrain.com
////////////////////////////////////////////////////////////////////////////////////////
#define CELLSMEMSEG 16384
#define COVERMEMSEG 1280

typedef signed short   int16;
typedef unsigned short int16u;

////////////////////////////////////////////////////////////////////////////////////////
//
// This class is used to transfer data from class outline(or a similar one)
// to the rendering buffer. It's organized very simple. The class stores 
// information of horizontal spans to render it into a pixel-map buffer. 
// Each span has initial X, length, and an array of bytes that determine the 
// alpha-values for each pixel. So, the restriction of using this class is 256 
// levels of Anti-Aliasing, which is quite enough for any practical purpose.
// Before using this class you should know the minimal and maximal pixel 
// coordinates of your scanline. The protocol of using is:
// 1. reset(min_x, max_x)
// 2. add_cell() / add_span() - accumulate scanline. You pass Y-coordinate 
//    into these functions in order to make scanline know the last Y. Before 
//    calling add_cell() / add_span() you should check with method is_ready(y)
//    if the last Y has changed. It also checks if the scanline is not empty. 
//    When forming one scanline the next X coordinate must be always greater
//    than the last stored one, i.e. it works only with ordered coordinates.
// 3. If the current scanline is_ready() you should render it and then call 
//    reset_spans() before adding new cells/spans.
//    
////////////////////////////////////////////////////////////////////////////////////////
//
// The question is: why should we accumulate the whole scanline when we
// could render just separate spans when they're ready?
// That's because using the scaline is in general faster. When is consists 
// of more than one span the conditions for the processor cash system
// are better, because switching between two different areas of memory 
// (that can be large ones) occures less frequently.
////////////////////////////////////////////////////////////////////////////////////////
struct tcover { int x; unsigned szcv; }; 

class scanline
{
  public:
  enum { aa_shift = 8 };
  ~scanline();
  scanline();
  void     reset(int min_x, int max_x, int dx = 0, int dy = 0);
  void     reset_spans();
  void     add_cell(int x, int y, unsigned cover);
  void     add_span(int x, int y, unsigned num, unsigned cover);
  int      is_ready(int y) const;
  int      base_x()    const { return m_min_x + m_dx;  }
  int      y()         const { return m_last_y + m_dy; }

  int       m_min_x;
  unsigned  m_max_len;
  int       m_dx, m_dy;
  int       m_last_x, m_last_y;
  int       m_count;
  tcover *m_covers;
};

////////////////////////////////////////////////////////////////////////////////////////
inline void scanline::reset_spans() { m_last_x = 0x7FFF; m_last_y = 0x7FFF; m_count  = 0; m_min_x  = 0; }

////////////////////////////////////////////////////////////////////////////////////////
inline void scanline::add_cell(int x, int y, unsigned cover)
{
  tcover *cv = (m_covers + m_count);
  cv->x = x; cv->szcv = (1 << 8) | cover;  
  m_count++; m_last_x = x; m_last_y = y;
}

////////////////////////////////////////////////////////////////////////////////////////
inline void scanline::add_span(int x, int y, unsigned num, unsigned cover)
{
  tcover *cv = (m_covers + m_count);
  cv->x = x; cv->szcv = (num << 8) | cover; 
  m_count++; m_last_x = x + num - 1; m_last_y = y;
}

////////////////////////////////////////////////////////////////////////////////////////
inline int scanline::is_ready(int y) const { return m_count && (y ^ m_last_y); }

////////////////////////////////////////////////////////////////////////////////////////
// This class template is used basically for rendering scanlines. 
//  
////////////////////////////////////////////////////////////////////////////////////////
void scanRender(const scanline& sl, dwRGB c); 

////////////////////////////////////////////////////////////////////////////////////////
// These constants determine the subpixel accuracy, to be more precise, 
// the number of bits of the fractional part of the coordinates. 
// The possible coordinate capacity in bits can be calculated by formula:
// sizeof(int) * 8 - poly_base_shift * 2, i.e, for 32-bit integers and
// 8-bits fractional part the capacity is 16 bits or [-32768...32767].
enum
{
  poly_base_shift = 8,
  poly_base_size  = 1 << poly_base_shift,
  poly_base_mask  = poly_base_size - 1
};

////////////////////////////////////////////////////////////////////////////////////////
inline int poly_coord(tfloat c) { return int(c * poly_base_size); }

////////////////////////////////////////////////////////////////////////////////////////
// A pixel cell. There're no constructors defined and it was done 
// intentionally in order to avoid extra overhead when allocating an 
// array of cells.
struct cell
{
  int16 x, y;
  int packed_coord, cover, area;

  void set(int x, int y, int c, int a);
  void set_coord(int x, int y);
  void set_cover(int c, int a);
  void add_cover(int c, int a);
};


////////////////////////////////////////////////////////////////////////////////////////
// An internal class that implements the main rasterization algorithm.
// Used in the rasterizer. Should not be used direcly.
class outline
{
  enum
  { cell_block_shift = 12,
    cell_block_size  = 1 << cell_block_shift,
    cell_block_mask  = cell_block_size - 1,
    cell_block_pool  = 512,
    cell_block_limit = 1024
  };

  public:
  ~outline();
  outline();

  void reset();

  void move_to(int x, int y);
  void line_to(int x, int y);

  unsigned num_cells() const {return m_num_cells; }
  const cell* const* cells();

  int       m_min_x;
  int       m_min_y;
  int       m_max_x;
  int       m_max_y;

  private:
  outline(const outline&);
  const outline& operator = (const outline&);

  void set_cur_cell(int x, int y);
  void add_cur_cell();
  void sort_cells();
  void render_scanline(int ey, int x1, int y1, int x2, int y2);
  void render_line(int x1, int y1, int x2, int y2);
  void allocate_block();
  
  static void qsort_cells(cell** start, unsigned num);

  unsigned  m_num_blocks;
  unsigned  m_max_blocks;
  unsigned  m_cur_block;
  unsigned  m_num_cells;
  cell**    m_cells;
  cell*     m_cur_cell_ptr;
  cell**    m_sorted_cells;
  unsigned  m_sorted_size;
  cell      m_cur_cell;
  int       m_cur_x;
  int       m_cur_y;
  int       m_close_x;
  int       m_close_y;
  unsigned  m_flags;
};

////////////////////////////////////////////////////////////////////////////////////////
// Polygon rasterizer that is used to render filled polygons with 
// high-quality Anti-Aliasing. Internally, by default, the class uses 
// integer coordinates in format 24.8, i.e. 24 bits for integer part 
// and 8 bits for fractional - see poly_base_shift. This class can be 
// used in the following  way:
//
// 1. filling_rule(filling_rule_e ft) - optional.
//
// 2. gamma() - optional.
//
// 3. reset()
//
// 4. move_to(x, y) / line_to(x, y) - make the polygon. One can create 
//    more than one contour, but each contour must consist of at least 3
//    vertices, i.e. move_to(x1, y1); line_to(x2, y2); line_to(x3, y3);
//    is the absolute minimum of vertices that define a triangle.
//    The algorithm does not check either the number of vertices nor
//    coincidence of their coordinates, but in the worst case it just 
//    won't draw anything.
//    The orger of the vertices(clockwise or counterclockwise) 
//    is important when using the non-zero filling rule(NonZero).
//    In this case the vertex order of all the contours must be the same
//    if you want your intersecting polygons to be without "holes".
//    You actually can use different vertices order. If the contours do not 
//    intersect each other the order is not important anyway. If they do, 
//    contours with the same vertex order will be rendered without "holes" 
//    while the intersecting contours with different orders will have "holes".
//
// filling_rule() and gamma() can be called anytime before "sweeping".
////////////////////////////////////////////////////////////////////////////////////////
class rasterizer
{
  public:
  enum
  { aa_shift = scanline::aa_shift,
    aa_num   = 1 << aa_shift,
    aa_mask  = aa_num - 1,
    aa_2num  = aa_num * 2,
    aa_2mask = aa_2num - 1
  };

  rasterizer() { m_filling_rule = EvenOdd; memcpy(m_gamma, s_default_gamma, sizeof(m_gamma)); }

////////////////////////////////////////////////////////////////////////////////////////
  void reset() { m_outline.reset(); }

////////////////////////////////////////////////////////////////////////////////////////
  void filling_rule(int filling_rule) { m_filling_rule = filling_rule; }

////////////////////////////////////////////////////////////////////////////////////////
  void gamma(tfloat g);
  void gamma(const int* g);

////////////////////////////////////////////////////////////////////////////////////////
  void move_to(tfloat x, tfloat y) { m_outline.move_to(poly_coord(x), poly_coord(y)); }
  void line_to(tfloat x, tfloat y) { m_outline.line_to(poly_coord(x), poly_coord(y)); }

////////////////////////////////////////////////////////////////////////////////////////
  unsigned calculate_alpha(int area) const
  {
    int cover = area >> (poly_base_shift*2 + 1 - aa_shift);
    if (cover < 0) cover = -cover;
    if (m_filling_rule == EvenOdd) { cover &= aa_2mask; if (cover > aa_num) cover = aa_2num - cover; }
    if (cover > aa_mask) cover = aa_mask;
    return cover;
  }

////////////////////////////////////////////////////////////////////////////////////////
  void render(dwRGB c, int dx = 0, int dy = 0)
  {
    const cell* const* cells = m_outline.cells();
    if (m_outline.num_cells() == 0) return;

    int x, y, cover = 0, alpha, area;
    m_scanline.reset(m_outline.m_min_x, m_outline.m_max_x, dx, dy);

    const cell* cur_cell = *cells++;
    for (;;)
    { const cell* start_cell = cur_cell;

      int coord  = cur_cell->packed_coord;
      x = cur_cell->x; y = cur_cell->y;
      area   = start_cell->area;
      cover += start_cell->cover;

      //accumulate all start cells
      while ((cur_cell = *cells++) != 0)
      { if (cur_cell->packed_coord != coord) break;
        area  += cur_cell->area; cover += cur_cell->cover;
      }
      if (area)
      { alpha = calculate_alpha((cover << (poly_base_shift + 1)) - area);
        if (alpha)
        { if ((y > 0) && m_scanline.is_ready(y)) { scanRender(m_scanline, c); m_scanline.reset_spans(); }
          m_scanline.add_cell(x, y, m_gamma[alpha]);
        }
        x++;
      }
      if (!cur_cell) break;
      if (cur_cell->x > x)
      { alpha = calculate_alpha(cover << (poly_base_shift + 1));
        if (alpha)
        { if (m_scanline.is_ready(y)) { scanRender(m_scanline, c); m_scanline.reset_spans(); }
          m_scanline.add_span(x, y, cur_cell->x - x, m_gamma[alpha]);
        }
      }
    } 
    if (m_scanline.m_count) scanRender(m_scanline, c);
  }

  bool hit_test(int tx, int ty);

  outline        m_outline;
  private:
  scanline       m_scanline;
  int            m_filling_rule;
  int            m_gamma[256];
  static const int s_default_gamma[256];     
};

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// Anti-Grain Geometry - Version 2.1 Lite 
// Copyright(C) 2002-2003 Maxim Shemanarev(McSeem)
//
// Permission to copy, use, modify, sell and distribute this software 
// is granted provided this copyright notice appears in all copies. 
// This software is provided "as is" without express or implied
// warranty, and with no claim as to its suitability for any purpose.
//
// The author gratefully acknowleges the support of David Turner, 
// Robert Wilhelm, and Werner Lemberg - the authors of the FreeType 
// libray - in producing this work. See http://www.freetype.org for details.
//
////////////////////////////////////////////////////////////////////////////////////////
// Contact: mcseem@antigrain.com
//          mcseemagg@yahoo.com
//          http://www.antigrain.com
////////////////////////////////////////////////////////////////////////////////////////
scanline::~scanline() { delete [] m_covers; }

////////////////////////////////////////////////////////////////////////////////////////
scanline::scanline() : m_min_x(0), m_max_len(0), m_dx(0), m_dy(0), m_last_x(0x7FFF), m_last_y(0x7FFF), m_covers(NULL), m_count(0) {}

////////////////////////////////////////////////////////////////////////////////////////
void scanline::reset(int min_x, int max_x, int dx, int dy)
{
  unsigned max_len = max_x - min_x + 2;
  if (max_len > m_max_len)
  { while (m_max_len < max_len) m_max_len += COVERMEMSEG; 
    delete [] m_covers;
    m_covers = new tcover [m_max_len];
  }
  m_dx     = dx;
  m_dy     = dy;
  m_last_x = 0x7FFF;
  m_last_y = 0x7FFF;
  m_count  = 0;
  m_min_x  = min_x;
}

////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
const int rasterizer::s_default_gamma[] = 
{
    0,  0,  1,  1,  2,  2,  3,  4,  4,  5,  5,  6,  7,  7,  8,  8,
    9, 10, 10, 11, 11, 12, 13, 13, 14, 14, 15, 16, 16, 17, 18, 18,
   19, 19, 20, 21, 21, 22, 22, 23, 24, 24, 25, 25, 26, 27, 27, 28,
   29, 29, 30, 30, 31, 32, 32, 33, 34, 34, 35, 36, 36, 37, 37, 38,
   39, 39, 40, 41, 41, 42, 43, 43, 44, 45, 45, 46, 47, 47, 48, 49,
   49, 50, 51, 51, 52, 53, 53, 54, 55, 55, 56, 57, 57, 58, 59, 60,
   60, 61, 62, 62, 63, 64, 65, 65, 66, 67, 68, 68, 69, 70, 71, 71,
   72, 73, 74, 74, 75, 76, 77, 78, 78, 79, 80, 81, 82, 83, 83, 84,
   85, 86, 87, 88, 89, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99,
  100,101,101,102,103,104,105,106,107,108,109,110,111,112,114,115,
  116,117,118,119,120,121,122,123,124,126,127,128,129,130,131,132,
  134,135,136,137,139,140,141,142,144,145,146,147,149,150,151,153,
  154,155,157,158,159,161,162,164,165,166,168,169,171,172,174,175,
  177,178,180,181,183,184,186,188,189,191,192,194,195,197,199,200,
  202,204,205,207,209,210,212,214,215,217,219,220,222,224,225,227,
  229,230,232,234,236,237,239,241,242,244,246,248,249,251,253,255
};

////////////////////////////////////////////////////////////////////////////////////////
enum
{
  not_closed    = 1,
  sort_required = 2
};

////////////////////////////////////////////////////////////////////////////////////////
inline void cell::set_cover(int c, int a) { cover = c; area = a; }

////////////////////////////////////////////////////////////////////////////////////////
inline void cell::add_cover(int c, int a) { cover += c; area += a; }

////////////////////////////////////////////////////////////////////////////////////////
inline void cell::set_coord(int cx, int cy)
{
  x = int16(cx); y = int16(cy);
  packed_coord = (cy << 16) + cx;
}

////////////////////////////////////////////////////////////////////////////////////////
inline void cell::set(int cx, int cy, int c, int a)
{
  x = int16(cx); y = int16(cy);
  packed_coord = (cy << 16) + cx;
  cover = c; area = a;
}

////////////////////////////////////////////////////////////////////////////////////////
outline::~outline()
{
  delete [] m_sorted_cells;
  if (m_num_blocks)
  { cell** ptr = m_cells + m_num_blocks - 1;
    while (m_num_blocks--) { delete [] *ptr; ptr--; }
    delete [] m_cells;
  }
}

////////////////////////////////////////////////////////////////////////////////////////
outline::outline() :  m_num_blocks(0),
                      m_max_blocks(0),
                      m_cur_block(0),
                      m_num_cells(0),
                      m_cells(0),
                      m_cur_cell_ptr(0),
                      m_sorted_cells(0),
                      m_sorted_size(0),
                      m_cur_x(0),
                      m_cur_y(0),
                      m_close_x(0),
                      m_close_y(0),
                      m_min_x(0x7FFFFFFF),
                      m_min_y(0x7FFFFFFF),
                      m_max_x(-0x7FFFFFFF),
                      m_max_y(-0x7FFFFFFF),
                      m_flags(sort_required)
{
  m_cur_cell.set(0x7FFF, 0x7FFF, 0, 0);
}

////////////////////////////////////////////////////////////////////////////////////////
void outline::reset()
{ 
  m_num_cells = 0; 
  m_cur_block = 0;
  m_cur_cell.set(0x7FFF, 0x7FFF, 0, 0);
  m_flags |= sort_required;
  m_flags &= ~not_closed;
  m_min_x =  0x7FFFFFFF;
  m_min_y =  0x7FFFFFFF;
  m_max_x = -0x7FFFFFFF;
  m_max_y = -0x7FFFFFFF;
}

////////////////////////////////////////////////////////////////////////////////////////
void outline::allocate_block()
{
  if (m_cur_block >= m_num_blocks)
  { if (m_num_blocks >= m_max_blocks)
    { cell** new_cells = new cell* [m_max_blocks + cell_block_pool];
      if (m_cells)
      { memcpy(new_cells, m_cells, m_max_blocks * sizeof(cell*));
        delete [] m_cells;
      }
      m_cells = new_cells; m_max_blocks += cell_block_pool;
    }
    m_cells[m_num_blocks++] = new cell [unsigned(cell_block_size)];
  }
  m_cur_cell_ptr = m_cells[m_cur_block++];
}

////////////////////////////////////////////////////////////////////////////////////////
inline void outline::add_cur_cell()
{
  if (m_cur_cell.area | m_cur_cell.cover)
  { if ((m_num_cells & cell_block_mask) == 0)
    { if (m_num_blocks >= cell_block_limit) return;
      allocate_block();
    }
    *m_cur_cell_ptr++ = m_cur_cell; m_num_cells++;
  }
}

////////////////////////////////////////////////////////////////////////////////////////
inline void outline::set_cur_cell(int x, int y)
{
  if (m_cur_cell.packed_coord != (y << 16) + x) { add_cur_cell(); m_cur_cell.set(x, y, 0, 0); }
}

////////////////////////////////////////////////////////////////////////////////////////
inline void outline::render_scanline(int ey, int x1, int y1, int x2, int y2)
{
  int ex1 = x1 >> poly_base_shift;
  int ex2 = x2 >> poly_base_shift;
  int fx1 = x1 & poly_base_mask;
  int fx2 = x2 & poly_base_mask;

  int delta, p, first, dx, incr, lift, mod, rem;

  //trivial case. Happens often
  if (y1 == y2) { set_cur_cell(ex2, ey); return; }

  //everything is located in a single cell.  That is easy!
  if (ex1 == ex2)
  { delta = y2 - y1;
    m_cur_cell.add_cover(delta,(fx1 + fx2) * delta);
    return;
  }

  //ok, we'll have to render a run of adjacent cells on the same
  //scanline...
  p = (poly_base_size - fx1) * (y2 - y1);
  first = poly_base_size;
  incr = 1;

  dx = x2 - x1;
  if (dx < 0) { p = fx1 * (y2 - y1); first = 0; incr  = -1; dx = -dx; }
  delta = p / dx;
  mod   = p % dx;
  if (mod < 0) { delta--; mod += dx; }

  m_cur_cell.add_cover(delta,(fx1 + first) * delta);
  ex1 += incr;
  set_cur_cell(ex1, ey);
  y1  += delta;

  if (ex1 != ex2)
  { p     = poly_base_size * (y2 - y1 + delta);
    lift  = p / dx;
    rem   = p % dx;
    if (rem < 0) { lift--; rem += dx; }
    mod -= dx;
    while (ex1 != ex2)
    { delta = lift;
      mod  += rem;
      if (mod >= 0) { mod -= dx; delta++; }

      m_cur_cell.add_cover(delta,(poly_base_size) * delta);
      y1  += delta;
      ex1 += incr;
      set_cur_cell(ex1, ey);
    }
  }
  delta = y2 - y1;
  m_cur_cell.add_cover(delta,(fx2 + poly_base_size - first) * delta);
}

////////////////////////////////////////////////////////////////////////////////////////
void outline::render_line(int x1, int y1, int x2, int y2)
{
  int dx, dy, x_from, x_to, p, rem, mod, lift, delta, first, incr, fs = 0, yr = DrawYR * poly_base_size;

  if (y1 > y2) { Swap(x1, x2); Swap(y1, y2); fs = 1; };
  if ((y2 < 0) || (y1 >= yr)) return;
  if (y1 < -1) { long long m = (x1 - x2); m = m * (y2 + 1) / (y2 - y1); x1 = x2 + m; y1 = -1; }; 
  if (y2 > yr) { long long m = (x2 - x1); m = m * (yr - y1) / (y2 - y1); x2 = x1 + m; y2 = yr; };

  int ey1 = y1 >> poly_base_shift, ey2 = y2 >> poly_base_shift;
  if (ey1   < m_min_y) m_min_y = ey1;
  if (ey2+1 > m_max_y) m_max_y = ey2+1;
  
  if (fs) { Swap(x1, x2); Swap(y1, y2); Swap(ey1, ey2); };

  int fy1 = y1 & poly_base_mask;
  int fy2 = y2 & poly_base_mask;

  dx = x2 - x1; dy = y2 - y1;

  //everything is on a single scanline
  if (ey1 == ey2) { render_scanline(ey1, x1, fy1, x2, fy2); return; }

  //Vertical line - we have to calculate start and end cells,
  //and then - the common values of the area and coverage for
  //all cells of the line. We know exactly there's only one 
  //cell, so, we don't have to call render_scanline().
  incr  = 1;
  if (dx == 0)
  { int area, ex = x1 >> poly_base_shift, two_fx = (x1 - (ex << poly_base_shift)) << 1;

    first = poly_base_size;
    if (dy < 0) { first = 0; incr  = -1; }
    x_from = x1;

    //render_scanline(ey1, x_from, fy1, x_from, first);
    delta = first - fy1;
    m_cur_cell.add_cover(delta, two_fx * delta);

    ey1 += incr; set_cur_cell(ex, ey1);

    delta = first + first - poly_base_size;
    area = two_fx * delta;
    while (ey1 != ey2)
    { //render_scanline(ey1, x_from, poly_base_size - first, x_from, first);
      m_cur_cell.set_cover(delta, area);
      ey1 += incr; set_cur_cell(ex, ey1);
    }
    //render_scanline(ey1, x_from, poly_base_size - first, x_from, fy2);
    delta = fy2 - poly_base_size + first;
    m_cur_cell.add_cover(delta, two_fx * delta);
    return;
  }

  //ok, we have to render several scanlines
  p = (poly_base_size - fy1) * dx; first = poly_base_size;

  if (dy < 0) { p = fy1 * dx; first = 0; incr = -1; dy = -dy; };
  delta = p / dy; mod = p % dy;
  if (mod < 0) { delta--; mod += dy; }
  x_from = x1 + delta;
  render_scanline(ey1, x1, fy1, x_from, first);
  ey1 += incr; set_cur_cell(x_from >> poly_base_shift, ey1);

  if (ey1 != ey2)
  { p = poly_base_size * dx; lift  = p / dy; rem   = p % dy;
    if (rem < 0) { lift--; rem += dy; }
    mod -= dy;
    while (ey1 != ey2)
    { delta = lift; mod  += rem;
      if (mod >= 0) { mod -= dy; delta++; }
      x_to = x_from + delta; render_scanline(ey1, x_from, poly_base_size - first, x_to, first);
      x_from = x_to; ey1 += incr; set_cur_cell(x_from >> poly_base_shift, ey1);
    }
  }
  render_scanline(ey1, x_from, poly_base_size - first, x2, fy2);
}

////////////////////////////////////////////////////////////////////////////////////////
void outline::move_to(int x, int y)
{
  int c;
  if ((m_flags & sort_required) == 0) reset();
  if (m_flags & not_closed) line_to(m_close_x, m_close_y);
  if ((y >> poly_base_shift) <= DrawYL) set_cur_cell(x >> poly_base_shift, y >> poly_base_shift);
  if ((c = x >> poly_base_shift) < m_min_x) m_min_x = c;
  if ((c++) > m_max_x) m_max_x = c;  
  m_close_x = m_cur_x = x; m_close_y = m_cur_y = y;
}

////////////////////////////////////////////////////////////////////////////////////////
void outline::line_to(int x, int y)
{
  int c;
  if ((m_flags & sort_required) && ((m_cur_x ^ x) | (m_cur_y ^ y)))
  { if ((c = x >> poly_base_shift) < m_min_x) m_min_x = c;
    if ((c++) > m_max_x) m_max_x = c;
    render_line(m_cur_x, m_cur_y, x, y);
    m_cur_x = x; m_cur_y = y; m_flags |= not_closed;
  }
}

enum { qsort_threshold = 9 };

////////////////////////////////////////////////////////////////////////////////////////
template <class T> static inline void swap_cells(T* a, T* b) { T temp = *a; *a = *b; *b = temp; }

////////////////////////////////////////////////////////////////////////////////////////
template <class T> static inline bool less_than(T* a, T* b) { return (*a)->packed_coord < (*b)->packed_coord; }

////////////////////////////////////////////////////////////////////////////////////////
void outline::qsort_cells(cell** start, unsigned num)
{
  cell**  stack[80];
  cell*** top; 
  cell**  limit;
  cell**  base;

  limit = start + num; base = start; top = stack;

  for (;;)
  { int len = int(limit - base);
    cell** i;
    cell** j;
    cell** pivot;
    if (len > qsort_threshold)
    { // we use base + len/2 as the pivot
      pivot = base + len / 2;
      swap_cells(base, pivot);
      i = base + 1; j = limit - 1;

      // now ensure that *i <= *base <= *j 
      if (less_than(j, i)) swap_cells(i, j);
      if (less_than(base, i)) swap_cells(base, i);
      if (less_than(j, base)) swap_cells(base, j);

      for (;;)
      { do i++; while (less_than(i, base));
        do j--; while (less_than(base, j));
        if (i > j) break;
        swap_cells(i, j);
      }
      swap_cells(base, j);

      // now, push the largest sub-array
      if (j - base > limit - i)
      { top[0] = base; top[1] = j; base   = i;
      } else
      { top[0] = i; top[1] = limit; limit  = j;
      }
      top += 2;
    } else
    { // the sub-array is small, perform insertion sort
      j = base; i = j + 1;
      for (; i < limit; j = i, i++)
      { for (; less_than(j + 1, j); j--)
        { swap_cells(j + 1, j);
          if (j == base) break;
        }
      }
      if (top > stack) { top  -= 2; base  = top[0]; limit = top[1]; } else break;
    }
  }
}

////////////////////////////////////////////////////////////////////////////////////////
void outline::sort_cells()
{
  if (m_num_cells == 0) return;
  if (m_num_cells > m_sorted_size)
  { while (m_num_cells > m_sorted_size) m_sorted_size += CELLSMEMSEG; 
    delete [] m_sorted_cells;
    m_sorted_cells = new cell* [m_sorted_size];
  }

  cell** sorted_ptr = m_sorted_cells;
  cell** block_ptr = m_cells;
  cell*  cell_ptr;

  unsigned nb = m_num_cells >> cell_block_shift, i;

  while (nb--)
  { cell_ptr = *block_ptr++; i = cell_block_size;
    while (i--) { *sorted_ptr++ = cell_ptr++; }
  }
  cell_ptr = *block_ptr++; i = m_num_cells & cell_block_mask;
  while (i--) { *sorted_ptr++ = cell_ptr++; }
  m_sorted_cells[m_num_cells] = 0;
  qsort_cells(m_sorted_cells, m_num_cells);
}

////////////////////////////////////////////////////////////////////////////////////////
const cell* const* outline::cells()
{
  if (m_flags & not_closed) { line_to(m_close_x, m_close_y); m_flags &= ~not_closed; }

  //Perform sort only the first time.
  if (m_flags & sort_required)
  { add_cur_cell();
    if (m_num_cells == 0) return 0;
    sort_cells(); m_flags &= ~sort_required;
  }
  return m_sorted_cells;
}

////////////////////////////////////////////////////////////////////////////////////////
void rasterizer::gamma(tfloat g)
{
  for (int i = 0; i < 256; i++) { m_gamma[i] = (pow((double)(i) / 255.0,(double)g) * 255.0); }
}

////////////////////////////////////////////////////////////////////////////////////////
void rasterizer::gamma(const int* g) { memcpy(m_gamma, g, sizeof(m_gamma)); }

////////////////////////////////////////////////////////////////////////////////////////
bool rasterizer::hit_test(int tx, int ty)
{
  const cell* const* cells = m_outline.cells();
  if (m_outline.num_cells() == 0) return no;

  int x, y, cover = 0, alpha, area;
  const cell* cur_cell = *cells++;

  for (;;)
  { const cell* start_cell = cur_cell;
    int coord  = cur_cell->packed_coord;
    x = cur_cell->x; y = cur_cell->y;
    if (y > ty) return no;
    area   = start_cell->area; cover += start_cell->cover;

    while ((cur_cell = *cells++) != 0)
    { if (cur_cell->packed_coord != coord) break;
      area  += cur_cell->area; cover += cur_cell->cover;
    }
    if (area)
    { alpha = calculate_alpha((cover << (poly_base_shift + 1)) - area);
      if (alpha) if (tx == x && ty == y) return yes;
      x++;
    }
    if (!cur_cell) break;
    if (cur_cell->x > x)
    { alpha = calculate_alpha(cover << (poly_base_shift + 1));
      if (alpha) if (ty == y && tx >= x && tx <= cur_cell->x) return yes;
    }
  }
  return no;
}

///////////////////////////////////////////////////////////////////////////////////////
void DrawPolyPoint_PUT(dwRGB *bits, unsigned c, unsigned a)
{
  DrawPoint_PUTALPHASP(bits, c, ALPHAsp(a));
};

///////////////////////////////////////////////////////////////////////////////////////
void DrawPolyLine_PUT(dwRGB *bits, unsigned c, unsigned sz, unsigned a)
{
  if (a == 255) DrawHLine_PUT(bits, c, sz); else DrawHLine_PUTALPHA(bits, ALPHAset(c, a), sz);
};

///////////////////////////////////////////////////////////////////////////////////////
void DrawPolyPoint_PUTALPHA(dwRGB *bits, unsigned c, unsigned a)
{
  DrawPoint_PUTALPHASP(bits, c, ALPHAsp(a * RGBalpha(c) >> 8));
};

///////////////////////////////////////////////////////////////////////////////////////
void DrawPolyLine_PUTALPHA(dwRGB *bits, unsigned c, unsigned sz, unsigned a)
{
  a = a * RGBalpha(c) / 255;
  if (a == 255) DrawHLine_PUT(bits, c, sz); else DrawHLine_PUTALPHA(bits, ALPHAset(c, a), sz);
};

///////////////////////////////////////////////////////////////////////////////////////
void DrawPolyPoint_ADD(dwRGB *bits, unsigned c, unsigned a)
{
  DrawPoint_ADD(bits, RGBmultV(c,a));
};

///////////////////////////////////////////////////////////////////////////////////////
void DrawPolyLine_ADD(dwRGB *bits, unsigned c, unsigned sz, unsigned a)
{
  DrawHLine_ADD(bits, RGBmultV(c, a), sz);
};

///////////////////////////////////////////////////////////////////////////////////////
void DrawPolyPoint_SUB(dwRGB *bits, unsigned c, unsigned a)
{
  DrawPoint_SUB(bits, RGBmultV(c,a));
};

///////////////////////////////////////////////////////////////////////////////////////
void DrawPolyLine_SUB(dwRGB *bits, unsigned c, unsigned sz, unsigned a)
{
  DrawHLine_SUB(bits, RGBmultV(c, a), sz);
};

///////////////////////////////////////////////////////////////////////////////////////
void DrawPolyPoint_MUL(dwRGB *bits, unsigned c, unsigned a)
{
  DrawPoint_MUL(bits, RGBblend(0x00ffffff, c, a));
};

///////////////////////////////////////////////////////////////////////////////////////
void DrawPolyPoint_IMUL(dwRGB *bits, unsigned c, unsigned a)
{
  DrawPoint_MUL(bits, RGBmultV(c, a));
};

///////////////////////////////////////////////////////////////////////////////////////
void DrawPolyLine_MUL(dwRGB *bits, unsigned c, unsigned sz, unsigned a)
{
  DrawHLine_MUL(bits, RGBblend(0x00ffffff, c, a), sz);
};

///////////////////////////////////////////////////////////////////////////////////////
void DrawPolyLine_IMUL(dwRGB *bits, unsigned c, unsigned sz, unsigned a)
{
  DrawHLine_MUL(bits, RGBmultV(c, a), sz);
};

///////////////////////////////////////////////////////////////////////////////////////
void (*DrawPolyPoint)(dwRGB *bits, unsigned c, unsigned a);
void (*DrawPolyLine)(dwRGB *bits, unsigned c, unsigned sz, unsigned a);

int DPMode = -1;

tPolyRotate DPRotate = {0, 0, 0};
int DPRotateDo = no; 

int DrawPolyRelink(unsigned m)
{ 
  if (m != DPMode)
   { switch (m)
     { default:
       case modePUT: DrawPolyPoint = DrawPolyPoint_PUT; DrawPolyLine = DrawPolyLine_PUT; break;
       case modePUTALPHA: DrawPolyPoint = DrawPolyPoint_PUTALPHA; DrawPolyLine = DrawPolyLine_PUTALPHA; break;
       case modeADD: DrawPolyPoint = DrawPolyPoint_ADD; DrawPolyLine = DrawPolyLine_ADD; break;
       case modeSUB: DrawPolyPoint = DrawPolyPoint_SUB; DrawPolyLine = DrawPolyLine_SUB; break;
       case modeMUL: DrawPolyPoint = DrawPolyPoint_MUL; DrawPolyLine = DrawPolyLine_MUL; break;
       case modeIMUL: DrawPolyPoint = DrawPolyPoint_IMUL; DrawPolyLine = DrawPolyLine_IMUL; break;
     };                  
     DPMode = m; 
   };
   return m;
};

int DrawPolyInited = DrawPolyRelink(modePUT);

void DrawPolyRotate(tfloat cx, tfloat cy, tfloat angle)
{
  DPRotate.CX = cx;
  DPRotate.CY = cy;
  DPRotate.Angle = angle;
  DPRotateDo = fabs(angle) > 0.00001;
};

void DrawPolyRotateNo() { DPRotateDo = no; };

///////////////////////////////////////////////////////////////////////////////////////
void scanRender(const scanline& sl, dwRGB c)
{
  int y = sl.y(), x, x2, sz; 
  if ((unsigned)y >= DrawYR) return;
  tcover *cvs = sl.m_covers;
  dwRGB *bits = DrawLinePtr(y);
  int cv;
  for (int i = 0; i < sl.m_count; i++)
  { x = cvs->x; sz = (cvs->szcv >> 8) & 0x0fff; x2 = x + sz - 1;
    if ((x > DrawXL) || (x2 < 0)) goto _jmp;
    if (x < 0) { x = 0; sz = x2 + 1; };
    if (x2 > DrawXL) sz = DrawXL - x + 1;
    cv = cvs->szcv & 0x00ff; 
    if (sz == 1) DrawPolyPoint(bits + x, c, cv); else DrawPolyLine(bits + x, c, sz, cv);
   _jmp: 
    cvs++;
  };
};

////////////////////////////////////////////////////////////////////////////////////////
rasterizer Poly;

struct tpoint { tfloat x, y; };
typedef tpoint tpoint_arr[256];
tpoint_arr *polyP = NULL;
tpoint *polyCP = NULL;
int polyI = 0, polyCount = 0, polyIn = 0;
tfRegion polyR;

inline void startPoly()
{ 
  polyI = 0; polyCP = (tpoint *)polyP;
  polyR.X = polyR.Y = 100000; polyR.XL = polyR.YL = -100000;
}

inline void addPoly(tfloat x, tfloat y)
{
  if (polyI >= polyCount)
  { polyP = (tpoint_arr *)GetMemAutoIncrease((char *)polyP,(polyI + 1) * sizeof(tpoint), 512 * sizeof(tpoint), polyCount * sizeof(tpoint));
    polyCount = MemAutoIncreaseSize / sizeof(tpoint);
    polyCP = &((*polyP)[polyI]);
  }
  DPRconv(x, y);
  if (x > polyR.XL) polyR.XL = x; if (x < polyR.X) polyR.X = x; 
  if (y > polyR.YL) polyR.YL = y; if (y < polyR.Y) polyR.Y = y; 
  polyCP->x = x; polyCP->y = y; polyI++; polyCP++;  
}

inline void pushPoly()
{
  if ((polyI < 2) || fDrawOutVR(polyR)) { startPoly(); return; };
  tpoint *p = (tpoint *)polyP; 
  Poly.move_to(p->x + 0.5, p->y + 0.5); p++;
  for (int i = 1; i < polyI; i++) { Poly.line_to(p->x + 0.5, p->y + 0.5); p++; };
  polyIn |= 1; startPoly();
};

////////////////////////////////////////////////////////////////////////////////////////
int DPComplex = no;
int DPOldFill = EvenOdd, DPFill = EvenOdd;

void DrawPolyFill(int t) { DPOldFill = DPFill; Poly.filling_rule(DPFill = t); };
void DrawPolyFillNonZero() { DrawPolyFill(NonZero); };
void DrawPolyFillEvenOdd() { DrawPolyFill(EvenOdd); };
void DrawPolyFillRestore() { Poly.filling_rule(DPFill = DPOldFill); };

void DrawPolyComplex(int t) { DPComplex = Yes; DrawPolyFill(t); };

void DrawPolyNew() { pushPoly(); };
void DrawPolyTo(tfloat x, tfloat y) { addPoly(x, y); };
void DrawPolyMoveTo(tfloat x, tfloat y) { pushPoly(); addPoly(x, y); };
void DrawPolyLineTo(tfloat x, tfloat y) { addPoly(x, y); };
void DrawPoly(dwRGB c, int mode)
{ 
  pushPoly(); 
  if (polyIn) { DrawPolyRelink(mode & 0x0f); Poly.render(c); };
  if (DPComplex) { DPComplex = no; DrawPolyFillRestore(); };
  polyIn = 0;
};


////////////////////////////////////////////////////////////////////////////////////////
int fDrawCurve = typePARABOLA;

inline int getDxDy(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat &dx, tfloat &dy)
{
  dx = x2 - x1; dy = y2 - y1;
  tfloat d = dx*dx + dy*dy;
  if (d < 0.00001) return no;
  d = sqrt(d); dx = (y2 - y1) / d; dy = (x2 - x1) / d;
  return Yes;
};

inline int getDxDy(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat &dx, tfloat &dy, tfloat &d)
{
  dx = x2 - x1; dy = y2 - y1;
  d = dx*dx + dy*dy;
  if (d < 0.00001) return no;
  d = sqrt(d); dx = (y2 - y1) / d; dy = (x2 - x1) / d;
  return Yes;
};

inline int getCircSegs(tfloat r)
{ 
  if (r < 4) return 12; else
  if (r < 7) return 16; else
  if (r > 2000) return 360; else return (int)(16 + 344 * Power((r - 7) / 1993, 0.75) + 4) & 0xfffffffc;
};

////////////////////////////////////////////////////////////////////////////////////////
void fDrawLine(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat w, dwRGB c, unsigned m)
{
  tfloat dx, dy;
  w *= 0.5;
  if ((!DPRotateDo && fDrawOut(x1, y1, x2, y2, w)) || !getDxDy(x1, y1, x2, y2, dx, dy)) return;
  dx *= w; dy *= w;
  DrawPolyMoveTo(x1 - dx,  y1 + dy);
  DrawPolyLineTo(x2 - dx,  y2 + dy);
  DrawPolyLineTo(x2 + dx,  y2 - dy);
  DrawPolyLineTo(x1 + dx,  y1 - dy);
  if (!DPComplex) DrawPoly(c, m);
}

////////////////////////////////////////////////////////////////////////////////////////
void fDrawRoundLine(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat w, dwRGB c, unsigned m, int r1, int r2)
{
  tfloat dx, dy, x, y, a, ad;
  w *= 0.5;
  if (!DPRotateDo && fDrawOut(x1, y1, x2, y2, w)) return;
  if (!getDxDy(x1, y1, x2, y2, dx, dy)) { fDrawCircle(x1, y1, w, c, m); return; };
  dx *= w; dy *= w;
  int s = getCircSegs(w) / 2; ad = M_PI / s;
  DrawPolyMoveTo(x1 - dx,  y1 + dy);
  DrawPolyLineTo(x2 - dx, y2 + dy);
  if (r1) { a = getAngle(-dx, dy);
            for (int i = 1; i < s; i++) { Rotate(x2, y2, w, a, x, y); DrawPolyLineTo(x, y); a += ad; };
          };  
  DrawPolyLineTo(x2 + dx,  y2 - dy);
  DrawPolyLineTo(x1 + dx,  y1 - dy);
  if (r2) { a = getAngle(dx, -dy);
            for (int i = 1; i < s; i++) { Rotate(x1, y1, w, a, x, y); DrawPolyLineTo(x, y); a += ad; };
          };  
  if (!DPComplex) DrawPoly(c, m);
}

////////////////////////////////////////////////////////////////////////////////////////
void fDrawRay(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat w1, tfloat w2, dwRGB c, unsigned m)
{
  tfloat dx1, dy1, dx2, dy2;
  w1 *= 0.5; w2 *= 0.5; 
  if (!DPRotateDo && fDrawOut(x1, y1, x2, y2, w1, w2)) return;
  if (!getDxDy(x1, y1, x2, y2, dx1, dy1)) return;
  dx2 = dx1; dy2 = dy1;
  dx1 *= w1; dy1 *= w1; dx2 *= w2; dy2 *= w2;
  DrawPolyMoveTo(x1 - dx1,  y1 + dy1);
  DrawPolyLineTo(x2 - dx2,  y2 + dy2);
  DrawPolyLineTo(x2 + dx2,  y2 - dy2);
  DrawPolyLineTo(x1 + dx1,  y1 - dy1);
  if (!DPComplex) DrawPoly(c, m);
}

////////////////////////////////////////////////////////////////////////////////////////
void fDrawRoundRay(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat w1, tfloat w2, dwRGB c, unsigned m, int r1, int r2)
{
  int s, mr = no;
  tfloat dx, dy, d, x, y, a, b, ad, dx1, dy1, dx2, dy2;
  w1 *= 0.5; w2 *= 0.5;
  if (!DPRotateDo && fDrawOut(x1, y1, x2, y2, w1, w2)) return;
  dx = x2 - x1; dy = y2 - y1;
  d = dx*dx + dy*dy;
  if (d > 0.0000001) d = sqrt(d);
  if ((w2 + d) <= w1) { fDrawCircle(x1, y1, w1, c, m); return; } else if ((w1 + d) <= w2) { fDrawCircle(x2, y2, w2, c, m); return; };
  if (w2 > w1) { Swap(x1, x2); Swap(y1, y2); Swap(w1, w2); dx = -dx, dy = -dy; };
  if (x2 < x1) { mr = Yes; x1 = -x1; x2 = -x2; dx = -dx; };
  a = M_PI / 2 - asin((w1 - w2) / d) + atan(dy / dx);
  dx1 = w1 * cos(a); dy1 = w1 * sin(a);
  dx2 = w2 * cos(a); dy2 = w2 * sin(a);
  if (mr) { x1 = -x1; x2 = -x2; dx1 = - dx1; dx2 = - dx2; //dx = -dx;
            Swap(x1, x2); Swap(y1, y2); Swap(w1, w2); Swap(dx1, dx2); Swap(dy1, dy2); dy = - dy;
          };
  b = 2 * acos((dx * dx1 + dy * dy1) / (d * sqrt(dx1 * dx1 + dy1 * dy1))); a = 2 * M_PI - b;
  DrawPolyNew();
  DrawPolyTo(x1 + dx1, y1 + dy1);
  if (r1) { s = (int)(a * 100) * getCircSegs(w1) / 628;
            ad = a / s; a = getAngle(dx1, dy1) - ad;
            for (int i = 0; i < s; i++) { Rotate(x1, y1, w1, a, x, y); DrawPolyTo(x, y); a -= ad; };
          } else { a = getAngle(dx1, dy1) - a; Rotate(w1, a, dx, dy); DrawPolyTo(x1 + dx, y1 + dy); };
  a = b + getAngle(dx2, dy2); Rotate(w2, a, dx, dy);
  DrawPolyTo(x2 + dx, y2 + dy);
  if (r2) { s = (int)(b * 100) * getCircSegs(w2) / 628;
            ad = b / s; a = getAngle(dx, dy) - ad;
            for (int i = 0; i < s; i++) { Rotate(x2, y2, w2, a, x, y); DrawPolyTo(x, y); a -= ad; };
          } else DrawPolyTo(x2 + dx2, y2 + dy2);
  if (!DPComplex) DrawPoly(c, m);
};

////////////////////////////////////////////////////////////////////////////////////////
void fDrawEllipse(tfloat x, tfloat y, tfloat rx, tfloat ry, dwRGB c, unsigned m)
{
    tfloat a = 0, aD;
    tfloat seg[91];
    if (!DPRotateDo && fDrawOut(x - rx, y - ry, x + rx, y + ry)) return;
    int s = getCircSegs(max(rx,ry)), q = s / 4; aD = 2 * M_PI / s;
    DrawPolyNew();
    //for (int i = 0; i < s; i++) { DrawPolyTo(x - cos(a) * rx, y + sin(a) * ry); a += aD; };
    for (int i = 0; i <= q; i++) { seg[i] = sin(a); a += aD; };
    for (int i = 0; i < q; i++) DrawPolyTo(x - seg[q - i] * rx, y + seg[i] * ry);
    for (int i = 0; i < q; i++) DrawPolyTo(x - (-seg[i]) * rx, y + seg[q - i] * ry);
    for (int i = 0; i < q; i++) DrawPolyTo(x - (-seg[q - i]) * rx, y + (-seg[i]) * ry);
    for (int i = 0; i < q; i++) DrawPolyTo(x - seg[i] * rx, y + (-seg[q - i]) * ry);/**/
    if (!DPComplex) DrawPoly(c, m);
}

////////////////////////////////////////////////////////////////////////////////////////
void fDrawCircle(tfloat x, tfloat y, tfloat r, dwRGB c, unsigned m)
{
  tfloat a = 0, aD;
  tfloat seg[91];
  int dpr = DPRotateDo;
  if (DPRotateDo) DPRotateDo = (!fFit(x, DPRotate.CX) || !fFit(y, DPRotate.CY)); 
  if (!DPRotateDo && fDrawOut(x, y, r)) { DPRotateDo = dpr; return; };
  int s = getCircSegs(r), q = s / 4; aD = 2 * M_PI / s;
  DrawPolyNew();
  //for (int i = 0; i < s; i++) { DrawPolyTo(x - cos(a) * r, y + sin(a) * r); a += aD; };
  for (int i = 0; i <= q; i++) { seg[i] = sin(a); a += aD; };
  for (int i = 0; i < q; i++) DrawPolyTo(x - seg[q - i] * r, y + seg[i] * r);
  for (int i = 0; i < q; i++) DrawPolyTo(x - (-seg[i]) * r, y + seg[q - i] * r);
  for (int i = 0; i < q; i++) DrawPolyTo(x - (-seg[q - i]) * r, y + (-seg[i]) * r);
  for (int i = 0; i < q; i++) DrawPolyTo(x - seg[i] * r, y + (-seg[q - i]) * r);/**/
  if (!DPComplex) DrawPoly(c, m);
  DPRotateDo = dpr;
}

////////////////////////////////////////////////////////////////////////////////////////
struct tchain { tfloat x, y, d, dx, dy; };
typedef tchain tchain_arr[256];
tchain_arr *chainP = NULL;
int chainI = -1, chainCount = 0;
tfloat chainW = 0;

void fDrawChainNew(tfloat w = 1.0)
{ 
  chainI = -1; chainW = w;
}

inline void nextChain()
{
  chainI++;
  if (chainI >= chainCount)
  { chainP = (tchain_arr *)GetMemAutoIncrease((char *)chainP,(chainI + 1) * sizeof(tchain), 128 * sizeof(tchain), chainCount * sizeof(tchain));
    chainCount = MemAutoIncreaseSize / sizeof(tchain);
  }
}

void fDrawChainTo(tfloat x, tfloat y, tfloat w)
{
  nextChain();
}
inline void fDrawChainTo(tfloat x, tfloat y)
{
  nextChain();
}

void fDrawChain(dwRGB, unsigned m, int close = no)
{
}

void fDrawRoundChain(dwRGB, unsigned m, int close = no)
{
}
 
////////////////////////////////////////////////////////////////////////////////////////
tfloat phill(tfloat t) {  t = 2 * t - 1; return 1 - t * t; };
tfloat chill(tfloat t) {  t = t * 2 - 1; return sqrt(1 - t * t); };
tfloat hhill(tfloat t) {  t = 1 - fabs(t * 2 - 1); return t * t * (3 - 2 * t); };

tfloat (*hill)(tfloat) = phill;

inline void linkHill()
{
  switch (fDrawCurve)
  { case typePARABOLA: hill = phill; break;
    case typeCIRCLE: hill = chill; break;
    case typeHHERMIT: hill = hhill; break;
  };
};

////////////////////////////////////////////////////////////////////////////////////////
void fDrawPotato(tfloat x, tfloat y, tfloat r, dwRGB c, unsigned m, tf4 p, tf4 t, tfloat a)
{
  int s = getCircSegs(r) * (1 + 3 * max(max(fabs(t.v[0]), fabs(t.v[1])),max(fabs(t.v[2]), fabs(t.v[3]))));
  s = (s + 4) & 0xfffffffc;
  int s4 = s / 4, si = s4, ki = 0;
  tfloat pi4 = M_PI / 4, pi2 = M_PI / 2, r0, rL, t0, tt, h = 0, hD = 1.0 / s4,
         xx, xL, xD, yy, yL, yD, dx, dy;
  if (a < 0) a = pi4;       
  linkHill();
  DrawPolyNew();
  for (int i = 0; i < s; i++)
  { if (si == s4)
    { r0 = p.v[ki] * r; t0 = r * t.v[ki];
      if (ki == 3) rL = p.v[0] * r; else rL = p.v[ki + 1] * r;
      xx = x - cos(a) * r0; xL = x - cos(a + pi2) * rL; xD = (xL - xx) / s4; 
      yy = y + sin(a) * r0; yL = y + sin(a + pi2) * rL; yD = (yL - yy) / s4;
      getDxDy(xx, yy, xL, yL, dx, dy); 
      a += pi2; ki++; si = h = 0;
    }; 
    tt = t0 * hill(h);
    DrawPolyTo(xx - dx * tt, yy + dy * tt);
    xx += xD; yy += yD;
    h += hD; si++;  
  };
  if (!DPComplex) DrawPoly(c, m);
};

////////////////////////////////////////////////////////////////////////////////////////
void fDrawNGon(tfloat x, tfloat y, tfloat r, int cp, dwRGB c, unsigned m,
                tfloat p0, tfloat p1, tfloat t0, tfloat t1, tfloat rp, tfloat rt, tfloat a)
{
  int s = getCircSegs(r) * (1 + 3 * (max(fabs(t0), fabs(t1)) + rt * 0.5));
  s = (s + 4) & 0xfffffffc;
  int f, ft, scp = s, si = scp, ki = 1;
  tfloat aD = 2 * M_PI / cp, r0, rL, rS, t, tt, h = 0, hD = 1.0 / scp,
         xx, xL, xD, yy, yL, yD, dx, dy;
  s *= cp; rp /= 2; rt /= 2;
  if (a < 0) a = 2 * M_PI / cp / 2 * (1 - 0.5 * (cp & 0x01));
  rL = r * (p0 + fRandom(-rp, rp));
  linkHill(); 
  DrawPolyNew();
  f = ((t0 == 0) && (t1 == 0));
  for (int i = 0; i < s; i++)
  { if (si == scp)
    { r0 = rL; if (ki == 1) rS = r0; 
      if (ki == cp) rL = rS; else rL = r * (p1 + fRandom(-rp, rp)); 
      xx = x - cos(a) * r0; xL = x - cos(a + aD) * rL; xD = (xL - xx) / scp; 
      yy = y + sin(a) * r0; yL = y + sin(a + aD) * rL; yD = (yL - yy) / scp;
      t = r * (t0 +  fRandom(-rt, rt));
      getDxDy(xx, yy, xL, yL, dx, dy);
      Swap(p0, p1); Swap(t0, t1); a += aD; si = h = 0; ki++; ft = Yes;
    }; 
    tt = t * hill(h);
    if (ft) DrawPolyTo(xx - dx * tt, yy + dy * tt); ft &= 1 - f;
    xx += xD; yy += yD;
    h += hD; si++;  
  };
  if (!DPComplex) DrawPoly(c, m);
};

////////////////////////////////////////////////////////////////////////////////////////
void fDrawRect(tfRegion r, dwRGB c, unsigned m)
{
  if (!DPRotateDo && fDrawOut(r.X, r.Y, r.XL, r.YL)) return;
  DrawPolyMoveTo(r.X, r.Y);
  DrawPolyLineTo(r.XL, r.Y);
  DrawPolyLineTo(r.XL, r.YL);
  DrawPolyLineTo(r.X, r.YL);
  if (!DPComplex) DrawPoly(c, m);
};

////////////////////////////////////////////////////////////////////////////////////////
void fDrawRoundRect(tfRegion r, tfloat rad, dwRGB c, unsigned m)
{
  if (!DPRotateDo && fDrawOut(r.X, r.Y, r.XL, r.YL)) return;
  int i, s, s4, ss, f = 1;
  tfloat a, x, y, pi2s;
  s = ss = s4 = getCircSegs(rad) / 4 + 1; s *= 4; pi2s = 2 * M_PI / s;
  x = r.X + rad; y = r.Y + rad;
  for (i = 0; i <= s4; i++)
  { a = pi2s * i;
    if (f) { DrawPolyMoveTo(x - rad, y); f = 0;
           } else DrawPolyLineTo(x - cos(a) * rad, y - sin(a) * rad);
  }
  x = r.XL - rad;  
  for (i = 0; i <= s4; i++)
  { a = pi2s * (i + ss); DrawPolyLineTo(x - cos(a) * rad, y - sin(a) * rad);
  }
  y = r.YL - rad; ss += s4;
  for (i = 0; i <= s4; i++)
  { a = pi2s * (i + ss); DrawPolyLineTo(x - cos(a) * rad, y - sin(a) * rad);
  }
  x = r.X + rad; ss += s4;
  for (i = 0; i <= s4; i++)
  { a = pi2s * (i + ss); DrawPolyLineTo(x - cos(a) * rad, y - sin(a) * rad);
  }
  if (!DPComplex) DrawPoly(c, m);
};

////////////////////////////////////////////////////////////////////////////
//     "" : fDraw...  ..

tfloat DefaultCurlWide(int i, int count, tfloat d) { return d; };
void DefaultCurlDraw(int i, int count, tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat w1, tfloat w2, dwRGB c, unsigned m)
{ 
  fDrawRoundRay(x1, y1, x2, y2, w1, w2, c, m);
};
tCurlStyle *CurlStyle;

cCurls :: cCurls(int size, int ssize)
{ 
  wDiff = -0.05; wStop = 0.25; Curl = NULL; Style = NULL; Recursion = 0; Min = 30; SetSize(size); SetStyleSize(ssize);
};

cCurls :: ~cCurls() {if (Curl) free(Curl); if (Style) free(Style); };

void cCurls :: SetSize(int size)
{ 
  if (size == Size) return;
  if (Curl) free(Curl);
  Size = size; Last = Items = 0;
  Curl = (tCurl_arr *)malloc(size * sizeof(tCurl));
  for (int i = 0; i < Size; i++)(*Curl)[i].Count = 0;
  Query.SetSize(size);
};

void cCurls :: SetStyleSize(int ssize)
{ 
  if (ssize == StyleSize) return;
  if (Style) free(Style);
  StyleSize = ssize;
  Style = (tCurlStyle_arr *)malloc(ssize * sizeof(tCurlStyle));
  tCurlStyle s;
  s.wProg = 0.975; s.dProg = 0.985, s.rProg = 1.015;
  s.EWide = DefaultCurlWide; s.EDraw = DefaultCurlDraw;
  for (int i = 0; i < StyleSize; i++)(*Style)[i] = s;
  
};

void cCurls :: SetStyle(int s, tfloat wP, tfloat dP, tfloat rP, int sC, tfloat sA)
{
  if (s >= StyleSize) return;
  CurlStyle = &((*Style)[s]);
  if (wP < 0) return;
  CurlStyle->wProg = wP; CurlStyle->dProg = dP; CurlStyle->rProg = rP; CurlStyle->sCount = sC; CurlStyle->sAngle = sA;  
};

void cCurls :: Add(tfloat x1, tfloat y1, tfloat x2, tfloat y2, tfloat w, tfloat a, int count, dwRGB c, int m, int s)
{
  unsigned i;
  tCurl *crl;
  x2 -= x1; y2 -= y1;
  tfloat d = x2*x2 + y2*y2; if (d < 0.00001) return;
  Items++; if (Items > Size) { Items--; return; };  
/*  for (i = 0; i < Last; i++) if ((*Curl)[i].Count == 0) break;
  Last += (i == Last);/**/
  if (!Query.Get(i)) return;
  if (i >= Last) Last = i+1;/**/
  crl = &((*Curl)[i]);
  crl->x = x1; crl->y = y1; crl->w = w;
  crl->dAngle = getAngle(x2, y2); crl->rAngle = a;
  Rotate(20.0, crl->dAngle, x2, y2);
  crl->d = sqrt(d) * Scale;
  crl->i = 0; crl->Count = count; crl->c = c; crl->m = m; crl->Style = s;  
}; 

void cCurls :: Add(tCurl c)
{
  unsigned i;
  Items++; if (Items > Size) { Items--; return; };  
/*  for (i = 0; i < Last; i++) if ((*Curl)[i].Count == 0) break;
  Last += (i == Last);/**/
  if (!Query.Get(i)) return;
  if (i >= Last) Last = i+1;/**/
  c.d *= 0.95; c.i = 0; c.rAngle *= -1.05;
  int sC = (*Style)[c.Style].sCount; 
  if ((sC < c.Count) && (c.Count % sC)) c.Count = (c.Count + sC / 2) / sC * sC; 
 (*Curl)[i] = c;
}; 

void cCurls :: Draw(unsigned count)
{
  tCurl *crl;
  tCurlStyle s;
  tfloat x, y, w, ew;
  for (int j = 0; j < Last; j++)
  if ((*Curl)[j].Count)
  { crl = &((*Curl)[j]); s = (*Style)[crl->Style];
    for (int i = 0; i < count; i++)
    { if ((crl->i < crl->Count) && (crl->w > wStop)) 
      { if ((Recursion) && (crl->i < (crl->Count - Min)) && (Random(crl->Count / Recursion) == 1))
        { tCurl crl_r = *crl; crl_r.Count -= crl_r.i; crl_r.i = 0; Add(crl_r);
        };       
        crl->dAngle += crl->rAngle; crl->rAngle *= s.rProg;
        Rotate(crl->d, crl->dAngle, x, y); crl->d *= s.dProg;
        x += crl->x; y += crl->y; w = (crl->w + wDiff) * s.wProg;
        if (crl->i == 0) crl->ew = s.EWide(0, crl->Count, crl->w);
        s.EDraw(crl->i, crl->Count, crl->x, crl->y, x, y, crl->ew, ew = s.EWide(crl->i + 1, crl->Count, w), crl->c, crl->m);
        crl->x = x; crl->y = y; crl->w = w; crl->ew = ew; crl->i++;
        if (!(crl->i % s.sCount)) crl->dAngle += crl->rAngle / fabs(crl->rAngle) * s.sAngle;
      } else { crl->Count = 0; Items--; Query.Return(j); break;
               if ((j + 1) == Last) { Last--; for (int k = j - 1; k >= 0; k--) if (!(*Curl)[k].Count) Last--; else break; };
             };
    };  
  };
};

////////////////////////////////////////////////////////////////////////////////////////